Documentation
=============

You can find full documentation, including installation instructions, at https://cosmosis.readthedocs.io

For GitHub Copilot coding agents, see [`.github/copilot-instructions.md`](.github/copilot-instructions.md) for comprehensive setup and usage instructions.

MultiNest v 3.7
Farhan Feroz, Mike Hobson
f.feroz@mrao.cam.ac.uk
arXiv:0704.3704, arXiv:0809.3437 & arXiv:1306.2144
Released June 2014

---------------------------------------------------------------------------

MultiNest Licence

Users are required to accept to the licence agreement given in LICENCE file.

Users are also required to cite the MultiNest papers (arXiv:0704.3704, arXiv:0809.3437 & arXiv:1306.2144) in their publications.

---------------------------------------------------------------------------

Required Libraries:

MultiNest requires lapack. To use MPI support, some MPI library must also be installed.

---------------------------------------------------------------------------

MPI Support:

The code is MPI compatible. In order to disable the MPI parallelization, remove -DMPI compilation flag.

---------------------------------------------------------------------------

gfortran compiler:

You might need to use the following flag while compiling MultiNest with gfortran compiler to remove the
restriction imposed by gfortran on line length.

-ffree-line-length-none

---------------------------------------------------------------------------

The subtoutine to begin MultiNest are as follows:

subroutine nestRun(IS, mmodal, ceff, nlive, tol, efr, ndims, nPar, nCdims, maxModes, updInt, Ztol, root, seed,
pWrap, feedback, resume, outfile, initMPI, logZero, maxiter, loglike, dumper, context)

logical IS 	 						!do Importance Nested Sampling (INS)?
logical mmodal 	 						!do mode separation?
integer nlive 	 						!number of live points
logical ceff							!run in constant efficiency mode
double precision tol 		 				!evidence tolerance factor
double precision efr 		 				!sampling efficiency
integer ndims	 						!number of dimensions
integer nPar	 						!total no. of parameters
integer nCdims							!no. of parameters on which clustering should be performed (read below)
integer maxModes						!maximum no. of modes (for memory allocation)
integer updInt							!iterations after which the output files should be written
double precision Ztol						!null log-evidence (read below)
character(len=root_max_len) root  					!root for MultiNest output files
integer seed 		 					!random no. generator seed, -ve value for seed from the sys clock
integer pWrap[ndims]						!wraparound parameters?
logical feedback						!need update on sampling progress?
logical resume							!resume from a previous run?
logical outfile							!write output files?
logical initMPI							!initialize MPI routines?, relevant only if compiling with MPI
								!set it to F if you want your main program to handle MPI initialization
double precision logZero					!points with loglike < logZero will be ignored by MultiNest
integer maxiter							!max no. of iterations, a non-positive value means infinity. MultiNest will terminate if either it 
								!has done max no. of iterations or convergence criterion (defined through tol) has been satisfied
loglike(Cube,ndims,nPar,lnew) 					!subroutine which gives lnew=loglike(Cube(ndims))
dumper(nSamples,nlive,nPar,physLive,posterior,
	paramConstr,maxloglike,logZ,INSlogZ,logZerr,c)		!subroutine called after every updInt*10 iterations with the posterior 
								!distribution, parameter constraints, max loglike & log evidence values
integer context							!not required by MultiNest, any additional information user wants to pass
      
--------------------------------------------------------------------------- 

likelihood routine: slikelihood(Cube,ndims,nPar,lnew,context)

Cube(1:nPar) has nonphysical parameters.

scale Cube(1:n_dim) & return the scaled parameters in Cube(1:n_dim) & additional parameters that you want to
be returned by MultiNest along with the actual parameters in Cube(n_dim+1:nPar)

Return the log-likelihood in lnew.

---------------------------------------------------------------------------

dumper routine: dumper(nSamples,nlive,nPar,physLive,posterior,paramConstr,maxloglike,logZ,INSlogZ,logZerr,context)

This routine is called after every updInt*10 iterations & at the end of the sampling allowing the posterior 
distribution & parameter constraints to be passed on to the user in the memory. The argument are as follows:

nSamples						= total number of samples in posterior distribution
nlive						     	= total number of live points
nPar						     	= total number of parameters (free + derived)
physLive(nlive, nPar+1) 		     		= 2D array containing the last set of live points (physical parameters plus derived parameters) along with their loglikelihood values
posterior(nSamples, nPar+2)		     		= posterior distribution containing nSamples points. Each sample has nPar parameters (physical + derived) along with the their loglike 
							value & posterior probability
paramConstr(1, 4*nPar):
     paramConstr(1, 1) to paramConstr(1, nPar)	     	= mean values of the parameters
     paramConstr(1, nPar+1) to paramConstr(1, 2*nPar)   = standard deviation of the parameters
     paramConstr(1, nPar*2+1) to paramConstr(1, 3*nPar) = best-fit (maxlike) parameters
     paramConstr(1, nPar*4+1) to paramConstr(1, 4*nPar) = MAP (maximum-a-posteriori) parameters
maxLogLike					    	= maximum loglikelihood value
logZ						     	= log evidence value from the default (non-INS) mode
INSlogZ						     	= log evidence value from the INS mode
logZerr						     	= error on log evidence value
context							not required by MultiNest, any additional information user wants to pass

The 2D arrays are Fortran arrays which are different to C/C++ arrays. In the example dumper routine provided with C & C++
eggbox examples, the Fortran arrays are copied on to C/C++ arrays.

---------------------------------------------------------------------------

Tranformation from hypercube to physical parameters:

MultiNest native space is unit hyper-cube in which all the parameter are uniformly distributed in [0, 1]. User
is required to transform the hypercube parameters to physical parameters. This transformation is described in
Sec 5.1 of arXiv:0809.3437. The routines to tranform hypercube parameters to most commonly used priors are
provided in module priors (in file priors.f90).

---------------------------------------------------------------------------

Checkpointing:

MultiNest is able to checkpoint. It creates [root]resume.dat file & stores information in it after every
updInt iterations to checkpoint, where updInt is set by the user. If you don't want to resume your program from
the last run run then make sure that you either delete [root]resume.dat file or set the parameter resume to F
before starting the sampling.

---------------------------------------------------------------------------

Periodic Boundary Conditions:

In order to sample from parameters with periodic boundary conditions (or wraparound parameters), set pWrap[i],
where i is the index of the parameter to be wraparound, to a non-zero value. If pWrap[i] = 0, then the ith
parameter is not wraparound.

---------------------------------------------------------------------------

Constant Efficiency Mode:

If ceff is set to T, then the enlargement factor of the bounding ellipsoids are tuned so that the sampling
efficiency is as close to the target efficiency (set by efr) as possible. This does mean however, that the
evidence value may not be accurate.

---------------------------------------------------------------------------

Sampling Parameters:

The recommended paramter values to be used with MultiNest are described below. For detailed description please
refer to the paper arXiv:0809.3437

nPar: 
Total no. of parameters, should be equal to ndims in most cases but if you need to store some additional
parameters with the actual parameters then you need to pass them through the likelihood routine.


efr:
defines the sampling efficiency. 0.8 and 0.3 are recommended for parameter estimation & evidence evalutaion
respectively.


tol:
A value of 0.5 should give good enough accuracy.

           
nCdims:
If mmodal is T, MultiNest will attempt to separate out the modes. Mode separation is done through a clustering
algorithm. Mode separation can be done on all the parameters (in which case nCdims should be set to ndims) & it
can also be done on a subset of parameters (in which case nCdims < ndims) which might be advantageous as
clustering is less accurate as the dimensionality increases. If nCdims < ndims then mode separation is done on
the first nCdims parameters.


Ztol:
If mmodal is T, MultiNest can find multiple modes & also specify which samples belong to which mode. It might be
desirable to have separate samples & mode statistics for modes with local log-evidence value greater than a
particular value in which case Ztol should be set to that value. If there isn't any particularly interesting
Ztol value, then Ztol should be set to a very large negative number (e.g. -1.d90).

---------------------------------------------------------------------------

Progress Monitoring:

MultiNest produces [root]physlive.dat & [root]ev.dat files after every updInt iterations which can be used to
monitor the progress. The format & contents of  these two files are as follows:

[root]physlive.dat:
This file contains the current set of live points. It has nPar+2 columns. The first nPar columns are the ndim
parameter values along with the (nPar-ndim)  additional parameters that are being passed by the likelihood
routine for MultiNest to save along with the ndim parameters. The nPar+1 column is the log-likelihood value &
the last column is the node no. (used for clustering).

[root]ev.dat:
This file contains the set of rejected points. It has nPar+3 columns. The first nPar columns are the ndim
parameter values along with the (nPar-ndim)  additional parameters that are being passed by the likelihood
routine for MultiNest to save along with the ndim parameters. The nPar+1 column is the log-likelihood value,
nPar+2 column is the log(prior mass) & the last column  is the node no. (used for clustering).

---------------------------------------------------------------------------

Posterior Files:

These files are created after every updInt*10 iterations of the algorithm & at the end of sampling.

MultiNest will produce five posterior sample files in the root, given by the user, as following


[root].txt
Compatable with getdist with 2+nPar columns. Columns have sample probability, -2*loglikehood, parameter values. 
Sample probability is the sample prior mass multiplied by its likelihood & normalized by the evidence.


[root]post_separate.dat
This file is only created if mmodal is set to T. Posterior samples for modes with local log-evidence value
greater than Ztol, separated by 2 blank lines. Format is the same as [root].txt file.


[root]stats.dat
Contains the global log-evidence, its error & local log-evidence with error & parameter means & standard
deviations as well as the  best fit & MAP parameters of each of the mode found with local log-evidence > Ztol.


[root]post_equal_weights.dat
Contains the equally weighted posterior samples. Columns have parameter values followed by loglike value.


[root]summary.txt
There are nmode+1 (nmode = number of modes) rows in this file. First row has the statistics for the global 
posterior. After the first line there is one row per mode with nPar*4+2 values in each line in this file. 
Each row has the following values in its column mean parameter values, standard deviations of the parameters, 
bestfit (maxlike) parameter values, MAP (maximum-a-posteriori) parameter values, local log-evidence, maximum 
loglike value. If IS = T (i.e. INS being used), first row has an additional value right at the end, INS 
log-evidence estimate.

---------------------------------------------------------------------------

INS Output Files:

In INS mode (when IS = T), MultiNest will produce 3 additional binary files: [root]IS.iterinfo, IS.points, IS.ptprob
These files are used for resuming job with IS (Importance Nested sampling) mode set to T. They can be quite
large and can be deleted once the job has finished.

---------------------------------------------------------------------------

C/C++ Interface:

Starting in MultiNest v2.18 there is a common C/C++ interface to MultiNest.  The file is located in the 
"includes" directory.  Examples of how it may be used are found in the example_eggboxC and 
example_eggboxC++ directories.

You may need to check the symbol table for your platform (nm libmulitnest.a | grep nestrun) and edit the 
multinest.h file to define NESTRUN.  Please let us know of any modifications made so they may be included
in future releases.


---------------------------------------------------------------------------

Python Interface:

Johannes Buchner has written an easy-to-use Python interface to MultiNest called PyMultiNest which 
provides integration with existing scientific Python code (numpy, scipy). It allows you to write Prior & 
likelihood functions in Python. It is available from:

https://github.com/JohannesBuchner/PyMultiNest


---------------------------------------------------------------------------

R Interface:

Johannes Buchner has written an R bridge for MultiNest called RMultiNest. It allows likelihood functions 
written in R (http://www.r-project.org) to be used by MultiNest. It is available from:

https://github.com/JohannesBuchner/RMultiNest


---------------------------------------------------------------------------

Matlab version of MultiNest:

Matthew Pitkin and Joe Romano have created a simple Matlab version of MultiNest. It doesn't have all the 
bells-and-whistles of the full implementation and just uses the basic Algorithm 1 from arXiv:0809.3437. It
is available for download the MultiNest website:

http://ccpforge.cse.rl.ac.uk/gf/project/multinest/


---------------------------------------------------------------------------

Visualization of MultiNest Output:

[root].txt file created by MultiNest is compatable with the format required by getdist package which is 
part of CosmoMC package. Refer to the following website in order to download or get more information about
getdist:
http://cosmologist.info/cosmomc/readme.html#Analysing


Johannes Buchner's PyMultiNest can also be used on exisiting MultiNest output to plot & visualize results.
https://github.com/JohannesBuchner/PyMultiNest


---------------------------------------------------------------------------

Toy Problems

There are 8 toy programs included with MultiNest.

example_obj_detect: The object detection problem discussed in arXiv:0704.3704. The positions, amplitudes &
widths of the Gaussian objects can be modified through params.f90 file. Sampling parameters are also set in
params.f90.

example_gauss_shell: The Gaussian shells problem discussed in arXiv:0809.3437. The dimensionality, positions and
thickness of these shells can be modified through params.f90 file. Sampling parameters are also set in
params.f90.

example_gaussian: The Gaussian shells problem discussed in arXiv:1001.0719. The dimensionality of the problem can 
be modified through params.f90 file. Sampling parameters are also set in params.f90.

example_eggboxC/example_eggboxC++: The C/C++ interface includes the egg box problem discussed in arXiv:0809.3437. 
The toy problem and sampling parameters are set in eggbox.c & eggbox.cc files.

example_ackley: The Ackley mimimization problem (see T. Bäck, Evolutionary Algorithms in Theory and Practice, 
Oxford University Press, New York (1996).)

example_himmelblau: The Himmelblau's minimization problem. (see http://en.wikipedia.org/wiki/Himmelblau's_function)

example_rosenbrock: Rosenbrock minimization problem. (see http://en.wikipedia.org/wiki/Rosenbrock_function)

example_gaussian: Multivariate Gaussian with uncorrelated paramters.

---------------------------------------------------------------------------

Common Problems & FAQs:


1. MultiNest crashes after segmentation fault.

Try increasing the stack size (ulimit -s unlimited on Linux) & resume your job.


2. Output files (.txt & post_equal_weights.dat) files have very few (of order tens) points.

If tol is set to a reasonable value (tol <= 1) & the job hasn't finished then it is possible for these files to 
have very few points in them. If even after the completion of job these files have very few points then increase the stack
size (ulimit -s unlimited on Linux) & resume the job again.


3. Not all modes are being reported in the stats file.

stats file reports all the modes with local log-evidence value greater than Ztol. Set Ztol to a very large 
negative number (e.g. -1.d90) in order for the stats file to report all the modes found.


4. Compilation fails with error something like 'can not find nestrun function'.

Check the symbol table for your platform (nm libnest3.a | grep nestrun) & edit multinest.h file to define NESTRUN
appropriately.


5. When to use the constant efficiency mode?

If the sampling efficiency with the standard MultiNest (when ceff = F) is very low & no. of free parameters is relatively 
high (roughly greater than 30) then constant efficiency mode can be used to get higher sampling efficiency. Users should use
ask for around 5% or lower targer efficiency (efr <= 0.05) in constant efficiency mode & ensure that posteriors are stable 
when a slightly lower value is used for target efficiency. Evidence values obtained with constant efficiency mode will not be
accurate in the default mode (IS = F). With INS (IS = T) accurate evidences can be calculated (read arXiv:1306.2144) for more
details.

---------------------------------------------------------------------------

Importance Nested Sampling:


Sampling Parameters:

INS can calculate an order of magnitude more accurate evidence values than the vanilla nested sampling, for the same number
of live points & target efficiency (efr). INS can also calculate reasonably accurate evidence values in constant efficiency
mode (when ceff = T). However, users should always check that the posterior distributions & evidence values are stable for
reasonable change in these sampling parameters. Potentially users can use fewer live points &/or higher target efficiency
(efr) with INS to get the same level of accuracy on evidence & therefore analysis can be sped-up.


Quoted Error on Log-Evidence:

The quoted error on log-evidence in INS mode is generally an overestimate. Users should use the quoted error on log-evidence
from vanilla nested sampling as an upper bound on the error on INS log-evidence.


Output Files:

In INS mode, MultiNest will produce 3 additional binary output files (see output files section) in which it will record 
information about all the points it has collected. These files can be quite large. It is recommended that the user sets 
updint parameter (which sets the number of iterations after which posterior files are updated) to 1000 or more otherwise 
a lot of time might be wasted in writing these large files. These binary files are only used while resuming jobs & can be
deleted once the job has finished.


Memory Requirements:

INS requires a lot more memory than the defult mode (when IS = F). With nlive <= 1000, memory requirements are feasible on
modern computers but with nlive >= 4000, segfaults may results due to not enough memory available.


Multi-Modal Mode:

Multi-modal mode is not supported yet when IS = T. If mmodal = T along with IS = T, MultiNest will set mmodal = F.

---------------------------------------------------------------------------

PolyChord v 1.14
Will Handley, Mike Hobson & Anthony Lasenby
wh260@mrao.cam.ac.uk
arXiv:1502.01856
arXiv:1506.00171
Released May 2018

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
PolyChord Licence
=================

Users are required to accept the licence agreement given in LICENCE
file. PolyChord is free for academic usage

Users are also required to cite the PolyChord papers: 
arXiv:1502.01856
arXiv:1506.00171
in their publications.

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MPI Support
===========

The code is MPI compatible with openMPI. To disable the MPI parallelization, 
set MPI= in ./Makefile, or compile with
make <target>  MPI=


~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Additional Libraries  
====================

PolyChord requires no additional libraries to run in linear mode
To run with MPI it requires the openMPI library


~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Compilers
=========

PolyChord compiles with both gfortran and intel compilers. 

Compiler type is chosen in the Makefile with the COMPILER_TYPE flag;
set
COMPILER_TYPE = gnu
for gfortran compilers (free)

set
COMPILER_TYPE = intel
for intel compilers (proprietary, much faster)


~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Running PolyChord
=================

Examples
--------
First, try a couple of quick examples:

1) 20 dimensional Gaussian

run the commands:
$  make gaussian
$  ./bin/gaussian ini/gaussian.ini

2) Rastrigin

run the commands:
$ make rastrigin
$ ./bin/rastrigin ini/rastrigin.ini

This runs the rastrigin 'bunch of grapes' loglikelihood.

In general, binary executables are stored in the directory ./bin, and ini files are
stored in the directory ./ini.

You can create new likelihoods by modelling them on the ones in
likelihoods/examples, and triggering them with their own ini files

Alternatively you can take a more "MultiNest" like approach, and manually
generate the prior transformations. PolyChord's settings are then modified in
the driver files src/drivers.


Fortran likelihoods
-------------------
You should place your likelihood code in the function loglikelihood and your
prior code in the function prior, contained in:

./likelihoods/fortran/likelihood.f90 

Any setup required (such as reading in input files) should be conducted in the
function setup_loglikelihood. In most cases, this will likely just be a call
to your own pre-written library.

You should then alter the polychord run-time settings within the driver file:

./src/drivers/polychord_fortran.f90

Your code can be compiled and run with the commands:
$  make polychord_fortran
$  ./bin/polychord_fortran



C++/C likelihoods
-----------------
You should place your likelihood code in the function loglikelihood,
contained in 

./likelihoods/CC/CC_likelihood.cpp

Any setup required (such as reading in input files) should be conducted in the
function setup_loglikelihood.  In most cases, this will likely just be a call
to your own pre-written library.

You should then alter the polychord run-time settings within the driver file:

./src/drivers/polychord_CC.cpp

or use the ini file version:

./likelihoods/CC_ini/CC_ini_likelihood.cpp
./src/drivers/polychord_CC_ini.cpp

Your code can be compiled and run with the commands:
$  make polychord_CC
$  ./bin/polychord_CC 

or

$  make polychord_CC_ini
$  ./bin/polychord_CC_ini ini/gaussian_CC.ini

If you have an additional suggestions to make the c++ wrapper more easy to use, 
please email Will (wh260@mrao.cam.ac.uk).



Python likelihoods (PyPolyChord)
--------------------------------
Being python, this interface is much more self-explanatory. You need to compile
the library with:
$  make PyPolyChord
$  python setup.py install --user

OSX users may need to specify their C compilers to not be clang, e.g:
                                                                     
$ CC=/usr/local/bin/gcc-6 CXX=/usr/local/bin/g++-6  python3 setup.py install --user

You can then import PyPolyChord from anywhere with the lines:
import PyPolyChord

and check that it's working by running:
$  python run_PyPolyChord.py

or in MPI:
$  mpirun -np 4 python run_PyPolyChord.py

If so, the rest of the interface is relatively painless. Follow the example in
run_PyPolyChord.py, and consult the docstring if you need help:
>   import PyPolyChord
>   from PyPolyChord.settings import PolyChordSettings
>
>   help(PyPolyChord.run_polychord)
>   help(PolyChordSettings)



~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Output files 
=============
PolyChord produces several output files depending on which settings
are chosen


[root].stats
------------
Run time statistics

[root].resume
-------------
Files for resuming a stopped run. Semi-human readable.
This is produced if settings%write_resume=.true.
This is used if settings%read_resume=.true.

[root].txt
----------
File containing weighted posterior samples. Compatable with the format
required by getdist package which is part of the CosmoMC package.
Contains ndims+nderived+2 columns:

weight -2*loglike <params> <derived params>

Refer to the following website in order to download or get more
information about getdist:
http://cosmologist.info/cosmomc/readme.html#Analysing

If settings%cluster_posteriors=.true. there are additional cluster files in
clusters/[root]_<integer>.txt 

[root]_equal_weights.txt
------------------------
As above, but the posterior points are equally weighted. This is
better for 'eyeballing' the posterior, and provides a natural ~4 fold
compression of the .txt file. 


[root]_phys_live.txt
--------------------
Live points in the physical space. This is produced if
settings%write_phys_live=.true.
This file contains ndims+nderived+1 columns, indicating the physical
parameters, derived parameters and the log-likelihood. This is useful
for monitoring a run as it progresses. 

[root]_dead.txt
---------------
Points that have been killed off. This is produced if
settings%write_dead=.true.
This file contains ndims+nderived+1 columns, indicating the loglikelihood,
physical parameters, derived parameters and the log-likelihood. This is useful
for monitoring a run as it progresses, and for performing alternative
calculations and checks on evidence and posterior computations

[root].paramnames
-----------------
Parameter names file for compatibility with getdist


[root]phys_live-birth.txt & [root]dead-birth.txt 
------------------------------------------------

These can be used to reconstruct a full nested sampling run, as well as
simulate dynamic nested sampling.  The format & contents of these two files
are as follows: They have has ndims+nderived+2 columns. The first
ndims+nderived columns are the ndim parameter values along with the nderived
additional parameters that are being passed by the likelihood routine for
PolyChord to save along with the ndims parameters. The ndims+nderived+1 column
is the log-likelihood value.  The ndims+nderived+2 column is the log-likelihood
value that the point was born at. They are is identical to the
[root]_phys_live.txt and [root]_dead.txt file, except for an additional column
including the birth contours


~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Visualization of PolyChord Output:

[root].txt file created by PolyChord is compatable with the format
required by getdist package which is part of the CosmoMC package.
Refer to the following website in order to download or get more
information about getdist:
http://getdist.readthedocs.org/en/latest/

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Common Problems & FAQs:


Run time Issues
===============
1. Output files ([root].txt & [root]_equal_weights.dat) files have
very few (of order tens) points.

These files only become populated as the algorithm approaches the
peak(s) of the posterior. Wait for the run to be closer to finishing.


2. MPI doesn't help

* Currently, the MPI parallelisation will only increase speed for 
  'slow' likelihoods, i.e. likelihoods where the slice sampling step
  is the dominant computational cost (compared to the organisation of
  live points and clustering steps). 
* Parallelisation is only effective up to ncores~O(nlive).


Compilation Issues
==================
Most issues are usually one associated with an out-of-date MPI library or
fortran compiler. Ideally you should be using:
* gfortran 4.8    or    ifort 14
* openMPI 1.6.5   or    Intel MPI 4.1

module nested_sampling_module
    use utils_module, only: dp

#ifdef MPI
    use mpi_module, only: get_mpi_information,mpi_bundle,is_root,linear_mode,catch_babies,throw_babies,throw_seed,catch_seed,broadcast_integers,mpi_synchronise
#else
    use mpi_module, only: get_mpi_information,mpi_bundle,is_root,linear_mode
#endif

    implicit none

    !interface NestedSampling
    !    module procedure NestedSampling_with_dumper, NestedSampling_without_dumper
    !end interface NestedSampling


    contains

    !> Main subroutine for computing a generic nested sampling algorithm
    function NestedSampling(loglikelihood,prior, dumper, settings, mpi_communicator) result(output_info)
        use settings_module,   only: program_settings
        use utils_module,      only: logsumexp,calc_similarity_matrix,swap_integers,cyc,time
        use read_write_module
        use feedback_module
        use run_time_module,   only: run_time_info,replace_point,calculate_logZ_estimate,calculate_covmats,delete_cluster,update_posteriors,delete_outermost_point
        use chordal_module,    only: SliceSampling
        use random_module,     only: random_integer,random_direction
        use cluster_module,    only: do_clustering
        use generate_module,   only: GenerateSeed,GenerateLivePoints,GenerateLivePointsFromSeed
#ifdef MPI
        use utils_module, only: normal_fb,stdout_unit
#endif

        implicit none

        ! Program Inputs
        ! ==============      

        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in), dimension(:)  :: theta
                real(dp), intent(out), dimension(:) :: phi
                real(dp) :: loglikelihood
            end function
        end interface
        interface
            function prior(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function
        end interface
        interface
            subroutine dumper(live, dead, logweights, logZ, logZerr)
                import :: dp
                real(dp), intent(in) :: live(:,:), dead(:,:), logweights(:)
                real(dp), intent(in) :: logZ, logZerr
            end subroutine dumper
        end interface

        !> Program settings
        type(program_settings), intent(in) :: settings

        !> MPI handle
        integer, intent(in) :: mpi_communicator
        
        ! Program Outputs
        ! ===============      
        ! 1) log(evidence)
        ! 2) error(log(evidence))
        ! 3) ndead
        ! 4) number of likelihood calls
        ! 5) log(evidence) + log(prior volume)
        real(dp), dimension(4) :: output_info



        ! Local variables
        ! ===============

        ! The run time info
        ! ----------------
        ! very important, see src/run_time_info.f90
        type(run_time_info) :: RTI

        ! The number of repeats within each parameter speed to do
        integer, dimension(size(settings%grade_dims)) :: num_repeats
        integer, dimension(size(settings%grade_dims)) :: nlike      ! Temporary storage for number of likelihood calls
        integer, dimension(size(settings%grade_dims)) :: nlikesum   ! rolling average of number of loglikelihood calls


        ! Temporary variables
        ! -------------------
        ! Seed point to generate babies from
        real(dp), dimension(settings%nTotal) :: seed_point
        ! Cholesky matrix to generate babies from
        real(dp), dimension(settings%nDims,settings%nDims)   :: cholesky
        ! Loglikelihood bound to generate babies from
        real(dp) :: logL
        ! New-born baby points, created by slice sampling routine
        real(dp), allocatable, dimension(:,:) :: baby_points

        integer :: cluster_id ! Cluster identifier


        ! Logical Switches
        ! ----------------
        logical :: temp_logical
        logical :: update

        ! MPI process variable
        ! --------------------
        type(mpi_bundle) :: mpi_information


#ifdef MPI
        ! MPI specific variables
        ! ----------------------
        integer                            :: i_slave       ! Slave iterator
        integer                            :: slave_id      ! Slave identifier
        integer, dimension(:), allocatable :: slave_cluster ! The cluster the slave is currently working on
        real(dp) :: time0,time1,slice_time,wait_time

        ! Slave switch
        ! ------------
        ! This prevents slaves delivering points to incorrect clusters after clustering
        ! has reorganised the cluster indices
        integer ::  slave_epoch
        integer ::  master_epoch
#endif


        ! A) Initialisation
        !    ==============
        ! MPI initialisation
        mpi_information = get_mpi_information(mpi_communicator)

#ifdef MPI
        allocate(slave_cluster(mpi_information%nprocs-1)) ! Allocate the slave arrays
        slave_cluster = 1                          ! initialise with 1

        ! slave switch
        slave_epoch=0
        master_epoch=0
#endif

        ! Rolling loglikelihood calculation
        nlikesum=0


        !-------------------------------------------------------!
        if(is_root(mpi_information)) call write_opening_statement(settings) !
        !-------------------------------------------------------!



        ! Check if we actually want to resume
        if ( settings%read_resume .and. resume_file_exists(settings) ) then 

            ! Read the resume file on root
            if(is_root(mpi_information)) then
                call read_resume_file(settings,RTI) 
                ! -------------------------------------------- !
                call write_resuming(settings%feedback)
                ! -------------------------------------------- !
            end if


        else 
            
            ! Delete any existing files if we're going to be producing our own new ones
            if(is_root(mpi_information)) then
                if(settings%write_resume) call delete_files(settings) 
            end if

            ! Intialise the run by setting all of the relevant run time info, and generating live points
            if (settings%generate_from_seed) then
                call GenerateLivePointsFromSeed(loglikelihood,prior,settings,RTI,mpi_information)
            else
                call GenerateLivePoints(loglikelihood,prior,settings,RTI,mpi_information)
            end if

            if(is_root(mpi_information)) then
                if(settings%write_prior) call write_prior_file(settings,RTI) 
            end if

            if (is_root(mpi_information)) then
                do while(RTI%nlive(1) > settings%nlive )
                    call delete_outermost_point(settings,RTI)
                end do
            end if

            ! Write a resume file (as the generation of live points can be intensive)
            if(is_root(mpi_information)) then
                if(settings%write_resume) then
                    call write_resume_file(settings,RTI) 
                    call rename_files(settings,RTI)
                end if
            end if


        end if 

        if(is_root(mpi_information)) then
            num_repeats = RTI%num_repeats
            call write_num_repeats(num_repeats,settings%feedback)
        end if
#ifdef MPI
        call broadcast_integers(num_repeats,mpi_information)
#endif
        allocate(baby_points(settings%nTotal,sum(num_repeats)))



        ! B) Main loop body
        !    ==============

        if(is_root(mpi_information)) then

            ! -------------------------------------------- !
            call write_started_sampling(settings%feedback) !
            ! -------------------------------------------- !

            do while ( more_samples_needed(settings,RTI)   )


                ! 1) Generate a new live point
                !    -------------------------
                ! Generate a seed point --- update this
                seed_point = GenerateSeed(settings,RTI,cluster_id)

                ! Choose the cholesky decomposition for the cluster
                cholesky = RTI%cholesky(:,:,cluster_id)

                ! Get the loglikelihood contour we're generating from
                logL = RTI%logLp(cluster_id)


                if(linear_mode(mpi_information)) then
                    ! Linear Mode
                    ! -----------

                    ! Generate a new set of points within the likelihood bound of the late point
                    baby_points = SliceSampling(loglikelihood,prior,settings,logL,seed_point,cholesky,nlike,num_repeats)
#ifdef MPI
                else
                    ! Parallel mode
                    ! -------------

                    ! Recieve any new baby points from any slave currently sending
                    slave_id = catch_babies(baby_points,nlike,slave_epoch,mpi_information)

                    ! and throw seeding information back to slave (true => keep going)
                    call throw_seed(seed_point,cholesky,logL,mpi_information,slave_id,master_epoch,.true.)

                    ! set cluster_id to be the cluster identity of the babies just recieved 
                    ! (saved in slave_cluster from the last send) and set slave_cluster to 
                    ! be the bound just sent off.
                    call swap_integers(cluster_id,slave_cluster(slave_id))

#endif
                end if

                ! Add the likelihood calls to our counter
                RTI%nlike = RTI%nlike + nlike
                nlikesum  = nlikesum  + nlike


                ! See if this point is suitable to be added to the arrays
#ifdef MPI
                if( linear_mode(mpi_information) .or. master_epoch==slave_epoch ) then
#endif
                    call replace_point(settings,RTI,baby_points,cluster_id)

                    update = logsumexp(RTI%logXp) <= RTI%logX_last_update + log(settings%compression_factor) 
                    if (update) then
                        RTI%logX_last_update = logsumexp(RTI%logXp)

                        ! Update the posterior array
                        call update_posteriors(settings,RTI)  

                        ! Update the resume files
                        if(settings%write_resume)                  call write_resume_file(settings,RTI)
                        if(settings%write_live)                    call write_phys_live_points(settings,RTI)
                        if(settings%write_dead)                    call write_dead_points(settings,RTI)   
                        if(settings%write_stats)                   call write_stats_file(settings,RTI,nlikesum)
                        if(settings%equals.or.settings%posteriors) call write_posterior_file(settings,RTI)   
                        call rename_files(settings,RTI)
                        call dump(dumper,settings,RTI)

                    end if

                    if(delete_cluster(settings,RTI)) then
#ifdef MPI
                        master_epoch = master_epoch+1
#endif
                    end if! Delete any clusters as necessary
                    if (RTI%ncluster == 0) exit

                    if(update) then
                        !--------------------------------------------!
                        call write_intermediate_results(settings,RTI,nlikesum)
                        nlikesum=0
                        !--------------------------------------------!
                        if(settings%do_clustering) then

                            ! If we want to cluster on sub dimensions, then do this first
                            if(allocated(settings%sub_clustering_dimensions)) then
                                if( do_clustering(settings,RTI,settings%sub_clustering_dimensions) )  then
#ifdef MPI
                                    master_epoch = master_epoch+1
#endif
                                end if
                            end if

                            if( do_clustering(settings,RTI) )  then
#ifdef MPI
                                master_epoch = master_epoch+1
#endif
                            end if
                        end if
                        call calculate_covmats(settings,RTI)
                    end if
#ifdef MPI
                end if
#endif

            end do ! End of main loop body

            ! Clean up the remaining live points
            if(settings%write_resume)                  call write_resume_file(settings,RTI)

            do while(RTI%ncluster > 0)
                call delete_outermost_point(settings,RTI)
                temp_logical = delete_cluster(settings,RTI)
            end do

            call update_posteriors(settings,RTI) 
            if(settings%write_live)                    call write_phys_live_points(settings,RTI)
            if(settings%equals.or.settings%posteriors) call write_posterior_file(settings,RTI)   
            if(settings%write_dead)                    call write_dead_points(settings,RTI)   
            if(settings%write_stats)                   call write_stats_file(settings,RTI,nlikesum)
            call rename_files(settings,RTI)
            call dump(dumper,settings,RTI)

            ! Create the output array
            ! (1) log evidence
            ! (2) variance in the log evidence
            ! (3) Number of dead points
            ! (4) Number of slow likelihood calls
            ! (5) log(evidence * prior volume)
            call calculate_logZ_estimate(RTI,output_info(1),output_info(2))
            output_info(3) = RTI%ndead
            output_info(4) = RTI%nlike(1)

            ! ------------------------------------------------------------ !
            call write_final_results(output_info,settings%feedback)        !
            ! ------------------------------------------------------------ !







            ! C) Clean up
            !    ========

#ifdef MPI
            ! MPI cleanup
            ! -----------
            ! Kill off the final slaves.
            ! If we're done, then clean up by receiving the last piece of
            ! data from each node (and throw it away) and then send a kill signal back to it
            do i_slave=mpi_information%nprocs-1,1,-1

                ! Recieve baby point from slave slave_id
                slave_id = catch_babies(baby_points,nlike,slave_epoch,mpi_information)

                ! Add the likelihood calls to our counter
                RTI%nlike = RTI%nlike + nlike

                ! Send kill signal to slave slave_id (note that we no longer care about seed_point, so we'll just use the last one
                call throw_seed(seed_point,cholesky,logL,mpi_information,slave_id,master_epoch,.false.) 

            end do


        else !(myrank/=root)

            ! These are the slave tasks
            ! -------------------------
            !
            ! This is considerably simpler than that of the master.
            ! All slaves do is:
            ! 1) recieve a seed point,cholesky decomposition and loglikelihood
            !    contour from the master
            ! 2) using the above, generate a new set of baby points
            ! 3) send the baby points and nlike back to the master.


            ! On the first loop, send a nonsense set of baby_points
            ! to indicate that we're ready to start receiving

            baby_points = 0d0                              ! Avoid sending nonsense
            baby_points(settings%l0,:) = settings%logzero  ! zero contour to ensure these are all thrown away
            nlike = 0                                      ! no likelihood calls in this round
            call throw_babies(baby_points,nlike,slave_epoch,mpi_information)
            wait_time = 0
            slice_time = 0
            time1 = time()




            ! 1) Listen for a seed point being sent by the master
            !    Note that this also tests for a kill signal sent by the master
            do while(catch_seed(seed_point,cholesky,logL,slave_epoch,mpi_information))
                time0 = time()
                ! 2) Generate a new set of baby points
                baby_points = SliceSampling(loglikelihood,prior,settings,logL,seed_point,cholesky,nlike,num_repeats)


                wait_time = wait_time + time0-time1
                time1 = time()
                slice_time = slice_time + time1-time0


                ! 3) Send the baby points back
                call throw_babies(baby_points,nlike,slave_epoch,mpi_information)

            end do

            if(slice_time<wait_time) then
                if(settings%feedback>=normal_fb) write(stdout_unit,'("Slave",I3,": Inefficient MPI parallisation, I spend more time waiting than slicing ", E17.8, ">", E17.8 )') mpi_information%rank, wait_time,slice_time
            else
                if(settings%feedback>=normal_fb) write(stdout_unit,'("Slave",I3,": efficient MPI parallisation; wait_time/slice_time= ", E17.8 )') mpi_information%rank, wait_time/slice_time 
            end if

#endif
        end if !(myrank==root / myrank/=root) 

#ifdef MPI
        call mpi_synchronise(mpi_information)
#endif




    end function NestedSampling


    !> This function checks whether we've done enough to stop
    function more_samples_needed(settings,RTI)
        use settings_module,   only: program_settings
        use run_time_module,   only: run_time_info,live_logZ
        implicit none

        type(program_settings), intent(in) :: settings
        type(run_time_info), intent(inout) :: RTI

        logical :: more_samples_needed

        ! Set it to default to true
        more_samples_needed = .true.

        ! If we've put a maximum number of iterations on the algorithm, then
        ! we'll stop if we've reached that number. 
        ! If we don't want a maximum number of iterations, then max_ndead should
        ! be set negative or 0
        if(settings%max_ndead>0 .and. RTI%ndead >= settings%max_ndead) then
            more_samples_needed = .false. 
            return
        end if

        ! If the evidence in the live points is less than precision_criterion %
        ! of the total accumulated evidence, then stop.
        if( live_logZ(settings,RTI) < log(settings%precision_criterion) + RTI%logZ )  then
            more_samples_needed = .false.
            return
        end if


    end function more_samples_needed


    subroutine dump(dumper, settings, RTI)
        use settings_module,   only: program_settings
        use run_time_module,   only: run_time_info, calculate_logZ_estimate
        use utils_module,      only: logsumexp
        implicit none
        type(run_time_info), intent(in) :: RTI
        type(program_settings), intent(in) :: settings

        interface
            subroutine dumper(live, dead, logweights, logZ, logZerr)
                import :: dp
                real(dp), intent(in) :: live(:,:), dead(:,:), logweights(:)
                real(dp), intent(in) :: logZ, logZerr
            end subroutine dumper
        end interface

        real(dp), dimension(settings%nDims+settings%nDerived+2,sum(RTI%nlive)) :: live
        real(dp), dimension(settings%nDims+settings%nDerived+2,RTI%ndead) :: dead
        real(dp), dimension(RTI%ndead) :: logweights
        real(dp) :: logZ, varlogZ

        integer i_cluster, nlive,n0,n1

        dead(1:settings%nDims,:) = RTI%dead(settings%p0:settings%p1,:RTI%ndead)
        dead(settings%nDims+1:settings%nDims+settings%nDerived,:) = RTI%dead(settings%d0:settings%d1,:RTI%ndead)
        dead(settings%nDims+settings%nDerived+1,:) = RTI%dead(settings%b0,:RTI%ndead)
        dead(settings%nDims+settings%nDerived+2,:) = RTI%dead(settings%l0,:RTI%ndead)

        logweights = RTI%logweights(:RTI%ndead) + RTI%dead(settings%l0,:RTI%ndead)
        logweights = logweights - logsumexp(logweights)

        do i_cluster=1,RTI%ncluster
            nlive = RTI%nlive(i_cluster)
            n0 = 1+sum(RTI%nlive(:i_cluster-1))
            n1 = sum(RTI%nlive(:i_cluster))
            live(1:settings%nDims,n0:n1) = RTI%live(settings%p0:settings%p1,:nlive,i_cluster)
            live(settings%nDims+1:settings%nDims+settings%nDerived,n0:n1) = RTI%live(settings%d0:settings%d1,:nlive,i_cluster)
            live(settings%nDims+settings%nDerived+1,n0:n1) = RTI%live(settings%b0,:nlive,i_cluster)
            live(settings%nDims+settings%nDerived+2,n0:n1) = RTI%live(settings%l0,:nlive,i_cluster)
        end do
        call calculate_logZ_estimate(RTI,logZ,varlogZ)
        call dumper(live, dead, logweights, logZ, sqrt(varlogZ))


    end subroutine dump





end module nested_sampling_module

module array_module
    use utils_module, only: dp

    interface add_point
        module procedure add_point_3d, add_point_2d
    end interface add_point
    interface delete_point
        module procedure delete_point_3d, delete_point_2d
    end interface delete_point
    interface reallocate
        module procedure reallocate_1_d, reallocate_2_d, reallocate_3_d, reallocate_1_i
    end interface reallocate
    contains

    !> Reallocate a 1D array of doubles
    !!
    !! The array is allocated with a new size defined by new_size1 (optional variable)
    !!
    !! The indices to be transferred across are defined by save_indices1 (optional variable)
    !!
    !! The positions of the data in the reallocated array are defined by target_indices1 (optional variable)
    subroutine reallocate_1_d(array,new_size1,save_indices1,target_indices1)
        use abort_module, only: halt_program
        implicit none
        real(dp), dimension(:),allocatable, intent(inout) :: array !> Array to be reallocated
        integer, intent(in),optional :: new_size1                          !> New size of the array
        integer, dimension(:),intent(in),optional :: save_indices1         !> indices of old array to be transferred
        integer, dimension(:),intent(in),optional :: target_indices1       !> new array indices after reallocation

        ! Temporary versions of the above variables
        real(dp), dimension(size(array,1)) :: a
        integer :: n1
        integer, allocatable, dimension(:) :: s1
        integer, allocatable, dimension(:) :: t1

        ! constructor variable
        integer :: i

        ! Check to see that it is already allocated
        if(.not.allocated(array)) call halt_program('reallocate_1_d error: array is not allocated') 

        ! Define the new size of the array
        if( present(new_size1) ) then
            n1 = new_size1     ! If the argument is present, then this is the reallocation size
        else
            n1 = size(array,1) ! Default reallocation size is the size of the original array
        end if

        ! Define the positions of where data is coming from and going to
        if(present(save_indices1) .and. present(target_indices1)) then
            s1 = save_indices1
            t1 = target_indices1
            if(size(s1)/=size(t1)) call halt_program('reallocate_1_d error: save and target indices must be equal in size') 
        else if(present(save_indices1)) then
            s1 = save_indices1
            t1 = [ (i,i=1,size(s1)) ]
        else if(present(target_indices1)) then
            t1 = target_indices1
            s1 = [ (i,i=1,size(t1)) ]
        else
            s1 = [ (i,i=1,size(array,1)) ]
            t1 = [ (i,i=1,size(array,1)) ]
        end if

        a = array                           ! Save the old array 
        deallocate(array)                   ! Deallocate it      
        allocate(array(n1))                 ! Re-allocate with new size
        array(t1) = a(s1)                   ! Reassign the old values

    end subroutine reallocate_1_d


    !> Reallocate a 2D array of doubles
    !!
    !! The array is allocated with a new size defined by new_size1,new_size2 (optional variables)
    !!
    !! The indices to be transferred across are defined by save_indices1,save_indices2 (optional variables)
    !!
    !! The positions of the data in the reallocated array are defined by target_indices1,target_indices2, (optional variables)
    subroutine reallocate_2_d(array,new_size1,new_size2,save_indices1,save_indices2,target_indices1,target_indices2)
        use abort_module, only: halt_program
        implicit none
        !> Array to be reallocated
        real(dp), dimension(:,:),allocatable, intent(inout) :: array
        !> New size of the array 
        integer, intent(in),optional :: new_size1,new_size2
        !> indices of old array to be transferred
        integer, dimension(:),intent(in),optional :: save_indices1,save_indices2
        !> new array indices after reallocation 
        integer, dimension(:),intent(in),optional :: target_indices1,target_indices2

        ! Temporary versions of the above variables
        real(dp), dimension(size(array,1),size(array,2)) :: a
        integer :: n1,n2
        integer, allocatable, dimension(:) :: s1,s2
        integer, allocatable, dimension(:) :: t1,t2

        ! constructor variable
        integer :: i

        ! Check to see that it is already allocated
        if(.not.allocated(array)) call halt_program('reallocate_2_d error: array is not allocated') 

        ! Define the new size of the array
        if( present(new_size1) ) then
            n1 = new_size1     ! If the argument is present, then this is the reallocation size
        else
            n1 = size(array,1) ! Default reallocation size is the size of the original array
        end if
        if( present(new_size2) ) then
            n2 = new_size2     ! If the argument is present, then this is the reallocation size
        else
            n2 = size(array,2) ! Default reallocation size is the size of the original array
        end if

        ! Define the positions of where data is coming from and going to
        if(present(save_indices1) .and. present(target_indices1)) then
            s1 = save_indices1
            t1 = target_indices1
            if(size(s1)/=size(t1)) call halt_program('reallocate_2_d error: save and target indices must be equal in size') 
        else if(present(save_indices1)) then
            s1 = save_indices1
            t1 = [ (i,i=1,size(s1)) ]
        else if(present(target_indices1)) then
            t1 = target_indices1
            s1 = [ (i,i=1,size(t1)) ]
        else
            s1 = [ (i,i=1,size(array,1)) ] 
            t1 = [ (i,i=1,size(array,1)) ] 
        end if


        ! Define the positions of where data is coming from and going to
        if(present(save_indices2) .and. present(target_indices2)) then
            s2 = save_indices2
            t2 = target_indices2
            if(size(s2)/=size(t2)) call halt_program('reallocate_2_d error: save and target indices must be equal in size') 
        else if(present(save_indices2)) then
            s2 = save_indices2
            t2 = [ (i,i=1,size(s2)) ]
        else if(present(target_indices2)) then
            t2 = target_indices2
            s2 = [ (i,i=1,size(t2)) ]
        else
            s2 = [ (i,i=1,size(array,2)) ] 
            t2 = [ (i,i=1,size(array,2)) ] 
        end if

        a = array                           ! Save the old array 
        deallocate(array)                   ! Deallocate it      
        allocate(array(n1,n2))              ! Re-allocate with new size
        array(t1,t2)= a(s1,s2)              ! Reassign the old values

    end subroutine reallocate_2_d


    !> Reallocate a 3D array of doubles
    !!
    !! The array is allocated with a new size defined by new_size1,new_size2,new_size3 (optional variables)
    !!
    !! The indices to be transferred across are defined by save_indices1,save_indices2,save_indices3 (optional variables)
    !!
    !! The positions of the data in the reallocated array are defined by target_indices1,target_indices2,target_indices3 (optional variables)
    subroutine reallocate_3_d(array,&
                                new_size1,new_size2,new_size3,&
                                save_indices1,save_indices2,save_indices3,&
                                target_indices1,target_indices2,target_indices3)
        use abort_module, only: halt_program
        implicit none
        !> Array to be reallocated
        real(dp), dimension(:,:,:),allocatable, intent(inout) :: array
        !> New size of the array 
        integer, intent(in),optional :: new_size1,new_size2,new_size3
        !> indices of old array to be transferred
        integer, dimension(:),intent(in),optional :: save_indices1,save_indices2,save_indices3
        !> new array indices after reallocation 
        integer, dimension(:),intent(in),optional :: target_indices1,target_indices2,target_indices3

        ! Temporary versions of the above variables
        real(dp), dimension(size(array,1),size(array,2),size(array,3)) :: a
        integer :: n1,n2,n3
        integer, allocatable, dimension(:) :: s1,s2,s3
        integer, allocatable, dimension(:) :: t1,t2,t3

        ! constructor variable
        integer :: i

        ! Check to see that it is already allocated
        if(.not.allocated(array)) call halt_program('reallocate_3_d error: array is not allocated') 

        ! Define the new size of the array
        if( present(new_size1) ) then
            n1 = new_size1     ! If the argument is present, then this is the reallocation size
        else
            n1 = size(array,1) ! Default reallocation size is the size of the original array
        end if
        if( present(new_size2) ) then
            n2 = new_size2     ! If the argument is present, then this is the reallocation size
        else
            n2 = size(array,2) ! Default reallocation size is the size of the original array
        end if
        if( present(new_size3) ) then
            n3 = new_size3     ! If the argument is present, then this is the reallocation size
        else
            n3 = size(array,3) ! Default reallocation size is the size of the original array
        end if

        ! Define the positions of where data is coming from and going to
        if(present(save_indices1) .and. present(target_indices1)) then
            s1 = save_indices1
            t1 = target_indices1
            if(size(s1)/=size(t1)) call halt_program('reallocate_3_d error: save and target indices must be equal in size') 
        else if(present(save_indices1)) then
            s1 = save_indices1
            t1 = [ (i,i=1,size(s1)) ]
        else if(present(target_indices1)) then
            t1 = target_indices1
            s1 = [ (i,i=1,size(t1)) ]
        else
            s1 = [ (i,i=1,size(array,1)) ] 
            t1 = [ (i,i=1,size(array,1)) ] 
        end if


        ! Define the positions of where data is coming from and going to
        if(present(save_indices2) .and. present(target_indices2)) then
            s2 = save_indices2
            t2 = target_indices2
            if(size(s2)/=size(t2)) call halt_program('reallocate_3_d error: save and target indices must be equal in size') 
        else if(present(save_indices2)) then
            s2 = save_indices2
            t2 = [ (i,i=1,size(s2)) ]
        else if(present(target_indices2)) then
            t2 = target_indices2
            s2 = [ (i,i=1,size(t2)) ]
        else
            s2 = [ (i,i=1,size(array,2)) ] 
            t2 = [ (i,i=1,size(array,2)) ] 
        end if


        ! Define the positions of where data is coming from and going to
        if(present(save_indices3) .and. present(target_indices3)) then
            s3 = save_indices3
            t3 = target_indices3
            if(size(s3)/=size(t3)) call halt_program('reallocate_3_d error: save and target indices must be equal in size') 
        else if(present(save_indices3)) then
            s3 = save_indices3
            t3 = [ (i,i=1,size(s3)) ]
        else if(present(target_indices3)) then
            t3 = target_indices3
            s3 = [ (i,i=1,size(t3)) ]

        else
            s3 = [ (i,i=1,size(array,3)) ] 
            t3 = [ (i,i=1,size(array,3)) ] 
        end if


        a = array                           ! Save the old array 
        deallocate(array)                   ! Deallocate it      
        allocate(array(n1,n2,n3))           ! Re-allocate with new size
        array(t1,t2,t3)= a(s1,s2,s3)        ! Reassign the old values

    end subroutine reallocate_3_d




    !> Reallocate a 1D array of integers
    !!
    !! The array is allocated with a new size defined by new_size1 (optional variable)
    !!
    !! The indices to be transferred across are defined by save_indices1 (optional variable)
    !!
    !! The positions of the data in the reallocated array are defined by target_indices1 (optional variable)
    subroutine reallocate_1_i(array,new_size1,save_indices1,target_indices1)
        use abort_module, only: halt_program
        implicit none
        integer,          dimension(:),allocatable, intent(inout) :: array !> Array to be reallocated
        integer, intent(in),optional :: new_size1                          !> New size of the array
        integer, dimension(:),intent(in),optional :: save_indices1         !> indices of old array to be transferred
        integer, dimension(:),intent(in),optional :: target_indices1       !> new array indices after reallocation

        ! Temporary versions of the above variables
        integer, dimension(size(array,1)) :: a
        integer :: n1
        integer, allocatable, dimension(:) :: s1
        integer, allocatable, dimension(:) :: t1

        ! constructor variable
        integer :: i

        ! Check to see that it is already allocated
        if(.not.allocated(array)) call halt_program('reallocate_1_i error: array is not allocated') 

        ! Define the new size of the array
        if( present(new_size1) ) then
            n1 = new_size1     ! If the argument is present, then this is the reallocation size
        else
            n1 = size(array,1) ! Default reallocation size is the size of the original array
        end if

        ! Define the positions of where data is coming from and going to
        if(present(save_indices1) .and. present(target_indices1)) then
            s1 = save_indices1
            t1 = target_indices1
            if(size(s1)/=size(t1)) call halt_program('reallocate_1_i error: save and target indices must be equal in size') 
        else if(present(save_indices1)) then
            s1 = save_indices1
            t1 = [ (i,i=1,size(s1)) ]
        else if(present(target_indices1)) then
            t1 = target_indices1
            s1 = [ (i,i=1,size(t1)) ]
        else
            s1 = [ (i,i=1,size(array,1)) ] 
            t1 = [ (i,i=1,size(array,1)) ] 
        end if

        a = array                           ! Save the old array 
        deallocate(array)                   ! Deallocate it      
        allocate(array(n1))                 ! Re-allocate with new size
        array(t1) = a(s1)                   ! Reassign the old values

    end subroutine reallocate_1_i





















    subroutine add_point_3d(point,array,narray,cluster_id)
        implicit none
        real(dp), dimension(:), intent(in) :: point                     !> Point to be added to end of array
        real(dp), dimension(:,:,:), allocatable, intent(inout) :: array !> Array to be added to
        integer,dimension(:), allocatable, intent(inout) :: narray              !> number of points in array (second index)
        integer, intent(in) :: cluster_id                                       !> cluster identity (third index)
        integer :: newsize2

        narray(cluster_id) = narray(cluster_id) + 1         ! Increase the number of points in the cluster

        ! If this takes us over the size of the array, then double it
        newsize2 = max(1,size(array,2)*2)
        if(narray(cluster_id) > size(array,2) ) call reallocate(array, new_size2=newsize2 )

        array(:,narray(cluster_id),cluster_id) = point       ! Add the point to the end position

    end subroutine add_point_3d

    subroutine add_point_2d(point,array,narray)
        implicit none
        real(dp), dimension(:), intent(in) :: point                   !> Point to be added to end of array
        real(dp), dimension(:,:), allocatable, intent(inout) :: array !> Array to be added to
        integer, intent(inout) :: narray                                      !> number of points in array (second index)
        integer :: newsize2

        narray = narray + 1         ! Increase the number of points

        ! If this takes us over the size of the array, then double it
        newsize2 = max(1,size(array,2)*2)
        if(narray > size(array,2) ) call reallocate(array, new_size2=newsize2 )

        array(:,narray) = point       ! Add the point to the end position

    end subroutine add_point_2d



    function delete_point_3d(i_point,array,narray,cluster_id) result(point)
        implicit none
        integer, intent(in) :: i_point                                          !> Position of point to be deleted from array
        real(dp), dimension(:,:,:), allocatable, intent(inout) :: array !> Array to be delete from
        integer,dimension(:), allocatable, intent(inout) :: narray              !> number of points in array (second index)
        integer, intent(in) :: cluster_id                                       !> cluster identity (third index)
        real(dp), dimension(size(array,1)) :: point                     ! The point we have just deleted

        point = array(:,i_point,cluster_id)                                  ! Output the point to be deleted
        array(:,i_point,cluster_id) = array(:,narray(cluster_id),cluster_id) ! delete the point by overwriting it with the point at the end 
        narray(cluster_id) = narray(cluster_id) - 1                          ! reduce the number of points in the cluster

    end function delete_point_3d

    function delete_point_2d(i_point,array,narray) result(point)
        implicit none
        integer, intent(in) :: i_point                                          !> Position of point to be deleted from array
        real(dp), dimension(:,:), allocatable, intent(inout) :: array   !> Array to be delete from
        integer, intent(inout) :: narray                                        !> number of points in array (second index)
        real(dp), dimension(size(array,1)) :: point                     ! The point we have just deleted

        point = array(:,i_point)           ! Output the point to be deleted
        array(:,i_point) = array(:,narray) ! delete the point by overwriting it with the point at the end 
        narray = narray - 1                ! reduce the number of points in the cluster

    end function delete_point_2d




end module array_module

function setup(options) result(result)
        USE cosmosis_modules
        implicit none
        integer(cosmosis_block), value :: options
        integer result
        result = 0
end function setup


function execute(block, config) result(status)
	use cosmosis_modules
	integer(cosmosis_block), value :: block
	integer(cosmosis_status) :: status
	type(c_ptr), value :: config
	integer, parameter :: nx = 10, ny=5
	real(8), dimension(nx) :: x
	real(8), dimension(ny) :: y
	real(8), dimension(nx, ny) :: z

	real(8), dimension(:), allocatable :: x_c, y_c, x_py, y_py
	real(8), dimension(:,:), allocatable :: z_c, z_py

	integer i,j;

	x = (/ -1.0, -2.0, -3.0, -4.0, -5.0, -6.0, -7.0, -8.0, -9.0, -10.  /)
	y = (/ -2.0, -4.0, -8.0, -16.0, -32.0  /)
	do i=1,nx
		do j=1,ny
			z(i,j) = 10*(i-1)+(j-1)
		enddo
	enddo

	status = datablock_put_double_grid(block, "f90_put", "x", x, "y", y, "z", z)
	if (status .ne. 0) write(*,*) "Failed to put in f90"

	status = datablock_get_double_grid(block, "c_put", "x", x_c, "y", y_c, "z", z_c)
	if (status == 0) then
		if (.not. all(shape(x)==shape(x_c))) write(*,*) "X C SHAPE WRONG!"
		if (.not. all(shape(y)==shape(y_c))) write(*,*) "Y C SHAPE WRONG!"
		if (.not. all(shape(z)==shape(z_c))) write(*,*) "Z C SHAPE WRONG!"
		if (.not. all(x_c==x)) write(*,*) "X C IS WRONG!"
		if (.not. all(y_c==y)) write(*,*) "Y C IS WRONG!"
		if (.not. all(z_c==z)) write(*,*) "Z C IS WRONG!"
	else
		write(*,*) "Failed to get C in f90", status
	endif

	status = datablock_get_double_grid(block, "py_put", "x", x_py, "y", y_py, "z", z_py)
	if (status == 0) then
		if (.not. all(shape(x)==shape(x_py))) write(*,*) "X PY SHAPE WRONG!"
		if (.not. all(shape(y)==shape(y_py))) write(*,*) "Y PY SHAPE WRONG!"
		if (.not. all(shape(z)==shape(z_py))) write(*,*) "Z PY SHAPE WRONG!"
		if (.not. all(x_py==x)) write(*,*) "X PY IS WRONG!"
		if (.not. all(y_py==y)) write(*,*) "Y PY IS WRONG!"
		if (.not. all(z_py==z)) write(*,*) "Z PY IS WRONG!"
	else
		write(*,*) "Failed to get py in f90", status
	endif


	status = 0



end function execute


function cleanup(options) result(result)
        USE cosmosis_modules
        implicit none
        integer(cosmosis_block), value :: options
        integer result
        result = 0
end function cleanup

module run_time_module
    use utils_module, only: dp
    implicit none

    !> The run time information.
    !!
    !! This is what needs to be saved in order to resume a run.
    !! Bundling these all into the same type enables easy passing of data 
    !! from one fuction to another
    type run_time_info

        !> Number of dead points
        integer :: ndead

        !> The number currently evolving clusters
        integer :: ncluster
        !> The number of dead clusters
        integer :: ncluster_dead

        !> Total number of likelihood calls
        integer,allocatable,dimension(:) :: nlike

        !> The number of repeats within each parameter speed to do
        integer,allocatable, dimension(:)           :: num_repeats

        !> The number of live points in each cluster
        integer, allocatable, dimension(:) :: nlive 
        !> The number of phantom points in each cluster
        integer, allocatable, dimension(:) :: nphantom
        !> The number of weighted posterior points in each cluster
        integer, allocatable, dimension(:) :: nposterior
        !> The number of equally weighted posterior points in each cluster
        integer, allocatable, dimension(:) :: nequals


        integer, allocatable, dimension(:) :: nposterior_dead
        integer                            :: nposterior_global
        integer, allocatable, dimension(:) :: nequals_dead
        integer                            :: nequals_global

        !> Live points
        real(dp), allocatable, dimension(:,:,:) :: live
        !> Phantom points
        real(dp), allocatable, dimension(:,:,:) :: phantom
        !> Posterior stack
        real(dp), allocatable, dimension(:,:,:) :: posterior_stack
        !> The number of posterior points in each cluster in the posterior stack
        integer, allocatable, dimension(:) :: nposterior_stack


        !> weighted posterior points
        real(dp), allocatable, dimension(:,:,:) :: posterior
        real(dp), allocatable, dimension(:,:,:) :: posterior_dead
        real(dp), allocatable, dimension(:,:)   :: posterior_global

        !> Equally weighted posterior points
        real(dp), allocatable, dimension(:,:,:) :: equals
        real(dp), allocatable, dimension(:,:,:) :: equals_dead
        real(dp), allocatable, dimension(:,:)   :: equals_global

        !> Pure nested sampling points
        real(dp), allocatable, dimension(:,:)   :: dead
        real(dp), allocatable, dimension(:)     :: logweights

        !> Covariance Matrices
        real(dp), allocatable, dimension(:,:,:) :: covmat
        !> Cholesky decompositions
        real(dp), allocatable, dimension(:,:,:) :: cholesky


        !> Global evidence estimate
        real(dp) :: logZ
        !> Global evidence^2 estimate
        real(dp) :: logZ2


        !> Local volume estimate
        real(dp), allocatable, dimension(:)   :: logXp
        !> Volume at last update
        real(dp)                              :: logX_last_update
        !> global evidence volume cross correlation
        real(dp), allocatable, dimension(:)   :: logZXp
        !> Local evidence estimate
        real(dp), allocatable, dimension(:)   :: logZp
        real(dp), allocatable, dimension(:)   :: logZp_dead
        !> Local evidence^2 estimate 
        real(dp), allocatable, dimension(:)   :: logZp2
        real(dp), allocatable, dimension(:)   :: logZp2_dead
        !> local evidence volume cross correlation
        real(dp), allocatable, dimension(:)   :: logZpXp
        !> local volume cross correlation
        real(dp), allocatable, dimension(:,:) :: logXpXq

        !> Minimum loglikelihoods
        real(dp), allocatable, dimension(:) :: logLp
        !> The minimum loglikelihood point within each cluster
        integer,allocatable, dimension(:)           :: i

        !> Maximum weight
        real(dp), allocatable, dimension(:) :: maxlogweight
        real(dp), allocatable, dimension(:) :: maxlogweight_dead
        real(dp)                            :: maxlogweight_global

        !> what to thin the posterior by
        real(dp) :: thin_posterior

    end type run_time_info

    contains

    !> This is a self explanatory subroutine.
    !!
    !! It allocates the arrays for a single cluster 
    subroutine initialise_run_time_info(settings,RTI)
        use utils_module,    only: identity_matrix
        use settings_module, only: program_settings

        implicit none
        !> Program settings
        type(program_settings), intent(in) :: settings
        !> Run time information
        type(run_time_info),intent(out) :: RTI

        ! Allocate all of the arrays with one cluster
        RTI%ncluster = 1
        RTI%ncluster_dead = 0
        allocate(                                                       &
            RTI%live(settings%nTotal,settings%nlive,1),                 &
            RTI%dead(settings%nTotal,settings%nlive),                   &
            RTI%logweights(settings%nlive),                             &
            RTI%phantom(settings%nTotal,settings%nlive,1),              &
            RTI%posterior_stack(settings%nposterior,settings%nlive,1),  &
            RTI%posterior(settings%nposterior,settings%nlive,1),        &
            RTI%posterior_dead(settings%nposterior,settings%nlive,0),   &
            RTI%posterior_global(settings%nposterior,settings%nlive),   &
            RTI%equals(settings%np,settings%nlive,1),                   &
            RTI%equals_dead(settings%np,settings%nlive,0),              &
            RTI%equals_global(settings%np,settings%nlive),              &
            RTI%logZp(1),                                               &
            RTI%logZp_dead(0),                                          &
            RTI%logXp(1),                                               &
            RTI%logZXp(1),                                              &
            RTI%logZp2(1),                                              &
            RTI%logZp2_dead(0),                                         &
            RTI%logZpXp(1),                                             &
            RTI%logXpXq(1,1),                                           &
            RTI%logLp(1),                                               &
            RTI%i(1),                                                   &
            RTI%nlive(1),                                               &
            RTI%nphantom(1),                                            &
            RTI%nposterior_stack(1),                                    &
            RTI%nposterior(1),                                          &
            RTI%nposterior_dead(0),                                     &
            RTI%nequals(1),                                             &
            RTI%nequals_dead(0),                                        &
            RTI%maxlogweight(1),                                        &
            RTI%maxlogweight_dead(0),                                   &
            RTI%cholesky(settings%nDims,settings%nDims,1),              &
            RTI%covmat(settings%nDims,settings%nDims,1),                &
            RTI%num_repeats(size(settings%grade_dims)),                 &
            RTI%nlike(size(settings%grade_dims))                        &
            )

        ! All evidences set to logzero
        RTI%logZ=settings%logzero
        RTI%logZ2=settings%logzero
        RTI%logZp=settings%logzero
        RTI%logZXp=settings%logzero
        RTI%logZp2=settings%logzero
        RTI%logZpXp=settings%logzero

        ! All volumes set to 1
        RTI%logXp=0d0
        RTI%logXpXq=0d0
        RTI%logX_last_update = 0d0

        !Initially no live points at all
        RTI%nlive=0
        RTI%nphantom=0
        RTI%nposterior_stack=0
        RTI%nposterior=0
        RTI%nequals=0
        RTI%nposterior_global=0
        RTI%nequals_global=0

        !No likelihood calls
        RTI%nlike=0

        !No dead points
        RTI%ndead=0

        !Cholesky and covmat set to identity
        RTI%cholesky(:,:,1) = identity_matrix(settings%nDims)
        RTI%covmat(:,:,1)   = identity_matrix(settings%nDims)

        ! Loglikelihoods at zero
        RTI%logLp = settings%logzero
        ! First position default lowest
        RTI%i     = 0

        ! maximum logweight
        RTI%maxlogweight = settings%logzero
        RTI%maxlogweight_dead = settings%logzero
        RTI%maxlogweight_global = settings%logzero

        RTI%thin_posterior = 0d0


    end subroutine initialise_run_time_info

    function update_evidence(RTI,p) result(logweight)
        use utils_module, only: logsumexp,logincexp
        implicit none

        !> The variable containing all of the runtime information
        type(run_time_info), intent(inout) :: RTI

        !> The cluster index to update
        integer :: p

        ! The loglikelihood to update
        real(dp) :: logL

        ! The logweight of the deleted point
        real(dp) :: logweight

        ! Iterator
        integer :: q

        ! Temporary variables for notational ease
        real(dp),parameter :: log2 = log(2d0)
        real(dp) :: lognp
        real(dp) :: lognp1
        real(dp) :: lognp2

        logL  = RTI%logLp(p)

        lognp = log( RTI%nlive(p) + 0d0 )
        lognp1= log( RTI%nlive(p) + 1d0 )
        lognp2= log( RTI%nlive(p) + 2d0 )

        ! Output the logweight
        logweight =  RTI%logXp(p) - lognp1

        ! Global evidence
        call logincexp( RTI%logZ,      RTI%logXp(p)+logL-lognp1  )
        ! Local evidence
        call logincexp( RTI%logZp(p) , RTI%logXp(p)+logL-lognp1  )
        ! Local volume
        RTI%logXp(p)  = RTI%logXp(p) + lognp - lognp1


        ! Global evidence error
        call logincexp( RTI%logZ2 ,                             &
            log2 + RTI%logZXp(p)     +   logL - lognp1,         &
            log2 + RTI%logXpXq(p,p)  + 2*logL - lognp1 - lognp2 &
            )

        ! global evidence volume cross correlation p=p
        RTI%logZXp(p) = RTI%logZXp(p) + lognp - lognp1
        call logincexp( RTI%logZXp(p),                       &
            RTI%logXpXq(p,p)+ logL + lognp - lognp1 - lognp2 &
            )

        ! global evidence volume cross correlation p/=q
        do q=1,RTI%ncluster
            if(p/=q) call logincexp( RTI%logZXp(q) , RTI%logXpXq(p,q)+ logL - lognp1 )
        end do


        ! Local evidence error
        call logincexp( RTI%logZp2(p),                          &
            log2 + RTI%logZpXp(p)    +   logL - lognp1,         &
            log2 + RTI%logXpXq(p,p)  + 2*logL - lognp1 - lognp2 &
            )


        ! Local evidence volume cross correlation
        RTI%logZpXp(p) = RTI%logZpXp(p) + lognp - lognp1
        call logincexp( RTI%logZpXp(p) ,                     &
            RTI%logXpXq(p,p)+ logL + lognp - lognp1 - lognp2 &
            )


        ! Local volume cross correlation (p=p)
        RTI%logXpXq(p,p) = RTI%logXpXq(p,p) + lognp - lognp2

        ! Local volume cross correlation (p=q)
        do q=1,RTI%ncluster
            if(p/=q) then
                RTI%logXpXq(p,q) = RTI%logXpXq(p,q) + lognp - lognp1
                RTI%logXpXq(q,p) = RTI%logXpXq(q,p) + lognp - lognp1
            end if
        end do

    end function update_evidence

    !> This function takes the evidence info in cluster p and splits it into
    !! several clusters according to the cluster numbers ni.
    !!
    !! It places these new clusters at the end of the active array, and deletes the old cluster
    !!
    subroutine add_cluster(settings,RTI,p,cluster_list,num_new_clusters) 
        use settings_module, only: program_settings
        use utils_module, only: logsumexp,logaddexp
        use array_module, only: reallocate,add_point
        implicit none

        type(program_settings), intent(in) :: settings  !> Program settings
        !> The variable containing all of the runtime information
        type(run_time_info), intent(inout) :: RTI

        !> The cluster index to be split
        integer,intent(in)              :: p
        !> The numbers in each new clusters
        integer,intent(in),dimension(:) :: cluster_list
        !> The number of new clusters
        integer,intent(in) :: num_new_clusters


        !Iterators
        integer :: i_live
        integer :: i_phantom,j_phantom
        integer :: i_cluster

        ! Constructor
        integer :: i


        integer, dimension(RTI%ncluster-1)   :: old_save
        integer, dimension(RTI%ncluster-1)   :: old_target
        integer, dimension(num_new_clusters) :: new_target
        integer                              :: num_old_clusters

        real(dp), dimension(size(RTI%live,1),RTI%nlive(p))     :: old_live
        integer :: old_nlive
        real(dp), dimension(size(RTI%phantom,1),size(RTI%phantom,2),size(RTI%phantom,3)) :: old_phantom
        integer, dimension(size(RTI%nphantom)) :: old_nphantom

        real(dp), dimension(size(RTI%posterior,1),RTI%nposterior(p)) :: old_posterior
        integer :: old_nposterior

        real(dp), dimension(size(RTI%equals,1),RTI%nequals(p)) :: old_equals
        integer :: old_nequals

        real(dp) :: old_maxlogweight

        real(dp), dimension(num_new_clusters) :: logni
        real(dp), dimension(num_new_clusters) :: logni1
        real(dp) :: logn
        real(dp) :: logn1
        real(dp) :: logXp
        real(dp) :: logZp
        real(dp) :: logZp2
        real(dp), dimension(RTI%ncluster-1) :: logXpXq
        real(dp) :: logXp2
        real(dp) :: logZXp
        real(dp) :: logZpXp

        ! 1) Save the old points as necessary
        old_live  = RTI%live(:,:RTI%nlive(p),p)                 ! Save the old live points
        old_nlive = RTI%nlive(p)                                ! Save the old number of live points 
        old_posterior = RTI%posterior(:,:RTI%nposterior(p),p)   ! Save the old posterior points
        old_nposterior = RTI%nposterior(p)                      ! Save the old number of posterior points  
        old_equals = RTI%equals(:,:RTI%nequals(p),p)            ! Save the old equals points
        old_nequals = RTI%nequals(p)                            ! Save the old number of equals points  
        old_phantom = RTI%phantom                               ! Save the old phantom points
        old_nphantom= RTI%nphantom                              ! Save the old numbers of phantom points
        old_maxlogweight = RTI%maxlogweight(p)                  ! save the old max log weight for the relevant cluster

        old_save   = [(i,i=1,p-1),(i,i=p+1,RTI%ncluster)]    ! The indices of the old clusters to save
        num_old_clusters = RTI%ncluster-1                    ! The number of old clusters
        RTI%ncluster = RTI%ncluster+num_new_clusters-1       ! The total number of new clusters

        old_target = [(i,i=1,num_old_clusters)]              ! Where the old clusters will be
        new_target = [(i,i=num_old_clusters+1,RTI%ncluster)] ! Where we're going to insert the new clusters

        ! Define some useful variables
        logXp  = RTI%logXp(p)
        logXp2 = RTI%logXpXq(p,p)
        logZp  = RTI%logZp(p)
        logZp2 = RTI%logZp2(p)
        logZXp = RTI%logZXp(p)
        logZpXp= RTI%logZpXp(p)
        logXpXq= [ RTI%logXpXq(p,:p-1) , RTI%logXpXq(p,p+1:) ]



        ! 2) Reallocate the arrays

        ! Reallocate the live,phantom and posterior points
        call reallocate(RTI%live,            new_size3=RTI%ncluster, save_indices3=old_save,target_indices3=old_target)
        call reallocate(RTI%nlive,           new_size1=RTI%ncluster, save_indices1=old_save,target_indices1=old_target)
        call reallocate(RTI%phantom,         new_size3=RTI%ncluster, save_indices3=old_save,target_indices3=old_target)
        call reallocate(RTI%nphantom,        new_size1=RTI%ncluster, save_indices1=old_save,target_indices1=old_target)
        call reallocate(RTI%posterior_stack, new_size3=RTI%ncluster, save_indices3=old_save,target_indices3=old_target)
        call reallocate(RTI%nposterior_stack,new_size1=RTI%ncluster, save_indices1=old_save,target_indices1=old_target)
        call reallocate(RTI%posterior,       new_size3=RTI%ncluster, save_indices3=old_save,target_indices3=old_target)
        call reallocate(RTI%nposterior,      new_size1=RTI%ncluster, save_indices1=old_save,target_indices1=old_target)
        call reallocate(RTI%equals,          new_size3=RTI%ncluster, save_indices3=old_save,target_indices3=old_target)
        call reallocate(RTI%nequals,         new_size1=RTI%ncluster, save_indices1=old_save,target_indices1=old_target)

        ! Reallocate the cholesky matrices
        call reallocate(RTI%cholesky, new_size3=RTI%ncluster, save_indices3=old_save,target_indices3=old_target)
        call reallocate(RTI%covmat,   new_size3=RTI%ncluster, save_indices3=old_save,target_indices3=old_target)

        ! Reallocate the evidence arrays 
        call reallocate(RTI%logXp,   RTI%ncluster,old_save,old_target)
        call reallocate(RTI%logZXp,  RTI%ncluster,old_save,old_target)
        call reallocate(RTI%logZp,   RTI%ncluster,old_save,old_target)
        call reallocate(RTI%logZp2,  RTI%ncluster,old_save,old_target)
        call reallocate(RTI%logZpXp, RTI%ncluster,old_save,old_target)
        call reallocate(RTI%logXpXq, RTI%ncluster,RTI%ncluster,old_save,old_save,old_target,old_target)

        call reallocate(RTI%logLp,   RTI%ncluster,old_save,old_target) 
        call reallocate(RTI%i,       RTI%ncluster,old_save,old_target)

        call reallocate(RTI%maxlogweight,   RTI%ncluster,old_save,old_target) 


        ! 3) Assign the new live points to their new clusters

        RTI%nlive(new_target) = 0 ! Zero the number of live points in the new clusters
        do i_live=1,old_nlive
            ! Insert the new points in the correct positions
            call add_point(old_live(:,i_live),RTI%live,RTI%nlive,new_target(cluster_list(i_live)))
        end do

        ! Find the new minimum loglikelihoods
        call find_min_loglikelihoods(settings,RTI) 

        ! 4) Reassign the posterior points
        RTI%nposterior_stack(new_target) = 0

        RTI%nposterior(new_target) = old_nposterior
        RTI%posterior(:,:old_nposterior,new_target) = spread(old_posterior,dim=3,ncopies=num_new_clusters)

        RTI%nequals(new_target) = old_nequals
        RTI%equals(:,:old_nequals,new_target) = spread(old_equals,dim=3,ncopies=num_new_clusters)

        RTI%maxlogweight(new_target) = old_maxlogweight


        ! 4) Reassign all the phantom points 
        RTI%nphantom = 0
        do i_cluster=1,size(old_nphantom)
            do i_phantom=1,old_nphantom(i_cluster)
                ! Reallocate all of the phantom points
                j_phantom = identify_cluster(settings,RTI,old_phantom(:,i_phantom,i_cluster))
                if(old_phantom(settings%l0,i_phantom,i_cluster) > RTI%logLp(j_phantom) ) &
                    call add_point(old_phantom(:,i_phantom,i_cluster),RTI%phantom,RTI%nphantom,j_phantom)
            end do
        end do




        ! 5) Initialise the new evidences and volumes
        ! Re-define where we're going to move the old clusters
        ! so that we don't include the deleted cluster

        ! Find the number of live+phantom points in each cluster
        logni  = log(RTI%nlive(new_target) + RTI%nphantom(new_target) + 0d0)
        logni1 = log(RTI%nlive(new_target) + RTI%nphantom(new_target) + 1d0)
        logn   = logsumexp(logni)
        logn1  = logaddexp(logn,0d0)

        ! Initialise the new volumes
        RTI%logXp(new_target) = logXp + logni - logn
        ! Initialise the new global evidence -local volume cross correlation
        RTI%logZXp(new_target) = logZXp + logni - logn 
        ! Initialise local evidences 
        RTI%logZp(new_target) = logZp + logni - logn 
        RTI%logZp2(new_target) = logZp2 + logni + logni1 - logn - logn1
        RTI%logZpXp(new_target) = logZpXp + logni + logni1 - logn - logn1 


        ! Initialise the volume cross correlations
        if(num_old_clusters>0) then
            RTI%logXpXq(new_target,old_target) = spread(logXpXq,1,num_new_clusters) + transpose(spread(logni,1,num_old_clusters)) - logn
            RTI%logXpXq(old_target,new_target) = transpose(RTI%logXpXq(new_target,old_target))
        end if

        ! When they're both new clusters
        RTI%logXpXq(new_target,new_target) &
            = logXp2 + spread(logni,1,num_new_clusters) + transpose(spread(logni,1,num_new_clusters)) -logn-logn1

        ! the squared one is slightly different
        do i_cluster=1,num_new_clusters

            RTI%logXpXq(new_target(i_cluster),new_target(i_cluster)) &
                = logXp2 + logni(i_cluster)+ logni1(i_cluster)-logn-logn1

        end do




        ! reduce the logweighting of posterior points by a factor proportional to the evidence
        do i_cluster=1,num_new_clusters
            RTI%equals(settings%pos_l,:RTI%nequals(new_target(i_cluster)),new_target(i_cluster)) = RTI%equals(settings%pos_l,:RTI%nequals(new_target(i_cluster)),new_target(i_cluster)) + RTI%logZp(new_target(i_cluster)) -logZp
            RTI%posterior(settings%pos_l,:RTI%nposterior(new_target(i_cluster)),new_target(i_cluster)) = RTI%posterior(settings%pos_l,:RTI%nposterior(new_target(i_cluster)),new_target(i_cluster)) + RTI%logZp(new_target(i_cluster)) -logZp
        end do

    end subroutine add_cluster

    function delete_cluster(settings,RTI) 
        use settings_module, only: program_settings
        use array_module, only: reallocate
        implicit none
        !> The variable containing all of the runtime information
        type(run_time_info), intent(inout) :: RTI
        type(program_settings), intent(in) :: settings
        logical :: delete_cluster

        !The cluster index to be deleted
        integer            :: p(1)

        integer :: size_n

        ! new indices of clusters
        integer,dimension(RTI%ncluster-1) :: indices

        ! Contstructor iterator
        integer :: i

        delete_cluster=.false.

        if(any(RTI%nlive==0)) then

            delete_cluster=.true.

            ! Update the posterior arrays
            call update_posteriors(settings,RTI) 

            p=minloc(RTI%nlive,RTI%nlive==0)

            ! Get the positions of the clusters to be saved
            indices = [(i,i=1,p(1)-1),(i,i=p(1)+1,RTI%ncluster)]

            ! Reduce the number of clusters
            RTI%ncluster=RTI%ncluster-1
            ! Increase the number of dead clusters
            RTI%ncluster_dead = RTI%ncluster_dead + 1

            ! Reallocate the dead arrays
            size_n = max(size(RTI%posterior_dead,2),RTI%nposterior(p(1)))
            call reallocate(RTI%posterior_dead, new_size2=size_n,new_size3=RTI%ncluster_dead)
            call reallocate(RTI%nposterior_dead,new_size1=RTI%ncluster_dead)
            size_n = max(size(RTI%equals_dead,2),RTI%nequals(p(1)))
            call reallocate(RTI%equals_dead,    new_size2=size_n,new_size3=RTI%ncluster_dead)
            call reallocate(RTI%nequals_dead,   new_size1=RTI%ncluster_dead)
            call reallocate(RTI%logZp_dead,     new_size1=RTI%ncluster_dead)
            call reallocate(RTI%logZp2_dead,    new_size1=RTI%ncluster_dead)
            call reallocate(RTI%maxlogweight_dead,new_size1=RTI%ncluster_dead)

            ! Place the newly dead cluster into this
            RTI%nposterior_dead(RTI%ncluster_dead) = RTI%nposterior(p(1))
            RTI%posterior_dead(:,:RTI%nposterior_dead(RTI%ncluster_dead),RTI%ncluster_dead) = RTI%posterior(:,:RTI%nposterior(p(1)),p(1))
            RTI%nequals_dead(RTI%ncluster_dead) = RTI%nequals(p(1))
            RTI%equals_dead(:,:RTI%nequals_dead(RTI%ncluster_dead),RTI%ncluster_dead) = RTI%equals(:,:RTI%nequals(p(1)),p(1))
            RTI%logZp_dead(RTI%ncluster_dead)  = RTI%logZp(p(1))
            RTI%logZp2_dead(RTI%ncluster_dead) = RTI%logZp2(p(1))
            RTI%maxlogweight_dead(RTI%ncluster_dead) = RTI%maxlogweight(p(1))


            ! Reallocate the live,phantom and posterior points
            call reallocate(RTI%live,            new_size3=RTI%ncluster, save_indices3=indices)
            call reallocate(RTI%nlive,           new_size1=RTI%ncluster, save_indices1=indices)
            call reallocate(RTI%phantom,         new_size3=RTI%ncluster, save_indices3=indices)
            call reallocate(RTI%nphantom,        new_size1=RTI%ncluster, save_indices1=indices)
            call reallocate(RTI%posterior_stack, new_size3=RTI%ncluster, save_indices3=indices)
            call reallocate(RTI%nposterior_stack,new_size1=RTI%ncluster, save_indices1=indices)
            call reallocate(RTI%posterior,       new_size3=RTI%ncluster, save_indices3=indices)
            call reallocate(RTI%nposterior,      new_size1=RTI%ncluster, save_indices1=indices)
            call reallocate(RTI%equals,          new_size3=RTI%ncluster, save_indices3=indices)
            call reallocate(RTI%nequals,         new_size1=RTI%ncluster, save_indices1=indices)

            ! Reallocate the cholesky matrices
            call reallocate(RTI%cholesky, new_size3=RTI%ncluster, save_indices3=indices)
            call reallocate(RTI%covmat,   new_size3=RTI%ncluster, save_indices3=indices)

            ! Reallocate the evidence arrays 
            call reallocate(RTI%logXp,   new_size1=RTI%ncluster,save_indices1=indices)
            call reallocate(RTI%logZXp,  new_size1=RTI%ncluster,save_indices1=indices)
            call reallocate(RTI%logZp,   new_size1=RTI%ncluster,save_indices1=indices)
            call reallocate(RTI%logZp2,  new_size1=RTI%ncluster,save_indices1=indices)
            call reallocate(RTI%logZpXp, new_size1=RTI%ncluster,save_indices1=indices)
            call reallocate(RTI%logXpXq, new_size1=RTI%ncluster,new_size2=RTI%ncluster,save_indices1=indices,save_indices2=indices)

            call reallocate(RTI%logLp,   new_size1=RTI%ncluster,save_indices1=indices) 
            call reallocate(RTI%i,       new_size1=RTI%ncluster,save_indices1=indices)

            call reallocate(RTI%maxlogweight,   new_size1=RTI%ncluster,save_indices1=indices) 
        end if


    end function delete_cluster


    subroutine calculate_covmats(settings,RTI)
        use settings_module, only: program_settings
        use utils_module, only: calc_cholesky
        implicit none

        type(program_settings), intent(in) :: settings  !> Program settings
        type(run_time_info),intent(inout) :: RTI        !> Run time information

        integer :: i_cluster ! cluster iterator
        real(dp), dimension(settings%nDims) :: mean ! The mean of a given cluster

        ! For each cluster:
        do i_cluster = 1,RTI%ncluster
            ! Calculate the mean
            mean = ( sum(RTI%live(settings%h0:settings%h1,:RTI%nlive(i_cluster),i_cluster),dim=2) &
                + sum(RTI%phantom(settings%h0:settings%h1,:RTI%nphantom(i_cluster),i_cluster),dim=2) ) &
                / (RTI%nlive(i_cluster) + RTI%nphantom(i_cluster) )

            ! Calculate the covariance by using a matrix multiplication
            RTI%covmat(:,:,i_cluster) =( & 
                matmul(&
                RTI%live(settings%h0:settings%h1,:RTI%nlive(i_cluster),i_cluster) &
                - spread(mean,dim=2,ncopies=RTI%nlive(i_cluster)) , &
                transpose( RTI%live(settings%h0:settings%h1,:RTI%nlive(i_cluster),i_cluster) &
                - spread(mean,dim=2,ncopies=RTI%nlive(i_cluster)) ) &
                )&
                +&
                matmul(&
                RTI%phantom(settings%h0:settings%h1,:RTI%nphantom(i_cluster),i_cluster) &
                - spread(mean,dim=2,ncopies=RTI%nphantom(i_cluster)) , &
                transpose( RTI%phantom(settings%h0:settings%h1,:RTI%nphantom(i_cluster),i_cluster) &
                - spread(mean,dim=2,ncopies=RTI%nphantom(i_cluster)) ) &
                ) &
                )/ (RTI%nlive(i_cluster) + RTI%nphantom(i_cluster) ) 

            ! Calculate the cholesky decomposition
            RTI%cholesky(:,:,i_cluster) = calc_cholesky(RTI%covmat(:,:,i_cluster))
        end do


    end subroutine calculate_covmats



    !> Calculate unbiased evidence estimates and errors. 
    !!
    !! The evidences generated by nested sampling are distributed according to a log-normal distribution:
    !! http://en.wikipedia.org/wiki/Log-normal_distribution
    !!
    !! What we accumulate in the routine update_evidence is log(<Z>), and log(<Z^2>).
    !! What we want is <log(Z)>,and 
    subroutine calculate_logZ_estimate(RTI,logZ,varlogZ,logZp,varlogZp,logZp_dead,varlogZp_dead)
        implicit none

        type(run_time_info),intent(in)                                  :: RTI        !> Run time information
        real(dp), intent(out)                                   :: logZ       !>
        real(dp), intent(out)                                   :: varlogZ  !>
        real(dp), intent(out), dimension(RTI%ncluster),optional :: logZp      !>
        real(dp), intent(out), dimension(RTI%ncluster),optional :: varlogZp !>
        real(dp), intent(out), dimension(RTI%ncluster_dead),optional :: logZp_dead      !>
        real(dp), intent(out), dimension(RTI%ncluster_dead),optional :: varlogZp_dead !>

        logZ       = max(-huge(1d0),2*RTI%logZ - 0.5*RTI%logZ2)
        varlogZ    = RTI%logZ2 - 2*RTI%logZ

        if(present(logZp).and.present(varlogZp))then
            logZp      = max(-huge(1d0),2*RTI%logZp - 0.5*RTI%logZp2)
            varlogZp = RTI%logZp2 - 2*RTI%logZp
        end if

        if(present(logZp_dead).and.present(varlogZp_dead))then
            logZp_dead      = max(-huge(1d0),2*RTI%logZp_dead - 0.5*RTI%logZp2_dead)
            varlogZp_dead   = RTI%logZp2_dead - 2*RTI%logZp_dead
        end if



    end subroutine calculate_logZ_estimate




    function live_logZ(settings,RTI)
        use utils_module, only: logsumexp,logincexp
        use settings_module, only: program_settings

        implicit none
        type(program_settings), intent(in) :: settings !> Program settings
        type(run_time_info),intent(inout)  :: RTI      !> Run time information

        real(dp) ::live_logZ ! Amount of evidence remaining in the live points

        integer :: i_cluster ! cluster iterator

        ! Initialise it with no log evidence
        live_logZ = settings%logzero

        ! Sum up over all the clusters mean(likelihood) * volume
        do i_cluster = 1,RTI%ncluster
            if(RTI%nlive(i_cluster)>0) then
                call logincexp(live_logZ, &
                        logsumexp(RTI%live(settings%l0,:RTI%nlive(i_cluster),i_cluster)) &
                        - log(RTI%nlive(i_cluster)+0d0) &
                        + RTI%logXp(i_cluster) &
                        )
            end if
        end do

    end function live_logZ






    subroutine replace_point(settings,RTI,baby_points,cluster_add)
        use utils_module, only: logsumexp,logincexp
        use settings_module, only: program_settings
        use random_module, only: bernoulli_trial
        use array_module, only: add_point

        implicit none
        type(program_settings), intent(in) :: settings !> Program settings
        type(run_time_info),intent(inout)  :: RTI      !> Run time information
        integer,intent(in) :: cluster_add              !> Cluster to add to
        !> New-born baby points, created by slice sampling routine
        real(dp),intent(in),dimension(:,:),allocatable :: baby_points

        logical :: replaced ! Have we successfully replaced a point?

        ! live point, last of the baby points
        real(dp),dimension(settings%nTotal) :: point

        real(dp) :: logL ! loglikelihood bound

        integer :: i_baby ! point iterator
        integer :: i_nlive, nlive ! where in the nlives array to search
        

        ! The birth loglikelihood contour is defined globally
        logL = minval(RTI%logLp)

        ! Assign the phantom points to cluster_add, if they are:
        ! (1) Within the isolikelihood contour of the cluster.
        ! (2) Within the voronoi cell of the cluster.

        do i_baby=1,size(baby_points,2)-1
            ! Assign a temporary variable
            point = baby_points(:,i_baby)

            if( point(settings%l0) > logL ) then ! (1)
                if( identify_cluster(settings,RTI,point) == cluster_add) then !(2)
                    call add_point(point,RTI%phantom,RTI%nphantom,cluster_add)  ! Add the new phantom point
                end if
            end if

        end do

        ! Now assign the live point
        point = baby_points(:,i_baby)

        replaced = .false.
        if( point(settings%l0) > logL ) then ! (1)
            if( identify_cluster(settings,RTI,point) == cluster_add) then !(2)

                i_nlive = maxloc(settings%loglikes,1,logL > settings%loglikes)
                if (i_nlive==0) then
                    nlive = settings%nlive
                else
                    nlive = settings%nlives(i_nlive)
                end if
                if (sum(RTI%nlive) >= max(nlive,1)) then
                    call delete_outermost_point(settings,RTI)
                    replaced = .true.                                                                ! Mark this as a replaced live point
                end if
                if (sum(RTI%nlive) < nlive) then
                    point(settings%b0) = logL                                                        ! Note the moment it is born at
                    call add_point(point,RTI%live,RTI%nlive,cluster_add)                             ! Add the new live point to the live points
                    call find_min_loglikelihoods(settings,RTI)                                       ! Find the new minimum likelihoods
                end if
            end if
        end if

    end subroutine replace_point

    subroutine delete_outermost_point(settings,RTI)
        use settings_module, only: program_settings
        use utils_module, only: logsumexp,logincexp,minpos
        use array_module, only: add_point,delete_point, reallocate
        use calculate_module, only: calculate_posterior_point
        implicit none
        type(program_settings), intent(in) :: settings !> Program settings
        type(run_time_info),intent(inout)  :: RTI      !> Run time information

        real(dp),dimension(settings%nTotal)     :: deleted_point   ! point we have just deleted
        real(dp),dimension(settings%nposterior) :: posterior_point   ! temporary posterior point
        real(dp)                                :: logweight       ! The log weighting of this point
        integer                                     :: cluster_del     ! cluster to delete from

        cluster_del   = minpos(RTI%logLp)                                                ! find the cluster we're deleting from
        logweight     = update_evidence(RTI,cluster_del)                                 ! Update the evidence value
        deleted_point = delete_point(RTI%i(cluster_del),RTI%live,RTI%nlive,cluster_del)  ! Delete the live point from the array
        call find_min_loglikelihoods(settings,RTI)                                       ! Find the new minimum likelihoods
        call add_point(deleted_point,RTI%dead,RTI%ndead)                                 ! Add the deleted point to the dead points
        if (RTI%ndead > size(RTI%logweights)) call reallocate(RTI%logweights,RTI%ndead*2)
        RTI%logweights(RTI%ndead) = logweight                                            ! Add the logweight to the array

        ! Calculate the posterior point and add it to the posterior stack
        posterior_point = calculate_posterior_point(settings,deleted_point,logweight,RTI%logZ,logsumexp(RTI%logXp))
        call add_point(posterior_point,RTI%posterior_stack,RTI%nposterior_stack,cluster_del )
        RTI%maxlogweight(cluster_del) = max(RTI%maxlogweight(cluster_del),posterior_point(settings%pos_w)+posterior_point(settings%pos_l))
        RTI%maxlogweight_global=max(RTI%maxlogweight_global,RTI%maxlogweight(cluster_del))

    end subroutine delete_outermost_point 


    subroutine clean_phantoms(settings,RTI)
        use utils_module, only: logsumexp,logincexp,minpos
        use settings_module, only: program_settings
        use calculate_module, only: calculate_posterior_point
        use random_module, only: bernoulli_trial
        use array_module, only: add_point,delete_point

        implicit none
        type(program_settings), intent(in) :: settings !> Program settings
        type(run_time_info),intent(inout)  :: RTI      !> Run time information

        real(dp),dimension(settings%nTotal) :: deleted_point   ! point we have just deleted
        real(dp),dimension(settings%nposterior) :: posterior_point   ! temporary posterior point
        
        integer :: i_cluster  ! cluster iterator
        integer :: i_phantom  ! phantom iterator
        integer :: i_stack(1) ! phantom iterator
        integer,dimension(size(RTI%nposterior_stack)) :: nposterior_stack ! original size of array (just live posteriors)

        nposterior_stack = RTI%nposterior_stack

        ! Now we delete the phantoms
        do i_cluster=1,RTI%ncluster
            i_phantom=1
            do while(i_phantom<=RTI%nphantom(i_cluster))

                ! Find the location of the live point which this point belongs to
                i_stack = minloc( RTI%posterior_stack(settings%pos_l,:nposterior_stack(i_cluster),i_cluster), &
                        RTI%posterior_stack(settings%pos_l,:nposterior_stack(i_cluster),i_cluster) &
                        > RTI%phantom(settings%l0,i_phantom,i_cluster)  )

                if(i_stack(1)<=0) then
                    i_phantom=i_phantom+1
                else

                    ! Delete this point
                    deleted_point = delete_point(i_phantom,RTI%phantom,RTI%nphantom,i_cluster)

                    ! Calculate the posterior point and add it to the array
                    if(settings%equals .or. settings%posteriors ) then
                        if(bernoulli_trial(RTI%thin_posterior)) then
                            posterior_point = calculate_posterior_point(settings,deleted_point,&
                                    RTI%posterior_stack(settings%pos_w,i_stack(1),i_cluster), &!logweight
                                    RTI%posterior_stack(settings%pos_Z,i_stack(1),i_cluster), &!RTI%logZ
                                    RTI%posterior_stack(settings%pos_X,i_stack(1),i_cluster)  &!logsumexp(RTI%logXp))
                                    )

                            call add_point(posterior_point,RTI%posterior_stack,RTI%nposterior_stack,i_cluster )
                            RTI%maxlogweight(i_cluster) = max(RTI%maxlogweight(i_cluster),posterior_point(settings%pos_w)+posterior_point(settings%pos_l))
                            RTI%maxlogweight_global=max(RTI%maxlogweight_global,RTI%maxlogweight(i_cluster))
                        end if
                    end if
                end if

            end do
        end do

    end subroutine clean_phantoms





    subroutine find_min_loglikelihoods(settings,RTI)
        use utils_module, only: minpos
        use settings_module, only: program_settings

        implicit none
        type(program_settings), intent(in) :: settings !> Program settings
        type(run_time_info),intent(inout)  :: RTI      !> Run time information
        
        integer :: i_cluster     ! cluster iterator

        ! Iterate through each cluster
        do i_cluster=1,RTI%ncluster

            ! Find the position of the lowest point in this cluster
            RTI%i(i_cluster)     = minpos(RTI%live(settings%l0,:RTI%nlive(i_cluster),i_cluster))

            if(RTI%i(i_cluster) == 0) then
                ! If the cluster is empty, we need to signal to delete all points
                RTI%logLp(i_cluster) = huge(1d0)
            else
                ! Find the likelihood of the lowest point in this cluster
                RTI%logLp(i_cluster) = RTI%live(settings%l0,RTI%i(i_cluster),i_cluster) 
            end if

        end do

    end subroutine find_min_loglikelihoods



    function identify_cluster(settings,RTI,point) result(cluster)
        use settings_module,   only: program_settings
        use utils_module,      only: distance2
        implicit none

        type(program_settings), intent(in) :: settings
        type(run_time_info), intent(in) :: RTI

        real(dp), dimension(settings%nTotal),intent(in)   :: point

        integer :: cluster

        integer :: i_cluster
        integer :: i_live

        real(dp) :: temp_distance2
        real(dp) :: closest_distance2

        if( RTI%ncluster == 1) then
            cluster=1
            return
        end if

        closest_distance2=huge(1d0)

        ! Find the cluster this point is nearest to
        do i_cluster=1,RTI%ncluster
            do i_live=1,RTI%nlive(i_cluster)
                temp_distance2 = distance2(point(settings%h0:settings%h1),RTI%live(settings%h0:settings%h1,i_live,i_cluster) )
                if(temp_distance2 < closest_distance2) then
                    cluster = i_cluster
                    closest_distance2 = temp_distance2
                end if
            end do
        end do

    end function identify_cluster





    subroutine update_posteriors(settings,RTI)
        use settings_module, only: program_settings
        use random_module, only: bernoulli_trial
        use array_module, only: delete_point,add_point
        implicit none
        !> Program settings
        type(program_settings), intent(in) :: settings
        !> Run time information
        type(run_time_info),intent(inout) :: RTI


        real(dp), dimension(settings%np) :: posterior_point

        integer :: i_post
        integer :: i_cluster


        ! Add in the phantoms from the stack (used to do this at every iteration, but this was the computational bottleneck)
        call clean_phantoms(settings,RTI) 

        if(settings%equals) then
            ! Clean the global equally weighted posteriors
            i_post=1
            do while(i_post<=RTI%nequals_global) 
                ! We don't need to bother with points that have a weight equal to
                ! the max weight, these are automatically accepted
                if(RTI%equals_global(settings%p_w,i_post)<RTI%maxlogweight_global) then

                    ! accept with probability p = weight/maxweight
                    if(bernoulli_trial( exp(RTI%equals_global(settings%p_w,i_post)-RTI%maxlogweight_global) )) then
                        ! If accepted, then their new probability is maxlogweight (for
                        ! the next round of stripping)
                        RTI%equals_global(settings%p_w,i_post) = RTI%maxlogweight_global
                        ! move on to the next point
                        i_post=i_post+1
                    else
                        ! delete this point if not accepted
                        posterior_point = delete_point(i_post,RTI%equals_global,RTI%nequals_global)
                    end if
                else
                    i_post=i_post+1 ! move on to the next point if automatically accepted
                end if
            end do

            ! Clean the local equally weighted posteriors
            if(settings%cluster_posteriors) then
                ! strip out old posterior points from equals
                do i_cluster=1,RTI%ncluster
                    i_post=1
                    do while(i_post<=RTI%nequals(i_cluster)) 
                        ! We don't need to bother with points that have a weight equal to
                        ! the max weight, these are automatically accepted
                        if(RTI%equals(settings%p_w,i_post,i_cluster)<RTI%maxlogweight(i_cluster)) then

                            ! accept with probability p = weight/maxweight
                            if(bernoulli_trial( exp(RTI%equals(settings%p_w,i_post,i_cluster)-RTI%maxlogweight(i_cluster)) )) then
                                ! If accepted, then their new probability is maxlogweight (for
                                ! the next round of stripping)
                                RTI%equals(settings%p_w,i_post,i_cluster) = RTI%maxlogweight(i_cluster) 
                                ! move on to the next point
                                i_post=i_post+1
                            else
                                ! delete this point if not accepted
                                posterior_point = delete_point(i_post,RTI%equals,RTI%nequals,i_cluster)
                            end if
                        else
                            i_post=i_post+1 ! move on to the next point if automatically accepted
                        end if
                    end do
                end do
            end if
        end if

        ! Add new posterior points from the stack
        do i_cluster=1,RTI%ncluster
            do i_post=1,RTI%nposterior_stack(i_cluster)

                if(settings%equals) then

                    ! Add the global equally weighted posteriors
                    if(bernoulli_trial( exp( RTI%posterior_stack(settings%pos_w,i_post,i_cluster) + RTI%posterior_stack(settings%pos_l,i_post,i_cluster) - RTI%maxlogweight_global) )) then
                        posterior_point(settings%p_w) = RTI%maxlogweight_global
                        posterior_point(settings%p_2l) = -2*RTI%posterior_stack(settings%pos_l,i_post,i_cluster)
                        posterior_point(settings%p_p0:settings%p_d1) = RTI%posterior_stack(settings%pos_p0:settings%pos_d1,i_post,i_cluster)
                        call add_point(posterior_point,RTI%equals_global,RTI%nequals_global)
                    end if

                    ! Add the clustered equally weighted posteriors
                    if(settings%cluster_posteriors) then
                        ! Test for acceptance of equally weighted posteriors
                        if(bernoulli_trial( exp( RTI%posterior_stack(settings%pos_w,i_post,i_cluster) + RTI%posterior_stack(settings%pos_l,i_post,i_cluster) - RTI%maxlogweight(i_cluster)) )) then
                            posterior_point(settings%p_w) = RTI%maxlogweight(i_cluster)
                            posterior_point(settings%p_2l) = -2*RTI%posterior_stack(settings%pos_l,i_post,i_cluster)
                            posterior_point(settings%p_p0:settings%p_d1) = RTI%posterior_stack(settings%pos_p0:settings%pos_d1,i_post,i_cluster)
                            call add_point(posterior_point,RTI%equals,RTI%nequals,i_cluster)
                        end if
                    end if

                end if

                if(settings%posteriors) then
                    ! Add point to global weighted posterior array
                    call add_point(RTI%posterior_stack(:,i_post,i_cluster),RTI%posterior_global,RTI%nposterior_global)
                    ! Add point to cluster weighted posterior array
                    if(settings%cluster_posteriors) call add_point(RTI%posterior_stack(:,i_post,i_cluster),RTI%posterior,RTI%nposterior,i_cluster)
                end if
            end do
        end do

        RTI%nposterior_stack=0 ! reset the stack to zero

    end subroutine update_posteriors



end module

module nestwrapper

! Nested sampling includes

use Nested
use params
use like
   
implicit none
   
contains

!-----*-----------------------------------------------------------------

subroutine nest_Sample
	
	implicit none
	
   	integer nclusters				! total number of clusters found
	integer context
   	integer maxNode 				! variables used by the posterior routine
   
   
   	! calling MultiNest
	
   	call nestRun(nest_IS,nest_mmodal,nest_ceff,nest_nlive,nest_tol,nest_efr,sdim,nest_nPar, &
   	nest_nClsPar,nest_maxModes,nest_updInt,nest_Ztol,nest_root,nest_rseed,nest_pWrap, &
   	nest_fb,nest_resume,nest_outfile,nest_initMPI,nest_logZero,nest_maxIter,getLogLike,dumper,context)

end subroutine nest_Sample

!-----*-----------------------------------------------------------------

! Wrapper around Likelihood Function

subroutine getLogLike(Cube,n_dim,nPar,lnew,context)
	
	implicit none
	
	! Input arguments
	integer n_dim 					! dimensionality (total number of free parameters) of the problem
	integer nPar 					! total number of free plus derived parameters

	!Input/Output arguments
	double precision Cube(nPar) 			! on entry has the ndim parameters in unit-hypercube
	 						! on exit, the physical parameters plus copy any derived parameters you want to store with the free parameters
	 
	! Output arguments
	double precision lnew 				! loglikelihood
	integer context					! not needed, any additional information user wants to pass
	
   
   	
	!call your loglike function here 
	
   	call slikelihood(Cube,lnew)

end subroutine getLogLike

!-----*-----------------------------------------------------------------

! dumper, called after every updInt*10 iterations

subroutine dumper(nSamples, nlive, nPar, physLive, posterior, paramConstr, maxLogLike, logZ, INSlogZ, logZerr, context)

	implicit none

	integer nSamples				! number of samples in posterior array
	integer nlive					! number of live points
	integer nPar					! number of parameters saved (physical plus derived)
	double precision, pointer :: physLive(:,:)	! array containing the last set of live points
	double precision, pointer :: posterior(:,:)	! array with the posterior distribution
	double precision, pointer :: paramConstr(:)	! array with mean, sigmas, maxlike & MAP parameters
	double precision maxLogLike			! max loglikelihood value
	double precision logZ				! log evidence value from the default (non-INS) mode
	double precision INSlogZ			! log evidence value from the INS mode
	double precision logZerr			! error on log evidence
	integer context					! not required by MultiNest, any additional information user wants to pass
	
end subroutine dumper

!-----*-----------------------------------------------------------------

end module nestwrapper

module abort_module
    use utils_module, only: dp
    contains

    subroutine halt_program(message)
        use utils_module, only: stderr_unit
        implicit none
#ifdef MPI
        include 'mpif.h'
#endif

        character(LEN=*), intent(in), optional :: message

#ifdef MPI
        integer :: errorcode=1
        integer :: mpierror
#endif

        if (present(message)) then
            write(stderr_unit,'( 20("=") )')
            write(stderr_unit,'(A)') trim(adjustl(message))
            write(stderr_unit,'( 20("=") )')
        end if 

#ifdef MPI
        call MPI_ABORT(MPI_COMM_WORLD,errorcode,mpierror)
#else
        stop 1
#endif

    end subroutine halt_program


end module abort_module

!> This module encodes the type 'program_settings' which contains all of the
!! details required to perform a nested sampling run.
module settings_module
    use utils_module, only: dp
    use utils_module,   only: STR_LENGTH
    implicit none

    integer, parameter :: live_type    = 1
    integer, parameter :: blank_type   = 0
    integer, parameter :: phantom_type =-1

    !> Type to contain all of the parameters involved in a nested sampling run
    Type :: program_settings

        integer :: nlive = 500                  !> The number of live points
        integer :: num_repeats = -1             !> The number of slow chords to draw
        logical :: do_clustering = .false.      !> Whether to do clustering or not

        integer :: feedback = 1                 !> The degree of feedback to provide

        real(dp) :: precision_criterion = 1d-3  !> The stopping criterion
        real(dp) :: logzero = -1d30             !> The threshold for 'log(0) values'

        !> The maximum number of dead points/samples
        !!
        !! Set equal to -1 for no maximum number
        integer :: max_ndead = -1

        !> What factor should we bulk up the posterior points by (using
        !! inter-chain points)
        !!
        !! set to <=0 to use all of them
        real(dp) :: boost_posterior = 0d0

        logical :: posteriors = .false.         !> Whether to calculate weighted posteriors
        logical :: equals     = .true.          !> Whether to calculate equally weighted posteriors
        logical :: cluster_posteriors = .false. !> Whether to calculate clustered posteriors


        
        logical :: write_resume = .false.     !> Whether or not to write resume files
        logical :: write_paramnames = .false. !> Whether or not to write paramnames file
        logical :: read_resume = .false.      !> Whether or not to resume from file
        logical :: write_stats = .true.       !> Whether or not to write stats file
        logical :: write_live = .true.        !> Whether or not to write phys_live points
        logical :: write_dead = .true.        !> Whether or not to write dead points

        integer, allocatable,dimension(:) :: grade_dims          !> The number of parameters in each grade
        real(dp), allocatable,dimension(:) :: grade_frac !> The fraction of time spent in each grade


        real(dp), allocatable,dimension(:) :: seed_point
        logical :: generate_from_seed = .false.
        integer :: nprior = -1
        integer :: nprior_repeat = -1
        logical :: write_prior = .false.

        integer :: seed = -1


        character(STR_LENGTH) :: base_dir='chains' !> The directory to put outputs in
        character(STR_LENGTH) :: file_root='test'  !> The file root for outputs


        !> Dimensionality of the space
        integer :: nDims = 1
        !> Number of derived parameters
        integer :: nDerived = 0   
        !> 2*ndims + nDerived + 1
        integer :: nTotal      

        ! Indices for the sections of a live_points array

        !> hypercube indices
        !!
        !! These are the coordinates in the unit hypercube.
        !! h0 indicates the starting index, h1 the finishing index.
        integer :: h0,h1       

        !> physical indices
        !!
        !! These are the coordinates in the physical space 
        !! These are linked to the hypercube coordinates via the prior.
        !! p0 indicates the starting index, p1 the finishing index
        integer :: p0,p1       

        !> derived indices
        !!
        !! These are the indices of the derived parameters to be calculated
        !! during the run.
        !! d0 indicates the starting index, d1 the finishing index
        integer :: d0,d1       

        !> Birth index
        !!
        !! This is the moment that the point was born
        integer :: b0          

        !> likelihood index
        !!
        !! This is the likelihood evaluated at the position of the live point
        integer :: l0          


        ! Posterior indices

        ! Weight index
        integer :: pos_w
        ! Cumulative weight index
        integer :: pos_Z
        ! Loglikelihood index
        integer :: pos_l
        ! Volume index
        integer :: pos_X
        ! physical parameter indices
        integer :: pos_p0
        integer :: pos_p1
        ! derived parameter indices
        integer :: pos_d0
        integer :: pos_d1

        ! Number of posterior parameters
        integer :: nposterior

        ! Final posterior indices
        integer :: p_w
        integer :: p_2l
        integer :: p_p0
        integer :: p_p1
        integer :: p_d0
        integer :: p_d1
        integer :: np



        ! Sub clustering dimensions
        integer,dimension(:),allocatable :: sub_clustering_dimensions

        integer,  dimension(:), allocatable :: nlives     !> The number of live points per contour
        real(dp), dimension(:), allocatable :: loglikes   !> The contours for nlive_list
        
        real(dp) :: compression_factor = exp(-1d0)

    end type program_settings

    contains

    !> This subroutine initialises all of the default settings
    !!
    !! It deals with all the fiddly stuff that's important, such as where to
    !! store things
    !!
    subroutine initialise_settings(settings)
        use abort_module, only: halt_program
        use utils_module, only: sort_doubles
        implicit none
        type(program_settings), intent(inout) :: settings


        ! Hypercube parameter indices
        settings%h0=1
        settings%h1=settings%h0+settings%nDims-1

        ! Physical parameter indices
        settings%p0=settings%h1+1
        settings%p1=settings%p0+settings%nDims-1 

        ! Derived parameter indices
        settings%d0=settings%p1+1
        settings%d1=settings%d0+settings%nDerived-1  

        ! birth index
        settings%b0=settings%d1+1

        ! Loglikelihood index
        settings%l0=settings%b0+1

        ! Total number of parameters
        settings%nTotal = settings%l0



        ! Posterior indices

        ! Volume index
        settings%pos_X = 1
        ! Loglikelihood index
        settings%pos_l = settings%pos_X+1
        ! Weight index
        settings%pos_w = settings%pos_l+1
        ! Cumulative weight index
        settings%pos_Z = settings%pos_w+1
        ! physical parameter indices
        settings%pos_p0= settings%pos_Z+1
        settings%pos_p1= settings%pos_Z+settings%nDims
        ! derived parameter indices
        settings%pos_d0= settings%pos_p1+1
        settings%pos_d1= settings%pos_p1+settings%nDerived

        ! Number of posterior parameters
        settings%nposterior = settings%pos_d1


        settings%p_w = 1
        settings%p_2l = settings%p_w+1
        settings%p_p0 = settings%p_2l+1
        settings%p_p1 = settings%p_2l+settings%nDims
        settings%p_d0 = settings%p_p1+1
        settings%p_d1 = settings%p_p1+settings%nDerived

        settings%np   = settings%p_d1

        if( settings%num_repeats < 1 ) call halt_program("You need to set num_repeats. Suggestion: 5*nDims")

        if(.not. allocated(settings%grade_dims)) then
            allocate(settings%grade_dims(1))
            settings%grade_dims = [settings%nDims]
        end if

        if(.not. allocated(settings%grade_frac)) then
            allocate(settings%grade_frac(1))
            settings%grade_frac = [1.0d0]
        end if

        if (.not. allocated(settings%nlives)) then
            allocate(settings%nlives(1),settings%loglikes(1))
            settings%nlives(1) = settings%nlive
            settings%loglikes(1) = settings%logzero
        end if

        settings%nlives = settings%nlives(sort_doubles(settings%loglikes))
        settings%loglikes = settings%loglikes(sort_doubles(settings%loglikes))



    end subroutine initialise_settings


end module settings_module 

#!/usr/bin/env Rscript

###
### Read a directory tree created by a run of cosmosis, and produce a
### standard set of plots, guided by what directories and files are
### found.
###

suppressPackageStartupMessages(library("optparse"))
suppressPackageStartupMessages(library("lattice"))
suppressPackageStartupMessages(library("latticeExtra"))
suppressPackageStartupMessages(library("tools"))
suppressPackageStartupMessages(library("reshape2"))

# These are a few functions to help make generating 'pretty' log-log
# plots a bit easier.
# xyplot.
scales.log.log <- function()
{
  list( x=list(log=10, equispaced=FALSE)
      , y=list(log=10, equispaced=FALSE)
      )
}

xscale.log <- function() xscale.components.log10ticks

yscale.log <- function() yscale.components.log10ticks

# Scan the given file in the given directory, ignoring lines that
#  start with '#'.
cosmo.scan <- function(dirname, filename)
{
  scan(file.path(dirname, filename), comment.char="#", quiet=TRUE)
}

# Create a dataframe from all the named files. It is assumed that each
# file contains a single column of data, and that all the columns are of
# the same length. Lines beginning with "#" are ignored. The names of
# the columns are determined from the names of the files, by dropping
# the file extension.
#
# If we change the output of CosmoSIS to make a single file with
# multiple columns, then read.table() would work directly and probably a
# bit more efficiently.
make.dataframe.from.files <- function(fnames)
{
  # Scan each file, creating a vector of the right name
  # bind the columns into a dataframe.
  columns <- lapply(fnames, function(n) scan(n, comment.char="#", quiet=TRUE))
  result <- data.frame(columns)
  names(result) <- lapply(fnames, function(n) file_path_sans_ext(basename(n)))
  result
}

# Create a matter power dataframe. This is handled specially, because
# the p_k matrix is stored in a linearized format, and needs to be
# interpreted correctly.
make.matter.power.dataframe.from.files <- function(dirname, type)
{
  # If the directory does not exist, return an empty dataframe.
  if (! file.exists(dirname)) return(data.frame())

  # Scan each file, creating a vector of the right name
  # bind the columns into a dataframe.

  z <- cosmo.scan(dirname, "z.txt")
  k_h <- cosmo.scan(dirname, "k_h.txt")
  p_k <- cosmo.scan(dirname, "p_k.txt")
  nkh <- length(k_h)

  # The p_k array carries the data for a matrix, with 'z' varying slowly
  # and 'k_h' varying rapidly. Thus to build the dataframe, we can rely
  # on the recycling rule to get k_h correct, but have to construct z
  # ourselves.
  dframe <- data.frame( p_k = p_k
                      , k_h = k_h
                      , z = rep(z, each=nkh)
                      )
  dframe$type = type
  dframe
}

# Create a single "distance plot". A distance plot is always a plot of
# something as a function of reshift "z'. The plot is written to a file,
# using the specified device. All additional arguments are passed to the
# device function.
make.distance.plot <- function(colname, dframe, prefix, outdir, verbose, devname, ...)
{
  device.fcn = get(devname)
  plotfile <- paste(outdir, "/", prefix, "_", colname, ".", devname, sep="")
  if (verbose) cat("Plotting", colname, "versus z into", plotfile, "\n")
  device.fcn(plotfile, ...)
  print(xyplot( as.formula(paste(colname, "~z"))
              , dframe
              , xlab="Redshift z"
              , ylab=toupper(colname)
              , grid=TRUE
              , type="l",
              , lwd = 2
              ))
  invisible(dev.off())
}

# Create a single "CMB spectrum plot". A CMB spectrum plot is always a
# plot fo something as a function of C_ell 'ell'. The plot is written to
# a file, using the specified device. All additional arguments are
# passed to the device function.
make.cmb.spectrum.plot <- function(colname, dframe, prefix, outdir, verbose, devname, ...)
{
  device.fcn <- get(devname)
  plotfile <- paste(outdir, "/", prefix, "_", colname, ".", devname, sep="")
  if (verbose) cat("Plotting", colname, "versus ell into", plotfile, "\n")
  device.fcn(plotfile, ...)
  print(xyplot( as.formula(paste(colname, "~ell"))
              , dframe
              , xlab = "ell"
              , ylab = paste("C_ell ", toupper(colname), "/uK^2", sep="")
              , grid=TRUE
              , type="l",
              , lwd = 2
              ))
  invisible(dev.off())
}

# Create the CMB spectrum plot with all spectra shown together. Because
# some of the spectra may have negative values, we take the absolute
# value (so that our log-log plot doesn't complain).
make.cmb.grand.spectrum.plot <- function(dframe, prefix, outdir, verbose, devname, ...)
{
  device.fcn <- get(devname)
  plotfile <- paste(outdir, "/", prefix, "_grand.", devname, sep="")
  if (verbose)
    cat("Plotting all spectra versus ell into", plotfile, "\n")
  device.fcn(plotfile, ...)
  print(xyplot( abs(value)~ell
              , dframe
              , xlab="ell"
              , ylab="C_ell spectra / uK^2"
              , grid=TRUE
              , type="l",
              , lwd = 2
              , group = variable
              , auto.key = list(space="right", points=FALSE, lines=TRUE)
              , scales = scales.log.log()
              , xscale.components = xscale.log()
              , yscale.components = yscale.log()
              ))
  invisible(dev.off())
}

# Make all the distance plots for files under the given top-level
# directory *topdir*. Distance plots are made for data files in the
# subdirectory "distances".
make.distance.plots <- function(topdir, verbose, prefix, outdir, devname)
{
  # data files are in "distances".
  datadir <- file.path(topdir, "distances")
  if (verbose) cat("Making distance plots from data in", datadir, "\n")

  # We don't want to read the "values.txt" file.
  excluded <- file.path(datadir, "values.txt")
  files <- Filter(function(x) {x!=excluded}, dir(datadir, full.names=TRUE))

  # Create a dataframe from all the named files.
  dframe <- make.dataframe.from.files(files)
  if (verbose)
     cat("Made the data frame for distances\n")

  # If we have a "h" column, we want to scale it. We do it here because
  # this is the function that knows about the nature of the directory
  # that it is working on.
  if (any(names(dframe) %in% "h"))
    dframe$h <- dframe$h * 2.99792458e+05

  # Plot each interesting column against "z".
  y.cols <- Filter(function(x) x!="z", names(dframe))
  for (y.col in y.cols)
    make.distance.plot(y.col, dframe, prefix, outdir, verbose, devname)
}

# Make all the CMB spectrum plots for files under the given top-level
# directory *topdir*. CMB spectrum plots are made for all data files in
# the subdirectory "cmb_cl".
make.cmb.spectrum.plots <- function(topdir, verbose, prefix, outdir, devname)
{
  # data files are in "cmb_cl"
  datadir <- file.path(topdir, "cmb_cl")
  if (verbose) cat("Making CMB spectrum plots from data in", datadir, "\n")

  files <- dir(datadir, full.names=TRUE)

  # Create a dataframe from all the named files.
  dframe <- make.dataframe.from.files(files)
  if (verbose)
    cat("Made the data frame for CMS spectrum plots\n")

  # Plot each interesting column against "C_ell"
  y.cols <- Filter(function(x) x!="ell", names(dframe))
  for (y.col in y.cols)
    make.cmb.spectrum.plot(y.col, dframe, prefix, outdir, verbose, devname)

  # Make a combined plot of all spectra versus "ell".
  molten<-melt(dframe, id="ell")
  make.cmb.grand.spectrum.plot(molten, prefix, outdir, verbose, devname)
}

make.matter.power.plots <- function(topdir, verbose, prefix, outdir, devname)
{
  # data files are in "matter_power_lin" and "matter_power_nl".
  lin_data_dir <- file.path(topdir, "matter_power_lin")
  nl_data_dir <- file.path(topdir, "matter_power_nl")

  if (verbose)
    cat("Making matter power plots from data in", lin_data_dir, "and", nl_data_dir)

  # We don't have to search what files are present, because the matter
  # power output format is special. Our handling has to rely on that.
  df.lin <- make.matter.power.dataframe.from.files(lin_data_dir, "linear")
  df.nl <- make.matter.power.dataframe.from.files(nl_data_dir, "nonlinear")

  # Combine the dataframes, creating appropriate factors.
  dframe <- rbind(df.lin, df.nl)
  dframe$type <- as.factor(dframe$type)

  plotfile <- paste(outdir, "/", prefix, "_matter_power.", devname, sep="")
  if (verbose)
    cat("Plotting matter power plot into", plotfile, "\n")
  log.log.scales=list( x=list(log=10, equispaced=FALSE)
                     , y=list(log=10, equispaced=FALSE)
                     )
  device.fcn = get(devname)
  device.fcn(plotfile)
  print( xyplot( p_k~k_h
               , subset(dframe, z==0)
               , ylab="p_k"
               , xlab="k"
               , group=type
               , type="l"
               , grid=TRUE
               , auto.key=list(space="top", lines=TRUE, points=FALSE)
               , scales = scales.log.log()
               , xscale.components = xscale.log()
               , yscale.components = yscale.log()
               ))
  invisible(dev.off())
}

################################################################################
###
### Start of the main program.

option_list <-
  list(  make_option( c("-v", "--verbose")
                     , action="store_true"
                     , default = FALSE
                     , help = "Print extra output [%default]"
                     )
       , make_option( c("-p", "--prefix")
                     , default="plot"
                     , type="character"
                     , help="Prefix for all output files"
                     )
       , make_option( c("-o", "--output")
                     , default="."
                     , type="character"
                     , help="Directory for all output files"
                     )
       , make_option( c("-d", "--device")
                    , default="png"
                    , type="character"
                    , help="Graphics device for plots: png or pdf"
                    )
       )

parser <- OptionParser(option_list=option_list, usage="%prog [options] directory")
args   <- parse_args(parser, positional_arguments = TRUE)
opt    <- args$options

if (length(args$args) != 1)
  {
    cat("Incorrect number of required arguments\n\n")
    print_help(parser)
    stop()    
  }

input.directory <- as.character(args$args)
if (opt$output != ".")
  if (! file.exists(opt$output))
    dir.create(opt$output, recursive=TRUE)

opt$device <- tolower(opt$device)

if (opt$device %in% c("png", "pdf") == FALSE)
{
  cat("Device", opt$device, "is not supported, using png\n")
  opt$device <- "png"
}

if (opt$verbose) 
   cat("Processing files in", input.directory, "\n")
                   
make.distance.plots(input.directory, opt$verbose, opt$prefix, opt$output, opt$device)
make.cmb.spectrum.plots(input.directory, opt$verbose, opt$prefix, opt$output, opt$device)
make.matter.power.plots(input.directory, opt$verbose, opt$prefix, opt$output, opt$device)

!> Module for reading and writing to files
module read_write_module
    use utils_module, only: dp
    implicit none
    interface read_doubles
        module procedure read_doubles_1, read_doubles_2, read_doubles_3
    end interface read_doubles
    interface write_doubles
        module procedure write_doubles_1, write_doubles_2, write_doubles_3
    end interface write_doubles

    contains

    !> Check to see whether resume file exists
    function resume_file_exists(settings) result(resume)
        use settings_module, only: program_settings
        implicit none

        !> settings variable to get the base_dir and root_name out of
        type(program_settings), intent(in) :: settings
        !> Whether or not we should resume from file
        logical :: resume

        ! See if the resume file with the correct name exists
        inquire(                                     &! Inquire function
            file=trim(resume_file(settings,.false.)),&! file name defined by subroutine resume_file
            exist=resume                             &! return whether this exists
            )

    end function resume_file_exists


    !> Remove resume files
    subroutine delete_files(settings)
        use settings_module, only: program_settings
        use utils_module, only: delete_file,verbose_fb
        implicit none

        !> settings variable to get the base_dir and root_name out of
        type(program_settings), intent(in) :: settings

        integer :: i_cluster ! cluster iterator

        logical :: deleted ! Whether a file has been deleted

        logical :: fb ! Temporary feedback variable

        fb = settings%feedback>=verbose_fb

        deleted = delete_file( stats_file(settings), fb )          ! Delete stats file
        deleted = delete_file( phys_live_file(settings), fb )      ! Delete phys_live file
        deleted = delete_file( resume_file(settings,.false.), fb ) ! Delete temp resume file
        deleted = delete_file( resume_file(settings,.true.), fb )  ! Delete resume file


        ! Delete posterior files
        deleted = delete_file( posterior_file(settings,.true.), fb )
        deleted = delete_file( posterior_file(settings,.false.), fb )

        i_cluster = 1
        do while ( &
                delete_file( posterior_file(settings,.true.,.false.,i_cluster), fb ) .or.  &
                delete_file( posterior_file(settings,.false.,.false.,i_cluster), fb )   &
                )
            i_cluster = i_cluster + 1
        end do


    end subroutine delete_files

    subroutine rename_files(settings,RTI)
        use settings_module, only: program_settings
        use run_time_module, only: run_time_info
        implicit none
        type(program_settings), intent(in) :: settings
        type(run_time_info),    intent(in) :: RTI

        integer i_cluster

        ! Move the resume file if resume
        if(settings%write_resume) call rename(trim(resume_file(settings,.true.)),trim(resume_file(settings,.false.)))

        ! Rename the files
        if(settings%equals) then
            call rename(trim(posterior_file(settings,.false.,.true.)),trim(posterior_file(settings,.false.,.false.)))
            do i_cluster = 1,RTI%ncluster+RTI%ncluster_dead
                call rename(trim(posterior_file(settings,.false.,.true.,i_cluster)),trim(posterior_file(settings,.false.,.false.,i_cluster)))
            end do
        end if

        if(settings%posteriors) then
            call rename(trim(posterior_file(settings,.true. ,.true.)),trim(posterior_file(settings,.true. ,.false.)))
            do i_cluster = 1,RTI%ncluster+RTI%ncluster_dead
                call rename(trim(posterior_file(settings,.true.,.true.,i_cluster)),trim(posterior_file(settings,.true.,.false.,i_cluster)))
            end do
        end if
    end subroutine rename_files
    








    subroutine write_integer(a,str)
        use utils_module, only: write_resume_unit,integer_format
        implicit none
        integer, intent(in) :: a
        character(len=*), intent(in),optional :: str

        if(present(str)) write(write_resume_unit,'("'//trim(str)//'")')
        write(write_resume_unit,integer_format(1)) a

    end subroutine write_integer

    subroutine write_integers(arr,str)
        use utils_module, only: write_resume_unit,integer_format
        implicit none
        integer,dimension(:), intent(in) :: arr
        character(len=*), intent(in),optional :: str

        if(present(str)) write(write_resume_unit,'("'//trim(str)//'")')
        if(size(arr)>0) write(write_resume_unit,integer_format(size(arr))) arr

    end subroutine write_integers
    
    subroutine write_double(a,str)
        use utils_module, only: write_resume_unit,double_format
        implicit none
        real(dp), intent(in) :: a
        character(len=*), intent(in),optional :: str

        if(present(str)) write(write_resume_unit,'("'//trim(str)//'")')
        write(write_resume_unit,double_format(1)) a

    end subroutine write_double

    subroutine write_doubles_1(arr,str)
        use utils_module, only: write_resume_unit,double_format
        implicit none
        real(dp),dimension(:), intent(in) :: arr
        character(len=*), intent(in),optional :: str

        if(present(str)) write(write_resume_unit,'("'//trim(str)//'")')
        if(size(arr)>0) write(write_resume_unit,double_format(size(arr))) arr

    end subroutine write_doubles_1

    subroutine write_doubles_2(arr,str,n)
        use utils_module, only: write_resume_unit,double_format
        implicit none
        real(dp),dimension(:,:), intent(in) :: arr
        integer, intent(in), optional :: n
        character(len=*), intent(in),optional :: str
        integer :: i

        if(present(str)) write(write_resume_unit,'("'//trim(str)//'")')
        if(present(n)) then
            do i=1,n
                call write_doubles( arr(:,i) )
            end do
        else
            do i=1,size(arr,2)
                call write_doubles( arr(:,i) )
            end do
        end if

    end subroutine write_doubles_2

    subroutine write_doubles_3(arr,str,n)
        use utils_module, only: write_resume_unit,double_format
        implicit none
        real(dp),dimension(:,:,:), intent(in) :: arr
        integer, intent(in),dimension(size(arr,3)),optional :: n
        character(len=*), intent(in),optional :: str
        integer :: i

        if(present(str)) write(write_resume_unit,'("'//trim(str)//'")')
        do i=1,size(arr,3)
            if(present(n)) then
                call write_doubles( arr(:,:,i), '---------------------------------------',n(i) )
            else
                call write_doubles( arr(:,:,i), '---------------------------------------' )
            end if
        end do

    end subroutine write_doubles_3



    subroutine write_resume_file(settings,RTI)
        use utils_module,    only: write_resume_unit
        use run_time_module, only: run_time_info
        use settings_module, only: program_settings

        implicit none
        type(program_settings), intent(in) :: settings
        type(run_time_info),    intent(in) :: RTI

        ! Open the .resume file
        open(write_resume_unit,file=trim(resume_file(settings,.true.)), action='write') 

        ! write integers 
        call write_integer(settings%nDims,           "=== Number of dimensions ===")
        call write_integer(settings%nDerived,        "=== Number of derived parameters ===")                    
        call write_integer(RTI%ndead,                "=== Number of dead points/iterations ===")                    
        call write_integer(RTI%ncluster,             "=== Number of clusters ===")
        call write_integer(RTI%ncluster_dead,        "=== Number of dead clusters ===")
        call write_integer(RTI%nposterior_global,    "=== Number of global weighted posterior points ===")
        call write_integer(RTI%nequals_global,       "=== Number of global equally weighted posterior points ===")
        call write_integer(size(settings%grade_dims),"=== Number of grades ===")
        call write_integers(settings%grade_dims,     "=== positions of grades ===")
        call write_integers(RTI%num_repeats,         "=== Number of repeats ===")
        call write_integers(RTI%nlike,               "=== Number of likelihood calls ===")                    
        call write_integers(RTI%nlive,               "=== Number of live points in each cluster ===")
        call write_integers(RTI%nphantom,            "=== Number of phantom points in each cluster ===")                    
        call write_integers(RTI%nposterior,          "=== Number of weighted posterior points in each cluster ===")                    
        call write_integers(RTI%nequals,             "=== Number of equally weighted posterior points in each cluster ===")                    
        call write_integers(RTI%i,                   "=== Minimum loglikelihood positions ===")                    
        call write_integers(RTI%nposterior_dead,     "=== Number of weighted posterior points in each dead cluster ===")
        call write_integers(RTI%nequals_dead,        "=== Number of equally weighted posterior points in each dead cluster ===")
  
       ! write evidences
        call write_double(RTI%logZ,                  "=== global evidence -- log(<Z>) ===")                    
        call write_double(RTI%logZ2,                 "=== global evidence^2 -- log(<Z^2>) ===")                    
        call write_double(RTI%thin_posterior,        "=== posterior thin factor ===")                    
        call write_doubles(RTI%logLp,                "=== local loglikelihood bounds ===")                    
        call write_doubles(RTI%logXp,                "=== local volume -- log(<X_p>) ===")                    
        call write_double(RTI%logX_last_update,      "=== last update volume ===")                    
        call write_doubles(RTI%logZXp,               "=== global evidence volume cross correlation -- log(<ZX_p>) ===")                    
        call write_doubles(RTI%logZp,                "=== local evidence -- log(<Z_p>) ===")                    
        call write_doubles(RTI%logZp2,               "=== local evidence^2 -- log(<Z_p^2>) ===")                    
        call write_doubles(RTI%logZpXp,              "=== local evidence volume cross correlation -- log(<Z_pX_p>) ===")                    
        call write_doubles_2(RTI%logXpXq,            "=== local volume cross correlation -- log(<X_pX_q>) ===")                    
        call write_doubles(RTI%maxlogweight,         "=== maximum log weights -- log(w_p) ===")                    
  
        call write_doubles(RTI%logZp_dead,           "=== local dead evidence -- log(<Z_p>) ===")
        call write_doubles(RTI%logZp2_dead,          "=== local dead evidence^2 -- log(<Z_p^2>) ===")
        call write_doubles(RTI%maxlogweight_dead,    "=== maximum dead log weights -- log(w_p) ===")                    
  
        call write_doubles(RTI%covmat,             "=== covariance matrices ===")
        call write_doubles(RTI%cholesky,           "=== cholesky decompositions ===")
  
        call write_doubles(RTI%live,                  "=== live points ===",                               RTI%nlive )
        call write_doubles(RTI%dead,                  "=== dead points ===",                               RTI%ndead )
        call write_doubles(RTI%logweights(:RTI%ndead),"=== logweights of dead points ===")
        call write_doubles(RTI%phantom,               "=== phantom points ===",                            RTI%nphantom )
        call write_doubles(RTI%posterior,             "=== weighted posterior points ===",                 RTI%nposterior )
        call write_doubles(RTI%posterior_dead,        "=== dead weighted posterior points ===",            RTI%nposterior_dead )
        call write_doubles(RTI%posterior_global,      "=== global weighted posterior points ===",          RTI%nposterior_global )
        call write_doubles(RTI%equals,                "=== equally weighted posterior points ===",         RTI%nequals )
        call write_doubles(RTI%equals_dead,           "=== dead equally weighted posterior points ===",    RTI%nequals_dead )
        call write_doubles(RTI%equals_global,         "=== global equally weighted posterior points ===",  RTI%nequals_global )

        ! Close the writing file
        close(write_resume_unit)

        write(*, *) "Resume data written to ", trim(resume_file(settings,.true.))

    end subroutine write_resume_file






    subroutine read_integer(a,str)
        use utils_module, only: read_resume_unit,integer_format
        implicit none
        integer, intent(out) :: a
        character(len=*), intent(in),optional :: str

        if(present(str)) read(read_resume_unit,*)
        read(read_resume_unit,integer_format(1)) a

    end subroutine read_integer

    subroutine read_integers(arr,str,n)
        use utils_module, only: read_resume_unit,integer_format
        implicit none
        integer, allocatable, dimension(:), intent(out) :: arr
        integer, intent(in) :: n
        character(len=*), intent(in),optional :: str

        if(present(str)) read(read_resume_unit,*)
        allocate(arr(n))
        if(n>0) read(read_resume_unit,integer_format(n)) arr

    end subroutine read_integers

    subroutine read_double(a,str)
        use utils_module, only: read_resume_unit,double_format
        implicit none
        real(dp), intent(out) :: a
        character(len=*), intent(in),optional :: str

        if(present(str)) read(read_resume_unit,*)
        read(read_resume_unit,double_format(1)) a

    end subroutine read_double

    subroutine read_doubles_1(arr,str,n)
        use utils_module, only: read_resume_unit,double_format
        implicit none
        real(dp),allocatable,dimension(:), intent(out) :: arr
        integer,intent(in) :: n
        character(len=*), intent(in),optional :: str

        if(present(str)) read(read_resume_unit,*)
        allocate(arr(n))
        if(n>0) read(read_resume_unit,double_format(n)) arr

    end subroutine read_doubles_1

    subroutine read_doubles_2(arr,str,n1,n2)
        use utils_module, only: read_resume_unit,double_format
        implicit none
        real(dp),allocatable,dimension(:,:), intent(out) :: arr
        integer,intent(in) :: n1,n2
        character(len=*), intent(in),optional :: str
        integer :: i2

        if(present(str)) read(read_resume_unit,*)
        allocate(arr(n1,n2))
        do i2=1,n2
            read(read_resume_unit,double_format(n1)) arr(:,i2)
        end do

    end subroutine read_doubles_2

    subroutine read_doubles_3(arr,str,n1,n2,n3,n)
        use utils_module, only: read_resume_unit,double_format
        implicit none
        real(dp),allocatable,dimension(:,:,:), intent(out) :: arr
        integer,intent(in) :: n1,n2,n3
        integer,optional,intent(in),dimension(n3) :: n
        character(len=*), intent(in),optional :: str
        integer :: i2,i3,m

        if(present(str)) read(read_resume_unit,*)
        allocate(arr(n1,n2,n3))
        do i3=1,n3
            read(read_resume_unit,*)
            if(present(n)) then
                m=n(i3)
            else
                m=n2
            end if
            do i2=1,m
                read(read_resume_unit,double_format(n1)) arr(:,i2,i3)
            end do
        end do

    end subroutine read_doubles_3

    subroutine read_resume_file(settings,RTI)
        use utils_module,    only: read_resume_unit
        use run_time_module, only: run_time_info
        use settings_module, only: program_settings
        use abort_module,    only: halt_program
        implicit none

        type(program_settings), intent(in) :: settings
        type(run_time_info),    intent(out) :: RTI

        integer :: i_temp
        integer,allocatable,dimension(:) :: i_temps
        integer :: ngrades

        ! Open the .resume file
        open(read_resume_unit,file=trim(resume_file(settings,.false.)), action='read') 

        call read_integer(i_temp,'-') ! number of dimensions
        if(settings%nDims/=i_temp) call halt_program('resume error: nDims does not match')
  
        call read_integer(i_temp,'-') ! number of derived parameters
        if(settings%nDerived/=i_temp) call halt_program('resume error: nDerived does not match')
  
        call read_integer(RTI%ndead,'-')             ! number of dead points
        call read_integer(RTI%ncluster,'-')          ! number of clusters
        call read_integer(RTI%ncluster_dead,'-')     ! number of dead clusters
        call read_integer(RTI%nposterior_global,'-') ! number of weighted posteriors 
        call read_integer(RTI%nequals_global,'-')    ! number of equally weighted posteriors 
  
        call read_integer(ngrades,'-') ! check the number of grades
        if(size(settings%grade_dims)/=ngrades) call halt_program('resume error: number of grades does not match')
  
        call read_integers(i_temps,'-',ngrades)    ! check the grades themselves
        if(any(settings%grade_dims/=i_temps)) call halt_program('resume error: Grades do not match') 
  
        call read_integers(RTI%num_repeats,'-',ngrades)  ! number of repeats per grade
        call read_integers(RTI%nlike,'-',ngrades)        ! number of likelihood calls per grade
  
        call read_integers(RTI%nlive,'-',RTI%ncluster)
        call read_integers(RTI%nphantom,'-',RTI%ncluster)
        call read_integers(RTI%nposterior,'-',RTI%ncluster)
        call read_integers(RTI%nequals,'-',RTI%ncluster)
        call read_integers(RTI%i,'-',RTI%ncluster)
  
        ! Check to see if this is consistent with settings
        !if(settings%nlive/=sum(RTI%nlive)) call halt_program('resume error: nlive does not match')
  
        call read_integers(RTI%nposterior_dead,'-',RTI%ncluster_dead)
        call read_integers(RTI%nequals_dead,'-',RTI%ncluster_dead)
        call read_double(RTI%logZ,'-')
        call read_double(RTI%logZ2,'-')
        call read_double(RTI%thin_posterior,'-')
        
        call read_doubles(RTI%logLp,'-',RTI%ncluster)
        call read_doubles(RTI%logXp,'-',RTI%ncluster)
        call read_double(RTI%logX_last_update,'-')
        call read_doubles(RTI%logZXp,'-',RTI%ncluster)
        call read_doubles(RTI%logZp,'-',RTI%ncluster)
        call read_doubles(RTI%logZp2,'-',RTI%ncluster)
        call read_doubles(RTI%logZpXp,'-',RTI%ncluster)
        call read_doubles(RTI%logXpXq,'-',RTI%ncluster,RTI%ncluster)
        call read_doubles(RTI%maxlogweight,'-',RTI%ncluster)
  
        call read_doubles(RTI%logZp_dead,'-',RTI%ncluster_dead)
        call read_doubles(RTI%logZp2_dead,'-',RTI%ncluster_dead)
        call read_doubles(RTI%maxlogweight_dead,'-',RTI%ncluster_dead)
  
        call read_doubles(RTI%covmat,'-',settings%nDims,settings%nDims,RTI%ncluster)
        call read_doubles(RTI%cholesky,'-',settings%nDims,settings%nDims,RTI%ncluster)
  
        call read_doubles(RTI%live,'-',settings%nTotal,maxval(RTI%nlive),RTI%ncluster,RTI%nlive)
        call read_doubles(RTI%dead,'-',settings%nTotal,RTI%ndead)
        call read_doubles(RTI%logweights,'-',RTI%ndead)
        call read_doubles(RTI%phantom,'-',settings%nTotal,maxval(RTI%nphantom),RTI%ncluster,RTI%nphantom)
  
        call read_doubles(RTI%posterior,'-',settings%nposterior,maxval(RTI%nposterior),RTI%ncluster,RTI%nposterior)
        call read_doubles(RTI%posterior_dead,'-',settings%nposterior,maxval(RTI%nposterior_dead),RTI%ncluster_dead,RTI%nposterior_dead)
        call read_doubles(RTI%posterior_global,'-',settings%nposterior,RTI%nposterior_global)
  
        call read_doubles(RTI%equals,'-',settings%np,maxval(RTI%nequals),RTI%ncluster,RTI%nequals)
        call read_doubles(RTI%equals_dead,'-',settings%np,maxval(RTI%nequals_dead),RTI%ncluster_dead,RTI%nequals_dead)
        call read_doubles(RTI%equals_global,'-',settings%np,RTI%nequals_global)

        ! Close the reading unit
        close(read_resume_unit)

        ! Allocate the posterior stack if we're calculating this
        allocate(RTI%posterior_stack(settings%nposterior,settings%nlive,RTI%ncluster),RTI%nposterior_stack(RTI%ncluster))
        RTI%nposterior_stack = 0 ! Initialise number of posterior points at 0

        RTI%maxlogweight_global = maxval(RTI%maxlogweight)

        write(*, *) "Resume data read from ", trim(resume_file(settings,.true.))


    end subroutine read_resume_file


    subroutine write_posterior_file(settings,RTI)
        use utils_module, only: DB_FMT,fmt_len,write_posterior_unit,write_equals_unit,sort_doubles
        use settings_module, only: program_settings
        use run_time_module, only: run_time_info 
        implicit none

        type(program_settings), intent(in)    :: settings
        type(run_time_info),    intent(inout) :: RTI

        integer :: i_cluster
        integer :: i_post
        real(dp) :: weight

        integer, dimension(RTI%ncluster+RTI%ncluster_dead) :: ordering

        character(len=fmt_len) :: fmt_dbl

        ! Assign the writing format
        write(fmt_dbl,'("(",I0,A,")")') settings%np,DB_FMT 

        ! ============= Equally weighted posteriors ================
        if(settings%equals) then
            ! ------------- global equally weighted posteriors ----------------

            ! Open the equally weighted global posterior file
            open(write_equals_unit,file=trim(posterior_file(settings,.false.,.true.)))

            ! Print out the posteriors
            do i_post=1,RTI%nequals_global
                write(write_equals_unit,fmt_dbl) 1d0,RTI%equals_global(settings%p_2l:,i_post)
            end do

            ! Close the equally weighted global posterior file
            close(write_equals_unit)


            ! Sort the indices into order
            ordering = sort_doubles([-RTI%logZp,-RTI%logZp_dead])

            ! ------------- cluster equally weighted posteriors ----------------

            if(settings%cluster_posteriors) then

                do i_cluster = 1,RTI%ncluster+RTI%ncluster_dead

                    if(ordering(i_cluster)<=RTI%ncluster) then
                        ! Open the equally weighted cluster posterior file
                        open(write_equals_unit,file=trim(posterior_file(settings,.false.,.true.,i_cluster)))

                        ! Print out the posterior for the active clusters
                        do i_post = 1,RTI%nequals(ordering(i_cluster))
                            write(write_equals_unit,fmt_dbl) exp(RTI%logZp(ordering(i_cluster))-RTI%logZ),RTI%equals(settings%p_2l:,i_post,ordering(i_cluster))
                        end do

                    else
                        ! Open the equally weighted cluster posterior file
                        open(write_equals_unit,file=trim(posterior_file(settings,.false.,.true.,i_cluster)))

                        ! Print out the posterior for the dead clusters
                        do i_post = 1,RTI%nequals_dead(ordering(i_cluster)-RTI%ncluster)
                            write(write_equals_unit,fmt_dbl) exp(RTI%logZp_dead(ordering(i_cluster)-RTI%ncluster)-RTI%logZ),RTI%equals_dead(settings%p_2l:,i_post,ordering(i_cluster)-RTI%ncluster)
                        end do
                    end if

                    ! Close the equally weighted cluster posterior file
                    close(write_equals_unit)

                end do

            end if
        end if

        ! ============= weighted posteriors ================
        if(settings%posteriors) then
            ! ------------- global weighted posteriors ----------------

            ! Open the weighted global posterior file
            open(write_posterior_unit,file=trim(posterior_file(settings,.true.,.true.)))

            ! Print out the posteriors
            do i_post=1,RTI%nposterior_global
                weight = exp(RTI%posterior_global(settings%pos_w,i_post) + RTI%posterior_global(settings%pos_l,i_post) - RTI%maxlogweight_global) 
                if( weight>0d0  ) write(write_posterior_unit,fmt_dbl) weight,-2*RTI%posterior_global(settings%pos_l,i_post),RTI%posterior_global(settings%pos_p0:,i_post) 
            end do

            ! Close the weighted global posterior file
            close(write_posterior_unit)

            ! ------------- cluster weighted posteriors ----------------
            if(settings%cluster_posteriors) then
                do i_cluster = 1,RTI%ncluster+RTI%ncluster_dead

                    if(ordering(i_cluster)<=RTI%ncluster) then

                        ! Open the weighted cluster posterior file
                        open(write_posterior_unit,file=trim(posterior_file(settings,.true.,.true.,i_cluster)))

                        ! Print out the posterior for the active clusters
                        do i_post = 1,RTI%nposterior(ordering(i_cluster))
                            weight = exp(RTI%posterior(settings%pos_w,i_post,ordering(i_cluster)) + RTI%posterior(settings%pos_l,i_post,ordering(i_cluster)) - RTI%maxlogweight(ordering(i_cluster)) +RTI%logZp(ordering(i_cluster))-RTI%logZ)
                            if( weight>0d0  ) write(write_posterior_unit,fmt_dbl) weight,-2*RTI%posterior(settings%pos_l,i_post,ordering(i_cluster)),RTI%posterior(settings%pos_p0:,i_post,ordering(i_cluster)) 
                        end do
                    else

                        ! Open the weighted cluster posterior file
                        open(write_posterior_unit,file=trim(posterior_file(settings,.true.,.true.,i_cluster+RTI%ncluster)))

                        ! Print out the posterior for the dead clusters
                        do i_post = 1,RTI%nposterior_dead(ordering(i_cluster)-RTI%ncluster)
                            weight = exp(RTI%posterior_dead(settings%pos_w,i_post,ordering(i_cluster)-RTI%ncluster) + RTI%posterior_dead(settings%pos_l,i_post,ordering(i_cluster)-RTI%ncluster) - RTI%maxlogweight_dead(ordering(i_cluster)-RTI%ncluster) +RTI%logZp_dead(ordering(i_cluster)-RTI%ncluster)-RTI%logZ)
                            if( weight>0d0  ) write(write_posterior_unit,fmt_dbl) weight,-2*RTI%posterior_dead(settings%pos_l,i_post,ordering(i_cluster)-RTI%ncluster),RTI%posterior_dead(settings%pos_p0:,i_post,ordering(i_cluster)-RTI%ncluster) 
                        end do

                    end if

                    ! Close the weighted cluster posterior file
                    close(write_posterior_unit)

                end do
            end if
        end if

        ! Rename the files
        if(settings%equals) then
            call rename(trim(posterior_file(settings,.false.,.true.)),trim(posterior_file(settings,.false.,.false.)))
            do i_cluster = 1,RTI%ncluster+RTI%ncluster_dead
                call rename(trim(posterior_file(settings,.false.,.true.,i_cluster)),trim(posterior_file(settings,.false.,.false.,i_cluster)))
            end do
        end if

        if(settings%posteriors) then
            call rename(trim(posterior_file(settings,.true. ,.true.)),trim(posterior_file(settings,.true. ,.false.)))
            do i_cluster = 1,RTI%ncluster+RTI%ncluster_dead
                call rename(trim(posterior_file(settings,.true.,.true.,i_cluster)),trim(posterior_file(settings,.true.,.false.,i_cluster)))
            end do
        end if

    end subroutine write_posterior_file



    subroutine write_phys_live_points(settings,RTI)
        use utils_module, only: DB_FMT,fmt_len,write_phys_unit,write_phys_cluster_unit, write_live_birth_unit
        use settings_module, only: program_settings 
        use run_time_module, only: run_time_info 
        implicit none

        type(program_settings), intent(in) :: settings
        type(run_time_info),    intent(in) :: RTI

        integer i_live
        integer i_cluster

        character(len=fmt_len) :: fmt_dbl, fmt_dbl_1

        ! Initialise the formats
        write(fmt_dbl,'("(",I0,A,")")') settings%nDims+settings%nDerived+1, DB_FMT
        write(fmt_dbl_1,'("(",I0,A,")")') settings%nDims+settings%nDerived+2, DB_FMT


        ! Open a new file for appending to
        open(write_phys_unit,file=trim(phys_live_file(settings)), action='write')
        open(write_live_birth_unit,file=trim(phys_live_birth_file(settings)), action='write')

        do i_cluster = 1,RTI%ncluster

            if(settings%do_clustering) open(write_phys_cluster_unit,file=trim(phys_live_file(settings,i_cluster)), action='write') 

            do i_live=1,RTI%nlive(i_cluster)
                write(write_phys_unit,fmt_dbl) &
                    RTI%live(settings%p0:settings%d1,i_live,i_cluster), &
                    RTI%live(settings%l0,i_live,i_cluster)

                write(write_live_birth_unit,fmt_dbl_1) &
                    RTI%live(settings%p0:settings%d1,i_live,i_cluster), &
                    RTI%live(settings%l0,i_live,i_cluster), &
                    RTI%live(settings%b0,i_live,i_cluster)

                if(settings%do_clustering) then
                    write(write_phys_cluster_unit,fmt_dbl) &
                        RTI%live(settings%p0:settings%d1,i_live,i_cluster), &
                        RTI%live(settings%l0,i_live,i_cluster)
                end if

            end do

            if(settings%do_clustering) close(write_phys_cluster_unit)

        end do

        close(write_phys_unit)
        close(write_live_birth_unit)


    end subroutine write_phys_live_points


    subroutine write_dead_points(settings,RTI)
        use utils_module, only: DB_FMT,fmt_len,write_dead_unit, write_dead_birth_unit
        use settings_module, only: program_settings 
        use run_time_module, only: run_time_info 
        implicit none

        type(program_settings), intent(in) :: settings
        type(run_time_info),    intent(in) :: RTI

        integer i_dead

        character(len=fmt_len) :: fmt_dbl

        ! Initialise the formats
        write(fmt_dbl,'("(",I0,A,")")') settings%nDims+settings%nDerived+1, DB_FMT

        ! Open a new file for appending to
        open(write_dead_unit,file=trim(dead_file(settings)), action='write')

        do i_dead=1,RTI%ndead
            write(write_dead_unit,fmt_dbl) &
                RTI%dead(settings%l0,i_dead), &
                RTI%dead(settings%p0:settings%d1,i_dead)
        end do
        close(write_dead_unit)

        write(fmt_dbl,'("(",I0,A,")")') settings%nDims+settings%nDerived+2, DB_FMT

        open(write_dead_birth_unit,file=trim(dead_birth_file(settings)), action='write')
        do i_dead=1,RTI%ndead
            write(write_dead_birth_unit,fmt_dbl) &
                RTI%dead(settings%p0:settings%d1,i_dead), &
                RTI%dead(settings%l0,i_dead), &
                RTI%dead(settings%b0,i_dead)
        end do
        close(write_dead_birth_unit)


    end subroutine write_dead_points

    subroutine write_prior_file(settings,RTI)
        use utils_module, only: DB_FMT,fmt_len,write_prior_unit
        use settings_module, only: program_settings 
        use run_time_module, only: run_time_info 
        implicit none

        type(program_settings), intent(in) :: settings
        type(run_time_info),    intent(in) :: RTI

        integer i_prior

        character(len=fmt_len) :: fmt_dbl

        ! Initialise the formats
        write(fmt_dbl,'("(",I0,A,")")') settings%np,DB_FMT 

        ! Open a new file for appending to
        open(write_prior_unit,file=trim(prior_file(settings)), action='write')

        do i_prior=1,RTI%nlive(1)
            write(write_prior_unit,fmt_dbl) &
                1d0,&
                -2*RTI%live(settings%l0,i_prior,1), &
                RTI%live(settings%p0:settings%d1,i_prior,1)
        end do

        close(write_prior_unit)


    end subroutine write_prior_file

    subroutine write_stats_file(settings,RTI,nlikesum)
        use utils_module, only: DB_FMT,fmt_len,write_stats_unit,logsubexp
        use settings_module, only: program_settings
        use run_time_module, only: run_time_info,calculate_logZ_estimate
        implicit none

        type(program_settings), intent(in) :: settings
        type(run_time_info),    intent(in) :: RTI
        integer,dimension(:),   intent(in) :: nlikesum    !> number of likelihood calls since last call

        real(dp)                           :: logZ       
        real(dp)                           :: varlogZ  
        real(dp), dimension(RTI%ncluster)  :: logZp      
        real(dp), dimension(RTI%ncluster)  :: varlogZp 
        real(dp), dimension(RTI%ncluster_dead) :: logZp_dead      
        real(dp), dimension(RTI%ncluster_dead) :: varlogZp_dead 
        real(dp), dimension(settings%nDims+settings%nDerived) :: mu,sig
        real(dp)                           :: update_files

        integer :: p, i_dims

        character(len=fmt_len) :: fmt_Z,fmt_nlike

        open(write_stats_unit,file=trim(stats_file(settings)), action='write') 

        call calculate_logZ_estimate(RTI,logZ,varlogZ,logZp,varlogZp,logZp_dead,varlogZp_dead)            


        write(fmt_Z,'("(""log(Z)       = "",", A, ","" +/- "",", A, ")")') DB_FMT,DB_FMT


        write(write_stats_unit, '("Evidence estimates:")')
        write(write_stats_unit, '("===================")')
        write(write_stats_unit, '("  - The evidence Z is a log-normally distributed, with location and scale parameters mu and sigma.")')
        write(write_stats_unit, '("  - We denote this as log(Z) = mu +/- sigma.")')
        write(write_stats_unit,'("")')
        write(write_stats_unit, '("Global evidence:")')
        write(write_stats_unit, '("----------------")')
        write(write_stats_unit,'("")')
        write(write_stats_unit,fmt_Z) logZ,sqrt(abs(varlogZ))
        write(write_stats_unit,'("")')
        write(write_stats_unit,'("")')
        write(write_stats_unit, '("Local evidences:")')
        write(write_stats_unit, '("----------------")')
        write(write_stats_unit,'("")')

        write(fmt_Z,'("(""log(Z_"",",A,","")  = "",", A, ","" +/- "",", A, ","" (Still Active)"")")') 'I2',DB_FMT,DB_FMT
        do p=1,RTI%ncluster
            write(write_stats_unit,fmt_Z) p, logZp(p), sqrt(abs(varlogZp(p)))
        end do
        write(fmt_Z,'("(""log(Z_"",",A,","")  = "",", A, ","" +/- "",", A, ")")') 'I2',DB_FMT,DB_FMT
        do p=1,RTI%ncluster_dead
            write(write_stats_unit,fmt_Z) p+RTI%ncluster, logZp_dead(p), sqrt(abs(varlogZp_dead(p)))
        end do

        write(write_stats_unit,'("")')
        write(write_stats_unit,'("")')
        write(write_stats_unit, '("Run-time information:")')
        write(write_stats_unit, '("---------------------")')
        write(write_stats_unit,'("")')
        write(write_stats_unit,'(" ncluster:   ", I8," /",I8           )') RTI%ncluster, RTI%ncluster+RTI%ncluster_dead
        write(write_stats_unit,'(" nposterior: ", I8                   )') RTI%nposterior_global
        write(write_stats_unit,'(" nequals:    ", I8                   )') RTI%nequals_global
        write(write_stats_unit,'(" ndead:      ", I8)') RTI%ndead
        write(write_stats_unit,'(" nlive:      ", I8)') sum(RTI%nlive)

        write(fmt_nlike,'("("" nlike:      "",",I0,"I8)")') size(nlikesum)
        write(write_stats_unit,fmt_nlike) RTI%nlike

        write(fmt_nlike,'(  "("" <nlike>:    "","  ,I0,   "F8.2,""   ("",",I0,"F8.2, "" per slice )"")")') size(nlikesum), size(nlikesum)
        if (sum(RTI%nlive)>0) then
            update_files = -sum(RTI%nlive)*log(settings%compression_factor)
            write(write_stats_unit,fmt_nlike) dble(nlikesum)/update_files,dble(nlikesum)/dble(RTI%num_repeats*update_files)
        else
            write(write_stats_unit,fmt_nlike) [(0d0, p=1,size(nlikesum))], [(0d0, p=1,size(nlikesum))]
        end if

        if (settings%posteriors) then
            write(fmt_Z,'("(I3,", A, ","" +/- "",", A, ")")') DB_FMT,DB_FMT
            write(write_stats_unit,'("")')
            write(write_stats_unit,'("")')
            write(write_stats_unit, '("Dim No.       Mean        Sigma")')
            mu = mean(RTI,settings)
            sig = sqrt(variance(RTI,settings))
            do i_dims=1,settings%nDims
                write(write_stats_unit,fmt_Z) i_dims, mu(i_dims), sig(i_dims)
            end do
        end if


        close(write_stats_unit)

    end subroutine write_stats_file

    function mean(RTI,settings) result(mu)
        use settings_module, only: program_settings
        use run_time_module, only: run_time_info
        implicit none
        type(run_time_info),    intent(in) :: RTI
        type(program_settings), intent(in) :: settings

        integer i
        real(dp), dimension(settings%nDims+settings%nDerived) :: mu,x
        real(dp) :: wsum, w
        mu = 0

        do i=1,RTI%nposterior_global
            x = RTI%posterior_global(settings%pos_p0:settings%pos_d1,i)
            w = RTI%posterior_global(settings%pos_w,i) 
            wsum = wsum + w
            mu = mu + (w/wsum)*(x-mu)
        end do
        

    end function mean

    function variance(RTI,settings) result(var)
        use settings_module, only: program_settings
        use run_time_module, only: run_time_info
        implicit none
        type(run_time_info),    intent(in) :: RTI
        type(program_settings), intent(in) :: settings

        integer i
        real(dp), dimension(settings%nDims+settings%nDerived) :: mu,mu_old,x,var,S
        real(dp) :: w, wsum
        mu = 0

        do i=1,RTI%nposterior_global
            x = RTI%posterior_global(settings%pos_p0:settings%pos_d1,i)
            w = RTI%posterior_global(settings%pos_w,i) 
            mu_old = mu
            wsum = wsum + w
            mu = mu_old + (w/wsum)*(x-mu_old)
            S = S + w * (x-mu_old)*(x-mu)
        end do
        if (RTI%nposterior_global <= 0) then
            var = 0
        else
            var = S/wsum
        end if

    end function variance


    subroutine write_paramnames_file(settings,params,derived_params)
        use priors_module, only: prior
        use settings_module,   only: program_settings
        use utils_module,  only: paramnames_unit
        use params_module, only: param_type
        implicit none
        
        type(program_settings),intent(in)                    :: settings       !> Program settings
        type(param_type),dimension(:),allocatable,intent(in) :: params         !> Parameter array
        type(param_type),dimension(:),allocatable,intent(in) :: derived_params !> Derived parameter array

        integer :: i

        open(unit=paramnames_unit,file=trim(paramnames_file(settings)))

        do i=1,size(params)
            write(paramnames_unit,'(A,"      ",A)') trim(params(i)%paramname),trim(params(i)%latex) 
        end do

        do i=1,size(derived_params)
            write(paramnames_unit,'(A,"      ",A)') trim(derived_params(i)%paramname),trim(derived_params(i)%latex) 
        end do


        close(paramnames_unit)
 
    end subroutine write_paramnames_file




    ! File namers

    !> Name of the resume file
    function resume_file(settings,temp) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        !> Program settings (for base_dir and file_root)
        type(program_settings), intent(in) :: settings
        !> whether or not to create a temp file
        logical, intent(in) :: temp

        character(STR_LENGTH) :: file_name

        if(temp) then
            file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '_temp.resume'
        else
            file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '.resume'
        end if

    end function resume_file

    function stats_file(settings) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings

        character(STR_LENGTH) :: file_name

        file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '.stats'

    end function stats_file

    function cluster_dir(settings) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings

        character(STR_LENGTH) :: file_name

        file_name = trim(settings%base_dir) // '/clusters'

    end function cluster_dir

    function posterior_file(settings,weighted,temp,i) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings
        logical,intent(in) :: weighted
        logical,intent(in),optional :: temp !> whether to put a temporary prefix on it
        integer,intent(in),optional :: i

        character(STR_LENGTH) :: file_name

        character(STR_LENGTH) :: cluster_num

        if(present(i)) then
            write(cluster_num,'(I5)') i
            file_name = trim(cluster_dir(settings)) // '/' // trim(settings%file_root) // '_' // trim(adjustl(cluster_num)) 
        else 
            file_name = trim(settings%base_dir) // '/' // trim(settings%file_root)
        end if

        if(present(temp)) then
            if(temp) file_name = trim(file_name) // '_temp'
        end if

        if(weighted) then
            file_name = trim(file_name) // '.txt'
        else
            file_name = trim(file_name) // '_equal_weights.txt'
        end if

    end function posterior_file







    function phys_live_file(settings,i) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings
        integer,intent(in),optional :: i

        character(STR_LENGTH) :: file_name

        character(STR_LENGTH) :: cluster_num

        if(present(i)) then
            write(cluster_num,'(I5)') i
            file_name = trim(cluster_dir(settings)) // '/' // trim(settings%file_root) &
                // '_phys_live_' // trim(adjustl(cluster_num)) //'.txt'
        else 
            file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '_phys_live.txt'
        end if

    end function phys_live_file


    function phys_live_birth_file(settings,i) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings
        integer,intent(in),optional :: i

        character(STR_LENGTH) :: file_name

        character(STR_LENGTH) :: cluster_num

        if(present(i)) then
            write(cluster_num,'(I5)') i
            file_name = trim(cluster_dir(settings)) // '/' // trim(settings%file_root) &
                // '_phys_live_' // trim(adjustl(cluster_num)) //'.txt'
        else 
            file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '_phys_live-birth.txt'
        end if

    end function phys_live_birth_file

    function prior_file(settings) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings
        character(STR_LENGTH) :: file_name

        file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '_prior.txt'

    end function prior_file

    function dead_file(settings) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings
        character(STR_LENGTH) :: file_name

        file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '_dead.txt'

    end function dead_file

    function dead_birth_file(settings) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings
        character(STR_LENGTH) :: file_name

        file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '_dead-birth.txt'

    end function dead_birth_file

    function paramnames_file(settings) result(file_name)
        use settings_module, only: program_settings
        use utils_module,    only: STR_LENGTH
        implicit none
        type(program_settings), intent(in) :: settings

        character(STR_LENGTH) :: file_name

        file_name = trim(settings%base_dir) // '/' // trim(settings%file_root) // '.paramnames'

    end function paramnames_file

end module

module mpi_module
    use utils_module, only: dp, normal_fb
#ifdef MPI
    use mpi
#endif

    implicit none
    integer :: mpierror
    logical :: finalize

    integer, parameter :: tag_gen_point=1
    integer, parameter :: tag_gen_request=2
    integer, parameter :: tag_gen_stop=3

    integer, parameter :: tag_run_baby=4
    integer, parameter :: tag_run_seed=5
    integer, parameter :: tag_run_cholesky=6
    integer, parameter :: tag_run_logL=7
    integer, parameter :: tag_run_nlike=8
    integer, parameter :: tag_run_epoch_seed=9
    integer, parameter :: tag_run_epoch_babies=10
    integer, parameter :: tag_run_stop=11

    type mpi_bundle
        integer :: rank
        integer :: nprocs
        integer :: root
        integer :: colour
        integer :: communicator

    end type mpi_bundle



    contains

    !> Subroutine to get all mpi information
    function get_mpi_information(mpi_communicator,colour) result(mpi_information)
        implicit none
        integer, intent(in)           :: mpi_communicator
        integer, intent(in), optional :: colour
        type(mpi_bundle)                :: mpi_information

        mpi_information%rank         = get_rank(mpi_communicator)
        mpi_information%nprocs       = get_nprocs(mpi_communicator)
        mpi_information%root         = get_root(mpi_communicator)
        mpi_information%communicator = mpi_communicator

        if(present(colour)) then
            mpi_information%colour = colour
        else
            mpi_information%colour = 0
        end if

    end function

    !> Returns whether this is the root node
    function is_root(mpi_information) 
        implicit none
        type(mpi_bundle),intent(in) :: mpi_information
        logical :: is_root

        is_root = mpi_information%rank==mpi_information%root

    end function is_root

    !> Returns whether there is a single processor
    function linear_mode(mpi_information) 
        implicit none
        type(mpi_bundle),intent(in) :: mpi_information
        logical :: linear_mode

        linear_mode = mpi_information%nprocs==1

    end function linear_mode

    !> Procedure to get the number of mpi processors
    !!
    !! http://www.mpich.org/static/docs/v3.1/www3/MPI_Comm_size.html
    function get_nprocs(mpi_communicator) result(nprocs)
        implicit none
        integer, intent(in) :: mpi_communicator
        integer :: nprocs

#ifdef MPI
        call MPI_COMM_SIZE(   & 
            mpi_communicator, &!handle
            nprocs,           &!return number of processors
            mpierror          &!error flag
            )
#else
        nprocs = 1
#endif

    end function get_nprocs

    !> Procedure to get the number of mpi processors
    !!
    !! http://www.mpich.org/static/docs/v3.1/www3/MPI_Comm_rank.html
    function get_rank(mpi_communicator) result(myrank)
        implicit none
        integer, intent(in) :: mpi_communicator
        integer :: myrank

#ifdef MPI
        call MPI_COMM_RANK(   & 
            mpi_communicator, &!handle
            myrank,           &!return rank of calling processor 
            mpierror          &!error flag
            )
#else
        myrank = 0
#endif

    end function get_rank


    !> This defines the root node for this mpi communicator
    !!
    !! All processes call this simultaneously, and the root is defined
    !! as the process with the lowest rank. This value is returned
    !!
    !! http://www.mpich.org/static/docs/v3.1/www3/MPI_Allreduce.html
    !!
    function get_root(mpi_communicator) result(root)
        implicit none
        integer, intent(in) :: mpi_communicator
        integer :: root
        integer, dimension(1) :: myrank

        ! Get the rank of the process
        myrank(1) = get_rank(mpi_communicator)

#ifdef MPI
        call MPI_ALLREDUCE(    &
            myrank,            &!send buffer 
            root,              &!recieve buffer
            1,                 &!number of elements sent
            MPI_INTEGER,       &!type of element sent
            MPI_MIN,           &!reduce by finding the minimum
            mpi_communicator,  &!handle
            mpierror           &!error flag
            )
#else
        root = myrank(1)
#endif

    end function get_root


#ifdef MPI
    !> Procedure to initialise mpi
    subroutine initialise_mpi(feedback)
        implicit none
        integer, intent(in) :: feedback
        logical :: flag


        ! Check for any current initilisation
        call MPI_Initialized(flag,mpierror)

        if( .not. flag ) then
            call MPI_INIT(mpierror)
            finalize = .true.
        else
            if(feedback >= normal_fb) write(*,'("PolyChord: MPI is already initilised, not initialising, and will not finalize")')
            finalize = .false.
        end if

    end subroutine initialise_mpi

    !> Procedure to finalise mpi
    subroutine finalise_mpi()
        implicit none

        if(finalize) call MPI_FINALIZE(mpierror)

    end subroutine finalise_mpi




    !> Split a communicator into n even groups
    function mpi_split(n,mpi_communicator) result(mpi_information)
        implicit none
        integer,intent(in)  :: n
        integer,intent(in)  :: mpi_communicator
        type(mpi_bundle)      :: mpi_information

        integer :: new_mpi_communicator
        integer :: numprocs
        integer :: colour
        integer :: key

        ! Get the original mpi info
        mpi_information = get_mpi_information(mpi_communicator)

        ! Define the new number of processors
        numprocs= ceiling(dble(mpi_information%nprocs)/dble(n))

        ! Define the 'colour' of this process by dividing it into n adjacent processes
        colour = mpi_information%rank / numprocs

        ! The new rank is just modulo this
        key  = mod(mpi_information%rank, numprocs)

        ! Split up the communicator
        call MPI_COMM_SPLIT(mpi_communicator,colour,key,new_mpi_communicator,mpierror)

        ! Assign the new mpi info
        mpi_information = get_mpi_information(new_mpi_communicator,colour)

    end function mpi_split

    subroutine mpi_synchronise(mpi_information)
        implicit none
        type(mpi_bundle), intent(in) :: mpi_information

#ifdef MPI
        call MPI_BARRIER(mpi_information%communicator,mpierror)
#endif 

    end subroutine mpi_synchronise


    !> This sums a whole set of integers across all processes
    !!
    !! All processes call this simultaneously
    !!
    !! http://www.mpich.org/static/docs/v3.1/www3/MPI_Allreduce.html
    !!
    function sum_integers(intgr_local,mpi_information) result(intgr)
        implicit none
        integer, intent(in) :: intgr_local
        type(mpi_bundle), intent(in) :: mpi_information
        integer :: intgr

        call MPI_ALLREDUCE(    &
            intgr_local,       &!send buffer 
            intgr,             &!recieve buffer
            1,                 &!number of elements sent
            MPI_INTEGER,       &!type of element sent
            MPI_SUM,           &!reduce by finding the minimum
            mpi_information%communicator,  &!handle
            mpierror           &!error flag
            )

    end function sum_integers

    function sum_doubles(db_local,mpi_information) result(db)
        implicit none
        real(dp), intent(in) :: db_local
        type(mpi_bundle), intent(in) :: mpi_information
        real(dp) :: db
        real(dp), dimension(1) :: mpi_db_local

        mpi_db_local(1) = db_local
        call MPI_ALLREDUCE(       &
            mpi_db_local,         &!send buffer
            db,                   &!recieve buffer
            1,                    &!number of elements sent
            MPI_DOUBLE_PRECISION, &!type of element sent
            MPI_SUM,              &!reduce by finding the sum
            mpi_information%communicator,     &!handle
            mpierror              &!error flag
            )

    end function sum_doubles

    subroutine broadcast_doubles(doubles,mpi_information)
        implicit none
        real(dp), dimension(:), intent(inout) :: doubles
        type(mpi_bundle), intent(in) :: mpi_information

        call MPI_BCAST(            & 
            doubles,               &!broadcast buffer
            size(doubles),         &!size of buffer
            MPI_DOUBLE_PRECISION,  &!type of element sent
            mpi_information%root,         &!root doing the sending
            mpi_information%communicator, &!handle
            mpierror               &!error flag
            )

    end subroutine broadcast_doubles

    subroutine broadcast_integers(integers,mpi_information)
        implicit none
        integer, dimension(:), intent(inout) :: integers
        type(mpi_bundle), intent(in) :: mpi_information

        call MPI_BCAST(            & 
            integers,              &!broadcast buffer
            size(integers),        &!size of buffer
            MPI_INTEGER,               &!type of element sent
            mpi_information%root,         &!root doing the sending
            mpi_information%communicator, &!handle
            mpierror               &!error flag
            )

    end subroutine broadcast_integers

    !============== Throwing and catching routines ====================
    ! There are four points in the algorithm where arrays need to be transferred 
    ! between master and slaves
    !
    ! 1) live point during initial generation
    !     any slave    ---->  root
    !     throw_point         catch_point
    !
    ! 2) baby points for use in nested sampling
    !     any slave   ----> root
    !     throw_babies      catch_babies
    !
    ! 3) seed information for generation of babies
    !     root      ----> specific slave
    !     throw_seed      catch_seed


    !> Root catch
    !!
    !! This a process by which the root node 'catches' a thrown point from 
    !! any slave, and returns the slave identifier for use to throw back
    function catch_point(live_point,mpi_information) result(slave_id)
        implicit none

        real(dp),intent(out),dimension(:) :: live_point !> The caught live point
        type(mpi_bundle), intent(in) :: mpi_information

        integer :: slave_id ! slave identifier

        integer, dimension(MPI_STATUS_SIZE) :: mpistatus ! status identifier

        call MPI_RECV(             &!
            live_point,            &!
            size(live_point),      &!
            MPI_DOUBLE_PRECISION,  &!
            MPI_ANY_SOURCE,        &!
            tag_gen_point,         &!
            mpi_information%communicator,      &!
            mpistatus,            &!
            mpierror               &!
            )

        slave_id = mpistatus(MPI_SOURCE) ! Pass on the slave id

    end function catch_point


    !> Slave throws a point to the master
    !!
    !! This a process by which a slave node 'throws' a point to the root
    subroutine throw_point(live_point,mpi_information)
        implicit none

        real(dp),intent(in),dimension(:) :: live_point !> live point to throw
        type(mpi_bundle), intent(in) :: mpi_information

        call MPI_SEND(             &!
            live_point,            &!
            size(live_point),      &!
            MPI_DOUBLE_PRECISION,  &!
            mpi_information%root,                  &!
            tag_gen_point,         &!
            mpi_information%communicator,      &!
            mpierror               &!
            )

    end subroutine throw_point







    !> Master catches babies thrown by any slave, and returns the slave identity that did the throwing
    function catch_babies(baby_points,nlike,epoch,mpi_information) result(slave_id)
        implicit none

        real(dp),intent(out),dimension(:,:) :: baby_points !> The babies to be caught
        integer, dimension(:), intent(out)          :: nlike       !> The number of likelihood evaluations to be caught
        integer,               intent(out)          :: epoch       !> The epoch the points were generated in
        type(mpi_bundle), intent(in)                :: mpi_information    !> The mpi communicator

        integer :: slave_id ! slave identifier

        integer, dimension(MPI_STATUS_SIZE) :: mpistatus ! status identifier

        call MPI_RECV(                               &!
            baby_points,                             &!
            size(baby_points,1)*size(baby_points,2), &!
            MPI_DOUBLE_PRECISION,                    &!
            MPI_ANY_SOURCE,                          &!
            tag_run_baby,                            &!
            mpi_information%communicator,            &!
            mpistatus,                               &!
            mpierror                                 &!
            )

        ! Pass on the slave id
        slave_id = mpistatus(MPI_SOURCE)

        call MPI_RECV(            &! 
            nlike,                &! 
            size(nlike),          &! 
            MPI_INTEGER,              &! 
            slave_id,             &! 
            tag_run_nlike,        &! 
            mpi_information%communicator,&! 
            mpistatus,            &! 
            mpierror              &! 
            )

        call MPI_RECV(            &! 
            epoch,                &! 
            1,                    &! 
            MPI_INTEGER,              &! 
            slave_id,             &! 
            tag_run_epoch_babies, &! 
            mpi_information%communicator,&! 
            mpistatus,            &! 
            mpierror              &! 
            )

    end function catch_babies

    !> Slave throws babies to the master
    subroutine throw_babies(baby_points,nlike,epoch,mpi_information)
        implicit none

        real(dp),intent(in),dimension(:,:) :: baby_points !> The babies to be thrown
        integer, dimension(:), intent(in) :: nlike                !> The number of likelihood evaluations to be caught
        integer,               intent(in) :: epoch                !> The epoch the babies were generated in
        type(mpi_bundle), intent(in) :: mpi_information

        call MPI_SEND(                               &! 
            baby_points,                             &! 
            size(baby_points,1)*size(baby_points,2), &! 
            MPI_DOUBLE_PRECISION,                    &! 
            mpi_information%root,                                    &! 
            tag_run_baby,                            &! 
            mpi_information%communicator,                        &! 
            mpierror                                 &! 
            )                                        
        call MPI_SEND(         &!  
            nlike,             &!  
            size(nlike),       &!  
            MPI_INTEGER,           &!  
            mpi_information%root,              &!  
            tag_run_nlike,     &!  
            mpi_information%communicator,  &!  
            mpierror           &!  
            )
        call MPI_SEND(         &!  
            epoch,             &!  
            1,                 &!  
            MPI_INTEGER,           &!  
            mpi_information%root,              &!  
            tag_run_epoch_babies,&!  
            mpi_information%communicator,  &!  
            mpierror           &!  
            )

    end subroutine throw_babies






    !> slave catches seed thrown by master
    function catch_seed(seed_point,cholesky,logL,epoch,mpi_information) result(more_points_needed)
        use abort_module, only: halt_program
        implicit none


        real(dp),intent(out),dimension(:) :: seed_point  !> The seed point to be caught
        real(dp),intent(out),dimension(:,:) :: cholesky  !> Cholesky matrix to be caught
        real(dp),intent(out)               :: logL       !> loglikelihood contour to be caught
        integer,         intent(out)               :: epoch
        type(mpi_bundle), intent(in)               :: mpi_information

        logical :: more_points_needed ! whether or not we need more points

        integer, dimension(MPI_STATUS_SIZE) :: mpistatus ! status identifier


        call MPI_RECV(                      &!
            seed_point,                     &!
            size(seed_point),               &!
            MPI_DOUBLE_PRECISION,           &!
            mpi_information%root,                           &!
            MPI_ANY_TAG,                    &!
            mpi_information%communicator,               &!
            mpistatus,                     &!
            mpierror                        &!
            )
        if(mpistatus(MPI_TAG) == tag_run_stop ) then
            more_points_needed = .false.
            return
        else if(mpistatus(MPI_TAG) == tag_run_seed) then
            more_points_needed = .true.
        else
            call halt_program('slave error: unrecognised tag')
        end if

        call MPI_RECV(                        &!
            cholesky,                         &!
            size(cholesky,1)*size(cholesky,1),&!
            MPI_DOUBLE_PRECISION,             &!
            mpi_information%root,                             &!
            tag_run_cholesky,                 &!
            mpi_information%communicator,                 &!
            mpistatus,                       &!
            mpierror                          &!
            )
        call MPI_RECV(                 &!
            logL,                      &!
            1,                         &!
            MPI_DOUBLE_PRECISION,      &!
            mpi_information%root,      &!
            tag_run_logL,              &!
            mpi_information%communicator,          &!
            mpistatus,                 &!
            mpierror                   &!
            )
        call MPI_RECV(            &! 
            epoch,                &! 
            1,                    &! 
            MPI_INTEGER,              &! 
            mpi_information%root, &! 
            tag_run_epoch_seed,   &! 
            mpi_information%communicator,&! 
            mpistatus,            &! 
            mpierror              &! 
            )

    end function catch_seed



    !> root throws seed to slave
    subroutine throw_seed(seed_point,cholesky,logL,mpi_information,slave_id,epoch,keep_going)
        implicit none

        real(dp),intent(in),dimension(:) :: seed_point   !> seed to be thrown
        real(dp),intent(in),dimension(:,:) :: cholesky   !> cholesky to be thrown
        real(dp),intent(in)                :: logL       !> loglikelihood contour to be thrown
        type(mpi_bundle),intent(in) :: mpi_information           !> mpi handle
        integer, intent(in) :: slave_id                          !> identity of target slave
        integer, intent(in) :: epoch                             !> epoch of seed
        logical, intent(in) :: keep_going                        !> Further signal whether to keep going 

        integer :: tag ! tag variable to
        real(dp), dimension(1) :: mpi_logL !> for use with MPI_SEND
        integer, dimension(1) :: mpi_epoch !> for use with MPI_SEND

        mpi_logL(1) = logL
        mpi_epoch(1) = epoch

        tag = tag_run_stop                 ! Default tag is stop tag
        if(keep_going) tag = tag_run_seed  ! If we want to keep going then change this to the seed tag

        call MPI_SEND(             &!  
            seed_point,            &!  
            size(seed_point),      &!
            MPI_DOUBLE_PRECISION,  &!  
            slave_id,              &!  
            tag,                   &!  
            mpi_information%communicator,      &!  
            mpierror               &!  
            )

        if(.not. keep_going) return ! Stop here if we're wrapping up

        call MPI_SEND(                          &!  
            cholesky,                           &!  
            size(cholesky,1)*size(cholesky,2),  &!  
            MPI_DOUBLE_PRECISION,               &!  
            slave_id,                           &!  
            tag_run_cholesky,                   &!  
            mpi_information%communicator,                   &!  
            mpierror                            &!  
            )
        call MPI_SEND(              &!  
            mpi_logL,               &!
            1,                      &!  
            MPI_DOUBLE_PRECISION,   &!  
            slave_id,               &!  
            tag_run_logL,           &!  
            mpi_information%communicator,       &!  
            mpierror                &!  
            )
        call MPI_SEND(         &!  
            mpi_epoch,         &!
            1,                 &!  
            MPI_INTEGER,           &!  
            slave_id,          &!  
            tag_run_epoch_seed,&!  
            mpi_information%communicator,  &!  
            mpierror           &!  
            )


    end subroutine throw_seed




    !============== Pure messaging routines ===========================
    ! During initial live point generation, the master needs to signal to the slaves
    ! whether or not to keep generating live points, or whether to stop
    !
    ! master         ----> slave
    ! request_point        more_points_needed -> true
    ! no_more_points       more_points_needed -> false
    ! 

    !> Request point
    !!
    !! This subroutine is used by the root node to request a new live point
    subroutine request_point(mpi_information,slave_id)
        implicit none
        type(mpi_bundle), intent(in) :: mpi_information
        integer, intent(in) :: slave_id         !> Slave to request a new point from


        integer, dimension(0):: empty_buffer ! empty buffer to send

        call MPI_SEND(         &
            empty_buffer,      &! not sending anything
            0,                 &! size of nothing
            MPI_INTEGER,       &! sending no integers
            slave_id,          &! process id to send to
            tag_gen_request,   &! continuation tag
            mpi_information%communicator,  &! mpi handle
            mpierror           &! error flag
            )

    end subroutine request_point


    !> No more points please
    !!
    !! This subroutine is used by the root node to signal that no more points are required
    subroutine no_more_points(mpi_information,slave_id)
        implicit none
        type(mpi_bundle), intent(in) :: mpi_information
        integer, intent(in) :: slave_id         !> Slave to request a new point from


        integer, dimension(1) :: empty_buffer ! empty buffer to send

        call MPI_SEND(         &
            empty_buffer,      &! not sending anything
            0,                 &! size of nothing
            MPI_INTEGER,       &! sending no integers
            slave_id,          &! process id to send to
            tag_gen_stop,      &! continuation tag
            mpi_information%communicator,  &! mpi handle
            mpierror           &! error flag
            )

    end subroutine no_more_points

    !> See if more points are needed
    !!
    !! This subroutine is used by the root node to request a new live point
    function more_points_needed(mpi_information)
        use abort_module
        implicit none
        type(mpi_bundle), intent(in) :: mpi_information

        integer :: empty_buffer(0) ! empty buffer to send
        integer, dimension(MPI_STATUS_SIZE) :: mpistatus  ! status identifier

        logical :: more_points_needed !> Whether we need more points or not

        call MPI_RECV(       &!
            empty_buffer,    &!
            0,               &!
            MPI_INTEGER,         &!
            mpi_information%root,            &!
            MPI_ANY_TAG,     &!
            mpi_information%communicator,&!
            mpistatus,      &!
            mpierror         &!
            )

        ! If we've recieved a kill signal, then exit this loop
        if(mpistatus(MPI_TAG) == tag_gen_stop ) then
            more_points_needed = .false.
        else if(mpistatus(MPI_TAG) == tag_gen_request) then
            more_points_needed = .true.
        else
            call halt_program('generate error: unrecognised tag')
        end if

    end function more_points_needed

#endif








end module mpi_module

program main

	use params
      	use nestwrapper
      
	implicit none
      
      
	integer i
      
	!setting priors
	spriorran(1:sdim,1)=-5.
      	spriorran(1:sdim,2)=5.
      
      	!no parameters to wrap around
      	nest_pWrap=0

      	call nest_Sample
      	stop
end

module like

use params
implicit none
      
contains
      
      
!=======================================================================

subroutine slikelihood(Cube,slhood)
         
	implicit none
      
	double precision Cube(nest_nPar),slhood
	double precision TwoPi
	integer i
         
	TwoPi = 6.2831853d0

	slhood = - sdim / 2d0 * log( TwoPi )
	do i = 1, sdim
		slhood = slhood - log( sigma(i) )
	enddo
	
	slhood = slhood - sum( ( ( Cube( 1:sdim ) - center ) / sigma( 1:sdim ) ) ** 2d0 ) / 2d0

end subroutine slikelihood
      
!=======================================================================

end module like

! soft k-means clustering with k=2
! D.J.C. MacKay, Information Theory, Inference & Learning Algorithms, 2003, p.304
! Aug 2006

module kmeans_clstr
  use RandomNS
  use utils1
  implicit none
      

contains
  
!----------------------------------------------------------------------
  
  !soft k-means corresponding to the model of axis aligned Gaussians (see
  !MacKay, 2003)
  subroutine kmeans(k,pt,npt,numdim,cluster,min_pt)
    implicit none
 
    integer k,numdim,npt
    double precision pt(numdim,npt)
    double precision sigsq(k,numdim),means(k,numdim),wt(k),r(npt,k)
    integer cluster(npt)
    double precision sumr,totR(k),temp,covmat(numdim,numdim),mean(numdim)
    integer i,j,indx(1),x,nochg,count,min_pt
    logical clstrd
    double precision urv

    if(k>npt/min_pt+1) k=npt/min_pt+1

    clstrd=.false.
    nochg=0
    count=0
    
    do i=1,numdim
    	mean(i)=sum(pt(i,1:npt))/dble(npt)
    end do
    
    call calc_covmat(npt,numdim,pt,mean,covmat)
    
    do i=1,k
    	wt(i)=ranmarns(0)
      urv=ranmarns(0)
      x=int(dble(npt)*urv)+1
    	means(i,:)=pt(:,x)
    end do

!    means(1,1)=0
!    means(1,2)=0
!    means(2,1)=1.
!    means(2,2)=1.

    temp=huge(1.d0)
    do j=1,numdim
	       if(covmat(j,j)<temp) temp=covmat(j,j)
    end do
    sigsq=temp
    temp=sum(wt)
    wt=wt/temp
    
    do
    	count=count+1
      clstrd=.true.
    	do i=1,npt
		do j=1,k
			temp=1.
			do x=1,numdim
				temp=temp*2.506628275*sqrt(sigsq(j,x))
			end do
			r(i,j)=wt(j)*exp(-sum(((means(j,:)-pt(:,i))**2.)/(2.*sigsq(j,:))))/temp
		end do
		sumr=sum(r(i,:))
		r(i,:)=r(i,:)/sumr
		indx=maxloc(r(i,:))
            if(cluster(i)/=indx(1)) clstrd=.false.
		cluster(i)=indx(1)
	end do
      
	if(clstrd) then
		nochg=nochg+1
		if(nochg==2) exit
	else
		nochg=0
	end if
	
	do i=1,k
		totR(i)=sum(r(:,i))
		
		! update means & sigsq
		do j=1,numdim
			means(i,j)=sum(r(:,i)*pt(j,:))/totR(i)
			sigsq(i,j)=sum(r(:,i)*((pt(j,:)-means(i,j))**2.))/totR(i)
		end do
	end do
		
	!update weights
	temp=sum(totR(:))
	wt(:)=totR(:)/temp	
		
    end do
  
	
  end subroutine kmeans  
 
!----------------------------------------------------------------------
 
  !soft k-means corresponding to the model of spherical Gaussians (see MacKay 2003)
  subroutine kmeans2(k,pt,npt,numdim,cluster,min_pt)
    implicit none
 
    integer k,numdim,npt
    double precision pt(numdim,npt)
    double precision sigsq(k),means(k,numdim),wt(k),r(npt,k)
    integer cluster(npt),old_cluster(npt)
    double precision sumr,totR(k),temp,covmat(numdim,numdim),mean(numdim)
    integer i,j,indx(1),x,nochg,min_pt
    logical clstrd
    double precision urv
    
    if(k>npt/min_pt+1) k=npt/min_pt+1
    clstrd=.false.
    nochg=0
    
    do i=1,numdim
    	mean(i)=sum(pt(i,1:npt))/dble(npt)
    end do
    
    call calc_covmat(npt,numdim,pt,mean,covmat)
    
    do i=1,k
    	wt(i)=ranmarns(0)
      urv=ranmarns(0)
      x=int(dble(npt)*urv)+1
    	means(i,:)=pt(:,x)
    end do
    
    temp=huge(1.d0)
    do j=1,numdim
	       if(covmat(j,j)<temp) temp=covmat(j,j)
    end do 
    sigsq=temp      
    temp=sum(wt)
    wt=wt/temp
    
    old_cluster=0
    
    do
    	do i=1,npt
		do j=1,k
			temp=(2.506628275*sqrt(sigsq(j)))**dble(numdim)
			r(i,j)=wt(j)*exp(-sum((means(j,:)-pt(:,i))**2.)/(2.*sigsq(j)))/temp
		end do
		sumr=sum(r(i,:))
		r(i,:)=r(i,:)/sumr
		indx=maxloc(r(i,:))
		cluster(i)=indx(1)
	end do
	
	clstrd=.true.
	do i=1,npt
		if(old_cluster(i).ne.cluster(i)) then
			clstrd=.false.
			exit
		end if
	end do
	if(clstrd) then
		nochg=nochg+1
		if(nochg==2) exit
	else
		nochg=0
	end if
	old_cluster=cluster
	
	do i=1,k
		totR(i)=sum(r(:,i))
		sigsq(i)=0.
		
		! update means & sigsq
		do j=1,numdim
			means(i,j)=sum(r(:,i)*pt(j,:))/totR(i)
			sigsq(i)=sigsq(i)+sum(r(:,i)*((pt(j,:)-means(i,j))**2.))
		end do
		sigsq(i)=sigsq(i)/(numdim*totR(i))
	end do
		
	!update weights
	temp=sum(totR(:))
	wt(:)=totR(:)/temp	
		
    end do
  
	
  end subroutine kmeans2     
 
!----------------------------------------------------------------------
 
  !simple k-means
  subroutine kmeans3(k,pt,npt,numdim,means,cluster,min_pt)
	implicit none
 
    	integer k,numdim,npt,i1,i2,i3
    	double precision pt(numdim,npt)
    	double precision means(k,numdim),dis(min_pt,2)
    	integer cluster(npt),old_cluster(npt),r(npt,k),totR(k)
    	double precision temp,dist
    	integer i,j,x,nochg,scrap(k),min_pt
    	logical clstrd,flag
    	double precision urv,d1

    	if(k>npt/min_pt+1) k=npt/min_pt+1
	
	if(k==1) then
		do i=1,numdim
			means(1,i)=sum(pt(i,1:npt))/dble(npt)
		enddo
		cluster=1
		return
	endif
	
    	clstrd=.false.
    	nochg=0
    
!    call ranmarns(urv)
!    x=int(dble(npt)*urv)+1
!    means(1,:)=pt(:,x)
!    temp=-1.
!    do i=2,k
!    	lmean(:)=sum(means(1:i-1,:))/dble(i-1)
!    	do j=1,npt
!      	dist=sum((lmean(:)-pt(:,j))**2.)
!            if(dist>temp) then
!			temp=dist
!                  x=j
!            end if
!	end do
!	means(i,:)=pt(:,x)
!    end do

!    lmean(:)=means(1,:)
!    do i=1,k/2+1
!    	do
!      	flag=.false.
!    		call ranmarns(urv)
!    		x=int(dble(npt)*urv)+1
!      	do j=1,i-1
!      		if(x==scrap(j)) then
!            		flag=.true.
!                  	exit
!			end if
!		end do
!            if(.not.flag) exit
!	end do
!      scrap(i)=x
!    	means(i*2-1,1:numdim)=pt(1:numdim,x)
!      if(i*2>k) exit
!    	means(i*2,1:numdim)=2.*lmean(1:numdim)-pt(1:numdim,x)
!    end do

    	!choose random points as starting positions
    	do i=1,k
    		do
      			flag=.false.
            		urv=ranmarns(0)
    			x=int(dble(npt)*urv)+1
      			do j=1,i-1
      				if(x==scrap(j)) then
                  			flag=.true.
                        		exit
				endif
			enddo
            		if(flag) then
            			cycle
            		else
            			scrap(i)=x
                  		exit
			endif
		enddo
      		means(i,:)=pt(:,x)
    	enddo
    
    
    	old_cluster=0
    
    	do
    		do i=1,npt
    			temp=huge(1.d0)
			do j=1,k
				dist=sum((means(j,:)-pt(:,i))**2.)
                  		if(dist<temp) then
                  			temp=dist
                        		x=j
                  		endif
			enddo
            		r(i,:)=0
            		r(i,x)=1
			cluster(i)=x
		enddo
	
		clstrd=.true.
		do i=1,npt
			if(old_cluster(i)/=cluster(i)) then
				clstrd=.false.
				exit
			endif
		enddo
      
		if(clstrd) then
			!check if all the clusters have more than min_pt points
			do i=1,k
				if(totR(i)<min_pt) then
					dis=1.d99
					i1=min_pt-totR(i)
					do j=1,npt
						if(cluster(j)/=i .and. totR(cluster(j))>min_pt) then
							d1=sum((means(i,:)-pt(:,j))**2.)
							i3=0
							do i2=i1,1,-1
								if(d1<dis(i2,1)) then
									i3=i2
								else	
									exit
								endif
							enddo
							if(i3/=0) then
								dis(i3+1:i1,:)=dis(i3:i1-1,:)
								dis(i3,1)=d1
								dis(i3,2)=dble(j)
							endif
						endif
					enddo
					do j=1,i1
						i3=int(dis(j,2))
						i2=cluster(i3)
						cluster(i3)=i
						totR(i)=totR(i)+1
						totR(i2)=totR(i2)-1
						r(i3,:)=0
            					r(i3,i)=1
					enddo
				endif
			enddo
			do i=1,k
				!update means
				do j=1,numdim
					means(i,j)=sum(r(:,i)*pt(j,:))/totR(i)
				enddo
			enddo
			exit
		endif
      
		old_cluster=cluster
	
		do i=1,k
			totR(i)=sum(r(:,i))
            		if(totR(i)==0) cycle
		
			!update means
			do j=1,numdim
				means(i,j)=sum(r(:,i)*pt(j,:))/totR(i)
			enddo
		enddo
    	enddo
  
	
  end subroutine kmeans3
 
!---------------------------------------------------------------------- 

  !Incremental K-means (Pham, Dimov, Nguyen, 2005)
  subroutine kmeans4(k,pt,npt,numdim,cluster,min_pt)
    implicit none
 
    integer k,numdim,npt
    double precision pt(:,:)
    double precision means(k,numdim)
    integer cluster(:)
    integer totR(k)
    integer i,j,x,m,min_pt
    logical clstrd
    double precision urv
    double precision distortion(k)!distortion of each cluster
    integer indx(1)
    
    if(k>npt/min_pt+1) k=npt/min_pt+1
    distortion=0.
    totR=0
    
    !choose a random point to be the cluster center
    cluster=1
    totR(1)=npt
    do j=1,numdim
    	means(1,j)=sum(pt(j,:))/dble(npt)
    end do
    
    if(k==1) return
    
    do m=2,k
    	clstrd=.false.
      
    	!pick the cluster with the max distortion
      indx=maxloc(distortion(1:m-1))
            
      !pick a random point from this cluster as new cluster center
      j=0
      urv=ranmarns(0)
    	x=int(dble(totR(indx(1)))*urv)+1
      do i=1,npt
      	if(cluster(i)==indx(1)) j=j+1
            if(j==x) exit
      end do
      means(cluster(i),:)=(means(cluster(i),:)*dble(totR(cluster(i)))-pt(:,i))/dble(totR(cluster(i))-1)
      means(m,:)=pt(:,i)
      totR(cluster(i))=totR(cluster(i))-1
      totR(m)=1
      cluster(i)=m
            
      do
      	clstrd=.true.
            
            !check whether each point is closest to its own cluster or to the newly formed
            !one & assign accordingly
            do i=1,npt
            	if(sum((pt(1:numdim,i)-means(cluster(i),1:numdim))**2.)> &
                  sum((pt(1:numdim,i)-means(m,1:numdim))**2.))then
                  	!point moved so not finished yet
                        clstrd=.false.
                              
                        !update cluster data
                        totR(cluster(i))=totR(cluster(i))-1
                        cluster(i)=m
                        totR(m)=totR(m)+1
                  end if
            end do
                        
		!update means & distortion of each cluster
            means=0.
            distortion=0.
            do i=1,npt
                  means(cluster(i),1:numdim)=means(cluster(i),1:numdim)+pt(1:numdim,i)
                  distortion(cluster(i))=distortion(cluster(i))+sum(pt(1:numdim,i)**2.)
            end do
            do j=1,numdim
                  means(1:m,j)=means(1:m,j)/dble(totR(1:m))
                  distortion(1:m)=distortion(1:m)-dble(totR(1:m))*(means(1:m,j)**2.)
            end do
                  
            if(clstrd) exit
	end do
    end do
  
	
  end subroutine kmeans4  
 
!----------------------------------------------------------------------

  !2-means with k=2 & clusters placed in their expected positions as the starting points
  subroutine kmeans6(pt,npt,numdim,cluster)
    implicit none
 
    integer numdim,npt
    double precision pt(numdim,npt)
    double precision means(2,numdim)
    integer cluster(npt)
    integer totR(2)
    integer i,j,x
    logical clstrd
    double precision covmat(numdim,numdim),evec(numdim,numdim),eval(numdim)
    
    !calculate the mean of the data
    do j=1,numdim
    	means(1,j)=sum(pt(j,1:npt))/dble(npt)
    end do
    
    !do principal component analysis
    call calc_covmat(npt,numdim,pt,means(1,:),covmat)
    evec=covmat
    call diagonalize(evec,eval,numdim,.false.)
    
    !place the cluster centers in their ex[ected locations
    means(2,:)=means(1,:)+evec(:,numdim)*sqrt(2.*eval(numdim)/3.1416)
    means(1,:)=means(1,:)-evec(:,numdim)*sqrt(2.*eval(numdim)/3.1416)
    
    cluster=1
    totR(1)=npt
    totR(2)=0

    do
      clstrd=.true.
            
	!check whether each point is closest to its own cluster or to the newly formed
	!one & assign accordingly
	do i=1,npt
      	if(cluster(i)==1) then
            	x=2
            else
            	x=1
            end if
            if(sum((pt(1:numdim,i)-means(cluster(i),1:numdim))**2.)> &
            sum((pt(1:numdim,i)-means(x,1:numdim))**2.))then
                  !point moved so not finished yet
                  clstrd=.false.
                              
                  !update cluster data
                  totR(cluster(i))=totR(cluster(i))-1
                  cluster(i)=x
                  totR(x)=totR(x)+1
		end if
	end do
                        
	!update means of each cluster
      means=0.
	do i=1,npt
		means(cluster(i),1:numdim)=means(cluster(i),1:numdim)+pt(1:numdim,i)
	end do
	do j=1,numdim
		means(1:2,j)=means(1:2,j)/dble(totR(1:2))
	end do
                  
	if(clstrd) exit
    end do
  	
  end subroutine kmeans6  
 
!----------------------------------------------------------------------
  !Incremental K-means with Unknown K 
  !(Pham, Dimov, Nguyen, 2005, "Incremental K-means Algorithm")
  !(Pham, Dimov, Nguyen, 2005, "Selection of K in K-means Clustering")
  subroutine kmeans5(k,pt,npt,numdim,cluster,min_pt)
    implicit none
 
    integer k,numdim,npt
    double precision pt(numdim,npt)
    double precision means(2,npt/(numdim+1),numdim),meanst(npt/(numdim+1),numdim)
    double precision mean(npt/(numdim+1),numdim)
    integer cls(2,npt),clst(npt),cluster(npt)
    integer totR(2,npt/(numdim+1)),totRt(npt/(numdim+1))!total points in each cluster
    integer i,j,x,m,min_pt
    logical clstrd
    !distortion of each cluster & total distortion of the recent two iterations
    double precision distortion(2,npt/(numdim+1)),totDistor(2),distor(npt/(numdim+1))
    integer indx(1)
    double precision f(npt/(numdim+1)),fmin,a(npt/(numdim+1))!evaluation function
    double precision S(npt/(numdim+1))!total distortion
    integer count!counter for evaluation function
    
    if(k>npt/min_pt+1) k=npt/min_pt+1
    distortion=0.
    totR=0
    f=0.
    a=0.
    S=0.
    count=0
    
    !choose a random point to be the cluster center
    cluster=1
    cls(2,:)=1
    totR(2,1)=npt
    do j=1,numdim
    	means(2,1,j)=sum(pt(j,:))/dble(npt)
      S(1)=S(1)+sum((pt(j,1:npt)-means(2,1,j))**2.)
    end do
    mean(:,:)=means(2,:,:)
    
    f(1)=1.
    fmin=1.
    k=1
    
    a(2)=1.-3./dble(4*numdim)
    m=1
    do 
    	m=m+1
    	clstrd=.false.
      
    	!pick the cluster with the max distortion
      indx=maxloc(distortion(2,1:m-1))
      !break this cluster
      clst(:)=cls(2,:)
      totRt(:)=totR(2,:)
      meanst(:,:)=means(2,:,:) 
      x=m-1 
      j=indx(1)
      call kmeansDis(x,pt,npt,numdim,clst,j,totRt,distor,meanst)
      cls(1,:)=clst(:)
      totR(1,:)=totRt(:)
      means(1,:,:)=meanst(:,:)
      distortion(1,:)=distor(:)
      totDistor(1)=sum(distor(1:m))
      
      do i=1,m-1
      	if(i==indx(1)) cycle
            if(distortion(2,i)>1.5*(totDistor(2)-totDistor(1))) then
            	clst(:)=cls(2,:)
      		totRt(:)=totR(2,:)
     	 		meanst(:,:)=means(2,:,:)
                  x=m-1
                  call kmeansDis(x,pt,npt,numdim,clst,i,totRt,distor,meanst)
                  if(sum(distor(1:m))<totDistor(1)) then
                  	cls(1,:)=clst(:)
      			totR(1,:)=totRt(:)
      			means(1,:,:)=meanst(:,:)
      			distortion(1,:)=distor(:)
      			totDistor(1)=sum(distor(1:m))
                  end if
            end if
      end do
      
            
      !calculate the total distortion
      S(m)=0.
      do i=1,npt
            S(m)=S(m)+sum((pt(1:numdim,i)-means(1,cls(1,i),1:numdim))**2.)
      end do
      
	!calculate the evaluation function
      f(m)=S(m)/(S(m-1)*a(m))
      a(m+1)=a(m)+(1.-a(m))/6.
      !write(*,*)m,fmin,f(m),f(m-1),a(m)
      
      if(f(m)<fmin.and.f(m)<0.85) then
      	fmin=f(m)
            cluster(:)=cls(1,:)
            mean(:,:)=means(1,:,:)
            k=m
            count=0
      else
      	count=count+1
      end if
      
      !if 5 consecutive f values are greater than 0.85 then exit
      if(count==5) exit
      
      means(2,:,:)=means(1,:,:)
      cls(2,:)=cls(1,:)
      totR(2,:)=totR(1,:)
      distortion(2,:)=distortion(1,:)
      totDistor(2)=totDistor(1)
    end do
    
    !meanst=mean
    !do i=1,k
      !do j=1,numdim
    		!call Rescale_nest(meanst(i,j),j)
      !end do
    !end do
    !write(*,*)"means",meanst(1:k,:)
    !write(*,*)"fmin=",fmin
	
  end subroutine kmeans5  
 
!---------------------------------------------------------------------- 

  !Incremental K-means (Pham, Dimov, Nguyen, 2005) with if npt in any cluster is
  !less than numdim+1 than (numdim+1-npt) closest points borrowed from its closest
  !neighbour cluster 
  subroutine kmeans7(k,pt,npt,numdim,cluster,ad,cluster2,min_p)
    implicit none
 
    integer k,numdim,npt
    double precision pt(:,:)
    double precision means(npt/min_p+10,numdim)
    integer cluster(:)
    integer totR(npt/min_p+10),min_p
    integer i,j,x,m,q,r,k0
    logical clstrd
    double precision urv
    !double precision distortion(k)!distortion of each cluster
    integer indx(1),indx2(1)
    double precision adis(npt)!for keeping a record of the point's distances
    double precision dis1,dis2,dis(npt,2)
    integer ad,nc,cluster2(:,:),cc(npt),cpt(npt)
    
    !distortion=0.
    means=0.
    totR=0
    
    !choose a random point to be the cluster center
    cluster=1
    totR(1)=npt
    do j=1,numdim
    	means(1,j)=sum(pt(j,1:npt))/dble(npt)
    end do
    
    k=min(npt/min_p,k+10)
    if(k<=1) then
    	k=1
      ad=0
      return
    end if
    k0=k

    do m=2,k
    	clstrd=.false.
      
      !pick the cluster with most points
      indx=maxloc(totR(1:m-1))
      
      !if all the clusters have less than npt<2(numdim+1) points then exit
      if(totR(indx(1))<2*min_p) then
      	k=m-1
            exit
      end if
            
      !pick a random point from this cluster as new cluster center
      j=0
      urv=ranmarns(0)
    	x=int(dble(totR(indx(1)))*urv)+1
      do i=1,npt
      	if(cluster(i)==indx(1)) j=j+1
            if(j==x) exit
      end do
      means(cluster(i),:)=(means(cluster(i),:)*dble(totR(cluster(i)))-pt(:,i))/dble(totR(cluster(i))-1)
	means(m,:)=pt(:,i)
      totR(cluster(i))=totR(cluster(i))-1
      totR(m)=1
      cluster(i)=m
      
      do
      	clstrd=.true.
            
            !check whether each point is closest to its own cluster or to the newly formed
            !one & assign accordingly
            do i=1,npt
                  	dis1=sum((pt(1:numdim,i)-means(cluster(i),1:numdim))**2)
                        dis2=sum((pt(1:numdim,i)-means(m,1:numdim))**2)
                        adis(i)=dis1-dis2
            end do
            
            do i=1,numdim
            	means(1:m,i)=means(1:m,i)*dble(totR(1:m))
            end do
            do
            	indx2=maxloc(adis)
                  if(adis(indx2(1))<=0.) then
                  	exit
                  else if(totR(cluster(indx2(1)))<=min_p) then
                  	adis(indx2(1))=-1.
                  else
				!point moved so not finished yet
                        clstrd=.false.
                        !update cluster data
                        totR(cluster(indx2(1)))=totR(cluster(indx2(1)))-1
                       	means(cluster(indx2(1)),1:numdim)=means(cluster(indx2(1)),1:numdim)-pt(1:numdim,indx2(1))
                       	cluster(indx2(1))=m
                        totR(m)=totR(m)+1
                        means(m,1:numdim)=means(m,1:numdim)+pt(1:numdim,indx2(1))
                        adis(indx2(1))=-1.
                  end if
		end do
    
		!update means
            do j=1,numdim
                  means(1:m,j)=means(1:m,j)/dble(totR(1:m))
            end do
                  	
                  
            !if num of points in the newly formed cluster are less than
            !(numdim+1) then borrow closest points from cluster from which the new cluster
            !was formed
            if(clstrd.and.(totR(m)<min_p.or.totR(indx(1))<min_p)) then
            	if(totR(m)<min_p) then
                  	x=m
                        q=indx(1)
                  else
                  	x=indx(1)
                        q=m
                  end if
                  
            	adis=1.d99
            	do i=1,npt
                  	if(cluster(i)==q) then
                        	adis(i)=sum((pt(1:numdim,i)-means(x,1:numdim))**2)
                        end if
                  end do
                  
                  means(q,1:numdim)=means(q,1:numdim)*dble(totR(q))
                  means(x,1:numdim)=means(x,1:numdim)*dble(totR(x))
                  
                  do i=1,min_p-totR(x)
                  	indx2=minloc(adis)
                        adis(indx2(1))=1.d99
                        cluster(indx2(1))=x
                        means(q,1:numdim)=means(q,1:numdim)-pt(1:numdim,indx2(1))
                        means(x,1:numdim)=means(x,1:numdim)+pt(1:numdim,indx2(1))
                  end do
    
                  totR(q)=totR(q)-min_p+totR(x)
                  totR(x)=min_p
                  means(q,1:numdim)=means(q,1:numdim)/dble(totR(q))
                  means(x,1:numdim)=means(x,1:numdim)/dble(totR(x))
            end if
                  
            if(clstrd) exit
	end do
    end do
    
    !find shared points
    ad=min(ad,npt-1)
    nc=min(k-1,ad)
    cluster2=0
    if(ad==0) return
    do i=1,k
      dis(1:nc,1)=1.d99
    	do j=1,k
      	if(i==j) cycle
         	dis1=sum((means(i,1:numdim)-means(j,1:numdim))**2)
            do r=1,nc
            	if(dis1<dis(r,1)) then
                  	dis(r+1:nc,1)=dis(r:nc-1,1)
                  	dis(r+1:nc,2)=dis(r:nc-1,2)
                        dis(r,1)=dis1
                        dis(r,2)=dble(j)
                        exit
                  end if
		end do
	end do
      
      cc(1:nc)=int(dis(1:nc,2))
      
      !make a list of point indices in cluster i
      q=0
      do j=1,npt
      	if(cluster(j)==i) then
                  q=q+1
            	cpt(q)=j
		end if
            if(q==totR(i)) exit
	end do
      
      !adis=1.d99
      dis(1:ad,1)=1.d99
      do j=1,npt
		do r=1,nc
                  if(cluster(j)==cc(r)) then
                  	do q=1,totR(i)
                        	dis1=sum((pt(1:numdim,cpt(q))-pt(1:numdim,j))**2)
                        	do k0=1,ad
                              	if(dis(k0,1)>dis1) then
            					dis(k0+1:ad,1)=dis(k0:ad-1,1)
                  				dis(k0+1:ad,2)=dis(k0:ad-1,2)
                        			dis(k0,1)=dis1
                        			dis(k0,2)=dble(j)
                                          exit
            				end if
					end do
                        end do
                        exit
                  end if
            end do
	end do
      
      cluster2(i,1:ad)=int(dis(1:ad,2))
    end do
	
  end subroutine kmeans7  
 
!----------------------------------------------------------------------

  !Incremental K-means (Pham, Dimov, Nguyen, 2005) with if npt in any cluster is
  !less than numdim+1 than (numdim+1-npt) closest points borrowed from its closest
  !neighbour cluster 
  subroutine sKmeans(k,pt,npt,numdim,cluster,min_p)
	implicit none
 
    	integer k,numdim,npt
    	double precision pt(:,:)
    	double precision means(npt/min_p+10,numdim)
    	integer cluster(npt)
    	integer totR(npt/min_p+10),min_p
    	integer i,j,x,m,q,k0
    	logical clstrd
    	double precision urv
    	integer indx(1),indx2(1)
    	double precision adis(npt)!for keeping a record of the point's distances
    	double precision dis1,dis2
    
	means=0.
    	totR=0
    
    	!choose a random point to be the cluster center
    	cluster=1
    	totR(1)=npt
    	do j=1,numdim
    		means(1,j)=sum(pt(j,1:npt))/dble(npt)
    	end do
    
    	k=min(npt/min_p,k+10)
    	if(k<=1) then
    		k=1
      	return
    	end if
    	k0=k

    	do m=2,k
    		clstrd=.false.
      
      		!pick the cluster with most points
      		indx=maxloc(totR(1:m-1))
      
      		!if all the clusters have less than npt<2(numdim+1) points then exit
      		if(totR(indx(1))<2*min_p) then
      			k=m-1
            		exit
      		endif
            
      		!pick a random point from this cluster as new cluster center
      		j=0
      		urv=ranmarns(0)
    		x=int(dble(totR(indx(1)))*urv)+1
      		do i=1,npt
      			if(cluster(i)==indx(1)) j=j+1
            		if(j==x) exit
      		enddo
      		means(cluster(i),:)=(means(cluster(i),:)*dble(totR(cluster(i)))-pt(:,i))/dble(totR(cluster(i))-1)
		means(m,:)=pt(:,i)
      		totR(cluster(i))=totR(cluster(i))-1
      		totR(m)=1
      		cluster(i)=m
      
      		do
      			clstrd=.true.
            
            		!check whether each point is closest to its own cluster or to the newly formed
            		!one & assign accordingly
            		do i=1,npt
                  		dis1=sum((pt(1:numdim,i)-means(cluster(i),1:numdim))**2)
                        	dis2=sum((pt(1:numdim,i)-means(m,1:numdim))**2)
                        	adis(i)=dis1-dis2
            		enddo
            
			do i=1,numdim
            			means(1:m,i)=means(1:m,i)*dble(totR(1:m))
            		enddo
            		do
            			indx2=maxloc(adis)
                  		if(adis(indx2(1))<=0.) then
                  			exit
                  		elseif(totR(cluster(indx2(1)))<=min_p) then
                  			adis(indx2(1))=-1.
                  		else
					!point moved so not finished yet
                        		clstrd=.false.
                        		!update cluster data
                        		totR(cluster(indx2(1)))=totR(cluster(indx2(1)))-1
                       			means(cluster(indx2(1)),1:numdim)=means(cluster(indx2(1)),1:numdim)-pt(1:numdim,indx2(1))
                       			cluster(indx2(1))=m
                        		totR(m)=totR(m)+1
                        		means(m,1:numdim)=means(m,1:numdim)+pt(1:numdim,indx2(1))
                        		adis(indx2(1))=-1.
                  		endif
			enddo
    
			!update means
            		do j=1,numdim
                  		means(1:m,j)=means(1:m,j)/dble(totR(1:m))
            		enddo
                  	
                  
            		!if num of points in the newly formed cluster are less than
            		!(numdim+1) then borrow closest points from cluster from which the new cluster
            		!was formed
            		if(clstrd.and.(totR(m)<min_p.or.totR(indx(1))<min_p)) then
            			if(totR(m)<min_p) then
                  			x=m
                        		q=indx(1)
                  		else
                  			x=indx(1)
                        		q=m
                  		endif
                  
            			adis=1.d99
            			do i=1,npt
                  			if(cluster(i)==q) then
                        			adis(i)=sum((pt(1:numdim,i)-means(x,1:numdim))**2)
                        		endif
                  		enddo
                  
                  		means(q,1:numdim)=means(q,1:numdim)*dble(totR(q))
                  		means(x,1:numdim)=means(x,1:numdim)*dble(totR(x))
                  
                  		do i=1,min_p-totR(x)
                  			indx2=minloc(adis)
                        		adis(indx2(1))=1.d99
                        		cluster(indx2(1))=x
                        		means(q,1:numdim)=means(q,1:numdim)-pt(1:numdim,indx2(1))
                        		means(x,1:numdim)=means(x,1:numdim)+pt(1:numdim,indx2(1))
                  		enddo
    
                  		totR(q)=totR(q)-min_p+totR(x)
                  		totR(x)=min_p
                  		means(q,1:numdim)=means(q,1:numdim)/dble(totR(q))
                  		means(x,1:numdim)=means(x,1:numdim)/dble(totR(x))
            		endif
                  
            		if(clstrd) exit
		enddo
    	enddo
	
  end subroutine sKmeans
 
!----------------------------------------------------------------------
  
  !soft k-means corresponding to the model of arbitrary Gaussians
  subroutine kmeans8(k,pt,npt,numdim,means,Covmat,cluster,min_pt)
    implicit none
 
    integer k,numdim,npt
    double precision pt(numdim,npt)
    double precision means(k,numdim),wt(k),r(npt,k)
    integer cluster(npt),min_pt
    double precision sumr,totR(k),temp,covmat(k,numdim,numdim),mean(numdim)
    integer i,j,indx(1),x,nochg,count,q
    logical clstrd
    double precision urv
	
    if(k>npt/min_pt+1) k=npt/min_pt+1
    clstrd=.false.
    nochg=0
    count=0
    
    do i=1,numdim
    	mean(i)=sum(pt(i,1:npt))/dble(npt)
    end do
    
    call calc_covmat(npt,numdim,pt,mean,covmat(1,1:numdim,1:numdim))
    do i=2,k
    	covmat(i,:,:)=covmat(1,:,:)
    end do
    
    do i=1,k
      wt(i)=ranmarns(0)
      urv=ranmarns(0)
      x=int(dble(npt)*urv)+1
    	means(i,:)=pt(:,x)
    end do
    temp=sum(wt)
    wt=wt/temp
    
    do
    	count=count+1
      clstrd=.true.
    	do i=1,npt
		do j=1,k
			r(i,j)=wt(j)*mNormalF(numdim,pt(:,i),means(j,:),Covmat(j,:,:))
		end do
		sumr=sum(r(i,:))
		r(i,:)=r(i,:)/sumr
		indx=maxloc(r(i,:))
            if(cluster(i)/=indx(1)) clstrd=.false.
		cluster(i)=indx(1)
	end do
      
	if(clstrd) then
		nochg=nochg+1
		if(nochg==2) exit
	else
		nochg=0
	end if
	
	do i=1,k
		totR(i)=sum(r(:,i))
		
		!update means
		do j=1,numdim
			means(i,j)=sum(r(:,i)*pt(j,:))/totR(i)
		end do
            !update the covariance matrix
            do q=1,numdim
            	do j=q,numdim
            		Covmat(i,q,j)=sum(r(:,i)*pt(q,:)*pt(j,:))/totR(i)-means(i,q)*means(i,j)
			end do
                  if(q/=j) Covmat(i,j,q)=Covmat(i,q,j)
		end do	
	end do
		
	!update weights
	temp=sum(totR(:))
	wt(:)=totR(:)/temp	
    end do
	
  end subroutine kmeans8  
 
!----------------------------------------------------------------------

  !Dinosaur clustering
  function Dmeans(k,pt,npt,like,ndim,cluster,min_pt,nptk,meank,covmatk,invcovk,tmatk,evalk,eveck,kfack,effk, &
  detcovk,volk,pVol,fVol,cSwitch,nCdim)
    implicit none
    
    !input variables
    integer k !no. of clusters required
    integer npt !no. of points
    double precision like(npt) !scaled log-like
    integer ndim !dimensionality
    double precision pt(ndim,npt) !points
    integer min_pt !min no. of points allowed in a cluster
    double precision pVol !prior volume
    logical cSwitch
    integer nCdim
    
    !input/output variables
    integer nptk(k) !input: no. of points in each of k-1 clusters, output: no. of points in each of k clusters
    integer cluster(npt) !input: cluster membership of each point for k-1 clusters, 
    		    !output: cluster membership of each point for k clusters
    double precision meank(k,ndim) !input: means of k-1 clusters, output: means of k clusters
    double precision covmatk(k,ndim,ndim) !input: covmat of k-1 clusters, output: covmat of k clusters
    double precision invcovk(k,ndim,ndim) !input: invcov of k-1 clusters, output: invcov of k clusters
    double precision tmatk(k,ndim,ndim) !input: tmat of k-1 clusters, output: tmat of k clusters
    double precision evalk(k,ndim) !input: eval of k-1 clusters, output: eval of k clusters
    double precision eveck(k,ndim,ndim) !input: evec of k-1 clusters, output: evec of k clusters
    double precision kfack(k) !input: kfac of k-1 clusters, output: kfac of k clusters
    double precision effk(k) !input: eff of k-1 clusters, output: eff of k clusters
    double precision detcovk(k) !input: detcov of k-1 clusters, output: detcov of k clusters
    double precision volk(k) !input: vol of k-1 clusters, output: vol of k clusters
    double precision fVol !volume of the father ellipsoid
    
    !output variables
    integer Dmeans !0 if found a better partition, 1 if found a partition but not better, 2 if couldn't partition
    
    !work variables
    integer i,j,x,i1,i2,indx(1),count,gcount,cls(2)
    double precision, allocatable :: h(:,:),mdis(:,:),ptk(:,:),mu_tmp(:,:)
    double precision d1,d2
    logical flag
    logical, allocatable :: doCal(:), broken(:)
    !ellipsoid properties
    integer, allocatable :: nptx(:), clusterx(:),cluster2(:)
    double precision, allocatable :: meanx(:,:),covmatx(:,:,:),invcovx(:,:,:),tmatx(:,:,:),evalx(:,:)
    double precision, allocatable :: evecx(:,:,:),kfacx(:),effx(:),detcovx(:),volx(:)
    
    
    !sanity check
    if(npt<min_pt*k) then
    	Dmeans=2
	return
    endif
    
    
    allocate( h(k,npt), mdis(k,npt), ptk(ndim+1,npt), mu_tmp(2,ndim+1), meanx(k,ndim), covmatx(k,ndim,ndim), &
    invcovx(k,ndim,ndim), tmatx(k,ndim,ndim), evalx(k,ndim), evecx(k,ndim,ndim), kfacx(k),effx(k), detcovx(k), volx(k) )
    allocate( doCal(k), broken(k) )
    allocate( nptx(k), clusterx(npt), cluster2(npt) )
    
    !initialization
    nptx=nptk
    clusterx=cluster
    meanx=meank
    covmatx=covmatk
    invcovx=invcovk
    tmatx=tmatk
    evalx=evalk
    evecx=eveck
    kfacx=kfack
    effx=effk
    detcovx=detcovk
    volx=volk
    gcount=1
    broken=.false.
    
    do
    	flag=.false.
    	!first find the ellipsoid with most fractional wastage
    	d2=-1.d99
    	do i=1,k-1
    		if(broken(i)) cycle
    		d1=(volx(i)-pVol*nptx(i)/npt)/(pVol*nptx(i)/npt)
		if(d1>d2) then
			flag=.true.
			d2=d1
			j=i
		endif
    	enddo
    
    	!if none of the ellipsoids can be split then return
    	if(.not.flag) exit
	
    	broken(j)=.true.
	
	!split ellipsoid j
	i1=0
	do i=1,npt
		if(clusterx(i)==j) then
			i1=i1+1
			if(cSwitch) then
				ptk(1:nCdim,i1)=pt(1:nCdim,i)
				ptk(nCdim+1,i1)=like(i)
			else
				ptk(1:ndim,i1)=pt(1:ndim,i)
				ptk(ndim+1,i1)=like(i)
			endif	
		endif
	enddo
	
	i2=2
!	if(cSwitch) then
!		call Kmeans3(i2,ptk(1:nCdim+1,1:i1),i1,nCdim+1,mu_tmp(:,1:nCdim+1),cluster2(1:i1),min_pt)
!	else
!		call Kmeans3(i2,ptk(1:ndim+1,1:i1),i1,ndim+1,mu_tmp(:,1:ndim+1),cluster2(1:i1),min_pt)
!	endif
	if(cSwitch) then
		call Kmeans3(i2,ptk(1:nCdim,1:i1),i1,nCdim,mu_tmp(:,1:nCdim),cluster2(1:i1),min_pt)
	else
		call Kmeans3(i2,ptk(1:ndim,1:i1),i1,ndim,mu_tmp(:,1:ndim),cluster2(1:i1),min_pt)
	endif
	
	!separate out the points
	nptx(j)=0
	nptx(k)=0
	i2=1
	do i=1,i1
		do x=i2,npt
			if(clusterx(x)==j) then
				if(cluster2(i)==1) then
					clusterx(x)=j
					nptx(j)=nptx(j)+1
				else
					clusterx(x)=k
					nptx(k)=nptx(k)+1
				endif
				i2=x+1
				exit
			endif
		enddo
	enddo
	
	cls(1)=j
	cls(2)=k
	do i2=1,2
		x=0
		!separate out the points
		do i=1,npt
			if(clusterx(i)==cls(i2)) then
				x=x+1
				ptk(1:ndim,x)=pt(1:ndim,i)
			endif
		enddo
		!min volume this ellipsoid should occupy
		d1=pVol*x/npt
		!calculate the ellipsoid properties
		call CalcEllProp(x,ndim,ptk(1:ndim,1:x),meanx(cls(i2),:),covmatx(cls(i2),:,:), &
		invcovx(cls(i2),:,:),tmatx(cls(i2),:,:),evecx(cls(i2),:,:),evalx(cls(i2),:),detcovx(cls(i2)),kfacx(cls(i2)), &
		effx(cls(i2)),volx(cls(i2)),d1,.false.)
	enddo
	
	!find if it's a better partition
!	if(nptx(j)<min_pt .or. nptx(k)<min_pt) then
!		count=0
!		Dmeans=2
!	else
		count=1
		if(gcount==1) then
			!save the best partition
			nptk=nptx
    			cluster=clusterx
    			meank=meanx
    			covmatk=covmatx
   			invcovk=invcovx
   			tmatk=tmatx
    			evalk=evalx
    			eveck=evecx
    			kfack=kfacx
   			effk=effx
    			detcovk=detcovx
    			volk=volx
		endif
		if(sum(volx(1:k))<fVol) then
			Dmeans=0
		else
			Dmeans=1
		endif
!	endif
    
    	doCal=.true.
		
	!calculate the distance measure
!    	do i=1,k
!		do j=1,npt
!			mdis(i,j)=MahaDis(ndim,pt(:,j),meanx(i,:),invcovx(i,:,:),kfacx(i)*effx(i))
!		enddo
!    	enddo
    
    	do
    		gcount=gcount+1
		!calculate the distance measure
    		do i=1,k
    			if(.not.doCal(i)) cycle
			do j=1,npt
				mdis(i,j)=MahaDis(ndim,pt(:,j),meanx(i,:),invcovx(i,:,:),kfacx(i)*effx(i))
				h(i,j)=volx(i)*mdis(i,j)/nptx(i)
			enddo
    		enddo
    		
!		do x=1,npt
!			i=clusterx(x) !cluster in which point x lies
!			
!			if(doCal(i)) mdis(x,i)=MahaDis(ndim,pt(:,x),meanx(i,:),invcovx(i,:,:),kfacx(i)*effx(i))
!			d2=kfacx(i)*effx(i)
!			d1=(((nptx(i)/(nptx(i)-1.d0))**3)*(1.d0-mdis(x,i)/(nptx(i)-1.d0))-1.d0)*sqrt(detcovx(i)*(d2**(ndim)))/ &
!    				(((nptx(i)/(nptx(i)-1.d0))**1.5d0)*sqrt(1.d0-mdis(x,i)/(nptx(i)-1.d0))+1.d0)
!			
!			do j=1,k
!				if(j==i) then
!					h(j,x)=0.d0
!				else
!					if(doCal(j)) mdis(x,j)=MahaDis(ndim,pt(:,x),meanx(j,:),invcovx(j,:,:),kfacx(j)*effx(j))
!					d2=kfacx(j)*effx(j)
!					h(j,x)=(((nptx(j)/(nptx(j)+1.d0))**3)*(1.d0+mdis(x,j)/(nptx(j)+1.d0))-1.d0)*sqrt(detcovx(j)*(d2**(ndim)))/ &
!    						(((nptx(j)/(nptx(j)+1.d0))**1.5d0)*(sqrt(1.d0+mdis(x,j)/(nptx(j)+1.d0)))+1.d0)
!					h(j,x)=(h(j,x)+d1)!/dble(nptx(i)+nptx(j))
!				endif
!			enddo
!    		enddo
    
    		!now assign point j to the ellipsoid i such that h(i,j) is min
    		flag=.false.
    		do j=1,npt
    			indx=minloc(h(1:k,j))
			if(clusterx(j)/=indx(1)) then
				doCal(clusterx(j))=.true.
				doCal(indx(1))=.true.
				flag=.true.
				nptx(clusterx(j))=nptx(clusterx(j))-1
				nptx(indx(1))=nptx(indx(1))+1
				clusterx(j)=indx(1)
			endif
    		enddo
		
		!if a cluster has less than min_pt points then kill it
		if(flag) then
			do j=1,k
				if(nptx(j)<min_pt) then
					do i1=1,npt
						if(clusterx(i1)==j) then
							h(j,i1)=1.d99
							indx=minloc(h(1:k,i1))
							doCal(indx(1))=.true.
							nptx(j)=nptx(j)-1
							nptx(indx(1))=nptx(indx(1))+1
							clusterx(i1)=indx(1)
						endif
					enddo
					doCal(j)=.false.
					mdis(j,1:npt)=1.d99
					volx(j)=0.d0
					kfacx(j)=0.d0
					evalx(j,:)=0.d0
				endif
			enddo
			exit
		endif

		if(.not.flag) then
			!no point reassigned
			!check if clustering resulted in the new cluster having more than min_pt points
			if(nptx(k)>0 .and. nptx(k)<npt) then
				!check the boundary point of each ellipsoid
				do i=1,k
					if(nptx(i)==min_pt) cycle
			
					!find the boundary point
					d1=0.d0
					do j=1,npt
						if(clusterx(j)==i) then
							if(mdis(i,j)>d1) then
								d1=mdis(i,j)
								i1=j
							endif
						endif
					enddo
			
					!now calculate delF for all the other ellipsoids
					do j=1,k
						if(i==j .or. nptx(j)==0) cycle
						d1=kfacx(i)*effx(i)
						d2=kfacx(j)*effx(j)
						if(delF(ndim,nptx(i),nptx(j),mdis(i,i1),mdis(j,i1),detcovx(i), &
						detcovx(j),d1,d2)<0.) then
							doCal(i)=.true.
							doCal(j)=.true.
							flag=.true.
							nptx(i)=nptx(i)-1
							nptx(j)=nptx(j)+1
							clusterx(i1)=j
							exit
						endif
					enddo
					if(flag) exit
				enddo
			endif
		endif
		
		if(flag) then
			!point reassigned, recalculate the ellipsoid properties
			count=count+1
			!if no better partition found in the past 5 iterations then return
			if(count==20) exit
			if(nptx(k)>0 .and. nptx(k)<npt) then
				do i=1,k
					if(.not.doCal(i)) cycle
					i1=0
					do j=1,npt
						if(clusterx(j)==i) then
							i1=i1+1
							ptk(1:ndim,i1)=pt(1:ndim,j)
						endif
					enddo
					d1=pVol*dble(i1)/dble(npt)
					call CalcEllProp(i1,ndim,ptk(1:ndim,1:i1),meanx(i,:),covmatx(i,:,:), &
						invcovx(i,:,:),tmatx(i,:,:),evecx(i,:,:),evalx(i,:),detcovx(i),kfacx(i), &
						effx(i),volx(i),d1,.false.)
				enddo
				!check if this resulted in a better partition
				if(sum(volx(1:k))<sum(volk(1:k))) then
					!reset the counter
					count=0
					!save the best partition
					nptk=nptx
    					cluster=clusterx
    					meank=meanx
    					covmatk=covmatx
	    				invcovk=invcovx
    					tmatk=tmatx
    					evalk=evalx
    					eveck=evecx
    					kfack=kfacx
	    				effk=effx
    					detcovk=detcovx
    					volk=volx
				
					if(sum(volx(1:k))<fVol) then
						Dmeans=0
						if(abs(sum(volx(1:k))-pVol)/pVol<0.01) return
					else
						Dmeans=1
					endif
				endif
			endif
		else
			exit
		endif
	enddo
	if(Dmeans==0) exit
    enddo
    
    deallocate( h, mdis, ptk, mu_tmp, meanx, covmatx, invcovx, tmatx, evalx, evecx, kfacx, effx, detcovx, volx )
    deallocate( doCal, broken )
    deallocate( nptx, clusterx, cluster2 )
    
	
  end function Dmeans  
 
!----------------------------------------------------------------------
  !calculate the variation in weighted average of e-tightness functions of 2 
  !components for re-assigning a point from component 1 to 2
  !Choi, Wang & Kim, Eurographics 2007, vol. 26, No. 3
  function delF(ndim,n1,n2,mdis1,mdis2,detcov1,detcov2,kfac1,kfac2)
    implicit none
    
    !input variables
    integer ndim !dinemsionality
    integer n1,n2 !no. of points in each ellipsoid
    double precision mdis1,mdis2 !Mahalanobis distance of the point from both ellipsoids
    double precision detcov1,detcov2 !determinant of the covariance matrices of the ellipsoids
    double precision kfac1,kfac2 !overall enlargement factors of the ellipsoids
    
    !output variables
    double precision delF
    
    
    delF=(((n1/(n1-1.))**3)*(1.-mdis1/(n1-1.))-1.)*sqrt(detcov1*(kfac1**(ndim)))/ &
    	(((n1/(n1-1.))**1.5)*sqrt(1.-mdis1/(n1-1.))+1.)
    delF=delF+(((n2/(n2+1.))**3)*(1.+mdis2/(n2+1.))-1.)*sqrt(detcov2*(kfac2**(ndim)))/ &
    	(((n2/(n2+1.))**1.5)*(sqrt(1.+mdis2/(n2+1.)))+1.)
	
    delF=delF/(dble(n1+n2))
	
  end function delF  
 
!----------------------------------------------------------------------
  !Incremental K-means with a given cluster 'm' to be split, returns means & distortions 
  !(Pham, Dimov, Nguyen, 2005, "Incremental K-means Algorithm")
  !(Pham, Dimov, Nguyen, 2005, "Selection of K in K-means Clustering")
  subroutine kmeansDis(k,pt,npt,numdim,cluster,m,totR,distortion,means)
    implicit none
 
    integer k,numdim,npt
    double precision pt(numdim,npt)
    double precision means(:,:)
    integer cluster(npt)
    integer totR(:)!total points in each cluster
    integer m!cluster to be split
    integer i,j,x
    logical clstrd
    double precision urv
    double precision distortion(:)!distortion of each cluster
    
    if(k==0) then
    	cluster=1
    	do j=1,numdim
    		means(1,j)=sum(pt(j,:))/dble(npt)
    	end do
     	return
    end if
    
    clstrd=.false.
            
    !pick a random point from the cluster to be split as new cluster center
    j=0
    urv=ranmarns(0)
    x=int(dble(totR(m))*urv)+1
    do i=1,npt
      if(cluster(i)==m) j=j+1
	if(j==x) exit
    end do
    means(k+1,1:numdim)=pt(1:numdim,i)
            
    do
      clstrd=.true.
            
      !check whether each point is closest to its own cluster or to the newly formed
      !one & assign accordingly
      do i=1,npt
		if(sum((pt(1:numdim,i)-means(cluster(i),1:numdim))**2)> &
            sum((pt(1:numdim,i)-means(k+1,1:numdim))**2))then
			!point moved so not finished yet
			clstrd=.false.
                         
			!update cluster data
                  totR(cluster(i))=totR(cluster(i))-1
			cluster(i)=k+1
			totR(k+1)=totR(k+1)+1
		end if
	end do
                        
	!update means & distortion of each cluster
	means=0.
	distortion=0.
	do i=1,npt
		means(cluster(i),1:numdim)=means(cluster(i),1:numdim)+pt(1:numdim,i)
		distortion(cluster(i))=distortion(cluster(i))+sum(pt(1:numdim,i)**2)
	end do
	do j=1,numdim
		means(1:k+1,j)=means(1:k+1,j)/dble(totR(1:k+1))
		distortion(1:k+1)=distortion(1:k+1)-dble(totR(1:k+1))*(means(1:k+1,j)**2)
	end do
                  
	if(clstrd) exit
    end do
	
  end subroutine kmeansDis
 
!----------------------------------------------------------------------  
  
  subroutine cal_means(numdim,npt,p,mean)
    implicit none
    integer numdim,npt
    double precision p(numdim,npt)
    double precision mean(numdim)
    integer i,j

    mean=0.
    do i=1,numdim
       do j=1,npt
          mean(i)=mean(i)+p(i,j)
       end do
       mean(i)=mean(i)/dble(npt)
    end do
    
    return
    
  end subroutine cal_means

!---------------------------------------------------------------------- 

end module kmeans_clstr

module cosmosis_wrappers
    use iso_c_binding
    use cosmosis_types
    implicit none

    interface
        function make_c_datablock() bind(C, name="make_c_datablock")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer(kind=cosmosis_block) :: make_c_datablock
        end function make_c_datablock

        function destroy_c_datablock(block) bind(C, name="destroy_c_datablock")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer(kind=cosmosis_block), value :: block
            integer (cosmosis_status) :: destroy_c_datablock
        end function destroy_c_datablock


        function c_datablock_num_sections_wrapper(block) bind(C, name="c_datablock_num_sections")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer(kind=cosmosis_block), value :: block
            integer(c_int) :: c_datablock_num_sections_wrapper
        end function c_datablock_num_sections_wrapper




        function c_datablock_get_array_length_wrapper(s, section, name) bind(C, name="c_datablock_get_array_length")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (kind=c_int) :: c_datablock_get_array_length_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section, name
        end function c_datablock_get_array_length_wrapper


        function c_datablock_has_section_wrapper(s, name) bind(C, name="c_datablock_has_section")
            use iso_c_binding
            use cosmosis_types
            implicit none
            logical (kind=c_bool) :: c_datablock_has_section_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: name
        end function c_datablock_has_section_wrapper

        function c_datablock_has_value_wrapper(s, section, name) bind(C, name="c_datablock_has_value")
            use iso_c_binding
            use cosmosis_types
            implicit none
            logical (kind=c_bool) :: c_datablock_has_value_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section, name
        end function c_datablock_has_value_wrapper

        function c_datablock_get_section_name_wrapper(s, i) bind(C, name="c_datablock_get_section_name")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer(kind=cosmosis_block), value :: s
            integer(kind=c_int), value :: i
            type(c_ptr) :: c_datablock_get_section_name_wrapper
        end function c_datablock_get_section_name_wrapper


!  const char* c_datablock_get_section_name(c_datablock const* s, int i)

        function c_datablock_put_int_wrapper(s, section, name, value) bind(C, name="c_datablock_put_int")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_int_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: value
        end function c_datablock_put_int_wrapper

        function c_datablock_put_bool_wrapper(s, section, name, value) bind(C, name="c_datablock_put_bool")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_bool_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            logical(kind=c_bool), value :: value
        end function c_datablock_put_bool_wrapper

        function c_datablock_put_double_wrapper(s, section, name, value) bind(C, name="c_datablock_put_double")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_double_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            real(kind=c_double), value :: value
        end function c_datablock_put_double_wrapper

        function c_datablock_put_complex_wrapper(s, section, name, value) bind(C, name="c_datablock_put_complex")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_complex_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            complex(kind=c_double_complex), value :: value
        end function c_datablock_put_complex_wrapper

        function c_datablock_put_string_wrapper(s, section, name, value) &
        bind(C, name="c_datablock_put_string")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_string_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            character(kind=c_char), dimension(*) :: value
        end function c_datablock_put_string_wrapper



        function c_datablock_put_int_array_1d_wrapper(s, section, name, value, sz) &
        bind(C, name="c_datablock_put_int_array_1d")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_int_array_1d_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: sz
            integer(kind=c_int), dimension(sz) :: value
        end function c_datablock_put_int_array_1d_wrapper

        function c_datablock_put_double_array_1d_wrapper(s, section, name, value, sz) &
        bind(C, name="c_datablock_put_double_array_1d")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_double_array_1d_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: sz
            real(kind=c_double), dimension(sz) :: value
        end function c_datablock_put_double_array_1d_wrapper

        function c_datablock_put_double_array_wrapper(s, section, name, value, ndims, extents) &
        bind(C, name="c_datablock_put_double_array")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_double_array_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            real(kind=c_double), dimension(*) :: value
            integer(kind=c_int), value :: ndims
            integer(kind=c_int), dimension(ndims) :: extents

        end function c_datablock_put_double_array_wrapper

        function c_datablock_get_double_array_wrapper(s, section, name, value, ndims, extents) &
        bind(C, name="c_datablock_get_double_array")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_double_array_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            real(kind=c_double), dimension(*) :: value
            integer(kind=c_int), value :: ndims
            integer(kind=c_int), dimension(ndims) :: extents

        end function c_datablock_get_double_array_wrapper

        function c_datablock_get_int_array_wrapper(s, section, name, value, ndims, extents) &
        bind(C, name="c_datablock_get_int_array")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_int_array_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), dimension(*) :: value
            integer(kind=c_int), value :: ndims
            integer(kind=c_int), dimension(ndims) :: extents

        end function c_datablock_get_int_array_wrapper



        function c_datablock_put_int_array_wrapper(s, section, name, value, ndims, extents) &
        bind(C, name="c_datablock_put_int_array")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_int_array_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), dimension(*) :: value
            integer(kind=c_int), value :: ndims
            integer(kind=c_int), dimension(ndims) :: extents

        end function c_datablock_put_int_array_wrapper

        function c_datablock_put_complex_array_1d_wrapper(s, section, name, value, sz) &
        bind(C, name="c_datablock_put_complex_array_1d")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_complex_array_1d_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: sz
            complex(kind=c_double_complex), dimension(sz) :: value
        end function c_datablock_put_complex_array_1d_wrapper



        !DATABLOCK_STATUS c_datablock_put_int(c_datablock* s, const char* section, const char* name, int val);
        function c_datablock_replace_int_wrapper(s, section, name, value) bind(C, name="c_datablock_replace_int")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_int_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int)  :: value
        end function c_datablock_replace_int_wrapper

        function c_datablock_replace_bool_wrapper(s, section, name, value) bind(C, name="c_datablock_replace_bool")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_bool_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            logical(kind=c_bool)  :: value
        end function c_datablock_replace_bool_wrapper

        function c_datablock_replace_double_wrapper(s, section, name, value) bind(C, name="c_datablock_replace_double")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_double_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            real(kind=c_double), value :: value
        end function c_datablock_replace_double_wrapper

        function c_datablock_replace_complex_wrapper(s, section, name, value) bind(C, name="c_datablock_replace_complex")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_complex_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            complex(kind=c_double_complex), value :: value
        end function c_datablock_replace_complex_wrapper

        function c_datablock_replace_string_wrapper(s, section, name, value) &
        bind(C, name="c_datablock_replace_string")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_string_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            character(kind=c_char), dimension(*) :: value
        end function c_datablock_replace_string_wrapper


        function c_datablock_replace_int_array_1d_wrapper(s, section, name, value, sz) &
        bind(C, name="c_datablock_replace_int_array_1d")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_int_array_1d_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: sz
            integer(kind=c_int), dimension(sz) :: value
        end function c_datablock_replace_int_array_1d_wrapper

        function c_datablock_replace_double_array_1d_wrapper(s, section, name, value, sz) &
        bind(C, name="c_datablock_replace_double_array_1d")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_double_array_1d_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: sz
            real(kind=c_double), dimension(sz) :: value
        end function c_datablock_replace_double_array_1d_wrapper

        function c_datablock_replace_complex_array_1d_wrapper(s, section, name, value, sz) &
        bind(C, name="c_datablock_replace_complex_array_1d")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_complex_array_1d_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: sz
            complex(kind=c_double_complex), dimension(sz) :: value
        end function c_datablock_replace_complex_array_1d_wrapper

        !DATABLOCK_STATUS c_datablock_get_int(c_datablock* s, const char* section, const char* name, int *val);
        function c_datablock_get_int_wrapper(s, section, name, value) bind(C, name="c_datablock_get_int")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_int_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int) :: value
        end function c_datablock_get_int_wrapper

        !DATABLOCK_STATUS c_datablock_get_int(c_datablock* s, const char* section, const char* name, int *val);
        function c_datablock_get_bool_wrapper(s, section, name, value) bind(C, name="c_datablock_get_bool")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_bool_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            logical(kind=c_bool) :: value
        end function c_datablock_get_bool_wrapper

        function c_datablock_get_double_wrapper(s, section, name, value) bind(C, name="c_datablock_get_double")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_double_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            real(kind=c_double) :: value
        end function c_datablock_get_double_wrapper

        function c_datablock_get_complex_wrapper(s, section, name, value) bind(C, name="c_datablock_get_complex")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_complex_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            complex(kind=c_double_complex) :: value
        end function c_datablock_get_complex_wrapper

        function c_datablock_get_string_wrapper(s, section, name, value) bind(C, name="c_datablock_get_string")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_string_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            type(c_ptr) :: value
        end function c_datablock_get_string_wrapper


        !DATABLOCK_STATUS c_datablock_get_int(c_datablock* s, const char* section, const char* name, int *val);
        function c_datablock_get_int_default_wrapper(s, section, name, default, value) bind(C, name="c_datablock_get_int_default")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_int_default_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int) :: value
            integer(kind=c_int), value :: default
        end function c_datablock_get_int_default_wrapper

        function c_datablock_get_bool_default_wrapper(s, section, name, default, value) bind(C, name="c_datablock_get_bool_default")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_bool_default_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            logical(kind=c_bool) :: value
            logical(kind=c_bool), value :: default
        end function c_datablock_get_bool_default_wrapper


        function c_datablock_get_double_default_wrapper(s, section, name, default, value) bind(C, name="c_datablock_get_double_default")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_double_default_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            real(kind=c_double) :: value
            real(kind=c_double), value :: default
        end function c_datablock_get_double_default_wrapper

        function c_datablock_get_complex_default_wrapper(s, section, name, default, value) bind(C, name="c_datablock_get_complex_default")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_complex_default_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            complex(kind=c_double_complex) :: value
            complex(kind=c_double_complex), value :: default
        end function c_datablock_get_complex_default_wrapper


        function c_datablock_get_string_default_wrapper(s, section, name, default, value) bind(C, name="c_datablock_get_string_default")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_string_default_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            character(kind=c_char), dimension(*) :: default
            type(c_ptr) :: value
        end function c_datablock_get_string_default_wrapper

        function c_datablock_get_int_array_1d_preallocated_wrapper(s, section, name, value, size, maxsize) &
        bind(C, name="c_datablock_get_int_array_1d_preallocated")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_int_array_1d_preallocated_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: maxsize
            integer(kind=c_int) :: value(maxsize)
            integer(kind=c_int) :: size
        end function c_datablock_get_int_array_1d_preallocated_wrapper

        function c_datablock_get_double_array_1d_preallocated_wrapper(s, section, name, value, size, maxsize) &
        bind(C, name="c_datablock_get_double_array_1d_preallocated")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_double_array_1d_preallocated_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: maxsize
            real(kind=c_double) :: value(maxsize)
            integer(kind=c_int) :: size
        end function c_datablock_get_double_array_1d_preallocated_wrapper

        function c_datablock_get_complex_array_1d_preallocated_wrapper(s, section, name, value, size, maxsize) &
        bind(C, name="c_datablock_get_complex_array_1d_preallocated")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_complex_array_1d_preallocated_wrapper
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: maxsize
            complex(kind=c_double_complex) :: value(maxsize)
            integer(kind=c_int) :: size
        end function c_datablock_get_complex_array_1d_preallocated_wrapper


        function c_datablock_get_metadata(s, section, name, key, value) &
        bind(C, name="c_datablock_get_metadata")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_metadata
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            character(kind=c_char), dimension(*) :: key
            type(c_ptr) :: value
        end function c_datablock_get_metadata

        function c_datablock_put_metadata(s, section, name, key, value) &
        bind(C, name="c_datablock_put_metadata")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_put_metadata
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            character(kind=c_char), dimension(*) :: key
            character(kind=c_char), dimension(*) :: value
        end function c_datablock_put_metadata

        function c_datablock_replace_metadata(s, section, name, key, value) &
        bind(C, name="c_datablock_replace_metadata")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_replace_metadata
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            character(kind=c_char), dimension(*) :: key
            character(kind=c_char), dimension(*) :: value
        end function c_datablock_replace_metadata

        function c_datablock_get_int_array_shape(s, section, name, ndims, extents) &
            bind(C, name="c_datablock_get_int_array_shape")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_int_array_shape
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int), value :: ndims
            integer(kind=c_int), dimension(ndims) :: extents
        end function c_datablock_get_int_array_shape

        function c_datablock_get_double_array_shape(s, section, name, ndims, extents) &
            bind(C, name="c_datablock_get_double_array_shape")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_double_array_shape
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int),value :: ndims
            integer(kind=c_int), dimension(ndims) :: extents
        end function c_datablock_get_double_array_shape

        function c_datablock_get_complex_array_shape(s, section, name, ndims, extents) &
            bind(C, name="c_datablock_get_complex_array_shape")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_get_complex_array_shape
            integer(kind=cosmosis_block), value :: s
            character(kind=c_char), dimension(*) :: section
            character(kind=c_char), dimension(*) :: name
            integer(kind=c_int),value :: ndims
            integer(kind=c_int), dimension(ndims) :: extents
        end function c_datablock_get_complex_array_shape

        function c_datablock_print_log(s) bind(C, name="c_datablock_print_log")
            use iso_c_binding
            use cosmosis_types
            implicit none
            integer (cosmosis_status) :: c_datablock_print_log
            integer(kind=cosmosis_block), value :: s
        end function c_datablock_print_log


    function wrap_strlen(str) bind(C, name='strlen')
        use iso_c_binding
        implicit none
        type(c_ptr), value :: str
        integer(c_size_t) :: wrap_strlen
    end function wrap_strlen

    subroutine wrap_free(p) bind(C, name='free')
        use iso_c_binding
        implicit none
        type(c_ptr), value :: p
    end subroutine wrap_free



    end interface

    contains



    function c_string_to_fortran(c_str, max_len) result(f_str)
        use iso_c_binding
        integer :: max_len
        character(max_len) :: f_str
        character, pointer, dimension(:) :: p_str
        type(c_ptr) :: c_str
        integer(c_size_t) :: n, shpe(1)
        integer(c_size_t) :: i

        !Initialize an empty string
        do i=1,max_len-1
            f_str(i:i+1) = " "
        enddo

        !Check for NULL pointer.  If so translate as blank
        if(.not. c_associated(c_str)) return

        !Otherwise, get string length and copy that many chars
        n = wrap_strlen(c_str)
        shpe(1) = n
        call c_f_pointer(c_str, p_str, shpe)
        do i=1,n
            f_str(i:i+1) = p_str(i)
        enddo

    end function


end module cosmosis_wrappers

! Do nested sampling algorithm to calculate Bayesian evidence
! Jul 2015
! Farhan Feroz

module Nested
  use utils1
  use kmeans_clstr
  use xmeans_clstr
  use posterior
  use priors
#ifdef MPI
  use mpi
#endif  

  implicit none

#ifdef MPI
  integer errcode
#endif
  integer my_rank
  integer maxCls,maxeCls
  integer mpi_nthreads !total no. of mpi processors
  integer min_pt,totPar
  integer nCdims !total no. of parameters on which clustering should be done
  integer nlive ! Number of live points
  integer ndims ! Number of dimensions
  integer nsc_def !no. of iterations per every sub-clustering step
  integer updInt !update interval
  double precision Ztol !lowest local evidence for which samples to produce
  double precision tol ! tolerance at end
  double precision ef
  logical multimodal ! multimodal or unimodal sampling
  logical ceff ! constant efficiency?
  integer numlike,globff
  double precision logZero
  integer maxIter
  logical fback,resumeFlag,dlive,genLive,dino
  !output files name
  character(len=root_max_len)physname,broot,rname,resumename,livename,evname,IS_Files(3)
  !output file units
  integer u_ev,u_resume,u_phys,u_live,u_IS(3)
  double precision gZ,ginfo !total log(evidence) & info
  integer count,sCount
  logical, dimension(:), allocatable :: pWrap
  logical mWrap,aWrap !whether to do wraparound for mode separation
  logical debug, prior_warning, resume, outfile
  !importance sampling
  logical :: IS = .true.
  logical bogus

contains
  
  subroutine nestRun(nest_IS,nest_mmodal,nest_ceff,nest_nlive,nest_tol,nest_ef,nest_ndims,nest_totPar,nest_nCdims,maxClst, &
  nest_updInt,nest_Ztol,nest_root,seed,nest_pWrap,nest_fb,nest_resume,nest_outfile,initMPI,nest_logZero,nest_maxIter, &
  loglike,dumper,context)
        
  	implicit none
        
	integer nest_ndims,nest_nlive,nest_updInt,context,seed,i
	integer maxClst,nest_nsc,nest_totPar,nest_nCdims,nest_pWrap(*),nest_maxIter
	logical nest_IS,nest_mmodal,nest_fb,nest_resume,nest_ceff,nest_outfile,initMPI
	character(len=root_max_len) nest_root
	double precision nest_tol,nest_ef,nest_Ztol,nest_logZero
    integer ierror
	
	INTERFACE
    		!the likelihood function
    		subroutine loglike(Cube,n_dim,nPar,lnew,context_pass)
			integer n_dim,nPar,context_pass
			double precision lnew,Cube(nPar)
		end subroutine loglike
    	end INTERFACE
	
	INTERFACE
		!the user dumper function
    		subroutine dumper(nSamples, nlive, nPar, physLive, posterior, paramConstr, maxLogLike, logZ, INSlogZ, logZerr, context_pass)
			integer nSamples, nlive, nPar, context_pass
			double precision, pointer :: physLive(:,:), posterior(:,:), paramConstr(:)
			double precision maxLogLike, logZ, INSlogZ, logZerr
		end subroutine dumper
	end INTERFACE
	
#ifdef MPI
	if( initMPI ) then
		!MPI initializations
		call MPI_INIT(errcode)
		if (errcode/=MPI_SUCCESS) then
     			write(*,*)'Error starting MPI. Terminating.'
     			call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
  		end if
	endif
	call MPI_COMM_RANK(MPI_COMM_WORLD, my_rank, errcode)
	call MPI_COMM_SIZE(MPI_COMM_WORLD, mpi_nthreads, errcode)
#else
	mpi_nthreads=1
	my_rank=0
#endif
	bogus = .false.
	nest_nsc=50
      	nlive=nest_nlive
	Ztol=nest_Ztol
	updInt=nest_updInt
	logZero=nest_logZero
	maxIter=nest_maxIter
	if(maxIter<=0) maxIter=huge(1)
	
	ndims=nest_ndims
      	totPar=nest_totPar
	nCdims=nest_nCdims
	debug=.false.
	prior_warning=.true.
	resume=nest_resume
	outfile=nest_outfile
	if(.not.outfile) resume=.false.
	
      	if(nCdims>ndims) then
		if(my_rank==0) then
			write(*,*)"ERROR: nCdims can not be greater than ndims."
			write(*,*)"Aborting"
		endif
#ifdef MPI
		call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
            	stop
	endif
	
	if(my_rank==0) then
		count=0
		sCount=0
      	
      		broot=nest_root
      		rname = trim(broot)
      		fback = nest_fb
		
      		!output file info
      		!setup the output files
      		resumename = trim(rname)//'resume.dat'
      		physname = trim(rname)//'phys_live.points'
      		livename = trim(rname)//'live.points'
      		evname = trim(rname)//'ev.dat'
      		u_ev=55
		u_phys=57
      		u_live=59
		u_resume=61
		
		if( IS ) then
			IS_Files(1) = trim(rname)//'IS.points'
			IS_Files(2) = trim(rname)//'IS.ptprob'
			IS_Files(3) = trim(rname)//'IS.iterinfo'
			u_IS(1) = 62
			u_IS(2) = 63
			u_IS(3) = 64
		endif
	endif
	
	allocate(pWrap(ndims))
	mWrap=.false.
	aWrap=.true.
	do i=1,ndims
		if(nest_pWrap(i)==0) then
			pWrap(i)=.false.
			if(i<=nCdims) aWrap=.false.
		else
			pWrap(i)=.true.
			if(i<=nCdims) mWrap=.true.
		endif
	enddo
	IS = nest_IS
      	multimodal=nest_mmodal
	if( IS ) multimodal = .false.
	ceff=nest_ceff
      	tol=nest_tol
      	ef=nest_ef
	if(ef>=1d6) then
		dino=.false.
		ef=1d0
		min_pt=ndims+1
	elseif(ceff) then
		if(ef>1d0) then
			if(my_rank==0) then
				write(*,*)"ERROR: Can not undersample in constant efficiency mode."
				write(*,*)"Aborting"
			endif
#ifdef MPI
			call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
            		stop
		endif
		dino=.true.
		min_pt=2
	else
		dino=.true.
		min_pt=2
	endif
	nsc_def=nest_nsc
	      
      	if(.not.multimodal) then
      		maxCls=1
	else
      		maxCls=maxClst*2
	endif
      
      	maxeCls=nlive/min_pt

      	if(seed<0) then
		!take the seed from system clock
        	call InitRandomNS(mpi_nthreads)
      	else
        	call InitRandomNS(mpi_nthreads,seed)
	endif
	
	if(my_rank==0) then
      		!set the resume flag to true if the resume file exists else to false
      		if(resume) then
			inquire(file=resumename,exist=resumeFlag)
			if(.not.resumeFlag) write(*,*)"MultiNest Warning: no resume file found, starting from scratch"
		else
			resumeFlag=.false.
		endif
      
		write(*,*)"*****************************************************"
		write(*,*)"MultiNest v3.10"
      		write(*,*)"Copyright Farhan Feroz & Mike Hobson"
      		write(*,*)"Release Jul 2015"
		write(*,*)
      		write(*,'(a,i4)')" no. of live points = ",nest_nlive
      		write(*,'(a,i4)')" dimensionality = ",nest_ndims
		if(ceff) write(*,'(a)')" running in constant efficiency mode"
      		if(resumeFlag) write(*,'(a)')" resuming from previous job"
      		write(*,*)"*****************************************************"
        
		if (fback) write (*,*) 'Starting MultiNest'
	
	
      		!create the output files
		if(.not.resumeFlag .and. outfile) then
			open(unit=u_ev,file=evname,status='replace')
			close(u_ev)
		endif
	endif
	
	call Nestsample(loglike, dumper, context)
	deallocate(pWrap)
      	call killRandomNS()
#ifdef MPI
	if( initMPI ) call MPI_FINALIZE(errcode)
#endif

  end subroutine nestRun

!----------------------------------------------------------------------

  subroutine Nestsample(loglike, dumper, context)
	
	implicit none
	
	integer context
	double precision, allocatable :: p(:,:), phyP(:,:) !live points
	double precision, allocatable :: l(:) !log-likelihood
	double precision vnow1!current vol
	double precision ltmp(totPar+2)
	character(len=root_max_len) fmt
	integer np,i,j,k,ios
	logical flag
    integer ierror
	
	INTERFACE
		!the likelihood function
		subroutine loglike(Cube,n_dim,nPar,lnew,context_pass)
			integer n_dim,nPar,context_pass
			double precision lnew,Cube(nPar)
		end subroutine loglike
	end INTERFACE
	
	INTERFACE
		!the user dumper function
    		subroutine dumper(nSamples, nlive, nPar, physLive, posterior, paramConstr, maxLogLike, logZ, INSlogZ, logZerr, context_pass)
			integer nSamples, nlive, nPar, context_pass
			double precision, pointer :: physLive(:,:), posterior(:,:), paramConstr(:)
			double precision maxLogLike, logZ, INSlogZ, logZerr
		end subroutine dumper
	end INTERFACE
	
	
	allocate( p(ndims,nlive+1), phyP(totPar,nlive+1), l(nlive+1) )

	if(my_rank==0) then
		np=ndims
		globff=0
		numlike=0
		vnow1=1.d0

		write(fmt,'(a,i5,a)')  '(',np+1,'E28.18)'
	
		genLive=.true.
	
		if(resumeflag) then
			!check if the last job was aborted during the live points generation
			open(unit=u_resume,file=resumename,status='old')
			read(u_resume,*)genLive
			
			if( .not.genLive ) then
				read(u_resume,*)i,j,j,j
		
				if( j /= nlive ) then
				  	write(*,*)"ERROR: no. of live points in the resume file is not equal to the the no. passed to nestRun."
					write(*,*)"Aborting"
#ifdef MPI
					call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
					stop
				endif
			endif
			close(u_resume)
		
			if( .not.genLive ) then
				j = 0
				open(unit=u_ev,file=evname,status='old') 
				write(fmt,'(a,i2.2,a)')  '(',totPar+2,'E28.18,i3)'
				do
					read(55,*,IOSTAT=ios) ltmp(1:totPar+2),k
				
					!end of file?
					if(ios<0) exit
				
					j = j + 1
				enddo
			
				close(u_ev)
			
				if( j + nlive /= i ) then
					write(*,*)"ERROR: no. of points in ev.dat file is not equal to the no. specified in resume file."
					write(*,*)"Aborting"
#ifdef MPI
					call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
					stop
				endif
			endif
		
		endif
	
		gZ=logZero
		ginfo=0.d0
	endif

#ifdef MPI
	call MPI_BARRIER(MPI_COMM_WORLD,errcode)
	call MPI_BCAST(genLive,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
#endif
	
	if(genLive) then
		if(my_rank==0 .and. fback) write(*,*) 'generating live points'
		
		call gen_initial_live(p,phyP,l,loglike,dumper,context)
	
		if(my_rank==0 .and. .not.bogus) then
			globff=nlive
			numlike=nlive
	  		if(fback) write(*,*) 'live points generated, starting sampling'
		endif
	endif

#ifdef MPI
	call MPI_BARRIER(MPI_COMM_WORLD,errcode)
#endif
	
	if( .not.bogus ) call clusteredNest(p,phyP,l,loglike,dumper,context)
	
	if( my_rank==0 ) then
		if( .not.bogus ) then
			write(*,*)"ln(ev)=",gZ,"+/-",sqrt(ginfo/dble(nlive))
			write(*,'(a,i12)')' Total Likelihood Evaluations: ', numlike
			write(*,*)"Sampling finished. Exiting MultiNest"
		else
			write(*,*)"Exit signal received"
		endif
		setBlk=.false.
	endif
	
	deallocate( p, phyP, l )

  end subroutine Nestsample

!----------------------------------------------------------------------

  subroutine gen_initial_live(p,phyP,l,loglike,dumper,context)
    
	implicit none
    
    	integer i,j,iostatus,idum,k,m,nptPerProc,nGen,nstart,nend,context
    	double precision, allocatable :: pnewP(:,:), phyPnewP(:,:), lnewP(:)
    	double precision p(ndims,nlive+1), phyP(totPar,nlive+1), l(nlive+1)
    	integer id
    	character(len=root_max_len) fmt,fmt2
#ifdef MPI
	double precision, allocatable ::  tmpl(:), tmpp(:,:), tmpphyP(:,:)
	integer q
    integer ierror
#endif
    
    	INTERFACE
    		!the likelihood function
    		subroutine loglike(Cube,n_dim,nPar,lnew,context_pass)
			integer n_dim,nPar,context_pass
			double precision lnew,Cube(nPar)
		end subroutine loglike
    	end INTERFACE
	
	INTERFACE
		!the user dumper function
    		subroutine dumper(nSamples, nlive, nPar, physLive, posterior, paramConstr, maxLogLike, logZ, INSlogZ, logZerr, context_pass)
			integer nSamples, nlive, nPar, context_pass
			double precision, pointer :: physLive(:,:), posterior(:,:), paramConstr(:)
			double precision maxLogLike, logZ, INSlogZ, logZerr
		end subroutine dumper
	end INTERFACE
	
	
	allocate( pnewP(ndims,10), phyPnewP(totPar,10), lnewP(10) )
#ifdef MPI
	allocate( tmpl(10), tmpp(ndims,10), tmpphyP(totPar,10) )
#endif

	if(my_rank==0) then
	
		if(outfile) then
    			open(unit=u_resume,file=resumename,form='formatted',status='replace')
    			write(u_resume,'(l2)')genLive
    			close(u_resume)
    			write(fmt,'(a,i5,a)')  '(',ndims+1,'E28.18)'
    			write(fmt2,'(a,i5,a)')  '(',totPar+1,'E28.18,i4)'
		endif

    		id=0
    		i=0
    
    		!resume from previous live points generation?
		if(outfile) then
	    		if(resumeflag) then
	    			!read hypercube-live file
				open(unit=u_live,file=livename,status='old')
				do
	      				i=i+1
					read(u_live,*,IOSTAT=iostatus) p(:,i),l(i)
	            			if(iostatus<0) then
	            				i=i-1
	                  			if(i>nlive) then
							write(*,*)"ERROR: more than ",nlive," points in the live points file."
							write(*,*)"Aborting"
#ifdef MPI
							call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
	                        			stop
						endif
	                  			exit
					endif
				enddo
	    			close(u_live)
	
				if(i>0) then
					!read physical live file
					open(unit=u_phys,file=physname,status='old')
					do j=1,i
						read(u_phys,*) phyP(:,j),l(j),idum
					enddo
	    				close(u_phys)
				endif
	    	
	      			open(unit=u_live,file=livename,form='formatted',status='old',position='append')
	    			open(unit=u_phys,file=physname,form='formatted',status='old',position='append')
	    		else
	      			open(unit=u_live,file=livename,form='formatted',status='replace')
	    			open(unit=u_phys,file=physname,form='formatted',status='replace')
				
				if( IS ) then
	      				open(unit=u_IS(2),file=IS_Files(2),form='unformatted',access='sequential',status='replace')
					write(u_IS(2))0,0,0
					close(u_IS(2))
	      				open(unit=u_IS(1),file=IS_Files(1),form='unformatted',access='sequential',status='replace')
					close(u_IS(1))
	      				open(unit=u_IS(3),file=IS_Files(3),form='unformatted',access='sequential',status='replace')
					close(u_IS(3))
				endif
	    		endif
		endif
    
    		j=i
		nend=i
		
		nGen = nlive - j
		nptPerProc = ceiling( dble(nGen) / dble(mpi_nthreads) )
	endif
	
#ifdef MPI
	call MPI_BARRIER(MPI_COMM_WORLD,errcode)
	call MPI_BCAST(nGen,1,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
	call MPI_BCAST(nptPerProc,1,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
#endif
      
      	if(nGen==0) then
      		if(my_rank==0) then
            		genLive=.false.
    			resumeFlag=.false.
		endif
		
		deallocate( pnewP, phyPnewP, lnewP )
#ifdef MPI
		deallocate( tmpl, tmpp, tmpphyP )
#endif
		if( outfile ) then
			close(u_live)
			close(u_phys)
		endif
		
            	return
		
	elseif(nGen<0) then
      		if(my_rank==0) then
			write(*,*)"ERROR: live points files have more live points than required."
			write(*,*)"Aborting"
		endif
#ifdef MPI
            	call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
            	stop
	endif
	
	k=0
	j=0
	id=my_rank
	do
    		k=k+1
		j=j+1
            	do
			call getrandom(ndims,pnewP(:,j),id)  ! start points
			phyPnewP(1:ndims,j)=pnewP(1:ndims,j)
			lnewP(j)=logZero
			call loglike(phyPnewP(:,j),ndims,totPar,lnewP(j),context)
			if( lnewP(j) == HUGE(1d0) ) bogus = .true.
                  	if(lnewP(j)>logZero) exit
		enddo
		if(k==nptPerProc .or. j==10) then
			if(k==nptPerProc) then
				i=mod(nptPerProc,10)
				if(i==0) i=10
			else
				i=10
				j=0
			endif

#ifdef MPI
			call MPI_BARRIER(MPI_COMM_WORLD,errcode)
#endif
			
			if(id/=0) then
#ifdef MPI
				!send the generated points to the root node
				call MPI_SEND(lnewP(1:i),i,MPI_DOUBLE_PRECISION,0,id,MPI_COMM_WORLD,errcode)
				call MPI_SEND(pnewP(1:ndims,1:i),ndims*i,MPI_DOUBLE_PRECISION,0,id,MPI_COMM_WORLD,errcode)
				call MPI_SEND(phyPnewP(1:totPar,1:i),totPar*i,MPI_DOUBLE_PRECISION,0,id,MPI_COMM_WORLD,errcode)
#endif
			else
				!first write the points generated by the root node
				nstart=nend+1
				p(1:ndims,nstart:nstart+i-1)=pnewP(1:ndims,1:i)
				phyP(1:totPar,nstart:nstart+i-1)=phyPnewP(1:totPar,1:i)
				l(nstart:nstart+i-1)=lnewP(1:i)
				nend=nstart+i-1

#ifdef MPI				
				!receive the points from other nodes
				do m=1,mpi_nthreads-1
					call MPI_RECV(tmpl(1:i),i,MPI_DOUBLE_PRECISION,m,m,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
					call MPI_RECV(tmpp(1:ndims,1:i),i*ndims,MPI_DOUBLE_PRECISION,m,m,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
					call MPI_RECV(tmpphyP(1:totPar,1:i),i*totPar,MPI_DOUBLE_PRECISION,m,m,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
					do q = 1 , i
						if( nend + 1 <= nlive ) then
							l(nend + 1) = tmpl(q)
							if( tmpl(q) == HUGE(1d0) ) bogus = .true.
							p(1 : ndims, nend + 1) = tmpp(1 : ndims, q)
							phyP(1 : totPar, nend + 1) = tmpphyP(1 : totPar, q)
							nend = nend + 1
						endif
					enddo
				enddo
#endif
				
				if( outfile .and. .not.bogus ) then
					!now write this batch to the files
					do m=nstart,nend
						write(u_live,fmt) p(1:ndims,m),l(m)
            					write(u_phys,fmt2) phyP(:,m),l(m),1
					enddo
				endif
			endif
		endif

#ifdef MPI
		call MPI_BCAST(bogus,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
#endif

		if(k==nptPerProc .or. bogus) exit
	enddo
	
	
		
	deallocate( pnewP, phyPnewP, lnewP )
#ifdef MPI
	deallocate( tmpl, tmpp, tmpphyP )
#endif
	
	if( outfile ) then
    		close(u_live)
   		close(u_phys)
	endif
	genLive=.false.
    	resumeFlag=.false.
#ifdef MPI
	call MPI_BARRIER(MPI_COMM_WORLD,errcode)
#endif
    
  end subroutine gen_initial_live

!----------------------------------------------------------------------
  
  subroutine getrandom(n,x,id)
    
    implicit none
    
    integer, intent(in) :: n
    double precision, intent(out) :: x(:)
    integer i,id
    
    ! --- uniform prior ----
    do i = 1,n
       x(i)=ranmarNS(id)
    enddo
    return
  end subroutine getrandom

!----------------------------------------------------------------------
  
  subroutine clusteredNest(p,phyP,l,loglike,dumper,context)
  	
	implicit none
	
	
	!input variables
	
	integer context
	double precision p(ndims,nlive+1) !live points
	double precision phyP(totPar,nlive+1) !physical live points
	double precision l(nlive+1) !log-likelihood
	
	
	!work variables
	
	!misc
	integer i, j, k, m, n, j1, i1, i2, i3, i4, ff, sff, n1, n2, q, nd, nd_i, nd_j, iostatus
	integer num_old
	integer, allocatable :: eswitchff(:), escount(:), dmin(:)
	double precision d1, d2, d3, d4, d5, urv
	double precision h, logX, vprev, vnext, shrink !prior volume
	double precision mar_r !marginal acceptance rate
	double precision gZOld !global evidence & info
	logical eswitch,peswitch,cSwitch !whether to do ellipsoidal sampling or not
	logical remFlag, acpt, flag, flag2
	integer funit1, funit2 !file units
	character(len=root_max_len) fName1, fName2 !file names
	character(len=root_max_len) fmt,fmt1
	
	!diagnostics for determining when to do eigen analysis
	integer neVol
	parameter(neVol=4)
	double precision, dimension(:), allocatable :: totVol, x1, x2, y1, y2, slope, intcpt, cVolFrac, pVolFrac
	double precision, dimension(:,:,:), allocatable :: eVolFrac
	
	!info for output file update
	double precision, allocatable :: evData(:,:), evDataAll(:), evDataTemp(:)
	
	!isolated cluster info
	integer ic_n !no. of nodes
	integer, allocatable :: ic_sc(:), ic_npt(:)
	logical, allocatable :: ic_done(:)
	integer, dimension(:), allocatable :: ic_fNode, ic_nsc, ic_nBrnch
	double precision, dimension(:,:,:),  allocatable :: ic_brnch, ic_llimits, ic_plimits
	double precision, allocatable :: ic_climits(:,:,:), ic_volFac(:)
	double precision, dimension(:),  allocatable :: ic_Z, ic_Zold, ic_info, ic_vnow, ic_hilike, ic_inc
	double precision, dimension(:,:),  allocatable :: ic_eff
	logical, dimension(:),  allocatable :: ic_reme, ic_rFlag, ic_chk
 	logical modeFound
	
	!means & standard deviations of the live points (for prior edge detection)
	double precision, dimension(:,:), allocatable :: ic_mean, ic_sigma
	double precision lPts(ndims)
	
	!sub-cluster properties
	integer sc_n !no. of sub-clusters
	integer, dimension(:), allocatable :: sc_npt, nptk, nptx ,sc_node, nodek, sck
	double precision, dimension(:,:), allocatable :: meank, sc_eval, evalk
	double precision, dimension(:,:,:), allocatable :: sc_invcov, invcovk, sc_evec, eveck, tMatk
	double precision, dimension(:), allocatable :: kfack, volk, effk
	double precision, allocatable :: sc_mean(:,:), sc_tmat(:,:,:), sc_kfac(:), sc_eff(:), sc_vol(:)
	
	!auxiliary points (to be re-arranged with main points during clustering)
	integer naux !dimensionality of aux points 
	double precision, dimension(:,:), allocatable :: aux, pt
	
	!rejected point info
	double precision lowlike !lowest log-like
	double precision, allocatable :: lowp(:), lowphyP(:) !point with the lowlike
	integer indx(1) !point no. of lowlike
	
	!new point
	double precision lnew
	double precision, allocatable :: pnew(:), phyPnew(:) ! new point
	double precision, dimension(:,:,:), allocatable :: pnewa, phyPnewa
	double precision, dimension(:,:), allocatable :: lnewa
	integer, dimension(:), allocatable :: rIdx
	integer, dimension(:,:), allocatable :: sEll
	logical, dimension(:), allocatable :: remain
	
	!mode separation
	integer nCdim
	
	!importance sampling
	double precision, allocatable :: IS_allpts(:,:), IS_iterinfo(:,:), IS_V(:)
	integer IS_counter(7)
	integer :: IS_nstore = 10000, IS_nMC = 1000
	double precision :: IS_Z(2)
	logical :: IS_CheckAll = .false., IS_betterMC = .true., IS_GetVolInsidePrior = .true.
    integer ierror

	INTERFACE
    		!the likelihood function
    		subroutine loglike(Cube,n_dim,nPar,lnew,context_pass)
			integer n_dim,nPar,context_pass
			double precision lnew,Cube(nPar)
		end subroutine loglike
      	end INTERFACE
	
	INTERFACE
		!the user dumper function
    		subroutine dumper(nSamples, nlive, nPar, physLive, posterior, paramConstr, maxLogLike, logZ, INSlogZ, logZerr, context_pass)
			integer nSamples, nlive, nPar, context_pass
			double precision, pointer :: physLive(:,:), posterior(:,:), paramConstr(:)
			double precision maxLogLike, logZ, INSlogZ, logZerr
		end subroutine dumper
	end INTERFACE
	
	
	allocate( eswitchff(maxCls), escount(maxCls), dmin(maxCls) )
	allocate( evData(updInt,totPar+3) )
	allocate( ic_sc(maxCls), ic_npt(maxCls) )
	allocate( ic_done(0:maxCls) )
	allocate( ic_climits(maxCls,ndims,2), ic_volFac(maxCls) )
	allocate( sc_mean(maxeCls,ndims), sc_tmat(maxeCls,ndims,ndims), sc_kfac(maxeCls), sc_eff(maxeCls), sc_vol(maxeCls) )
	allocate( lowp(ndims), lowphyP(totPar) )
	allocate( pnew(ndims), phyPnew(totPar) )
	
	
	!initializations
	ic_done=.false.
	ic_npt=nlive
	ic_climits(:,:,2)=1d0
	ic_climits(:,:,1)=0d0
	ic_volFac(:)=1d0
	
	if(my_rank==0) then
		if( IS ) then
			if( IS_GetVolInsidePrior ) then
				IS_GetVolInsidePrior = .false.
				do i = 1, ndims
					if( .not.pWrap(i) ) then
						IS_GetVolInsidePrior = .true.
						exit
					endif
				enddo
			endif
			
			!memory allocation
			allocate(IS_allpts(nlive+IS_nstore,ndims+6), IS_iterinfo(nlive+IS_nstore/10,5), IS_V(maxeCls))
			IS_allpts = 0d0
			IS_iterinfo = 0d0
			
			do i = 1, nlive
				IS_allpts(i,1:ndims) = p(1:ndims,i)	!point
			enddo
			IS_allpts(1:nlive,ndims+1) = l(1:nlive)		!likelihood
			IS_allpts(1:nlive,ndims+2) = dble(nlive)	!p(\Theta) n = \Sum_{i}^{niter} n_{i} E_{i}(\Theta) / V_{i}
			IS_allpts(1:nlive,ndims+3) = 1d0		!check this point for ellipsoid membership in later iterations
			IS_allpts(1:nlive,ndims+4) = 1d0		!which ellipsoid this point lies in
			IS_allpts(1:nlive,ndims+5) = 1d0		!Mahalanobis distance
			IS_allpts(1:nlive,ndims+6) = 1d0		!node
			
			IS_iterinfo(1:nlive,1) = 1d0			!volume
			IS_iterinfo(1:nlive,2) = 1d0			!total no. of points collected at each iteration, excluding points outside prior
			IS_iterinfo(1:nlive,4) = 1d0			!total no. of points collected at each iteration, including points outside prior
			IS_iterinfo(1:nlive,3) = 1d0			!effective no. of points collected at each iteration
			IS_iterinfo(1:nlive,5) = 1d0			!node
			
			IS_counter(1) = nlive				!total no. of points collected so far
			IS_counter(2) = 1				!first point to be checked for ellipsoid membership in later iterations
			IS_counter(3) = nlive+IS_nstore			!total no. of points that can be stored in IS_allpts array
			IS_counter(4) = nlive+IS_nstore/10		!total no. of points that can be stored in IS_iterinfo array
			IS_counter(5) = nlive				!total no. of iterations done so far
			IS_counter(6) = 0				!total no. of IS_iterinfo members written to output file
			IS_counter(7) = 0				!total no. of IS_allpts members written to output file
		endif
		
		allocate(evDataAll(1))
		allocate(sc_npt(maxeCls), nptk(maxeCls), nptx(nlive), meank(maxeCls,ndims), &
		sc_eval(maxeCls,ndims), evalk(maxeCls,ndims), sc_invcov(maxeCls,ndims,ndims), &
		invcovk(maxeCls,ndims,ndims), tMatk(maxeCls,ndims,ndims), &
		sc_evec(maxeCls,ndims,ndims), eveck(maxeCls,ndims,ndims), kfack(maxeCls), &
		effk(maxeCls), volk(maxeCls), &
 		sc_node(maxeCls),nodek(maxeCls),sck(maxCls))
		allocate(pt(ndims,nlive), aux(ndims+totPar+4-nCdims,nlive))
		allocate(ic_fNode(maxCls),ic_nsc(maxCls),ic_nBrnch(maxCls), &
		ic_brnch(maxCls,maxCls,2),ic_reme(maxCls),ic_rFlag(maxCls),ic_z(maxCls),ic_zold(maxCls),ic_info(maxCls), &
		ic_vnow(maxCls),ic_hilike(maxCls),ic_inc(maxCls),ic_chk(maxCls),ic_llimits(maxCls,ndims,2))
		if(multimodal) allocate(ic_plimits(maxCls,nCdims,2))
		if(ceff) then
			allocate(ic_eff(maxCls,4))
			ic_eff(:,1:2)=0d0
			ic_eff(:,3)=1d0
			ic_eff(:,3)=ef
			ic_eff(:,4)=1d0
		endif
		allocate(pnewa(maxCls,mpi_nthreads,ndims),phyPnewa(maxCls,mpi_nthreads,totPar),lnewa(maxCls,mpi_nthreads), &
		sEll(maxCls,mpi_nthreads),remain(maxCls),rIdx(maxCls))
		allocate(totVol(maxCls),eVolFrac(maxCls,neVol*2,neVol),x1(maxCls),x2(maxCls),y1(maxCls), &
		y2(maxCls),slope(maxCls),intcpt(maxCls),cVolFrac(maxCls),pVolFrac(maxCls))
		if( prior_warning ) allocate( ic_mean(maxCls, ndims), ic_sigma(maxCls, ndims) )
	
		!global logZ = log(0)
		gZ=logZero
		gZOld=logZero
		ic_Z=logZero
		ic_zold=logZero
		ginfo=0.d0
		ic_info=0.d0
		
		ic_llimits(:,:,2)=1d0
		ic_llimits(:,:,1)=0d0
		if(multimodal) then
			ic_plimits(:,:,2)=huge(1d0)
			ic_plimits(:,:,1)=-huge(1d0)
		endif
		
		!just one node to sttart with
		ic_n=1
		ic_fNode(1)=0
		ic_sc(1)=0
		ic_nsc=nsc_def
		ic_reme=.false.
		ic_nBrnch=0
	
		!set the prior volume
		ic_vnow=0.d0
      		ic_vnow(1)=1.d0
	
		!no ellipsoidal sampling to start with
		eswitch=.false.
		peswitch=.false.
		escount=0
      	
		!no leftover points
		remain=.false.
		rIdx=1
	
		!no sub-clusters at the beginning
		sc_n=0
		totVol=1.d0
		sc_node=1
	
		!eigen analysis diagnostics
		eVolFrac=0.d0
	
		dmin=ndims+1
		ic_rFlag=.false.
		sff=0
	
		if(resumeFlag) then
			!read the resume file
			funit1=u_resume
	
			open(unit=funit1,file=resumename,status='old')
                	  	
			read(funit1,*)genLive
			read(funit1,*)globff,numlike,ic_n,nlive
			read(funit1,*)gZ,ginfo
			ic_rFlag(1:ic_n)=.true.
			read(funit1,*)eswitch
			peswitch=eswitch
			if(eswitch) totVol=1.d0
			
			!read branching info
	            	do i=1,ic_n
            			read(funit1,*)ic_nBrnch(i)
				if(ic_nBrnch(i)>0) read(funit1,*)ic_brnch(i,1:ic_nBrnch(i),1),ic_brnch(i,1:ic_nBrnch(i),2)
			enddo
				
			!read the node info
			do i=1,ic_n
				read(funit1,*)ic_done(i),ic_reme(i),ic_fNode(i),ic_npt(i)
				read(funit1,*)ic_vnow(i),ic_Z(i),ic_info(i)
				if(ceff) then
					read(funit1,*)ic_eff(i,4)
					ic_eff(i,3)=ic_eff(i,4)
				endif
			enddo
			if(.not.eswitch .or. ic_n==1) ic_npt(1)=nlive
                  	close(funit1)
			eswitchff=0
			
    			!read hypercube-live file
			open(unit=u_live,file=livename,status='old')
			i=0
			do
      				i=i+1
				read(u_live,*,IOSTAT=iostatus) p(1:ndims,i),l(i)
            			if(iostatus<0) then
            				i=i-1
                  			if(i<nlive) then
                  				write(*,*)"ERROR: live points file has less than ",nlive," points."
						write(*,*)"Aborting"
#ifdef MPI
						call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
                        			stop
					endif
                  			exit
				endif
				if(i>nlive) then
					write(*,*)"ERROR: live points file has greater than ",nlive," points."
					write(*,*)"Aborting"
#ifdef MPI
					call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
                        		stop
				endif
			enddo
			close(u_live)
			
    			!read physical-live file
			open(unit=u_phys,file=physname,status='old')
			i=0
			do
      				i=i+1
				read(u_phys,*,IOSTAT=iostatus) phyP(1:totPar,i),d1,j
            			if(iostatus<0) then
            				i=i-1
                  			if(i<nlive) then
                  				write(*,*)"ERROR: phys live points file has less than ",nlive," points."
						write(*,*)"Aborting"
#ifdef MPI
						call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
                        			stop
					endif
                  			exit
				endif
				if(i>nlive) then
					write(*,*)"ERROR: phys live points file has greater than ",nlive," points."
					write(*,*)"Aborting"
#ifdef MPI
					call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
                        		stop
				endif
			enddo
			close(u_phys)
			
			!read the IS files
			if( IS ) then
				!read all the points collected so far
				open(unit=u_IS(2),file=IS_Files(2),form='unformatted',access='sequential',status='old')
				read(u_IS(2))j,IS_counter(2),k
				call ExtendArrayIfRequired(IS_counter(1),j-IS_counter(1),IS_counter(3),IS_nstore,ndims+6,IS_allpts)
				IS_counter(1) = j
				IS_counter(7) = j
				call ExtendArrayIfRequired(IS_counter(5),k-IS_counter(5),IS_counter(4),IS_nstore/10,5,IS_iterinfo)
				IS_counter(5) = k
				IS_counter(6) = k
				
				do i = 1, IS_counter(1)
					read(u_IS(2),IOSTAT=iostatus)IS_allpts(i,ndims+2),IS_allpts(i,ndims+3)
					
					!end of file?
					if(iostatus<0) then
						write(*,*)"ERROR: Not enough points in ",IS_Files(2)
						write(*,*)"Aborting"
#ifdef MPI
						call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
						stop
					endif
				enddo
				close(u_IS(2))
				
				open(unit=u_IS(1),file=IS_Files(1),form='unformatted',access='sequential',status='old')
				do i = 1, IS_counter(1)
					read(u_IS(1),IOSTAT=iostatus)IS_allpts(i,1:ndims+1),IS_allpts(i,ndims+6)
					
					!end of file?
					if(iostatus<0) then
						write(*,*)"ERROR: Not enough points in ",IS_Files(1)
						write(*,*)"Aborting"
#ifdef MPI
						call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
						stop
					endif
				enddo
				close(u_IS(1))
				
				!read the iteration info
				open(unit=u_IS(3),file=IS_Files(3),form='unformatted',access='sequential',status='old')
				do i = 1, IS_counter(5)
					read(u_IS(3),IOSTAT=iostatus)IS_iterinfo(i,1),i1,i2,i3,i4
					IS_iterinfo(i,2)=dble(i1); IS_iterinfo(i,3)=dble(i2); IS_iterinfo(i,4)=dble(i3); IS_iterinfo(i,5)=dble(i4)
					!end of file?
					if(iostatus<0) then
						write(*,*)"ERROR: Not enough points in ",IS_Files(3)
						write(*,*)"Aborting"
#ifdef MPI
						call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
						stop
					endif
				enddo
				close(u_IS(3))
			endif
		endif
		
		!find the highest likelihood for each node
		j=0
		ic_done(0)=.true.
		do i=1,ic_n
			ic_hilike(i)=maxval(l(j+1:j+ic_npt(i)))
			lowlike=minval(l(j+1:j+ic_npt(i)))
			ic_inc(i)=ic_hilike(i)+log(ic_vnow(i))-ic_Z(i)
			if(ic_npt(i)<ndims+1 .or. abs(lowlike-ic_hilike(i))<= 0.0001d0 .or. (ic_inc(i)<log(tol) .and. globff-nlive>50)) then
				ic_done(i)=.true.
			else
				ic_done(i)=.false.
				ic_done(0)=.false.
			endif
			
			!set the limits
			if(.not.ic_done(i)) then
				ic_llimits(i,:,1)=p(:,j+1)
				ic_llimits(i,:,2)=p(:,j+1)
				if(multimodal) then
					ic_plimits(i,1:nCdims,1)=phyP(1:nCdims,j+1)
					ic_plimits(i,1:nCdims,2)=phyP(1:nCdims,j+1)
				endif
				do k=j+2,j+ic_npt(i)
					if(multimodal) then
						call setLimits(multimodal,ndims,nCdims,ic_llimits(i,:,:), &
						ic_plimits(i,:,:),p(:,k),phyP(1:nCdims,k),ic_climits(i,:,:))
					else
						call setLimits(multimodal,ndims,nCdims,ic_llimits(i,:,:), &
						ic_climits(i,:,:),p(:,k),phyP(1:nCdims,k),ic_climits(i,:,:))
					endif
				enddo
			endif
			
			j=j+ic_npt(i)
		enddo
	endif
    	
#ifdef MPI
	call MPI_BARRIER(MPI_COMM_WORLD,errcode)
	call MPI_BCAST(ic_n,1,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
	call MPI_BCAST(ic_npt(1:ic_n),ic_n,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
#endif
		
	do ff=1,maxIter

#ifdef MPI
    		call MPI_BARRIER(MPI_COMM_WORLD,errcode)
    		call MPI_BCAST(ic_done(0:ic_n),ic_n+1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
#endif	
		!stopping condition reached
		if(ic_done(0)) then
			if(my_rank==0) then
                        
				if(outfile) then
	                        	!write the resume file
	                        	funit1=u_resume
					fName1=resumename
	                        	write(fmt,'(a,i5,a)')  '(',totPar+1,'E28.18,i4)'
					open(unit=funit1,file=fName1,form='formatted',status='replace')
					write(funit1,'(l2)').false.
					write(funit1,'(4i12)')globff,numlike,ic_n,nlive
					write(funit1,'(2E28.18)')gZ,ginfo
					write(funit1,'(l2)')eswitch
	            			!write branching info
		            		do i=1,ic_n
	            				write(funit1,'(i4)')ic_nBrnch(i)
						if(ic_nBrnch(i)>0) then
							write(fmt,'(a,i5,a)')  '(',2*ic_nBrnch(i),'E28.18)'
							write(funit1,fmt)ic_brnch(i,1:ic_nBrnch(i),1),ic_brnch(i,1:ic_nBrnch(i),2)
						endif
					enddo
					!write the node info
					do i=1,ic_n
						write(funit1,'(2l2,i6,i12)')ic_done(i),ic_reme(i),ic_fNode(i),ic_npt(i)
						write(funit1,'(3E28.18)')ic_vnow(i),ic_Z(i),ic_info(i)
						if(ceff) write(funit1,'(1E28.18)')ic_eff(i,4)
					enddo
	                  		close(funit1)
				endif
				
				if( IS ) then
					IS_Z = logZero
					do j = 1, IS_counter(1)
						d1 = IS_allpts(j,ndims+1)-log(IS_allpts(j,ndims+2))
						IS_Z(1) = LogSumExp(IS_Z(1), d1)
						IS_Z(2) = LogSumExp(IS_Z(2), 2d0*d1)
					enddo
					IS_Z(2) = sqrt(exp(IS_Z(2)-2d0*IS_Z(1)) - 1d0/IS_counter(1))
				endif
				
				!fback
                		if(fback) call gfeedback(gZ,IS,IS_Z,numlike,globff,.false.)
				
				call pos_samp(Ztol,globff,broot,nlive,ndims,nCdims,totPar,multimodal,outfile,gZ,ginfo,ic_n,ic_Z(1:ic_n), &
				ic_info(1:ic_n),ic_reme(1:ic_n),ic_vnow(1:ic_n),ic_npt(1:ic_n),ic_nBrnch(1:ic_n),ic_brnch(1:ic_n,:,1),phyP(:,1:nlive), &
				l(1:nlive),evDataAll,IS,IS_Z,dumper,context)
				
				!if done then add in the contribution to the global evidence from live points
				j=0
				do i1=1,ic_n
					!live point's contribution to the evidence
                			logX=log(ic_vnow(i1)/dble(ic_npt(i1)))
					do i=j+1,j+ic_npt(i1)
						d1=l(i)+logX
						!global evidence
            					gZold=gZ
                  				gZ=LogSumExp(gZ,d1)
						!ginfo=exp(d1-gZ)*l(i)+exp(gZold-gZ)*(ginfo+gZold)-gZ
						ginfo=ginfo*exp(gZold-gZ)+exp(d1-gZ)*l(i)
						!local evidence
            					!gZold=ic_Z(i1)
						ic_Zold(i1)=ic_Z(i1)
                  				ic_Z(i1)=LogSumExp(ic_Z(i1),d1)
						!ic_info(i1)=exp(d1-ic_Z(i1))*l(i)+ &
						!exp(gZold-ic_Z(i1))*(ic_info(i1)+gZold)-ic_Z(i1)
						ic_info(i1)=ic_info(i1)*exp(ic_zold(i1)-ic_Z(i1))+exp(d1-ic_Z(i1))*l(i)
					enddo
					j=j+ic_npt(i1)
                		enddo
				
				ginfo=ginfo-gZ
			
				!memory deallocation
				deallocate(sc_npt, sc_invcov, sc_node, sc_eval, sc_evec)
 				deallocate(nptk, nptx, meank, evalk, invcovk, tMatk, eveck, kfack, effk, volk, &
				nodek ,sck)
				deallocate(pt, aux)
				deallocate(ic_fNode,ic_nsc,ic_nBrnch,ic_brnch,ic_reme,ic_rFlag,ic_Z,ic_zold, &
				ic_info,ic_vnow,ic_hilike,ic_inc,ic_chk,ic_llimits)
				if(multimodal) deallocate(ic_plimits)
				if(ceff) deallocate(ic_eff)
				deallocate(pnewa,phyPnewa,lnewa,sEll,remain,rIdx)
				deallocate(totVol,eVolFrac,x1,x2,y1,y2,slope,intcpt,cVolFrac,pVolFrac)
				if( prior_warning ) deallocate( ic_mean, ic_sigma )
				deallocate( evDataAll )
				if( IS ) deallocate(IS_allpts,IS_iterinfo,IS_V)
			endif
			
			deallocate( eswitchff, escount, dmin, evData, ic_sc, ic_npt, ic_done, ic_climits, &
			ic_volFac, sc_mean, sc_tmat, sc_kfac, sc_eff, sc_vol, lowp, lowphyP, pnew, phyPnew )
			return
		endif
		
		modeFound=.false.
		
		if(my_rank==0) then
			!mode separation
			if(ff/=1 .and. eswitch .and. multimodal .and. mod(ff,15)==0 .and. ic_n<maxCls) then
			
!				if(mod(ff,30)==0) then
					nCdim=nCdims
!				else
!					nCdim=3
!				endif
				
				!aux information to be re-arranged with the live points
				naux=ndims+totPar+1-nCdim
				aux(1,1:nlive)=l(1:nlive)
				aux(2:totPar+1,1:nlive)=phyP(1:totPar,1:nlive)
				aux(totPar+2:naux,1:nlive)=p(nCdim+1:ndims,1:nlive)
				
				!save old no. of modes
				i=ic_n
				nptk(1:i)=ic_npt(1:i)
				
				!decide which nodes to check for mode separation
				ic_chk(1:ic_n)=.not.(ic_done(1:ic_n))
				do j=1,ic_n
					if(ic_chk(j)) then
						if(ic_inc(j)<log(0.5d0)) ic_chk(j)=.false.
					endif
				enddo
				
				modeFound=isolateModes2(nlive,ndims,nCdim,p(1:nCdim,1:nlive),naux,aux(1:naux,:), &
				ic_n,ic_fnode,ic_npt,ic_reme,ic_chk(1:ic_n),ic_vnow(1:ic_n),ic_rFlag,ic_climits(:,1:nCdim,:))

				if(modeFound) then			
					!re-arrange info
					l(1:nlive)=aux(1,1:nlive)
					phyP(1:totPar,1:nlive)=aux(2:totPar+1,1:nlive)
					p(nCdim+1:ndims,1:nlive)=aux(totPar+2:naux,1:nlive)
					
					if(nCdims<ndims .or. .true.) then
						ic_sc(i+1:ic_n)=1
						sc_npt(sc_n+1:sc_n+ic_n-i)=ic_npt(i+1:ic_n)
						sc_n=sc_n+ic_n-i
					endif
					
					!new nodes should inherit nsc from their parents
					do j=i+1,ic_n
						ic_nsc(j)=nsc_def
						ic_nsc(ic_fNode(j))=nsc_def
						
						!branching info
						ic_nBrnch(ic_fNode(j))=ic_nBrnch(ic_fNode(j))+1
						ic_brnch(ic_fNode(j),ic_nBrnch(ic_fNode(j)),1)=dble(j)
						ic_brnch(ic_fNode(j),ic_nBrnch(ic_fNode(j)),2)=dble(ic_npt(j))/dble(nptk(ic_fNode(j)))
					enddo
					
					!assign prior volumes
					nodek(1:i)=0
					!first the new nodes
					q=sum(ic_npt(1:i))
					do j=i+1,ic_n
						if(ic_rFlag(j)) then
							!parent node
							k=ic_fNode(j)
							!divide prior volume
							ic_vnow(j)=ic_vnow(k)*dble(ic_npt(j))/dble(nptk(k))
							!divide the evidences & info
							ic_zold(j)=ic_z(k)
							ic_Z(j)=log(dble(ic_npt(j))/dble(nptk(k)))+ic_Z(k)
							ic_info(j)=ic_info(k)*dble(ic_npt(j))/dble(nptk(k))*exp(ic_zold(j)-ic_z(j))
							nodek(k)=1 !note the parent node
							ic_hilike(j)=maxval(l(q+1:q+ic_npt(j)))
							if(ic_hilike(j)-minval(l(q+1:q+ic_npt(j)))<= 0.0001) ic_done(j)=.true.
							if(ceff) then
								ic_eff(j,1:2)=0d0
								ic_eff(j,3:4)=ic_eff(k,3:4)
							endif
							
							!ellipsoidal decomposition prediction variables
							eVolFrac(j,:,:)=0d0
							eVolFrac(k,:,:)=0d0
							
							!set the limits
							ic_climits(j,:,:)=ic_climits(k,:,:)
							ic_llimits(j,:,:)=ic_llimits(k,:,:)
							ic_plimits(j,:,:)=ic_plimits(k,:,:)
							ic_volFac(j)=ic_volFac(k)
						endif
						q=q+ic_npt(j)
					enddo
					!now the father nodes
					q=0
					m=0
					do j=1,i
						if(nodek(j)==1) then
							ic_vnow(j)=ic_vnow(j)*dble(ic_npt(j))/dble(nptk(j))
							if(ic_npt(j)==0) then
								ic_Z(j)=logZero
								ic_info(j)=0.d0
							else
								ic_zold(j)=ic_z(j)
								ic_Z(j)=log(dble(ic_npt(j))/dble(nptk(j)))+ic_Z(j)
								ic_info(j)=ic_info(j)*dble(ic_npt(j))/dble(nptk(j))*exp(ic_zold(j)-ic_z(j))
							endif
							ic_hilike(j)=maxval(l(q+1:q+ic_npt(j)))
							if(ic_hilike(j)-minval(l(q+1:q+ic_npt(j)))<= 0.0001) ic_done(j)=.true.
							if(ceff) ic_eff(j,1:2)=0d0
							
							sc_npt(m+1)=ic_npt(j)
							sc_npt(m+2:m+ic_sc(j))=0
						endif
						
						!no leftover points
						remain(j)=.false.
						rIdx(j)=1
						
						q=q+ic_npt(j)
						m=m+ic_sc(j)
					enddo
					ic_rFlag(1:ic_n)=.true.
				endif
			endif
			
			num_old=numlike
		
			!ellipsoidal decomposition
			flag2=.false.

			if(peswitch) then
				q=0 !no. of sub-clusters traversed
				m=0 !no. of points traversed
				n=0 !no. of sub-clusters created so far
				do i1=1,ic_n
					if(ic_npt(i1)==0) then
						totvol(i1) = 0d0
						sck(i1)=0
						q=q+ic_sc(i1) !no. of sub-clusters traversed
						cycle
					endif
					
					if(ic_done(i1)) then
						sck(i1)=1
						q=q+ic_sc(i1) !no. of sub-clusters traversed
						m=m+ic_npt(i1)
						nptk(n+1)=ic_npt(i1)
						nodek(n+1)=i1
						n=n+1
						cycle
					endif
					
					if(ic_npt(i1)>=ndims+1 .and. totVol(i1)==0.d0) ic_rFlag(i1)=.true.
					
					if(.not.eswitch) then
						if(mod(ff-1-eswitchff(i1),ic_nsc(i1))==0) then
							flag=.true.
						else
							flag=.false.
						endif
					elseif(ic_npt(i1)<ndims+1 .and. .not.ic_rFlag(i1)) then
						flag=.false.
					elseif(ic_rFlag(i1)) then
						flag=.true.
					else
						flag=.false.
						
						if(ceff) then
							d4=ic_eff(i1,3)
						else
							d4=ef
						endif
						
						!current vol fraction
						cVolFrac(i1)=totVol(i1)*d4/((ic_vnow(i1)*ic_volFac(i1)))
				
						!predicted vol fraction
!						if(dino) then
!							pVolFrac(i1)=max(slope(i1)*dble(globff)+intcpt(i1),1.d0)
!						else
!							pVolFrac(i1)=slope(i1)*dble(globff)+intcpt(i1)
!						endif
						
						pVolFrac(i1)=0d0
						i3=0
						do i2=1,neVol
							if(eVolFrac(i1,i2,1)<=0d0) exit
							pVolFrac(i1)=pVolFrac(i1)+eVolFrac(i1,i2,1)
							i3=i3+1
						enddo
						if(pVolFrac(i1)==0d0) then
							pVolFrac(i1)=1d0
						else
							pVolFrac(i1)=pVolFrac(i1)/dble(i3)
						endif

						if(.not.flag .and. (cVolFrac(i1)>1.1 .or. .not.dino) .and.  &
						(pVolFrac(i1)<cVolFrac(i1) .or. mod(ff-1-eswitchff(i1),ic_nsc(i1))==0)) flag=.true.
				
						if(flag .and. dino) then
							do i=q+1,q+ic_sc(i1)
								if(sc_eff(i)<=1.00001) exit
								if(i==sc_n) flag=.false.
							enddo
						endif
	
						if(.not.flag .and. eVolFrac(i1,2*neVol,1)==0.d0 .and. mod(ff-1-eswitchff(i1),ic_nsc(i1))==0) flag=.true.
						!if(mod(ff-1-eswitchff(i1),20)==0) flag=.true.
					endif
					
					if(flag) then
						!target vol
						if(ceff) then
							d4=ic_eff(i1,3)
						else
							d4=ef
						endif

						d5=1d0
						do i2=1,ndims
							d5=d5/(ic_llimits(i1,i2,2)-ic_llimits(i1,i2,1))
						enddo
						d1=ic_vnow(i1)*d5/d4
				
						!volume threshold
						if(ic_rFlag(i1)) then
							d2=1000.*d1
						else
							d2=totVol(i1)*d5/ic_volFac(i1)
						endif
					
						!volume tolerance
						d3=0.d0
					
						eswitchff(i1)=ff-1
						
						flag=.false.
						
						!aux information to be re-arranged with the live points
						naux=totPar+2
						!rescaling
						do i3=1,ndims
							!rescale back into unit hypercube
							d4=ic_climits(i1,i3,2)-ic_climits(i1,i3,1)
							pt(i3,1:ic_npt(i1))=ic_climits(i1,i3,1)+d4*p(i3,m+1:m+ic_npt(i1))
							
							if(pWrap(i3)) then
								do i4=1,ic_npt(i1)
									call wraparound(pt(i3,i4),pt(i3,i4))
								enddo
							endif
							
							!scale to the new limits
							d4=ic_llimits(i1,i3,2)-ic_llimits(i1,i3,1)
							pt(i3,1:ic_npt(i1))=(pt(i3,1:ic_npt(i1))-ic_llimits(i1,i3,1))/d4
						enddo
						aux(1,1:ic_npt(i1))=l(m+1:m+ic_npt(i1))
						aux(2:totPar+1,1:ic_npt(i1))=phyP(1:totPar,m+1:m+ic_npt(i1))
						lowlike=minval(l(m+1:m+ic_npt(i1)))
						aux(naux,1:ic_npt(i1))=(l(m+1:m+ic_npt(i1))-lowlike)/(ic_hilike(i1)-lowlike)
						
						!max no. of sub-clusters allowed
						n2=min(ceiling(dble(ic_npt(i1))/dble(min_pt)),maxeCls-n)
						
						if(ic_npt(i1)<nlive/1.5) then
							cSwitch=.false.
						else
							cSwitch=.false.
						endif

						if(dino) then
							d5=d1
							do i3=1,50
								count=count+1
							
								!make dinosaur (sub-clustering)
								if(Dinosaur(pt(:,1:ic_npt(i1)),ic_npt(i1),ndims,sck(i1),nptk(n+1:n+n2), &
								naux,aux(1:naux,1:ic_npt(i1)),min_pt,n2,meank(n+1:n+n2,:),invcovk(n+1:n+n2,:,:), &
								tMatk(n+1:n+n2,:,:),evalk(n+1:n+n2,:),eveck(n+1:n+n2,:,:),kfack(n+1:n+n2), &
								effk(n+1:n+n2),volk(n+1:n+n2),d1,d2,neVol,eVolFrac(i1,:,:),globff,d3,.false., &
								ic_rFlag(i1),cSwitch,nCdims)) then
									if(eswitch) then
										ic_nsc(i1)=max(1,ic_nsc(i1)-10)
									else
										eswitch=.true.
										ic_sc(1)=sck(i1)
									endif
								
									scount=scount+1
									totVol(i1)=sum(volk(n+1:n+sck(i1)))
								
									flag=.true.
									flag2=.true.
								
									!no leftover points
									remain(i1)=.false.
									rIdx(i1)=1
									
									!set the limits
									ic_climits(i1,:,:)=ic_llimits(i1,:,:)
									
									ic_volFac(i1)=1d0
									do i2=1,ndims
										ic_volFac(i1)=ic_volFac(i1)/(ic_climits(i1,i2,2)-ic_climits(i1,i2,1))
									enddo
									
									!eVolFrac(i1,1,1)=eVolFrac(i1,1,1)*d1/d5
									
									if(ceff) then
										!eVolFrac(i1,1,1)=eVolFrac(i1,1,1)/ic_eff(i1,3)
										ic_eff(i1,4)=ic_vnow(i1)*ic_volFac(i1)/totVol(i1)
									else
										!eVolFrac(i1,1,1)=eVolFrac(i1,1,1)/ef
									endif
									
									exit
								elseif(.not.ic_rFlag(i1)) then
									if(eswitch) ic_nsc(i1)=ic_nsc(i1)+10
									exit
								endif
								
								eVolFrac(i1,1,1)=eVolFrac(i1,1,1)*d1/d5
							
								if(mod(i3,5)==0) then
									d2=d2*2.d0
									d1=d1*2.d0
								endif
							enddo
						endif
						
						if(.not.Flag .and. ic_rFlag(i1)) then
							sck(i1)=1
							nptk(n+1)=ic_npt(i1)
							kfack(n+1)=0.d0
							volk(n+1)=0.d0
							effk(n+1)=1.d0
							totVol(i1)=0.d0
							flag=.true.
							ic_done(i1)=.true.
							ic_done(0)=.true.
							do i3=1,ic_n
								if(.not.ic_done(i3)) then
									ic_done(0)=.false.
									exit
								endif
							enddo
						else
							!predict the current vol fraction
							x1(i1)=sum(eVolFrac(i1,neVol+1:2*neVol,2))/neVol
							y1(i1)=sum(eVolFrac(i1,neVol+1:2*neVol,1))/neVol
							x2(i1)=sum(eVolFrac(i1,1:neVol,2))/neVol
							y2(i1)=sum(eVolFrac(i1,1:neVol,1))/neVol
							slope(i1)=(y2(i1)-y1(i1))/(x2(i1)-x1(i1))
							intcpt(i1)=(x2(i1)*y1(i1)-x1(i1)*y2(i1))/(x2(i1)-x1(i1))
						endif
					endif
					
					if(ic_rFlag(i1) .and. .not.eswitch) exit
						
					if(flag) then
						!aux information to be re-arranged with the live points
						p(:,m+1:m+ic_npt(i1))=pt(:,1:ic_npt(i1))
						l(m+1:m+ic_npt(i1))=aux(1,1:ic_npt(i1))
						phyP(1:totPar,m+1:m+ic_npt(i1))=aux(2:totPar+1,1:ic_npt(i1))
					else
						sck(i1)=ic_sc(i1)
						meank(n+1:n+sck(i1),:)=sc_mean(q+1:q+sck(i1),:)
						invcovk(n+1:n+sck(i1),:,:)=sc_invcov(q+1:q+sck(i1),:,:)
						tMatk(n+1:n+sck(i1),:,:)=sc_tMat(q+1:q+sck(i1),:,:)
						evalk(n+1:n+sck(i1),:)=sc_eval(q+1:q+sck(i1),:)
						eveck(n+1:n+sck(i1),:,:)=sc_evec(q+1:q+sck(i1),:,:)
						kfack(n+1:n+sck(i1))=sc_kfac(q+1:q+sck(i1))
						effk(n+1:n+sck(i1))=sc_eff(q+1:q+sck(i1))
						volk(n+1:n+sck(i1))=sc_vol(q+1:q+sck(i1))
						nptk(n+1:n+sck(i1))=sc_npt(q+1:q+sck(i1))
						
						slope(i1)=slope(i1)*1.01
					endif
					nodek(n+1:n+sck(i1))=i1
					
					q=q+ic_sc(i1) !no. of sub-clusters traversed
					m=m+ic_npt(i1) !no. of points traversed
					n=n+sck(i1) !no. of sub-clusters created so far
				enddo
				
				if(flag2) then
					!update mode info
					ic_sc(1:ic_n)=sck(1:ic_n)
					!update sub-cluster info
					sc_n=sum(ic_sc(1:ic_n))
					sc_mean(1:sc_n,:)=meank(1:sc_n,:)
					sc_invcov(1:sc_n,:,:)=invcovk(1:sc_n,:,:)
					sc_tMat(1:sc_n,:,:)=tMatk(1:sc_n,:,:)
					sc_eval(1:sc_n,:)=evalk(1:sc_n,:)
					sc_evec(1:sc_n,:,:)=eveck(1:sc_n,:,:)
					sc_kfac(1:sc_n)=kfack(1:sc_n)
					sc_eff(1:sc_n)=effk(1:sc_n)
					sc_vol(1:sc_n)=volk(1:sc_n)
					sc_npt(1:sc_n)=nptk(1:sc_n)
					sc_node(1:sc_n)=nodek(1:sc_n)
					
					!find the index of the low-like points because of re-arrangement
					indx=minloc(l(1:nlive))
				endif
			endif
			
			ic_rFlag(1:ic_n)=.false.
		endif
		
		
            	if(my_rank==0 .and. eswitch .and. sc_n==0) eswitch=.false.
#ifdef MPI
		call MPI_BARRIER(MPI_COMM_WORLD,errcode)
		call MPI_BCAST(eswitch,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
		call MPI_BCAST(flag2,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
		call MPI_BCAST(modeFound,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
		call MPI_BCAST(lowlike,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
		
		if(modeFound) then
			call MPI_BCAST(ic_n,1,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(ic_npt(1:ic_n),ic_n,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
    			call MPI_BCAST(ic_done(0:ic_n),ic_n+1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
		endif
		
		if(flag2 .and. eswitch) then
			call MPI_BCAST(sc_n,1,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(ic_sc(1:ic_n),ic_n,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(sc_mean(1:sc_n,1:ndims),sc_n*ndims,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(sc_tmat(1:sc_n,1:ndims,1:ndims),sc_n*ndims*ndims,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(sc_kfac(1:sc_n),sc_n,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(sc_eff(1:sc_n),sc_n,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(sc_vol(1:sc_n),sc_n,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(ic_climits(1:ic_n,1:ndims,1:2),ic_n*ndims*2,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
			call MPI_BCAST(ic_volFac(1:ic_n),ic_n,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
		endif
#endif

		if( IS .and. (flag2 .or. mod(ff,100)==0) .and. eswitch .and. my_rank == 0 ) then
			!estimate the total ellipsoidal volume taking the overlap into account
			
			nd_i = 0 !no. of ellipsoids traversed
			nd_j = 0 !no. of points traversed
			flag = .false.
			do i = 1, ic_n
				IS_V(i) = 0d0
				if( IS_GetVolInsidePrior ) then
					do k = nd_i+1, nd_i+ic_sc(i)
						j1 = max(5, int( ( dble(IS_nMC) * dble(ic_npt(i)) / dble(nlive) ) * ( dble(sc_vol(k)) / dble(totVol(i)) ) ))
						m = 0
						do i3 = 1, j1
							d1=sc_kfac(k)*sc_eff(k)
							call genPtInEll(ndims, sc_mean(k,:), d1, sc_tMat(k,:,:), my_rank, pnew(1:ndims))
							do i2 = 1, ndims
								if( .not.pWrap(i2) .and. ( pnew(i2) < 0d0 .or. pnew(i2) > 1d0 ) ) then
									m = m+1
									flag = .true.
									exit
								endif
							enddo
						enddo
						IS_V(i) = IS_V(i) + sc_vol(k)*(1d0 - dble(m)/dble(j1))
					enddo
				else
					IS_V(i) = totVol(i)
				endif
				
				if( ic_sc(i) <= 1 .or. ic_done(i) ) then
					j1 = 1
					m = 1
				else
					m = 0
					j1 = ic_npt(i)
					if( IS_betterMC .and. IS_nMC > nlive ) j1 = int(dble(IS_nMC) * dble(ic_npt(i)) / dble(nlive))
					do j = nd_j+1, nd_j+j1
						if( j > nd_j+ic_npt(i) ) then
							!first pick an ellipsoid according to the vol
							do
								!pick a sub-cluster according to the vol
								call selectEll(ic_sc(i), sc_vol(nd_i+1:nd_i+ic_sc(i)), k)
								k = k + nd_i
								if( sc_kfac(k) == 0d0 .or. sc_vol(k) == 0d0 ) cycle
								exit
							enddo
							
							d1=sc_kfac(k)*sc_eff(k)
							call genPtInEll(ndims, sc_mean(k,:), d1, sc_tMat(k,:,:), my_rank, pnew(1:ndims))
						else
							pnew(1:ndims) = p(1:ndims,j)
						endif
						
						i2 = 0
						do k = nd_i+1, nd_i+ic_sc(i)
		            				if( ptIn1Ell(ndims, pnew(1:ndims), sc_mean(k,:), sc_invcov(k,:,:), sc_kfac(k)*sc_eff(k)) ) i2 = i2+1
		            			enddo
						
						if( j > nd_j+ic_npt(i) ) then
							if( i2 > 1 ) then
								urv = ranmarNS(0)
								if( urv > 1d0/dble(i2) ) then
									i2 = 0
									j1 = j1-1
								endif
							endif
						endif
						m = m+i2
					enddo
				endif
				
				IS_V(i) = ( IS_V(i) / ic_volFac(i) ) * dble(j1) / dble(m)
				
				nd_j = nd_j+ic_npt(i)
				nd_i = nd_i+ic_sc(i)
			enddo
			
			if( IS_GetVolInsidePrior .and. .not.flag ) IS_GetVolInsidePrior = .false.
			
			
			if( flag2 ) then
				lowlike = minval(l(1:nlive))
				flag = .false.	!found the very first point which is inside the ellipsoidal bound?
				j1 = IS_counter(2)
				if( IS_CheckAll ) j1 = 1
				do j = j1, IS_counter(1)
					d1 = huge(1d0)
					if( IS_CheckAll .or. IS_allpts(j,ndims+3) == 1d0 ) then
						IS_allpts(j,ndims+3) = 0d0
						
						nd_i = 0 !no. of ellipsoids traversed
						do i = 1, ic_n
							if( ic_done(i) .or. totvol(i) == 0d0 .or. ic_npt(i) == 0 .or. ( multimodal .and. .not.isAncestor(int(IS_allpts(j,ndims+6)), i, ic_fnode(1:i)) ) ) then
								nd_i = nd_i+ic_sc(i)
								cycle
							endif
							
							!apply current limits to this point
							call ApplyLimits(0, ic_climits(i,:,:), IS_allpts(j,1:ndims), pt(1,1:ndims))
							
							do k = nd_i+1, nd_i+ic_sc(i)
								!check if this point is inside the ellipsoid
								call ScaleFactor(1, ndims , pt(1,1:ndims), sc_mean(k,:), sc_invcov(k,:,:), d2)
								if( d2  < sc_kfac(k)*sc_eff(k) .and. d2/(sc_kfac(k)*sc_eff(k)) < d1 ) then
									d1 = d2/(sc_kfac(k)*sc_eff(k))
										
									IS_allpts(j,ndims+3) = 1d0
									IS_allpts(j,ndims+4) = dble(k)	!ellipsoid ID
									IS_allpts(j,ndims+5) = d2	!Mahalanobis distance of this point
										
									if( .not.flag ) then
										flag = .true.
										IS_counter(2) = j
									endif
								endif
							enddo
							
							nd_i = nd_i+ic_sc(i)
						enddo
					endif
				enddo
				
				!not a single point inside the current ellipsoidal decomposition
				if( .not.flag ) IS_counter(2) = IS_counter(1)+1
			endif
		endif

		nd_i=0 !no. of ellipsoids traversed
		nd_j=0 !no. of points traversed
		do nd=1,ic_n
			if(ic_npt(nd)<ndims+1 .or. (ic_sc(nd)==1 .and. sc_vol(nd_i+1)==0.d0)) then
				ic_done(nd)=.true.
				ic_done(0)=.true.
				do i3=1,ic_n
					if(.not.ic_done(i3)) then
						ic_done(0)=.false.
						exit
					endif
				enddo
			endif
			
			if(ic_done(nd) .and. .not.ic_done(0)) then
				nd_i=nd_i+ic_sc(nd)
				nd_j=nd_j+ic_npt(nd)
				cycle
			endif
			
			if(.not.ic_done(nd)) then
				!adjust the prior volumes & inc
				shrink=exp(-1.d0/dble(ic_npt(nd)))
				if(my_rank==0) then
	      				vprev=ic_vnow(nd)/shrink
					vnext=ic_vnow(nd)*shrink
					h=(vprev-vnext)/2.d0
		            		ic_inc(nd)=ic_hilike(nd)+log(ic_vnow(nd))-ic_Z(nd)
				
					!find lowlike
					indx=minloc(l(nd_j+1:nd_j+ic_npt(nd)))
					indx(1)=indx(1)+nd_j
		      			lowlike=l(indx(1))
					lowp(:)=p(:,indx(1))
					lowphyP(:)=phyP(:,indx(1))
					
					!set the limits
					do i3=1,ndims
						d4=ic_climits(nd,i3,2)-ic_climits(nd,i3,1)
						d1=ic_climits(nd,i3,1)+d4*lowp(i3)
						
						if( abs( d1 - ic_llimits(nd,i3,1) ) < d4 * 1d-5 ) then
							pt(1,1:ic_npt(nd))=ic_climits(nd,i3,1)+d4*p(i3,nd_j+1:nd_j+ic_npt(nd))
							ic_llimits(nd,i3,1)=minval(pt(1,1:ic_npt(nd)),MASK=pt(1,1:ic_npt(nd))>d1)
						elseif( abs( d1 - ic_llimits(nd,i3,2) ) < d4 * 1d-5 ) then
							pt(1,1:ic_npt(nd))=ic_climits(nd,i3,1)+d4*p(i3,nd_j+1:nd_j+ic_npt(nd))
							ic_llimits(nd,i3,2)=maxval(pt(1,1:ic_npt(nd)),MASK=pt(1,1:ic_npt(nd))<d1)
						endif
					enddo
					if(multimodal) then
						do i3=1,nCdims
							d4=ic_plimits(nd,i3,2)-ic_plimits(nd,i3,1)
							if( abs( lowPhyP(i3) - ic_plimits(nd,i3,1) ) < d4 * 1d-5 ) then
								ic_plimits(nd,i3,1)=minval(phyP(i3,nd_j+1:nd_j+ic_npt(nd)), &
								MASK=phyP(i3,nd_j+1:nd_j+ic_npt(nd))>lowPhyP(i3))
							elseif( abs( lowPhyP(i3) - ic_plimits(nd,i3,2) ) < d4 * 1d-5 ) then
								ic_plimits(nd,i3,2)=maxval(phyP(i3,nd_j+1:nd_j+ic_npt(nd)), &
								MASK=phyP(i3,nd_j+1:nd_j+ic_npt(nd))<lowPhyP(i3))
							endif
						enddo
					endif
				endif
			
				!now find a new point inside the hard constraint
				if(.not.eswitch) then
	            			acpt=.false.
					do
						if(my_rank==0) remFlag=remain(nd)
#ifdef MPI
						call MPI_BARRIER(MPI_COMM_WORLD,errcode)
						call MPI_BCAST(remFlag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
#endif
	                  			if(.not.remFlag) then
	            					!generate mpi_nthreads potential points
							call samp(pnew,phyPnew,lnew,sc_mean(1,:),d1,sc_tMat(1,:,:),ic_climits(nd,:,:),loglike,eswitch,lowlike,n,context)
						
							if(my_rank==0) then
								lnewa(nd,1)=lnew
							
								if(lnew>logZero) then
									pnewa(nd,1,:)=pnew(:)
									phyPnewa(nd,1,:)=phyPnew(:)
								endif
								
								if( lnew == HUGE(1d0) ) bogus = .true.
							endif
#ifdef MPI
							call MPI_BARRIER(MPI_COMM_WORLD,errcode)
							!now send the points to the root node
							if(my_rank/=0) then
								call MPI_SEND(lnew,1,MPI_DOUBLE_PRECISION,0,my_rank,MPI_COMM_WORLD,errcode)
								if(lnew>logZero) then
									call MPI_SEND(pnew,ndims,MPI_DOUBLE_PRECISION,0,my_rank,MPI_COMM_WORLD,errcode)
									call MPI_SEND(phyPnew,totPar,MPI_DOUBLE_PRECISION,0,my_rank,MPI_COMM_WORLD,errcode)
								endif
							else
								do i2=1,mpi_nthreads-1
									call MPI_RECV(lnewa(nd,i2+1),1,MPI_DOUBLE_PRECISION,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
									if(lnewa(nd,i2+1)>logZero) then
										call MPI_RECV(pnewa(nd,i2+1,1:ndims),ndims,MPI_DOUBLE_PRECISION,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
										call MPI_RECV(phyPnewa(nd,i2+1,1:totPar),totPar,MPI_DOUBLE_PRECISION,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
									endif
									if( lnewa(nd,i2+1) == HUGE(1d0) ) bogus = .true.
								enddo
							endif
							call MPI_BARRIER(MPI_COMM_WORLD,errcode)
#endif
							
							if( IS .and. my_rank == 0 ) then
								call ExtendArrayIfRequired(IS_counter(5),globff+1-IS_counter(5),IS_counter(4),IS_nstore/10,5,IS_iterinfo)
								call ExtendArrayIfRequired(IS_counter(1),mpi_nthreads,IS_counter(3),IS_nstore,ndims+6,IS_allpts)
								
								IS_counter(5) = globff+1
								
								i3 = IS_counter(1)	!no. of points in IS_allpts array
								do i2 = 1, mpi_nthreads
									if( lnewa(nd,i2)>logZero ) then
										IS_counter(1) = IS_counter(1)+1					!total no. of points collected so far
										IS_allpts(IS_counter(1),1:ndims) = pnewa(nd,i2,1:ndims)		!point
										IS_allpts(IS_counter(1),ndims+1) = lnewa(nd,i2)			!likelihood
									else
										if( IS ) IS_iterinfo(globff+1,4) = IS_iterinfo(globff+1,4) + 1
									endif
								enddo
								IS_allpts(i3+1:IS_counter(1),ndims+3) = 1d0					!check this point for ellipsoid membership in later iterations
								IS_allpts(i3+1:IS_counter(1),ndims+6) = dble(nd)				!node
								
								IS_iterinfo(globff+1,1) = 1d0							!current volume, V_{i}
								IS_iterinfo(globff+1,2:4) = IS_iterinfo(globff+1,2:4) + IS_counter(1)-i3	!no. of points collected at current iteration, n_{i}
								IS_iterinfo(globff+1,5) = dble(nd)						!current node
							endif
						endif
					
						if(my_rank==0) then
							!now check if any of them is a good one
	                        			do i=rIdx(nd),mpi_nthreads
	                        				numlike=numlike+1
	                        				if(lnewa(nd,i)>lowlike) then
									pnew(:)=pnewa(nd,i,:)
	                                    				phyPnew(:)=phyPnewa(nd,i,:)
	                                    				lnew=lnewa(nd,i)
	                                    				acpt=.true.
	                                    				!leftover points?
	                                    				if(i==mpi_nthreads) then
	                                    					remain(nd)=.false.
	                                          				rIdx(nd)=1
									else
	                                    					remain(nd)=.true.
	                                    					rIdx(nd)=i+1
									endif
	                                    				exit
								endif
	                              				if(i==mpi_nthreads) then
	                                    				remain(nd)=.false.
									rIdx(nd)=1
								endif
							enddo
						endif
					
#ifdef MPI
						call MPI_BARRIER(MPI_COMM_WORLD,errcode)
						call MPI_BCAST(acpt,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
						call MPI_BCAST(bogus,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
#endif
	                        	
						if(acpt .or. bogus) exit
					enddo
				
	                        	if(my_rank==0) then      	
	                  			p(:,indx(1))=pnew(:)
	                  			phyP(:,indx(1))=phyPnew(:)
	                  			l(indx(1))=lnew
						if(lnew>ic_hilike(nd)) ic_hilike(nd)=lnew
						
						!set the limits
						if(multimodal) then
							call setLimits(multimodal,ndims,nCdims,ic_llimits(nd,:,:), &
							ic_plimits(nd,:,:),pnew,phyPnew(1:nCdims),ic_climits(nd,:,:))
						else
							call setLimits(multimodal,ndims,nCdims,ic_llimits(nd,:,:), &
							ic_climits(nd,:,:),pnew,phyPnew(1:nCdims),ic_climits(nd,:,:))
						endif
						
						
						!calculate p(\Theta) n = \Sum_{i}^{niter} n_{i} E_{i}(\Theta) / V_{i}
						if( IS ) then
							n1 = 0; n2 = 0
							if( IS_counter(5) == globff+1 ) then
								n1 = int(IS_iterinfo(globff+1,2))	!n_{i}
								n2 = int(IS_iterinfo(globff+1,4))	!n_{i}
							endif
							
							if( n1 > 0 .and. n2 > 0 ) then
								!(p(\Theta) n1) for points collected in current iteration from current iteration
								IS_allpts(IS_counter(1)-n1+1:IS_counter(1),ndims+2) = dble(n2)
							
								!(p(\Theta) n1) for points collected in previous iterations from current iteration
								IS_allpts(1:IS_counter(1)-n1,ndims+2) = IS_allpts(1:IS_counter(1)-n1,ndims+2) + dble(n2)
							
								!(p(\Theta) n1) for points collected in current iteration from previous iterations
								do i = 1, globff
									IS_allpts(IS_counter(1)-n1+1:IS_counter(1),ndims+2) = IS_allpts(IS_counter(1)-n1+1:IS_counter(1),ndims+2) + IS_iterinfo(i,4)
								enddo
							endif
						endif
					endif
	            		else
					num_old=numlike
					
					acpt=.false.
					do
						if(my_rank==0) remFlag=remain(nd)
#ifdef MPI
						call MPI_BARRIER(MPI_COMM_WORLD,errcode)
						call MPI_BCAST(remFlag,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
#endif
						if(.not.remFlag) then
							!first pick an ellipsoid according to the vol
							do
								!pick a sub-cluster according to the vol
								call selectEll(ic_sc(nd),sc_vol(nd_i+1:nd_i+ic_sc(nd)),i)
								i=i+nd_i
								if(sc_kfac(i)==0.d0 .or. sc_vol(i)==0.d0) then
									cycle
								else
									exit
								endif
							enddo
						
							!generate mpi_nthreads potential points
							d1=sc_kfac(i)*sc_eff(i)
							call samp(pnew,phyPnew,lnew,sc_mean(i,:),d1,sc_tMat(i,:,:),ic_climits(nd,:,:),loglike,eswitch,lowlike,n,context)
							
							if(my_rank==0) then
								if( IS ) then
									call ExtendArrayIfRequired(IS_counter(5),globff+1-IS_counter(5),IS_counter(4),IS_nstore/10,5,IS_iterinfo)
									call ExtendArrayIfRequired(IS_counter(1),mpi_nthreads,IS_counter(3),IS_nstore,ndims+6,IS_allpts)
									IS_counter(5) = globff+1
								endif
								
								lnewa(nd,1)=lnew
								if( lnew == HUGE(1d0) ) bogus = .true.
						
								if(lnew>logZero) then
									sEll(nd,1)=i-nd_i
									pnewa(nd,1,:)=pnew(:)
									phyPnewa(nd,1,:)=phyPnew
								endif
								
								if( IS ) IS_iterinfo(globff+1,4) = IS_iterinfo(globff+1,4) + n
							endif
#ifdef MPI
							call MPI_BARRIER(MPI_COMM_WORLD,errcode)
							!now send the points to the root node
							if(my_rank/=0) then
								if( IS ) call MPI_SEND(n,1,MPI_INTEGER,0,my_rank,MPI_COMM_WORLD,errcode)
								call MPI_SEND(lnew,1,MPI_DOUBLE_PRECISION,0,my_rank,MPI_COMM_WORLD,errcode)
								if(lnew>logZero) then
									call MPI_SEND(i-nd_i,1,MPI_INTEGER,0,my_rank,MPI_COMM_WORLD,errcode)
									call MPI_SEND(pnew,ndims,MPI_DOUBLE_PRECISION,0,my_rank,MPI_COMM_WORLD,errcode)
									call MPI_SEND(phyPnew,totPar,MPI_DOUBLE_PRECISION,0,my_rank,MPI_COMM_WORLD,errcode)
								endif
							else
								do i2=1,mpi_nthreads-1
									if( IS ) then
										call MPI_RECV(n,1,MPI_INTEGER,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
										IS_iterinfo(globff+1,4) = IS_iterinfo(globff+1,4) + n
									endif
									call MPI_RECV(lnewa(nd,i2+1),1,MPI_DOUBLE_PRECISION,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
									if(lnewa(nd,i2+1)>logZero) then
										call MPI_RECV(sEll(nd,i2+1),1,MPI_INTEGER,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
										call MPI_RECV(pnewa(nd,i2+1,1:ndims),ndims,MPI_DOUBLE_PRECISION,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
										call MPI_RECV(phyPnewa(nd,i2+1,1:totPar),totPar,MPI_DOUBLE_PRECISION,i2,i2,MPI_COMM_WORLD,MPI_STATUS_IGNORE,errcode)
									endif
									
									if( lnewa(nd,i2+1) == HUGE(1d0) ) bogus = .true.
								enddo
							endif
							call MPI_BARRIER(MPI_COMM_WORLD,errcode)
#endif
							if( IS .and. my_rank == 0 .and. .not.bogus ) then
								i3 = IS_counter(1)
								do i2=1, mpi_nthreads
									if( lnewa(nd,i2) > logZero ) then
										IS_counter(1) = IS_counter(1)+1					!total no. of points collected so far
										
										!reverse the limits on this point such that it is in unit hypercube & store it
										call ApplyLimits(1, ic_climits(nd,:,:), pnewa(nd,i2,1:ndims), IS_allpts(IS_counter(1),1:ndims))
										IS_allpts(IS_counter(1),ndims+1) = lnewa(nd,i2)			!likelihood
										
										!check how many ellipsoids this point lies in
										j = 1
	            								do m = nd_i+1, nd_i+ic_sc(nd)
	            									if( m == sEll(nd,i2)+nd_i .or. sc_npt(m) == 0 ) then
												IS_allpts(IS_counter(1),ndims+4) = m
												call ScaleFactor(1, ndims , pnewa(nd,i2,:), sc_mean(m,:), sc_invcov(m,:,:), IS_allpts(IS_counter(1),ndims+5))
												cycle
											endif
											if( ptIn1Ell(ndims,pnewa(nd,i2,:),sc_mean(m,:),sc_invcov(m,:,:),sc_kfac(m)*sc_eff(m))) j=j+1
	            								enddo
										IS_allpts(IS_counter(1),ndims+2) = dble(j) / ( totvol(nd) / ic_volFac(nd) )
										IS_iterinfo(globff+1,3) = IS_iterinfo(globff+1,3) + 1d0/dble(j)	!effective no. of points collected at each iteration
									endif
								enddo
								
								IS_iterinfo(globff+1,1) = IS_V(nd)						!volume, V_{i}
								IS_iterinfo(globff+1,2) = IS_iterinfo(globff+1,2) + IS_counter(1)-i3		!total no. of points collected at each iteration
								IS_iterinfo(globff+1,5) = dble(nd)						!node
								IS_allpts(i3+1:IS_counter(1),ndims+3) = 1d0					!check this point for ellipsoid membership in later iterations					!node
								IS_allpts(i3+1:IS_counter(1),ndims+6) = dble(nd)				!node
							endif
						endif
					
						if(my_rank==0 .and. .not.bogus) then
							!check if any of them is inside the hard edge
	                        			do j1=rIdx(nd),mpi_nthreads
								numlike=numlike+1
								if(my_rank==0 .and. ceff) then
									if(.not.remain(nd)) ic_eff(nd,2)=ic_eff(nd,2)+1d0
								endif
								
								if(lnewa(nd,j1)>lowlike) then
	                              					if(sc_npt(sEll(nd,j1)+nd_i)>0) then
	            								!find the no. of ellipsoids, j, the new points lies in
										j=1
	                                   					acpt=.true.
	            								do m=nd_i+1,nd_i+ic_sc(nd)
	            									if(m==sEll(nd,j1)+nd_i .or. sc_npt(m)==0) cycle
											if(ptIn1Ell(ndims,pnewa(nd,j1,:),sc_mean(m,:), &
											sc_invcov(m,:,:),sc_kfac(m)*sc_eff(m))) j=j+1
	            								enddo
									endif
	                                    			
									if(acpt) then
										!accept it with probability 1/j						
										if(j>1) then
	            									urv=ranmarNS(0)
											if(urv<=(1.d0/dble(j))) then
	           	 									acpt=.true.
											else
												acpt=.false.
											endif
										else
											acpt=.true.
										endif
										
										!point accepted
										if(acpt) then
											if(my_rank==0 .and. ceff) then
												if(.not.remain(nd)) ic_eff(nd,1)=ic_eff(nd,1)+1d0
											endif
											!leftover points?
	                                    						if(j1==mpi_nthreads) then
	                                    							remain(nd)=.false.
	                                          						rIdx(nd)=1
											else
	                                    							remain(nd)=.true.
	                                    							rIdx(nd)=j1+1
											endif
	                                    						exit
										endif
									endif
								endif
	                              				
								if(j1==mpi_nthreads) then
	                                    				remain(nd)=.false.
									rIdx(nd)=1
								endif
							enddo
						endif
					
#ifdef MPI
						call MPI_BARRIER(MPI_COMM_WORLD,errcode)
						call MPI_BCAST(acpt,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
						call MPI_BCAST(bogus,1,MPI_LOGICAL,0,MPI_COMM_WORLD,errcode)
#endif
					
						if( bogus ) exit
					
	                        		if(acpt) then
							if(my_rank==0) then
								pnew=pnewa(nd,j1,:)
								phyPnew=phyPnewa(nd,j1,:)
								lnew=lnewa(nd,j1)
								i=sEll(nd,j1)+nd_i
							
								if(lnew>ic_hilike(nd)) ic_hilike(nd)=lnew
						
								!set the limits
								if(multimodal) then
									call setLimits(multimodal,ndims,nCdims,ic_llimits(nd,:,:), &
									ic_plimits(nd,:,:),pnew,phyPnew(1:nCdims),ic_climits(nd,:,:))
								else
									call setLimits(multimodal,ndims,nCdims,ic_llimits(nd,:,:), &
									ic_climits(nd,:,:),pnew,phyPnew(1:nCdims),ic_climits(nd,:,:))
								endif
	                              			endif
							exit
	            				endif
	      				enddo
					
					if( bogus ) exit

				
					if(my_rank==0) then
						
						!calculate p(\Theta) n = \Sum_{i}^{niter} n_{i} E_{i}(\Theta) / V_{i}
						if( IS ) then
							n1 = 0; n2 = 0
							if( IS_counter(5) == globff+1 ) then
								n1 = int(IS_iterinfo(globff+1,2))	!n_{coll, i}
								n2 = int(IS_iterinfo(globff+1,4))	!n_{i}
							endif
							
							if( n1 > 0 .and. n2 > 0 ) then
								
								!(p(\Theta) n) for points collected in current iteration from current iteration
								IS_allpts(IS_counter(1)-n1+1:IS_counter(1),ndims+2) = IS_allpts(IS_counter(1)-n1+1:IS_counter(1),ndims+2) * dble(n2)
								
								!(p(\Theta) n) for points collected in previous iterations from current iteration
								i1 = 0
								do j = IS_counter(2), IS_counter(1)-n1
									if( IS_allpts(j,ndims+3) == 0d0 ) cycle
									
									if( multimodal .and. .not.isAncestor(int(IS_allpts(j,ndims+6)), nd, ic_fnode(1:nd)) ) then
										IS_allpts(j,ndims+3) = 0d0
										cycle
									endif
								
									!check if this point lies in current ellipsoidal decomposition
									m = int(IS_allpts(j,ndims+4))
									if( m > nd_i .and. m <= nd_i+ic_sc(nd) .and. IS_allpts(j,ndims+5) <= sc_kfac(m)*sc_eff(m) ) then
										IS_allpts(j,ndims+2) = IS_allpts(j,ndims+2) + dble(n2) / IS_iterinfo(globff+1,1)
										if( i1 == 0 ) IS_counter(2) = j
										i1 = j
									else
										IS_allpts(j,ndims+3) = 0d0
									endif
								enddo
								if( i1 == 0 ) IS_counter(2) = IS_counter(1)-n1+1
								
								!(p(\Theta) n) for points collected in current iteration from previous iterations
								do j = 1, globff
									if( multimodal .and. .not.isAncestor(int(IS_iterinfo(j,5)), nd, ic_fnode(1:nd)) ) cycle
									
									if( int(IS_iterinfo(j,4)) > 0 ) IS_allpts(IS_counter(1)-n1+1:IS_counter(1),ndims+2) = IS_allpts(IS_counter(1)-n1+1:IS_counter(1),ndims+2) + IS_iterinfo(j,4) / IS_iterinfo(j,1)
								enddo
							endif
						endif
				
						if(ceff) then
							if(ic_eff(nd,1)>0d0 .and. mod(int(ic_eff(nd,1)),10)==0) then
								d1=ic_eff(nd,1)/ic_eff(nd,2)
								ic_eff(nd,1)=0d0
								ic_eff(nd,2)=0d0
								
								if(1.2d0*d1<ef) then
									!ic_eff(nd,3)=ic_eff(nd,4)*(1d0+0.2d0*sqrt(1000d0/dble(ic_npt(nd))))
									ic_eff(nd,3)=max(ic_eff(nd,3),ic_eff(nd,4)*(1d0+0.2d0*sqrt(1000d0/dble(ic_npt(nd)))))
								elseif(d1>1.2d0*ef) then
									ic_eff(nd,3)=max(ef,ic_eff(nd,4)/(1d0+0.2d0*sqrt(1000d0/dble(ic_npt(nd)))))
									!ic_eff(nd,3)=ic_eff(nd,4)/(1d0+0.2d0*sqrt(1000d0/dble(ic_npt(nd))))
									ic_eff(nd,4)=ic_eff(nd,3)
								endif
							endif
						endif
						
						!find the sub-cluster in which the rejected point lies
						n1=nd_j	
						do q=nd_i+1,nd_i+ic_sc(nd)
							if(sc_npt(q)==0) cycle
							n1=n1+sc_npt(q)
							if(indx(1)<=n1) then
								n1=n1-sc_npt(q)
	            						exit
	            					endif
						enddo
	
						i1=nlive
		
						!remove the rejected point & its likelihood & update the no. of points in the cluster
						if(indx(1)<nlive) then
							p(:,indx(1):nd_j+ic_npt(nd)-1)=p(:,indx(1)+1:nd_j+ic_npt(nd))
							phyP(:,indx(1):nd_j+ic_npt(nd)-1)=phyP(:,indx(1)+1:nd_j+ic_npt(nd))
							l(indx(1):nd_j+ic_npt(nd)-1)=l(indx(1)+1:nd_j+ic_npt(nd))
						endif
						sc_npt(q)=sc_npt(q)-1
						
						if(sc_npt(q)==0) then
							sc_vol(q)=0.d0
							sc_kfac(q)=0.d0
							sc_eff(q)=1.d0
							if(ic_sc(nd)==1) ic_inc(nd)=log(tol)
						elseif(sc_vol(q)>0.d0 .and. sc_kfac(i)>0.d0 .and. (i/=q .or. (i==q .and. sc_npt(q)>0))) then
				
							!min vol this ellipsoid should occupy
							if(dino) then
								if(ceff) then
									d4=ic_eff(nd,3)
								else
									d4=ef
								endif
								
								d1=(ic_vnow(nd)*ic_volFac(nd)*shrink/d4)*(sc_npt(q))/dble(ic_npt(nd))
							else
								d1=tiny(1.d0)
							endif
	
							!now evolve the ellipsoid with the rejected point
							call evolveEll(0,sc_npt(q),ndims,lowp,p(:,n1+1:n1+sc_npt(q)),sc_mean(q,:), &
							sc_eval(q,:),sc_invcov(q,:,:),sc_kfac(q),sc_eff(q),sc_vol(q),d1)
						endif
	                  	
						n1=sum(sc_npt(1:i-1))
						
						if(i/=q .or. (i==q .and. sc_npt(q)>0)) then
							!min vol this ellipsoid should occupy
							if(dino) then
								if(ceff) then
									d4=ic_eff(nd,3)
								else
									d4=ef
								endif
								
								d1=(ic_vnow(nd)*ic_volFac(nd)*shrink/d4)*(dble(sc_npt(i))+1.d0)/dble(ic_npt(nd))
							else
								d1=tiny(1.d0)
							endif
	
							!now evolve the ellipsoid with the inserted point
							call evolveEll(1,sc_npt(i),ndims,pnew,p(:,n1+1:n1+sc_npt(i)),sc_mean(i,:), &
							sc_eval(i,:),sc_invcov(i,:,:),sc_kfac(i),sc_eff(i),sc_vol(i),d1)
						endif
					endif
				
#ifdef MPI
					call MPI_BARRIER(MPI_COMM_WORLD,errcode)
					call MPI_BCAST(q,1,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
					call MPI_BCAST(i,1,MPI_INTEGER,0,MPI_COMM_WORLD,errcode)
					call MPI_BCAST(sc_kfac(i),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
					call MPI_BCAST(sc_eff(i),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
					call MPI_BCAST(sc_vol(i),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
					call MPI_BCAST(sc_kfac(q),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
					call MPI_BCAST(sc_eff(q),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
					call MPI_BCAST(sc_vol(q),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,errcode)
#endif
				
					!now evolve the rest of the sub-clusters
					!only if sub-clustering wasn't done in the current iteration
					do j=nd_i+1,nd_i+ic_sc(nd)
						!sub-clusters with rejected/inserted point already evolved
						if(j==i .or. j==q) cycle
						if(sc_eff(j)>1.d0 .and. sc_vol(j)>0.d0 .and. sc_kfac(i)>0.d0) then
							d1=sc_eff(j)
							sc_eff(j)=max(1.d0,sc_eff(j)*(shrink**(2.d0/dble(ndims))))
							d1=sc_eff(j)/d1
							sc_vol(j)=sc_vol(j)*(d1**(dble(ndims)/2.d0))
						endif						
					enddo
				
					if(my_rank==0) then
						!add the new point & its likelihood & update the no. of points 
						!in the cluster new point's index
						n1=n1+sc_npt(i)+1
						!make room
						p(:,n1+1:nd_j+ic_npt(nd))=p(:,n1:nd_j+ic_npt(nd)-1)
						phyP(:,n1+1:nd_j+ic_npt(nd))=phyP(:,n1:nd_j+ic_npt(nd)-1)
						l(n1+1:nd_j+ic_npt(nd))=l(n1:nd_j+ic_npt(nd)-1)
						!insert the new point
						p(:,n1)=pnew(:)
						phyP(:,n1)=phyPnew(:)
						l(n1)=lnew
						!increment no. of points in sub-cluster i
						sc_npt(i)=sc_npt(i)+1
					endif
				endif
			
				if(my_rank==0) then
					!update evidence, info, prior vol, sampling statsitics
					globff=globff+1
					sff=sff+1
					gZold=gZ
					ic_zold(nd)=ic_z(nd)
					d1=lowlike+log(h)
	      				gZ=LogSumExp(gZ,d1)
	      				ic_Z(nd)=LogSumExp(ic_Z(nd),d1)
!					ic_info(nd)=exp(d1-ic_Z(nd))*lowlike+exp(gZold-ic_Z(nd))* &
!					(ic_info(nd)+gZold)-ic_Z(nd)
					ginfo=ginfo*exp(gzold-gz)+exp(d1-gz)*lowlike
					ic_info(nd)=ic_info(nd)*exp(ic_zold(nd)-ic_z(nd))+exp(d1-ic_z(nd))*lowlike
		
					!data for ev.dat file
					j1=mod(sff-1,updInt)+1
					evData(j1,1:totPar)=lowphyP(1:totPar)
					evData(j1,totPar+1)=lowlike
					evData(j1,totPar+2)=log(h)
					evData(j1,totPar+3)=dble(nd)
					
					lowlike=minval(l(nd_j+1:nd_j+ic_npt(nd)))
				
					if(abs(lowlike-ic_hilike(nd))<= 0.0001 .or. (ic_inc(nd)<log(tol) .and. &
					globff-nlive>50) .or. ff==maxIter) then
						ic_done(nd)=.true.
							
						!check if all done
						ic_done(0)=.true.
						do i=1,ic_n
							if(.not.ic_done(i)) then
								ic_done(0)=.false.
								exit
							endif
						enddo
					endif
				endif
			endif
		
			if(my_rank==0) then
				if(sff>0 .and. (mod(sff,updInt)==0 .or. ic_done(0))) then
				
					if( .not.outfile ) then
						k=0
						if( sff > updInt ) then
							k=size(evDataAll)
							allocate( evDataTemp(k) )
							evDataTemp=evDataAll
							deallocate( evDataAll )
							allocate( evDataAll(k+j1*(totPar+3)) )
							evDataAll(1:k)=evDataTemp(1:k)
							deallocate( evDataTemp )
						else
							deallocate( evDataAll )
							allocate( evDataAll(j1*(totPar+3)) )
						endif
						do i=1,j1
    							evDataAll(k+1:k+totPar+3) = evData(i,1:totPar+3)
							k=k+totPar+3
						enddo
					else
						!write the evidence file
						funit1=u_ev
						fName1=evname
						open(unit=funit1,file=fName1,form='formatted',status='old', position='append')
	    					write(fmt,'(a,i5,a)')  '(',totPar+2,'E28.18,i5)'	
						do i=1,j1
	    						write(funit1,fmt) evData(i,1:totPar+2),int(evData(i,totPar+3))
						enddo
						!close the files
						close(funit1)
					
		                		!write the live file
						funit1=u_phys
						fName1=physname
						funit2=u_live
						fName2=livename
						open(unit=funit1,file=fName1,form='formatted',status='replace')
						open(unit=funit2,file=fName2,form='formatted',status='replace')
	                		
						write(fmt,'(a,i5,a)')  '(',totPar+1,'E28.18,i4)'
	                			write(fmt1,'(a,i5,a)')  '(',ndims+1,'E28.18)'
						k=0
						do i=1,ic_n
							do j=1,ic_npt(i)
								k=k+1
								write(funit1,fmt) phyP(1:totPar,k),l(k),i
								lPts(1:ndims) = ic_climits(i,1:ndims,1)+(ic_climits(i,1:ndims,2)-ic_climits(i,1:ndims,1))*p(1:ndims,k)
								write(funit2,fmt1) lPts(1:ndims),l(k)
							enddo
	                			enddo
						!close the files
						close(funit1)
						close(funit2)
						
                  	
	                  			!write the resume file
						funit1=u_resume
						fName1=resumename
						open(unit=funit1,file=fName1,form='formatted',status='replace')
	                	  	
						write(funit1,'(l2)')genLive
						write(funit1,'(4i12)')globff,numlike,ic_n,nlive
						write(funit1,'(2E28.18)')gZ,ginfo
						write(funit1,'(l2)')eswitch
					
	            				!write branching info
		            			do i=1,ic_n
	            					write(funit1,'(i4)')ic_nBrnch(i)
							if(ic_nBrnch(i)>0) then
								write(fmt,'(a,i5,a)')  '(',2*ic_nBrnch(i),'E28.18)'
								write(funit1,fmt)ic_brnch(i,1:ic_nBrnch(i),1), ic_brnch(i,1:ic_nBrnch(i),2)
							endif
						enddo
					
						!write the node info
						do i=1,ic_n
							write(funit1,'(2l2,i6,i12)')ic_done(i),ic_reme(i),ic_fNode(i),ic_npt(i)
							write(funit1,'(3E28.18)')ic_vnow(i),ic_Z(i),ic_info(i)
							if(ceff) write(funit1,'(1E28.18)')ic_eff(i,4)
						enddo
	                  			close(funit1)
						
						
						!write the IS files
						if( IS ) then
							!write all the points collected so far
							open(unit=u_IS(1), file=IS_Files(1), form='unformatted', access='sequential', status='old', position='append')
							do i = IS_counter(7)+1, IS_counter(1)
								write(u_IS(1))IS_allpts(i,1:ndims+1),int(IS_allpts(i,ndims+6))
							enddo
							IS_counter(7) = IS_counter(1)
							close(u_IS(1))
							
							!write all the points collected so far
							open(unit=u_IS(2), file=IS_Files(2), form='unformatted', access='sequential', status='replace')
							write(u_IS(2))IS_counter(1:2),IS_counter(5)
							do i = 1, IS_counter(1)
								write(u_IS(2))IS_allpts(i,ndims+2),int(IS_allpts(i,ndims+3))
							enddo
							close(u_IS(2))
							
							!write the iteration info
							open(unit=u_IS(3), file=IS_Files(3), form='unformatted', access='sequential',status='old', position='append')
							do i = IS_counter(6)+1, IS_counter(5)
								write(u_IS(3))IS_iterinfo(i,1),int(IS_iterinfo(i,2:5))
							enddo
							IS_counter(6) = IS_counter(5)
							close(u_IS(3))
						endif
					endif
					
					!check if the parameters are close the prior edges
					if( .not.ic_done(0) .and. prior_warning .and. mod(ff,50)== 0 ) then
						flag = .false.
						k=0
						do i=1,ic_n
							if( ic_npt(i) == 0 .or. ic_done(i) ) cycle
								
							ic_mean(i,1:ndims) = 0d0
							ic_sigma(i,1:ndims) = 0d0
							
							do j=1,ic_npt(i)
								k=k+1
								lPts(1:ndims) = ic_climits(i,1:ndims,1)+(ic_climits(i,1:ndims,2)-ic_climits(i,1:ndims,1))*p(1:ndims,k)
								if( prior_warning .and. mod(ff,50)== 0 ) then
									ic_mean(i,1:ndims) = ic_mean(i,1:ndims) + lPts(1:ndims)
									ic_sigma(i,1:ndims) = ic_sigma(i,1:ndims) + lPts(1:ndims) * lPts(1:ndims)
								endif
							enddo
							
							ic_mean(i,1:ndims) = ic_mean(i,1:ndims) / dble(ic_npt(i))
							ic_sigma(i,1:ndims) = sqrt(max(0d0, ic_sigma(i,1:ndims) / dble(ic_npt(i)) + ic_mean(i,1:ndims) * ic_mean(i,1:ndims)))
							
							do j = 1, ndims
								if( ic_sigma(i,j) <= 0.05 .and. ( ic_sigma(i,j) <= 0.05 .or. ic_sigma(i,j) >= 0.95 ) ) then
									if( .not. flag ) then
										write(*,*)
										write(*,*)"MultiNest Warning!"
										flag = .true.
									endif
									write(*,*)"Parameter ", j, " of mode ", i, " is converging towards the edge of the prior."
								endif
							enddo
						enddo
					endif
					
					if(mod(sff,updInt*10)==0 .or. ic_done(0)) call pos_samp(Ztol,globff,broot,nlive,ndims,nCdims,totPar, &
					multimodal,outfile,gZ,ginfo,ic_n,ic_Z(1:ic_n),ic_info(1:ic_n),ic_reme(1:ic_n),ic_vnow(1:ic_n),ic_npt(1:ic_n), &
					ic_nBrnch(1:ic_n),ic_brnch(1:ic_n,:,1),phyP(:,1:nlive),l(1:nlive),evDataAll,IS,IS_Z,dumper,context)
				endif
			endif
			
			nd_i=nd_i+ic_sc(nd)
			
			!prior volume shrinks
			if(my_rank==0) then
				if(.not.ic_done(nd)) ic_vnow(nd)=ic_vnow(nd)*shrink
				nd_j=nd_j+ic_npt(nd)
			endif
			
			if( ic_done(0) ) exit
		enddo
		
		if( bogus ) exit
		
		if(my_rank==0) then
			!update the total volume
			if(eswitch) then
				k = 0
				do i = 1, ic_n
					if( ic_done(i) ) then
						totVol(i) = 0d0
					else
						d1 = totVol(i)
						totVol(i) = sum(sc_vol(k+1:k+ic_sc(i)))
						if( ceff ) ic_eff(i,4) = ic_vnow(i) * ic_volFac(i) / totVol(i)
						
						if( IS ) IS_V(i) = IS_V(i) * totVol(i) / d1
					endif
					k = k + ic_sc(i)
				enddo
			endif
			
			!calculate the global evidence & info
			if(mod(ff,50)==0) then
				
				if(fback) then
					if( IS ) then
						IS_Z = logZero
						do j = 1, IS_counter(1)
							d1 = IS_allpts(j,ndims+1)-log(IS_allpts(j,ndims+2))
							IS_Z(1) = LogSumExp(IS_Z(1), d1)
							IS_Z(2) = LogSumExp(IS_Z(2), 2d0*d1)
						enddo
						IS_Z(2) = sqrt(exp(IS_Z(2)-2d0*IS_Z(1)) - 1d0/IS_counter(1))
					endif
					
					call gfeedback(gZ,IS,IS_Z,numlike,globff,.false.)
				
					if(debug) then
						d1=0.d0
						d2=0.d0
						j=0
						do i=1,ic_n
							if(ic_done(i)) then
								j=j+ic_sc(i)
								cycle
							endif
							d1=d1+ic_vnow(i)*ic_volFac(i)
							d2=d2+sum(sc_vol(j+1:j+ic_sc(i)))
							j=j+ic_sc(i)
						enddo
						write(*,*)ic_n,sc_n,d2/d1,count,scount
						if(ceff) write(*,*)ic_eff(1:ic_n,4)
					endif
				endif
			endif
			
			!switch ellipsoidal sampling on if the sum of the volumes of all the
		      	!clusters/sub-cluster is less than 1
			if(.not.peswitch) then
            			!marginal acceptance rate
				if(.not.peswitch) mar_r=1.d0/dble(numlike-num_old)
            			
				if(mar_r<ef) then
					escount(1)=escount(1)+1
					if(escount(1)==5) then
						peswitch=.true.
		                               	eswitchff(1)=ff
						totVol=1.d0
						escount(1)=0
					endif
				else
					escount(1)=0
				endif
			endif
		endif
	enddo
	
	deallocate( eswitchff, escount, dmin, evData, ic_sc, ic_npt, ic_done, &
	ic_climits, ic_volFac, sc_mean, sc_tmat, sc_kfac, sc_eff, sc_vol, lowp, lowphyP, pnew, phyPnew )
	
  end subroutine clusteredNest
  
!----------------------------------------------------------------------
 
 logical function ellIntersect(ndim,mean1,mean2,eval1,evec1,ef1,ef2,inv_cov1,inv_cov2)
 	
      implicit none
      
      integer ndim !dimensionality
      double precision eval1(:), evec1(:,:), mean1(:), mean2(:), inv_cov1(:,:), inv_cov2(:,:)
      ! matrices for ellipsoid interaction detection
      double precision, allocatable :: matA(:,:), matB(:,:), matR(:,:), matAinvB(:,:)
      ! variables for calculating eigenvalues of N*N real non-sym matrix
      double precision, allocatable :: evalR(:), evalI(:), VL(:,:), VR(:,:), WORK(:), delMean(:)
      ! effective enlargement factor
      double precision ef1,ef2
      integer inf,k,i
      integer i1,i2,i3,i4,i5
      
      
      
	if( ef1 == 0.d0 .and. ef2 == 0.d0 ) then
      		ellIntersect=.false.
            	return
      	else if( ef1 == 0.d0 ) then
      		ellIntersect = ptIn1Ell(ndim, mean1, mean2, inv_cov2, ef2)
            	return
	else if( ef2==0.d0 ) then
      		ellIntersect = ptIn1Ell(ndim, mean2, mean1, inv_cov1, ef1)
            	return
	endif
	
	allocate( matA(ndim+1,ndim+1), matB(ndim+1,ndim+1), matR(ndim+1,ndim+1), matAinvB(ndim+1,ndim+1) )
	allocate( evalR(ndim+1),evalI(ndim+1),VL(ndim+1,ndim+1),VR(ndim+1,ndim+1), WORK(4*ndim+4), delMean(ndim) )
      
      	delMean(1:ndim) = mean1(1:ndim) - mean2(1:ndim)
      	matA = 0.d0

	do i = 1, ndim
		matA(i,i)=eval1(i)
		matB(i,1:ndim)=inv_cov2(i,1:ndim)
		matB(ndim+1,i)=sum(-delMean(:)*inv_cov2(:,i))
		matB(i,ndim+1)=matB(ndim+1,i)
      	enddo
      	
	matA(ndim+1,ndim+1)=-1.d0/(ef1)
      	matB(ndim+1,ndim+1)=sum(matB(ndim+1,1:ndim)*(-delMean(:)))-ef2
      	matR=0.d0
      	
	do i=1,ndim
		matR(i,1:ndim)=evec1(:,i)
	enddo
      
      	matR(ndim+1,ndim+1)=1.d0
      	matB=MATMUL(MATMUL(matR,matB),TRANSPOSE(matR))
      	matAinvB=MATMUL(matA,matB)
      	i1=ndim+1
      	i2=ndim+1
      	i3=ndim+1
      	i4=ndim+1
      	i5=4*ndim+4
      	call DGEEV('N','N',i1,matAinvB,i2,evalR,evalI,VL,i3,VR,i4,WORK,i5,INF)
      	k=0
      
      	do i=1,ndim+1
		if(evalI(i)/=0.d0) then
			ellIntersect=.true.
			deallocate( matA, matB, matR, matAinvB, evalR, evalI, VL,VR, WORK, delMean )
			return
		else if(evalR(i)<0.d0) then
            		k=k+1
		endif
      	enddo
      
      	if(k<2) then
		ellIntersect=.true.
		deallocate( matA, matB, matR, matAinvB, evalR, evalI, VL,VR, WORK, delMean )
		return
      	endif
            
      	ellIntersect=.false.
	deallocate( matA, matB, matR, matAinvB, evalR, evalI, VL,VR, WORK, delMean )
 end function ellIntersect

!---------------------------------------------------------------------- 
  !sample a point inside the given ellipsoid with log-likelihood>lboundary
  subroutine samp(pnew,phyPnew,lnew,mean,ekfac,TMat,limits,loglike,eswitch,lowlike,n,context)
	
	implicit none
	double precision lnew
    	double precision pnew(ndims),spnew(ndims),phyPnew(totPar),ekfac
    	double precision mean(ndims),TMat(ndims,ndims)
	double precision limits(ndims,2)
	double precision lowlike	!likelihood threshold
	integer n			!no. of points drawn
    	logical eswitch
    	integer id,i,context
    
    	INTERFACE
    		!the likelihood function
    		subroutine loglike(Cube,n_dim,nPar,lnew,context_pass)
			integer n_dim,nPar,context_pass
			double precision lnew,Cube(nPar)
		end subroutine loglike
    	end INTERFACE
    	
	
	n = 0
    	id = my_rank
    	
	do
		n = n+1
		
	    	if(.not.eswitch) then
			!generate a random point inside unit hypercube
			call getrandom(ndims,pnew(1:ndims),id)
			phyPnew(1:ndims)=pnew(1:ndims)
			lnew=lowlike
	    		call loglike(phyPnew,ndims,totPar,lnew,context)
	    	else
			!generate a point uniformly inside the given ellipsoid
			call genPtInEll(ndims,mean,ekfac,TMat,id,pnew(1:ndims))
			spnew(:)=limits(:,1)+(limits(:,2)-limits(:,1))*pnew(:)
			do i=1,ndims
				if(pWrap(i)) then
					call wraparound(spnew(i),spnew(i))
				endif
			enddo
			if(.not.inprior(ndims,spnew(1:ndims))) cycle
			phyPnew(1:ndims)=spnew(1:ndims)
			lnew=lowlike
	    		call loglike(phyPnew,ndims,totPar,lnew,context)
	      	endif
		if(lnew>logZero) exit
	enddo
        
  end subroutine samp
  
  !----------------------------------------------------------------------
  
  subroutine ApplyLimits(flag,limits,pt,transpt)
  	
	implicit none
	
	!input parameters
	integer flag				!0 => given point in unit hypercube, apply the limits
						!1 => point to be transformed to unit hypercube, reverse the limits
	double precision limits(ndims,2)	!current limits
	double precision pt(ndims)		!point
	
	!output variables
	double precision transpt(ndims)		!final result
	
	
	if( flag == 0 ) then
		!apply the limits to point in unit hypercube
		transpt(:)=(pt(:)-limits(:,1))/(limits(:,2)-limits(:,1))
	elseif( flag == 1 ) then
		!reverse the limits such that the point is in unit hypercube
		transpt(:)=limits(:,1)+(limits(:,2)-limits(:,1))*pt(:)
	else
		write(*,*)'Incorrect value of flag passed to ApplyLimits'
		stop
	endif
	
  end subroutine ApplyLimits
  
  !----------------------------------------------------------------------
 
  subroutine selectEll(n,volx,sEll)
 	
      implicit none
      
      integer n!total no. of ellipsoids
      double precision volx(n)!no. points in each ellipsoid
      integer sEll!answer, the ellipsoid to sample from
      double precision volTree(n),totvol,urv
      integer i
 
 	totvol=0.d0
	volTree=0.d0
	do i=1,n
      		volTree(i)=totvol+volx(i)
            	totvol=volTree(i)
	enddo
	volTree=volTree/totvol
	urv=ranmarNS(0)
	do i=1,n
		if(urv<=volTree(i)) exit
	enddo
	sEll=i
  end subroutine selectEll
  
!----------------------------------------------------------------------
   
   !provide fback to the user
  subroutine gfeedback(logZ,IS,IS_Z,nlike,nacc,dswitch)
    
	implicit none
    	!input variables
    	double precision logZ !log-evidence
	logical IS !importance sampling being done?
	double precision IS_Z(2) !importance sampling log-evidence & its standard deviation
    	integer nlike !no. of likelihood evaluations
    	integer nacc !no. of accepted samples
	logical dswitch !dynamic live points
    
    	write(*,'(a,F14.6)')	     'Acceptance Rate:                  ',dble(nacc)/dble(nlike)
	write(*,'(a,i14)')   	     'Replacements:                     ',nacc
	write(*,'(a,i14)')   	     'Total Samples:                    ',nlike
	write(*,'(a,F14.6)')	     'Nested Sampling ln(Z):            ',logZ
	if( IS ) write(*,'(a,F14.6,a,F10.6)')'Importance Nested Sampling ln(Z): ',IS_Z(1), ' +/-', IS_Z(2)
	if(dswitch) write(*,'(a,i5)')'Total No. of Live Points:         ',nlive
    
  end subroutine gfeedback
  
!----------------------------------------------------------------------
 
 !isolate the modes
 logical function isolateModes2(npt,ndim,nCdim,pt,naux,aux,ic_n,ic_fnode,ic_npt,ic_reme,ic_chk,ic_vnow,reCluster,limits)
 	implicit none
	
	!input parameters
	integer npt !total no. of points
	integer ndim !dimensionality
	integer nCdim !clustering dimensionality
	double precision pt(nCdim,npt)
	integer naux !no. of dimensions of the aux array
	double precision aux(naux,npt)
	logical ic_chk(ic_n) !whether to check a node for mode separation
	double precision ic_vnow(ic_n) !prior volumes
	double precision limits(maxCls,nCdim,2) !physical parameter ranges
	
	!input/output parameters
	!mode info
	integer ic_n !input: no. of existing modes. output: updated no. of existing modes
	integer ic_fnode(maxCls),ic_npt(maxCls)
	logical ic_reme(maxCls)
	
	!output variables
	logical reCluster(maxCls)
	
	!work variables
	integer i,j,k,i1,j2,j3,j4,i2,i3,i4,i5,n,n1,n2,n_mode,npt_mode,m,nLost
	integer, allocatable :: order(:), nptx(:), nodex(:)
	double precision d1,d2,d4,ef0, ef1, ef2
	integer nN,sc_n
	logical, allocatable :: gList(:), lList(:), toBeChkd(:), overlapk(:,:)
	logical flag,intFlag
	double precision, allocatable :: ptk(:,:), auxk(:,:), ptx(:,:), auxx(:,:)
	double precision, allocatable :: mMean(:), lMean(:), mStdErr(:), lStdErr(:)
	double precision, allocatable :: mean1(:), mean2(:), mean1w(:), mean2w(:)
	double precision, allocatable :: eval1(:), evec1(:,:), invcov1(:,:), invcov2(:,:)
	logical, allocatable :: wrapEll(:), wrapDim(:,:,:)
	integer, allocatable :: wrapN(:)
	double precision, allocatable :: meanw(:,:),meank(:,:),evalk(:,:),eveck(:,:,:),invcovk(:,:,:),tmatk(:,:,:),kfack(:)
    integer ierror	
	
	allocate( order(nCdim), nptx(npt/(nCdim+1)+1), nodex(npt/(nCdim+1)+1) )
	allocate( gList(npt/(nCdim+1)+1), lList(npt/(nCdim+1)+1), toBeChkd(npt/(nCdim+1)+1), overlapk(npt/(nCdim+1)+1,npt/(nCdim+1)+1) )
	allocate( ptk(nCdim,npt), auxk(naux,npt), ptx(nCdim,npt), auxx(naux,npt), mMean(nCdim), lMean(nCdim), mStdErr(nCdim), &
	lStdErr(nCdim), mean1(nCdim), mean2(nCdim), mean1w(nCdim), mean2w(nCdim), eval1(nCdim), evec1(nCdim,nCdim), &
	invcov1(nCdim,nCdim), invcov2(nCdim,nCdim) )
	
	nN=ic_n
	isolateModes2=.false.
	reCluster=.false.
	
	i1=0 !no. of points traversed
	sc_n=0 !no. of clusters created so far
	
	do i=1,nN
		!enlargement factor
		ef0 = max( ( ic_vnow(i) * 100d0 / 111d0 ) + ( 11d0 / 111d0 ) , 0.8d0 )
	
		i3=ic_n
		
		if(ic_npt(i)==0) cycle
		
		if(.not.ic_chk(i)) then
			do j=1,nCdim
				ptk(j,i1+1:i1+ic_npt(i))=pt(j,i1+1:i1+ic_npt(i))
			enddo
			auxk(1:naux,i1+1:i1+ic_npt(i))=aux(1:naux,i1+1:i1+ic_npt(i))
			nptx(sc_n+1)=ic_npt(i)
			nodex(sc_n+1)=i
			i1=i1+ic_npt(i)
			sc_n=sc_n+1
			cycle
		endif
		
		nLost=0
		overlapk=.true.
		gList=.false.
		
		!cluster using G-means
		do j=1,nCdim
			d4=limits(i,j,2)-limits(i,j,1)
			ptk(j,i1+1:i1+ic_npt(i))=pt(j,i1+1:i1+ic_npt(i))
			
			if(pWrap(j)) then
				do i2=i1+1,i1+ic_npt(i)
					!scale to unit hypercube
					d2=limits(i,j,1)+d4*ptk(j,i2)
					
					call wraparound(d2,d1)
					
					!scale back to the limits
					if(d1 /= d2) ptk(j,i2)=(d1-limits(i,j,1))/d4
				enddo
			endif
		enddo
		
		auxk(1:naux,i1+1:i1+ic_npt(i))=aux(1:naux,i1+1:i1+ic_npt(i))
		n1=max(nCdim+1,3) !min no. of points allowed in a cluster
		n2=ic_npt(i)/n1+1 !max no. of clusters possible
		
		call doGmeans(ptk(1:nCdim,i1+1:i1+ic_npt(i)),ic_npt(i),nCdim,k,nptx(sc_n+1:sc_n+n2), &
		naux,auxk(:,i1+1:i1+ic_npt(i)),n1,n2)

		allocate(wrapN(k),wrapEll(k),wrapDim(k,nCdim,2),meank(k,nCdim),evalk(k,nCdim), &
		eveck(k,nCdim,nCdim),invcovk(k,nCdim,nCdim),tmatk(k,nCdim,nCdim),kfack(k),meanw(k,nCdim))
		wrapEll=.false.
		wrapDim=.false.
		
		nodex(sc_n+1:sc_n+k)=i

		!enclose sub-clusters in bounding ellipsoids
		n=i1
		wrapN=1
		do j=1,k
			call CalcBEllInfo(nptx(sc_n+j),nCdim,ptk(1:nCdim,n+1:n+nptx(sc_n+j)),meank(j,:), &
			evalk(j,:),eveck(j,:,:),invcovk(j,:,:),tmatk(j,:,:),kfack(j),n1)
			
			if(mWrap) then
				ef1=kfack(j)*max(2d0,((1.d0+ef0*sqrt(50.d0/dble(nptx(sc_n+j))))**(1d0/nCdim)))
				call wrapEllCheck(nCdim,meank(j,:),tmatk(j,:,:),ef1,limits(i,:,:), &
				wrapEll(j),wrapDim(j,:,:))
				
				!transform the mean to hypercube
				call Scaled2Cube(nCdim,limits(j,:,:),meank(j,:),meanw(j,:))
				
				if(wrapEll(j)) then
					do i2=1,nCdim
						if(wrapDim(j,i2,1)) then
							wrapN(j)=wrapN(j)+1
							meanw(j,i2)=1d0+meanw(j,i2)
						elseif(wrapDim(j,i2,2)) then
							wrapN(j)=wrapN(j)+1
							meanw(j,i2)=meanw(j,i2)-1d0
						endif
					enddo
				endif
				
				!scale the mean
				call Cube2Scaled(nCdim,limits(j,:,:),meanw(j,:),meanw(j,:))
			endif

			n=n+nptx(sc_n+j)
		enddo
		
		!calculate the standard error, required for localization
		if(.not.aWrap) then
			mMean=0.d0
			mStdErr=0.d0
			do j=i1+1,i1+ic_npt(i)
				mMean(:)=mMean(:)+ptk(:,j)
				mStdErr(:)=mStdErr(:)+ptk(:,j)**2
			enddo
			mMean=mMean/dble(ic_npt(i))
			mStdErr=mStdErr/dble(ic_npt(i))
			mStdErr=sqrt(mStdErr-mMean**2)
		endif
		
		do
			npt_mode=0
			lList=.false.
			toBeChkd=.false.
			n_mode=0 !no. of clusters in the mode
		
			!find a starting sub-cluster
			do j=1,k
				if(gList(j)) then
					cycle
				else
					n_mode=1
					npt_mode=nptx(sc_n+j)
					lList(j)=.true.
					gList(j)=.true.
					toBeChkd(j)=.true.
					m=j
					exit
				endif
			enddo
		
			!didn't find a starting position?
			if(n_mode==0) exit
			
			do
				flag=.false.
				do j=1,k
					if(.not.toBeChkd(j)) cycle
					flag=.true.
					toBeChkd(j)=.false.
					mean1(:)=meank(j,:)
					eval1(:)=evalk(j,:)
					ef1=kfack(j)*((1.d0+ef0*sqrt(60.d0/dble(nptx(sc_n+j))))**(1d0/nCdim))
					ef1=kfack(j)*1.5d0
					invcov1(:,:)=invcovk(j,:,:)
					evec1(:,:)=eveck(j,:,:)
					exit
				enddo
				
				if(.not.flag) exit
						
				do n=1,k
					if(lList(n) .or. n==j .or. .not.overlapk(n,j)) cycle
					mean2(:)=meank(n,:)
					ef2=kfack(n)*((1.d0+ef0*sqrt(60.d0/dble(nptx(sc_n+n))))**(1d0/nCdim))
					ef2=kfack(n)*1.5d0
					invcov2(:,:)=invcovk(n,:,:)
					
					intFlag=.false.
					
					if(mWrap .and. (wrapEll(j) .or. wrapEll(n))) then
						do i2=0,2**(wrapN(j)-1)-1
							call returnOrder(wrapN(j)-1,i2,order(1:wrapN(j)-1))
							
							i4=0
							do i5=1,nCdim
								if(wrapDim(j,i5,1) .or. wrapDim(j,i5,2)) then
									i4=i4+1
									if(order(i4)==0) then
										mean1w(i5)=meanw(j,i5)
									else
										mean1w(i5)=mean1(i5)
									endif
								else
									mean1w(i5)=mean1(i5)
								endif
							enddo
							
							
							do j2=0,2**(wrapN(n)-1)-1
								call returnOrder(wrapN(n)-1,j2,order(1:wrapN(n)-1))
								
								j4=0
								do j3=1,nCdim
									if(wrapDim(n,j3,1) .or. wrapDim(n,j3,2)) then
										j4=j4+1
										if(order(j4)==0) then
											mean2w(j3)=meanw(n,j3)
										else
											mean2w(j3)=mean2(j3)
										endif
									else
										mean2w(j3)=mean2(j3)
									endif
								enddo
							
								if(ellIntersect(nCdim,mean1w,mean2w,eval1,evec1,ef1,ef2,invcov1,invcov2)) then
									intFlag=.true.
									exit
								endif
							enddo
							
							if(intFlag) exit
						enddo
					elseif(ellIntersect(nCdim,mean1,mean2,eval1,evec1,ef1,ef2,invcov1,invcov2)) then
						intFlag=.true.
					endif
					
					if(intFlag) then
						lList(n)=.true.
						gList(n)=.true.
						toBeChkd(n)=.true.
						n_mode=n_mode+1
						npt_mode=npt_mode+nptx(sc_n+n)
					else
						overlapk(n,j)=.false.
						overlapk(j,n)=.false.
					endif
				enddo
			enddo
			
			!found a candidate?
			if((n_mode<k .or. ic_reme(i)) .and. npt_mode>=2*(ndim+1) .and. ((ic_npt(i)-npt_mode)>=2*(ndim+1) &
			.or. (ic_reme(i) .and. ic_npt(i)-npt_mode==0))) then
				flag=.true.
			else
				flag=.false.
			endif

			!now check for localization in ndim parameters
			!calculate the standard error
			if(flag .and. n_mode<k .and. npt_mode<ic_npt(i) .and. .not.aWrap) then
				n=i1
				lMean=0.d0
				lStdErr=0.d0
				do j=sc_n+1,sc_n+k
					if(lList(j)) then
						do i2=n+1,n+nptx(j)
							lMean(:)=lMean(:)+ptk(:,i2)
							lStdErr(:)=lStdErr(:)+ptk(:,i2)**2
						enddo
					endif
					n=n+nptx(j)
				enddo
				lMean=lMean/dble(npt_mode)
				lStdErr=lStdErr/dble(npt_mode)
				lStdErr=sqrt(lStdErr-lMean**2)
				
				do j=1,nCdim
					if(lStdErr(j)<mStdErr(j)) exit
					if(j==nCdim) flag=.false.
				enddo
			endif
			
			if(flag) then
				nLost=nLost+npt_mode
				ic_n=ic_n+1
				if(ic_n>maxCls) then
					write(*,*)"ERROR: More modes found than allowed memory."
					write(*,*)"Increase maxmodes in the call to nestrun and run MultiNest again."
					write(*,*)"Aborting"
#ifdef MPI
					call MPI_ABORT(MPI_COMM_WORLD,errcode,ierror)
#endif
                        		stop
				endif
				ic_fnode(ic_n)=i
				ic_reme(ic_n)=.false.
				ic_reme(i)=.true.
				isolateModes2=.true.
				reCluster(i)=.true.
				reCluster(ic_n)=.true.
				do j=1,k
					if(lList(j)) nodex(sc_n+j)=ic_n
				enddo
			endif
		enddo
		
		!make the leftover points into a new node
		if(ic_reme(i) .and. ic_npt(i)-nLost>=ndim+1 .and. .false.) then
			ic_n=ic_n+1
			ic_fnode(ic_n)=i
			ic_reme(ic_n)=.false.
			reCluster(ic_n)=.true.
			do j=1,k
				if(nodex(sc_n+j)==i) nodex(sc_n+j)=ic_n
			enddo
		endif
		
		if(ic_n==i3) then
			do j=1,nCdim
				ptk(j,i1+1:i1+ic_npt(i))=pt(j,i1+1:i1+ic_npt(i))
			enddo
			auxk(1:naux,i1+1:i1+ic_npt(i))=aux(1:naux,i1+1:i1+ic_npt(i))
		endif
		
		i1=i1+ic_npt(i)
		sc_n=sc_n+k
		deallocate(wrapN,wrapEll,wrapDim,meank,evalk,eveck,invcovk,tmatk,kfack,meanw)
	enddo
	
	!if modes found then re-arrange everything
	if(isolateModes2) then
		i1=0 !no. of points re-arranged
		do i=1,ic_n
			ic_npt(i)=0
			k=0 !no. of points traversed
			do j=1,sc_n
				if(nodex(j)==i) then
					!arrange the points
					do i2=1,nCdim
						ptx(i2,i1+1:i1+nptx(j))=ptk(i2,k+1:k+nptx(j))
					enddo
					auxx(1:naux,i1+1:i1+nptx(j))=auxk(1:naux,k+1:k+nptx(j))
					i1=i1+nptx(j)
					ic_npt(i)=ic_npt(i)+nptx(j)
				endif
				k=k+nptx(j)
			enddo
		enddo
		pt=ptx
		aux=auxx
	endif
	
	deallocate( order, nptx, nodex )
	deallocate( gList, lList, toBeChkd, overlapk )
	deallocate( ptk, auxk, ptx, auxx, mMean, lMean, mStdErr, lStdErr, mean1, mean2, mean1w, &
	mean2w, eval1, evec1, invcov1, invcov2 )
 
 end function isolateModes2
  
!----------------------------------------------------------------------

 subroutine setLimits(multimodal,ndim,nCdim,llimits,plimits,pnew,phyPnew,climits)
 
 	implicit none
	
	!input variables
	logical multimodal !set clustering limits?
	integer ndim !dimensionality
	integer nCdim !clustering dimension
	double precision pnew(ndim) !new point
	double precision phyPnew(nCdim) !new physical point
	double precision climits(ndim,2) !current scaling limits
	
	!input/output variables
	double precision llimits(ndim,2) !current limits
	double precision plimits(nCdim,2) !current clustering limits
	
	!work variables
	integer i
	double precision pt(ndim)
	
	
	!first scale the point
	do i=1,ndim
		pt(i)=climits(i,1)+(climits(i,2)-climits(i,1))*pnew(i)
		
		!wraparound
		if(pWrap(i)) call wraparound(pt(i),pt(i))
	enddo
					
	do i=1,ndim
		if(pt(i)<llimits(i,1)) then
			llimits(i,1)=pt(i)
		elseif(pt(i)>llimits(i,2)) then
			llimits(i,2)=pt(i)
		endif
	enddo
	
	if(multimodal) then
		do i=1,nCdim
			if(phyPnew(i)<plimits(i,1)) then
				plimits(i,1)=phyPnew(i)
			elseif(phyPnew(i)>plimits(i,2)) then
				plimits(i,2)=phyPnew(i)
			endif
		enddo
	endif
 
 end subroutine setLimits
  
!----------------------------------------------------------------------

 subroutine wraparound(oPt,wPt)
 	
	implicit none
	double precision oPt !actual point
	double precision wPt !wrapped-around point
	
	wPt=oPt
	do
		if(wPt<0.d0 .or. wPt>1.d0) then
			wPt=wPt-floor(wPt)
		else
			exit
		endif
	enddo
	
 end subroutine wraparound
  
!----------------------------------------------------------------------

 subroutine wrapEllCheck(ndim,mean,TMat,ef,limits,wrapEll,wrapDim)
 	
	implicit none
	
	!input variables
	integer ndim !dimensionality
	double precision mean(ndim)
	double precision TMat (ndim,ndim) !transformation matrix
	double precision ef !enlargement factor
	double precision limits(ndim,2) !current scale limits
	
	!output variable
	logical wrapEll
	logical wrapDim(ndim,2) !which dimensions in which directions to wrap
	
	!work variable
	integer i,j,k
	double precision cubeEdge(ndim),sCubeEdge
	double precision pnewM(1,ndim),u(1,ndim)
	
	
	wrapEll=.false.
	wrapDim=.false.
	
	!loop over the principle directions
	do i=1,ndim
		!loop over the two edges
		do k=1,2
			u(1,:)=0d0
			if(k==1) then
				u(1,i)=1d0
			else
				u(1,i)=-1d0
			endif
				
			pnewM=MatMul(u,TMat)
			cubeEdge(:)=sqrt(ef)*pnewM(1,:)+mean(:)
		
			!loop over dimensions
			do j=1,ndim
				if(pWrap(j) .and. (.not.wrapDim(j,1) .or. .not.wrapDim(j,2))) then
					!transform back to unit hypercube
					sCubeEdge=limits(j,1)+(limits(j,2)-limits(j,1))*cubeEdge(j)
				
					if(sCubeEdge<0d0) then
						wrapDim(j,1)=.true.
						wrapEll=.true.
					endif
					if(sCubeEdge>1d0) then
						wrapDim(j,2)=.true.
						wrapEll=.true.
					endif
				endif
			enddo
		enddo
	enddo
	
	!sanity check
	!no wraparound if both edges are outside the hyper cube boundary
	if(wrapEll) then
		wrapEll=.false.
		do i=1,ndim
			if(wrapDim(i,1) .and. wrapDim(i,2)) then
				wrapDim(i,1)=.false.
				wrapDim(i,2)=.false.
			else
				wrapEll=.true.
			endif
		enddo
	endif
	
	
 end subroutine wrapEllCheck
  
!----------------------------------------------------------------------

 subroutine scaled2Cube(ndim,limits,sP,cP)
 
 	implicit none
	
	!input variables
	integer ndim
	double precision limits(ndim,2) !current limits
	double precision sP(ndim) !scaled point
	
	!output variable
	double precision cP(ndim) !point in unit hypercube
	
	!work variables
	integer i
	
	
	do i=1,ndim
		cP(i)=limits(i,1)+(limits(i,2)-limits(i,1))*sP(i)
	enddo
 
 end subroutine scaled2Cube
  
!----------------------------------------------------------------------

 subroutine Cube2Scaled(ndim,limits,sP,cP)
 
 	implicit none
	
	!input variables
	integer ndim
	double precision limits(ndim,2) !current limits
	double precision sP(ndim) !scaled point
	
	!output variable
	double precision cP(ndim) !point in unit hypercube
	
	!work variables
	integer i
	
	
	do i=1,ndim
		sP(i)=(cP(i)-limits(i,1))/(limits(i,2)-limits(i,1))
	enddo
 
 end subroutine Cube2Scaled
  
!----------------------------------------------------------------------

 subroutine returnOrder(nBits,n,order)
 
 	implicit none
	
	!input variables
	integer nBits !no. of bits
	integer n !number under consideration
	
	!output variable
	integer order(nBits) !list with the order
	
	!work variables
	integer i,j
	
	
	order=0
	
	do i=1,nBits
		j=2**(i-1)
		if(mod(n/j,2)==0) then
			order(i)=0
		else
			order(i)=1
		endif
	enddo
 
 end subroutine returnOrder
 
!----------------------------------------------------------------------
 
 subroutine ExtendArrayIfRequired(n1,n2,n3,n4,n5,array)
 
 	implicit none
	
	!input variables
	integer n1					!number of rows stored
	integer n2					!additional rows to be stored
	integer n3					!max rows that can be stored
	integer n4					!no. of rows to be added if required
	integer n5					!no. of columns
	
	!output variables
	double precision, allocatable :: array(:,:)	!array
	
	!work variables
	integer i
	double precision, allocatable :: temp(:,:)
	
	
	if( n2 == 0 ) return
	
	if( n1+n2 > n3 ) then
		allocate(temp(n3,n5))
		temp = array
		deallocate(array)
		allocate(array(n1+max(n2,n4),n5))
		array = 0d0
		do i = 1, n1
			array(i,:) = temp(i,:)
		enddo
		deallocate(temp)
		
		n3 = n1+max(n2,n4)
	endif
 
 end subroutine ExtendArrayIfRequired
  
!----------------------------------------------------------------------
 
 !check if node1 is ancestor of node2
 logical function isAncestor(node1, node2, fnode)
 
 	implicit none
	
	!input variables
	integer node1			!ancestor node to be checked
	integer node2			!child node to be checked
	integer fnode(node2)		!array with parent nodes
	
	!work variables
	integer i, n2
	
	isAncestor = .false.
	if( node1 > node2 ) return
	
	if( node1 == 1 ) then
		isAncestor = .true.
		return
	endif
	
	n2 = node2
	do
		if( n2 == node1 ) then
			isAncestor = .true.
			return
		else
			n2 = fnode(n2)
			if( node1 > n2 ) return
		endif
	enddo
 
 end function isAncestor
  
!----------------------------------------------------------------------

end module Nested

module like
	
use params
use utils1
implicit none
      
contains
      
      
!=======================================================================

subroutine slikelihood(Cube,slhood)
         
	implicit none
      
	double precision Cube(nest_nPar),slhood
	double precision temp(sdim),dist,loclik
	integer i,j
	double precision TwoPi
         
	TwoPi=6.2831853

	slhood=-huge(1.d0)*epsilon(1.d0)
	
	!rescaling the parameters in unit hypercube according to the prior
	do i=1,sdim
		temp(i)=(spriorran(i,2)-spriorran(i,1))*Cube(i)+spriorran(i,1)
	end do
	Cube(1:sdim)=temp(1:sdim)

	do i=1,sModes
		dist=(sqrt(sum((temp(1:sdim)-sc(i,1:sdim))**2.))-sr(i))**2
		loclik=-dist/(2.*(sw(i)**2.))-log(TwoPi*sw(i)**2)/2.
		slhood=logSumExp(slhood,loclik)
	end do

end subroutine slikelihood
      
!=======================================================================

end module like

! iso_c_binding interface for MultiNest_v3.3 Nested::nestRun
! Michele Vallisneri, 2013/09/20
!
! allows calling multinest with the "natural" C prototype
!
! void run(bool nest_IS,bool nest_mmodal,bool nest_ceff, \
!          int nest_nlive,double nest_tol,double nest_ef,int nest_ndims,int nest_totPar,int nest_nCdims,int maxClst, \
!          int nest_updInt,double nest_Ztol,char nest_root[],int seed,int nest_pWrap[], \
!          bool nest_fb,bool nest_resume,bool nest_outfile,bool initMPI,double nest_logZero,int nest_maxIter, \
!          double (*loglike)(double *,int,int,void *context), \
!          void (*dumper)(int,int,int,double *,double *,double *,double,double,double,void *context),void *context);
!
! as well as
!
! double loglike(double *Cube,int n_dim,int nPar,void *context);
! void dumper(int nSamples,int nlive,int nPar, \
!             double *physLive,double *posterior,double *paramConstr, \
!             double maxLogLike,double logZ,double logZerr,void *context);
!
! note that we are assuming that (void *) is the same size as int, but that's what multinest uses

module cnested
	
	contains
	
	subroutine run(nest_IS,nest_mmodal,nest_ceff,nest_nlive,nest_tol,nest_ef,nest_ndims,nest_totPar,nest_nCdims,maxClst, &
	nest_updInt,nest_Ztol,nest_root,seed,nest_pWrap,nest_fb,nest_resume,nest_outfile,initMPI,nest_logZero,nest_maxIter, &
	loglike,dumper,context) bind(c)

	use iso_c_binding, only: c_int, c_bool, c_double, c_char, c_funptr, c_ptr, C_NULL_CHAR
	use Nested, only: nestRun
	use utils1, only: root_max_len
	implicit none

	integer(c_int),  intent(in), value :: nest_ndims,nest_nlive,nest_updInt,seed
	integer(c_int),  intent(in), value :: maxClst,nest_totPar,nest_nCdims,nest_maxIter
	integer(c_int),  intent(in) :: nest_pWrap(nest_ndims)
	logical(c_bool), intent(in), value :: nest_IS,nest_mmodal,nest_fb,nest_resume,nest_ceff,nest_outfile,initMPI
	character(kind=c_char,len=1), dimension(1), intent(in) :: nest_root
	real(c_double),  intent(in), value :: nest_tol,nest_ef,nest_Ztol,nest_logZero
	type(c_funptr),  intent(in), value :: loglike, dumper
	type(c_ptr),     intent(in) :: context

	character(len=root_max_len) :: fnest_root
	integer :: i, context_f

	fnest_root = ' '
	do i = 1, root_max_len
		if (nest_root(i) == C_NULL_CHAR) then
			exit
		else
			fnest_root(i:i) = nest_root(i)
		end if
	end do

	! context_f = transfer(context,context_f)

	call nestRun(logical(nest_IS),logical(nest_mmodal),logical(nest_ceff), &
	nest_nlive,nest_tol,nest_ef,nest_ndims,nest_totPar,nest_nCdims,maxClst, &
	nest_updInt,nest_Ztol,fnest_root,seed,nest_pWrap, &
	logical(nest_fb),logical(nest_resume),logical(nest_outfile),logical(initMPI),nest_logZero,nest_maxIter, &
	loglike_f,dumper_f,context_f)

	
	contains

	subroutine loglike_f(Cube,n_dim,nPar,lnew,context_pass)
	use iso_c_binding, only: c_double, c_f_procpointer
	  
	implicit none

	integer          :: n_dim,nPar,context_pass
	double precision :: Cube(nPar)
	double precision :: lnew

	interface
		real(c_double) function loglike_proto(Cube,n_dim,nPar,context)
		use iso_c_binding, only: c_int, c_double, c_ptr
		
		implicit none

		integer(c_int), intent(in), value :: n_dim,nPar
		real(c_double), intent(inout)     :: Cube(nPar)
		integer(c_int), intent(in) :: context
		! better, but "transfer" is problematic:
		! type(c_ptr),  intent(in) :: context
		
		end function loglike_proto
	end interface

	procedure(loglike_proto), pointer :: loglike_c
	call c_f_procpointer(loglike,loglike_c)

	! type(c_ptr) :: context_c
	! context_c = transfer(context_pass,context_c)

	lnew = loglike_c(Cube,n_dim,nPar,context_pass)

	end subroutine loglike_f

	subroutine dumper_f(nSamples,nlive,nPar,physLive,posterior,paramConstr,maxLogLike,logZ,INSlogZ,logZerr,context_pass)
	use iso_c_binding, only: c_double, c_f_procpointer
	  
	implicit none

	integer          :: nSamples, nlive, nPar, context_pass
	double precision, pointer :: physLive(:,:), posterior(:,:), paramConstr(:)
	double precision :: maxLogLike, logZ, INSlogZ, logZerr

	interface
		subroutine dumper_proto(nSamples,nlive,nPar,physLive,posterior,paramConstr,maxLogLike,logZ,INSlogZ,logZerr,context)
		use iso_c_binding, only: c_int, c_double, c_ptr
	      
		implicit none

		integer(c_int), intent(in), value :: nSamples, nlive, nPar
		real(c_double), intent(in) :: physLive(nlive,nPar+1), posterior(nSamples,nPar+2),paramConstr(4*nPar)
		real(c_double), intent(in), value :: maxLogLike, logZ, logZerr, INSlogZ
		integer(c_int), intent(in), value :: context
		! better, but "transfer" is problematic:
		! type(c_ptr),  intent(in) :: context
		
		end subroutine dumper_proto
	end interface

	procedure(dumper_proto), pointer :: dumper_c
	call c_f_procpointer(dumper,dumper_c)

	! type(c_ptr) :: context_c
	! context_c = transfer(context_pass,context_c)

	call dumper_c(nSamples,nlive,nPar,physLive,posterior,paramConstr,maxLogLike,logZ,INSlogZ, logZerr,context_pass)

	end subroutine dumper_f

	end subroutine

end module

module ini_module
    use utils_module, only: dp


  implicit none

  character(len=2), parameter :: comment='#!'
  character(len=2), parameter :: equals='=:'
  character(len=1), parameter :: section_start='['
  character(len=1), parameter :: section_end=']'

contains


    subroutine initialise_program(settings,priors,params,derived_params)
        use priors_module, only: create_priors,prior
        use settings_module,   only: program_settings,initialise_settings
        use params_module, only: param_type
        use read_write_module, only: write_paramnames_file
        implicit none
        
        type(program_settings),intent(inout)            :: settings  !> Program settings
        type(prior),dimension(:),allocatable,intent(out):: priors

        type(param_type),dimension(:),allocatable,intent(in) :: params         ! Parameter array
        type(param_type),dimension(:),allocatable,intent(in) :: derived_params ! Derived parameter array

        settings%nDims = size(params)
        settings%nDerived = size(derived_params)

        if(settings%write_paramnames.and.(settings%equals.or.settings%posteriors)) call write_paramnames_file(settings,params,derived_params)

        call create_priors(priors,params,settings)

        ! Calculate all of the rest of the settings
        call initialise_settings(settings)   

    end subroutine initialise_program





    subroutine read_params(file_name,settings,params,derived_params)
        use settings_module,   only: program_settings
        use params_module, only: param_type
        implicit none
        
        character(len=*)                    :: file_name !> The name of the file
        type(program_settings),intent(out)  :: settings  !> Program settings

        type(param_type),dimension(:),allocatable,intent(out) :: params         ! Parameter array
        type(param_type),dimension(:),allocatable,intent(out) :: derived_params ! Derived parameter array


        settings%nlive              = get_integer(file_name,'nlive')
        settings%num_repeats        = get_integer(file_name,'num_repeats')
        settings%nprior             = get_integer(file_name,'nprior',-1)
        settings%do_clustering      = get_logical(file_name,'do_clustering',.false.)
        settings%feedback           = get_integer(file_name,'feedback',1)
        settings%precision_criterion= get_double(file_name,'precision_criterion',1d-3)
        settings%logzero            = get_double(file_name,'logzero',-1d30)
        settings%max_ndead          = get_integer(file_name,'max_ndead',-1)
        settings%boost_posterior    = get_double(file_name,'boost_posterior',0d0)
        settings%posteriors         = get_logical(file_name,'posteriors',.false.)
        settings%equals             = get_logical(file_name,'equals',.false.)
        settings%cluster_posteriors = get_logical(file_name,'cluster_posteriors',.false.)
        settings%write_resume       = get_logical(file_name,'write_resume',.false.)
        settings%write_paramnames   = get_logical(file_name,'write_paramnames',.false.)
        settings%read_resume        = get_logical(file_name,'read_resume',.false.)
        settings%write_stats        = get_logical(file_name,'write_stats',.true.)
        settings%write_live         = get_logical(file_name,'write_live',.false.)
        settings%write_dead         = get_logical(file_name,'write_dead',.true.)
        settings%write_prior        = get_logical(file_name,'write_prior',.false.)
        settings%compression_factor = get_double(file_name,'compression_factor',exp(-1d0))
        settings%base_dir           = get_string(file_name,'base_dir','chains')
        settings%file_root          = get_string(file_name,'file_root','test')
        settings%seed               = get_integer(file_name,'seed', -1)

        settings%generate_from_seed = get_logical(file_name,'generate_from_seed',.false.)
        settings%nprior_repeat      = get_integer(file_name,'nprior_repeat',-1)
        call get_doubles(file_name,'seed_point',settings%seed_point)

        call get_doubles(file_name,'grade_frac',settings%grade_frac)
        call get_integers(file_name,'nlives',settings%nlives)
        call get_doubles(file_name,'loglikes',settings%loglikes)

        call get_params(file_name,params,derived_params)  

        settings%nDims         = size(params)
        settings%nDerived      = size(derived_params)

    end subroutine read_params


    function default_params(nDims,root,latex)
        use priors_module, only: uniform_type
        use params_module, only: param_type,add_parameter
        implicit none
        integer, intent(in) :: nDims
        type(param_type),dimension(:),allocatable :: default_params

        integer :: i
        character(len=*) :: root
        character(len=*) :: latex
        character(len=500) :: i_string
        character(len=500) :: paramname
        character(len=500) :: latex_paramname

        allocate(default_params(0))

        do i=1,nDims
            write(i_string, '(I20)') i
            paramname = trim(adjustl(root))//trim(adjustl(i_string))
            latex_paramname = trim(adjustl(latex))//'_{'//trim(adjustl(i_string))//'}'
            call add_parameter(default_params,trim(adjustl(paramname)),trim(adjustl(latex_paramname)),1,uniform_type,1,[ 0d0 , 1d0 ])
        end do

    end function default_params



    function get_string(file_name,key_word,dflt,ith)
        use utils_module,  only: STR_LENGTH,params_unit
        use abort_module,  only: halt_program
        implicit none
        character(len=*),intent(in)  :: file_name !> The name of the file to search in
        character(len=*),intent(in)  :: key_word  !> keyword to search for
        character(len=*),intent(in),optional  :: dflt  !> keyword to search for
        integer,intent(in), optional :: ith       !> Get the ith instance of this string

        character(len=STR_LENGTH) :: get_string  ! string following keyword

        character(len=STR_LENGTH) :: keyword    !> keyword to search for
        character(len=STR_LENGTH) :: filename   ! The fortran readable filename

        character(len=STR_LENGTH)                :: line_buffer     ! Line buffer

        integer :: io_stat   ! check to see if we've reached the end of the file

        integer :: i_equals ! placement of equals signs
        integer :: counter



        ! Convert filename to something fortran can read
        write(filename,'(A)') file_name
        open(unit=params_unit,file=trim(filename),iostat=io_stat)
        if(io_stat/=0) call halt_program('ini error: '//trim(file_name)//' does not exist')
        write(keyword,'(A)') key_word

        get_string = ''

        counter=1

        do 
            ! Read in the next line
            read(params_unit,'(A)',iostat=io_stat) line_buffer
            ! Exit if io_stat is less than zero
            if (io_stat < 0) exit

            ! Skip any comment lines
            if( scan(line_buffer,comment) /=0 ) cycle

            ! Search for equals signs
            i_equals = scan(line_buffer,equals)
            if(i_equals==0) cycle

            ! check to see if this matches our keyword
            if( trim(adjustl(line_buffer(:i_equals-1))) == trim(adjustl(keyword)) ) then


                if(present(ith)) then
                    
                    if(counter==ith) then
                        get_string = adjustl(line_buffer(i_equals+1:))
                        exit
                    else
                        counter=counter+1
                    end if
                else
                    get_string = adjustl(line_buffer(i_equals+1:))
                    exit
                end if

            end if

        end do

        if(trim(get_string)==''.and. present(dflt)) get_string=trim(dflt)

        ! close the file
        close(params_unit)


    end function get_string

    function get_double(file_name,key_word,dflt)
        use utils_module,  only: STR_LENGTH
        use abort_module,  only: halt_program
        character(len=*),intent(in)  :: file_name !> The name of the file to search in
        character(len=*),intent(in)  :: key_word  !> keyword to search for
        real(dp),intent(in),optional :: dflt

        character(len=STR_LENGTH) :: string  ! string following keyword
        real(dp) :: get_double  ! double following keyword

        string = get_string(file_name,key_word)
        if(trim(string)/='') then
            read(string,*) get_double
        else if(present(dflt)) then
            get_double = dflt
        else
            call halt_program('ini error: no keyword '//trim(key_word))
        end if

    end function get_double

    subroutine get_doubles(file_name,key_word,doubles)
        use utils_module,  only: STR_LENGTH
        use array_module,  only: reallocate
        character(len=*),intent(in)  :: file_name !> The name of the file to search in
        character(len=*),intent(in)  :: key_word  !> keyword to search for
        real(dp), intent(out), allocatable, dimension(:) :: doubles

        character(len=STR_LENGTH) :: string  ! string following keyword

        integer :: i

        ! Allocate a zero size array
        if(allocated(doubles)) deallocate(doubles)
        allocate(doubles(0))

        ! Get the string
        string = get_string(file_name,key_word)

        do while( trim(string)/='' )
            i=size(doubles)+1
            call reallocate(doubles,i)
            read(string,*) doubles(i)
            call next_element(string,' ')
        end do

    end subroutine get_doubles

    subroutine get_integers(file_name,key_word,integers)
        use utils_module,  only: STR_LENGTH
        use array_module,  only: reallocate
        character(len=*),intent(in)  :: file_name !> The name of the file to search in
        character(len=*),intent(in)  :: key_word  !> keyword to search for
        integer, intent(out), allocatable, dimension(:) :: integers

        character(len=STR_LENGTH) :: string  ! string following keyword

        integer :: i

        ! Allocate a zero size array
        if(allocated(integers)) deallocate(integers)
        allocate(integers(0))

        ! Get the string
        string = get_string(file_name,key_word)

        do while( trim(string)/='' )
            i=size(integers)+1
            call reallocate(integers,i)
            read(string,*) integers(i)
            call next_element(string,' ')
        end do

    end subroutine get_integers

    function get_integer(file_name,key_word,dflt)
        use utils_module,  only: STR_LENGTH
        use abort_module,  only: halt_program
        character(len=*),intent(in)  :: file_name !> The name of the file to search in
        character(len=*),intent(in)  :: key_word  !> keyword to search for
        integer,intent(in),optional :: dflt

        character(len=STR_LENGTH) :: string  ! string following keyword
        integer :: get_integer  ! integer following keyword

        if(present(dflt)) get_integer=dflt

        string = get_string(file_name,key_word)
        if(trim(string)/='') then
            read(string,*) get_integer
        else if(present(dflt)) then
            get_integer = dflt
        else
            call halt_program('ini error: no keyword '//trim(key_word))
        end if

    end function get_integer

    function get_logical(file_name,key_word,dflt)
        use utils_module,  only: STR_LENGTH
        use abort_module,  only: halt_program
        character(len=*),intent(in)  :: file_name !> The name of the file to search in
        character(len=*),intent(in)  :: key_word  !> keyword to search for
        logical,intent(in),optional :: dflt

        character(len=STR_LENGTH) :: string  ! string following keyword
        logical :: get_logical  ! logical following keyword

        string = get_string(file_name,key_word)
        if(trim(string)/='') then
            read(string,*) get_logical
        else if(present(dflt)) then
            get_logical = dflt
        else
            call halt_program('ini error: no keyword '//trim(key_word))
        end if

    end function get_logical















    subroutine get_params(file_name,params,derived_params) 
        use priors_module, only: prior_type_from_string,unknown_type
        use utils_module,  only: STR_LENGTH
        use abort_module,  only: halt_program
        use params_module, only: param_type,add_parameter
        implicit none
        
        character(len=*),intent(in)               :: file_name !> The name of the file
        type(param_type),dimension(:),allocatable,intent(out) :: params         ! Parameter array
        type(param_type),dimension(:),allocatable,intent(out) :: derived_params ! Derived parameter array

        
        character(len=STR_LENGTH)                :: line_buffer     ! Line buffer
        character(len=STR_LENGTH)                :: paramname       ! parameter name
        character(len=STR_LENGTH)                :: latex           ! latex name
        integer                                  :: speed           ! parameter speed
        character(len=STR_LENGTH)                :: prior_type_str  ! prior type string
        integer                                  :: prior_type      ! prior type integer
        integer                                  :: prior_block     ! prior block
        real(dp),allocatable,dimension(:):: prior_params    ! prior parameters

        integer                                  :: sub_cluster     ! whether or not to do sub clustering on this parameter
        character(1),parameter                   :: sc='*'          ! indicator for sub clustering


        integer :: i_param

        allocate(params(0),derived_params(0))

        i_param = 1
        do 
            line_buffer = get_string(file_name,'P',ith=i_param)
            if(trim(line_buffer)=='') exit
            i_param=i_param+1

            !1) Parameter name
            read(line_buffer,*) paramname !read in string
            sub_cluster = index(paramname,sc)
            if(sub_cluster>0) then
                paramname=trim(paramname(:sub_cluster-1))
            else
                paramname=trim(paramname)     !trim string
            end if


            !2) Latex name
            call next_element(line_buffer,'|') ! advance
            read(line_buffer,*) latex          ! read in string
            latex=trim(latex)                  ! trim string


            !3) Parameter speed/grade
            call next_element(line_buffer,'|') ! advance
            read(line_buffer,*) speed          ! read in integer


            !4) Prior type
            call next_element(line_buffer,'|')                     ! advance
            read(line_buffer,*) prior_type_str                     ! read in string
            prior_type = prior_type_from_string(prior_type_str)    ! convert to integer

            ! Halt if we don't know this prior type
            if(prior_type==unknown_type) call halt_program('get_priors error: Unknown prior type for parameter '//trim(paramname)) 

            !5) Prior block
            call next_element(line_buffer,'|') ! advance
            read(line_buffer,*) prior_block    ! read in integer


            call next_element(line_buffer,'|')              ! advance
            call get_prior_params(prior_params,line_buffer) ! get the prior params

            ! Add this parameter to the array
            if(sub_cluster==0) then
                call add_parameter(params,paramname,latex,speed,prior_type,prior_block,prior_params) 
            else
                call add_parameter(params,paramname,latex,speed,prior_type,prior_block,prior_params,.true.) 
            end if

        end do

        i_param = 1
        do 
            line_buffer = get_string(file_name,'D',ith=i_param)
            if(line_buffer=='') exit
            i_param=i_param+1

            !1) Parameter name
            read(line_buffer,*) paramname !read in string
            paramname=trim(paramname)     !trim string


            !2) Latex name
            call next_element(line_buffer,'|') ! advance
            read(line_buffer,*) latex          ! read in string
            latex=trim(latex)                  ! trim string

            deallocate(prior_params)
            allocate(prior_params(0))

            ! Add this parameter to the array
            call add_parameter(derived_params,paramname,latex,0,0,0,prior_params) 
        end do

    end subroutine get_params



    subroutine next_element(line_buffer,delimiter) 
        use utils_module,  only: STR_LENGTH
        implicit none
        character(len=STR_LENGTH),intent(inout)  :: line_buffer ! Line buffer
        character :: delimiter

        line_buffer = trim(line_buffer(scan(line_buffer,delimiter)+1:)) ! Find the next element
    end subroutine next_element

    subroutine get_prior_params(prior_params,line_buffer)
        use utils_module,  only: STR_LENGTH
        implicit none
        character(len=STR_LENGTH),intent(inout)               :: line_buffer ! Line buffer
        real(dp),allocatable,dimension(:),intent(out) :: prior_params      ! prior parameters
        real(dp),allocatable,dimension(:)             :: temp_params       ! prior parameters

        integer :: i

        ! deallocate it if it's already allocated
        if(allocated(prior_params)) deallocate(prior_params)
        if(allocated(temp_params)) deallocate(temp_params)

        ! Trim leading spaces
        line_buffer = adjustl(line_buffer)

        ! If it's an empty string, then allocate a zero-length array
        allocate(prior_params(0),temp_params(0)) 
        i=0

        do while(trim(line_buffer)/='') 

            deallocate(temp_params)
            allocate(temp_params(i))
            temp_params = prior_params

            deallocate(prior_params)
            allocate(prior_params(i+1))
            prior_params(:i) = temp_params

            read(line_buffer,*) prior_params(i+1)

            call next_element(line_buffer,' ')
            line_buffer = adjustl(line_buffer)
            i=i+1

        end do

    end subroutine get_prior_params








    function split_string(string,separator)
        implicit none
        character(len=*),intent(in) :: string
        character(1),intent(in) :: separator
        character(len=len(string)), dimension(:), allocatable :: split_string

        character(len=len(string)), dimension(:), allocatable :: temp_split_string

        integer :: i,j,k


        allocate(split_string(0))
        temp_split_string = split_string
        i = 0
        k = 0
        do 
            j = index(string(i+1:),separator)
            if(trim(adjustl(string(i+1:i+j)))=='') exit

            k = k+1 
            deallocate(split_string)
            allocate(split_string(k))
            split_string(:k-1) = temp_split_string
            deallocate(temp_split_string)
            split_string(k) = trim(adjustl(string(i+1:i+j))) 
            temp_split_string = split_string

            i = i+j
        end do

    end function split_string



 
end module ini_module

 module RandomNS
    double precision, dimension(:), allocatable :: C, CD, CM, GSET
    double precision, dimension(:, :), allocatable :: U
    integer, dimension(:), allocatable :: I97, J97, ISET
    integer numNodes

 contains

    subroutine initRandomNS(n, i)
       implicit none
       integer n !no. of nodes
       integer, optional, intent(IN) :: i
       integer kl, ij, k
       integer, dimension(8) :: now
       real :: klr

       !sanity  check
       if (n <= 0) then
          write (*, *) 'you have asked for ', n, 'nodes'
          stop
       endif

       numNodes = n

       !memory allocation
       allocate (C(n), CD(n), CM(n), U(n, 97), I97(n), J97(n), ISET(n), GSET(n))

       ISET = 0

       do k = 1, n
          if (present(i)) then
             kl = 9373
             ij = (i + (k - 1))*45
          else
             call system_clock(count=ij)
             ij = mod(ij, 31328) + (k - 1)*45
             call date_and_time(VALUES = now)
             ! The following could be simplified using all integer arithmetic.
             ! The current implementation is designed to obtain the same rounding
             ! behavior of the earlier implementation, which read the time into
             ! a character array and parsed it with the 'read' statement.
             klr = ((now(5) * 10) + now(6)) * 10 + now(7) + now(8)/1000.0
             kl = mod(int(klr*1000), 30081)
          end if

          call RMARINNS(ij, kl, k)
       enddo
    end subroutine initRandomNS

    subroutine killRandomNS
       deallocate (C, CD, CM, U, I97, J97, ISET, GSET)
    end subroutine killRandomNS

    double precision function GAUSSIAN1NS(idg)
       implicit none
       integer idg, id !node no.
       double precision urv
       double precision R, V1, V2, FAC

       id = idg + 1
       if (ISET(id) == 0) then
          R = 2
          do while (R >= 1.d0)
             urv = ranmarns(id - 1)
             V1 = 2.d0*urv - 1.d0
             urv = ranmarns(id - 1)
             V2 = 2.d0*urv - 1.d0
             R = V1**2 + V2**2
          end do
          FAC = sqrt(-2.d0*log(R)/R)
          GSET(id) = V1*FAC
          gaussian1ns = V2*FAC
          ISET(id) = 1
       else
          gaussian1ns = GSET(id)
          ISET(id) = 0
       endif

    end function GAUSSIAN1NS

    subroutine RMARINNS(IJ, KL, id)
! This is the initialization routine for the randomNS number generator ranmarns()
! NOTE: The seed variables can have values between:    0 <= IJ <= 31328
!                                                      0 <= KL <= 30081
!The randomNS number sequences created by these two seeds are of sufficient
! length to complete an entire calculation with. For example, if sveral
! different groups are working on different parts of the same calculation,
! each group could be assigned its own IJ seed. This would leave each group
! with 30000 choices for the second seed. That is to say, this randomNS
! number generator can create 900 million different subsequences -- with
! each subsequence having a length of approximately 10^30.
!
! Use IJ = 1802 & KL = 9373 to test the randomNS number generator. The
! subroutine ranmarns should be used to generate 20000 randomNS numbers.
! Then display the next six randomNS numbers generated multiplied by 4096*4096
! If the randomNS number generator is working properly, the randomNS numbers
!    should be:
!           6533892.0  14220222.0  7275067.0
!           6172232.0  8354498.0   10633180.0

       if (IJ < 0) IJ = 31328 + IJ
       if (IJ > 31328) IJ = mod(IJ, 31328)
       if (KL < 0) KL = 30081 + KL
       if (KL > 30081) KL = mod(KL, 30081)

       if (IJ < 0 .or. IJ > 31328 .or. KL < 0 .or. KL > 30081) then
          print '(A)', ' The first randomNS number seed must have a value  between 0 and 31328'
          print '(A)', ' The second seed must have a value between 0 and   30081'
          stop
       endif
       I = mod(IJ/177, 177) + 2
       J = mod(IJ, 177) + 2
       K = mod(KL/169, 178) + 1
       L = mod(KL, 169)
       do II = 1, 97
          S = 0.0
          T = 0.5
          do JJ = 1, 24
             M = mod(mod(I*J, 179)*K, 179)
             I = J
             J = K
             K = M
             L = mod(53*L + 1, 169)
             if (mod(L*M, 64) >= 32) S = S + T
             T = 0.5*T
          enddo
          U(id, II) = S
       enddo
       C(id) = 362436.0/16777216.0
       CD(id) = 7654321.0/16777216.0
       CM(id) = 16777213.0/16777216.0
       I97(id) = 97
       J97(id) = 33

    end subroutine RMARINNS

    double precision function ranmarns(idg)
! This is the random number generator proposed by George Marsaglia in
! Florida State University Report: FSU-SCRI-87-50
! It was slightly modified by F. James to produce an array of pseudorandom
! numbers.

       id = idg + 1

       UNI = U(id, I97(id)) - U(id, J97(id))
       if (UNI < 0.) UNI = UNI + 1.
       U(id, I97(id)) = UNI
       I97(id) = I97(id) - 1
       if (I97(id) == 0) I97(id) = 97
       J97(id) = J97(id) - 1
       if (J97(id) == 0) J97(id) = 97
       C(id) = C(id) - CD(id)
       if (C(id) < 0.) C(id) = C(id) + CM(id)
       UNI = UNI - C(id)
       if (UNI < 0.) UNI = UNI + 1. ! bug?
       ranmarns = UNI

    end function ranmarns

 end module RandomNS

#!/usr/bin/env Rscript

install.if.needed <- function(pkgname)
{
  cat("Trying to load package", pkgname, "\n")
  rc <- require(pkgname, character.only=TRUE, quietly=TRUE)
  if ( !rc )
    invisible(install.packages( pkgname
                              , repos="http://cran.us.r-project.org"))
}

needed.packages <- c( "optparse"
                    , "latticeExtra"
                    , "reshape2"
                    , "RSQLite"
                    , "doBy"
                    , "MASS"
                    )
for (pkg in needed.packages)
  install.if.needed(pkg)

!> Module containing utilities to generate random numbers

module random_module
    use utils_module, only: dp

#ifdef MPI
    use mpi_module
#endif

    implicit none           

    contains


    ! ===========================================================================================


    !> Initialise the random number generators
    !! 
    !! Takes an optional argument in case you want to set the seed. Otherwise it
    !! just uses the system time. 
    !!
    !! @todo Write seed to log file

    subroutine initialise_random(seed_input)
        use iso_fortran_env, only: int64
        implicit none
        !> Optional seed input.
        !! If this isn't included, then the system time is used
        integer, optional, intent(in) :: seed_input

        integer,allocatable,dimension(:) :: seed ! vector to be passed to random_seed
#ifdef MPI
        integer :: mpierror
#endif

        integer :: myrank

        integer :: size_seed
        integer :: dt(8)
        integer(int64) :: t
        integer :: i



        ! Get the global ranking
#ifdef MPI
        call MPI_COMM_RANK(MPI_COMM_WORLD, myrank, mpierror)
#else
        myrank = 0
#endif

        call random_seed(size = size_seed)
        allocate(seed(size_seed))

        if (present(seed_input)) then
            ! If the seed argument is present, initialise stream with this
            t = seed_input
        else

            ! Seed from the system time (hopefully one of these will work on your machine)
            call system_clock(t)
            if (t == 0) then
                call date_and_time(values=dt)
                t = &
                    (dt(1) - 1970) * 365 * 24 * 60 * 60 * 1000 &
                    + dt(2) * 31 * 24 * 60 * 60 * 1000 &
                    + dt(3) * 24 * 60 * 60 * 1000 &
                    + dt(5) * 60 * 60 * 1000 &
                    + dt(6) * 60 * 1000 &
                    + dt(7) * 1000 &
                    + dt(8)
            end if

        end if

#ifdef MPI
        ! Broadcast the system time to all nodes
        call MPI_BCAST(t,1,MPI_INTEGER,0,MPI_COMM_WORLD,mpierror)      

        ! Augment the seed on each node by adding 1 to it
        t = ieor(t, int(myrank, kind(t)))
#endif

        ! set up the seeds for the better generator
        do i=1,size_seed
            seed(i) = basic_random(t)
        end do

        ! Seed the better generator
        call random_seed(put=seed)

        contains

        function basic_random(s)
          integer :: basic_random
          integer(int64) :: s
          if (s == 0) then
             s = 104729
          else
             s = mod(s, 4294967296_int64)
          end if
          s = mod(s * 279470273_int64, 4294967291_int64)
          basic_random = int(mod(s, int(huge(0), int64)), kind(0))
        end function basic_random

    end subroutine initialise_random


    ! ===========================================================================================


    !>  Random unit hypercube coordinate
    !!
    !! Generate a randomly directed unit vector in the unit hypercube

    function random_reals(nDims) result(reals)
        implicit none

        !> Size of coordinate vector
        integer,intent(in) :: nDims 

        ! The output nDims coordinate
        real(dp), dimension(nDims) :: reals

        call random_number(reals)


    end function random_reals

    ! ===========================================================================================

    !>  Random array of logicals, produced with probability p
    function random_logicals(nDims,p)
        implicit none

        !> Size of coordinate vector
        integer,intent(in) :: nDims 

        !> probability of true
        real(dp),intent(in) :: p 

        ! The output nDims coordinate
        logical, dimension(nDims) :: random_logicals

        random_logicals = random_reals(nDims)<p


    end function random_logicals

    ! ===========================================================================================


    !>  Single random real number

    function random_real()
        implicit none

        ! The output nDims coordinate
        real(dp) :: random_real
        real(dp) :: random_real_vec(1)

        random_real_vec = random_reals(1)
        random_real = random_real_vec(1)

    end function random_real

    ! ===========================================================================================


    !>  Bernoulli trials, probability p, or odds ratio p:q for
    !!
    !! http://en.wikipedia.org/wiki/Bernoulli_trial
    !! 
    !! http://en.wikipedia.org/wiki/Odds#Gambling_odds_versus_probabilities
    !!
    !! Returns true with probability p
    !! Returns true with probability p/(p+q)

    function bernoulli_trials(nDims,p,q)
        implicit none

        ! The output nDims coordinate
        integer, intent(in) :: nDims
        real(dp),intent(in) :: p
        real(dp),intent(in),optional :: q

        logical, dimension(nDims) :: bernoulli_trials

        if(present(q)) then
            bernoulli_trials = random_reals(nDims) < p/(p+q)
        else
            bernoulli_trials = random_reals(nDims) < p
        end if


    end function bernoulli_trials

    ! ===========================================================================================


    !>  Bernoulli trial (see above)

    function bernoulli_trial(p,q)
        implicit none

        ! The output nDims coordinate
        real(dp),intent(in) :: p
        real(dp),intent(in),optional :: q

        logical :: bernoulli_trial
        logical :: bernoulli_trial_vec(1)

        if(present(q)) then
            bernoulli_trial_vec = bernoulli_trials(1,p,q)
        else
            bernoulli_trial_vec = bernoulli_trials(1,p)
        end if

        bernoulli_trial = bernoulli_trial_vec(1)

    end function bernoulli_trial

    ! ===========================================================================================


    !>  Random integer between 1 and nmax (inclusive)

    function random_integer(nmax)
        implicit none

        !> Maximum integer to generate
        integer,intent(in) :: nmax

        ! The output nDims coordinate
        integer :: random_integer

        random_integer = ceiling(random_real()*nmax)


    end function random_integer

    ! ===========================================================================================

    !>  Random Gaussian vector
    !!
    !! Generate nDims random gausian numbers with mean 0 and variance 1

    function random_gaussian(nDims)
        use utils_module, only: inv_normal_cdf
        implicit none

        !> Size of vector to be generated
        integer,intent(in) :: nDims

        ! The output unit vector
        real(dp), dimension(nDims) :: random_gaussian

        random_gaussian = inv_normal_cdf(random_reals(nDims))

    end function random_gaussian

    ! ===========================================================================================


    !>  Random direction vector
    !!
    !! Generate a randomly directed unit vector in nDims dimensional space
    !!
    !! This is done by generating nDims gaussian random numbers with mean 0 and
    !! variance 1. These are spherically symetrically distributed, so
    !! normalising this give a random direction.

    function random_direction(nDims)
        implicit none

        !> Size of vector to be generated
        integer,intent(in) :: nDims

        ! The output unit vector
        real(dp), dimension(nDims) :: random_direction
        real(dp) :: random_direction2

        random_direction2=0
        do while(random_direction2<=0)

            ! Generate nDims gaussian random numbers
            random_direction = random_gaussian(nDims)
            ! Calculate the modulus squared
            random_direction2 = dot_product(random_direction,random_direction)
        end do

        ! normalise the vector
        random_direction = random_direction / sqrt(random_direction2)

    end function random_direction

    ! ===========================================================================================


    !>  Random subspace vector
    !!
    !! Generate a randomly directed unit vector in the nDims-1 dimensional subspace defined by rhat
    !!
    !! This is done by generating nDims gaussian random numbers with mean 0 and
    !! variance 1. These are spherically symetrically distributed, so
    !! normalising this give a random direction.

    function random_subdirection(nDims,rhat)
        implicit none

        !> Size of vector to be generated
        integer,intent(in) :: nDims
        real(dp), dimension(nDims),intent(in) :: rhat

        ! The output unit vector
        real(dp), dimension(nDims) :: random_subdirection
        real(dp) :: random_subdirection2

        random_subdirection2=0
        do while (random_subdirection2<=0)

            ! Generate nDims gaussian random numbers
            random_subdirection = random_gaussian(nDims)

            ! Project into the rhat space
            random_subdirection = random_subdirection - rhat * dot_product(rhat,random_subdirection) / dot_product(rhat,rhat)

            ! Find the modulus squared
            random_subdirection2 = dot_product(random_subdirection,random_subdirection)

        end do
        ! normalise the vector
        random_subdirection = random_subdirection / sqrt(random_subdirection2)

    end function random_subdirection


    ! ===========================================================================================


    !>  Random point in unit sphere
    !!
    !! Generate a uniformly distributed point in the unit n-sphere
    !!
    !! This is done by generating a random direction, and then multiplying it by
    !! a radius distributed as \f$ P(r) ~ r^{d-1}\f$. where \f$d\f$ is the
    !! dimension of the input vector

    function random_point_in_sphere(nDims)
        implicit none

        !> Dimension of sphere
        integer,intent(in) :: nDims 

        ! The output vector
        real(dp), dimension(nDims) :: random_point_in_sphere

        ! Temporary variable for storing a random radius
        real(dp) :: rand_rad


        ! generate a random direction
        random_point_in_sphere = random_direction(nDims)

        ! generate a single random number distributed as ~ r^{d-1}
        rand_rad = random_real()**(1d0/nDims)

        ! Create a point in the sphere
        random_point_in_sphere = random_point_in_sphere * rand_rad


    end function random_point_in_sphere

    !> Construct a randomly oriented ndimensional orthogonormal basis by using 
    !! [Gram-Schmidt Orthogonalisation](http://en.wikipedia.org/wiki/Gram%E2%80%93Schmidt_process). 
    !!
    !! Outputs a matrix where the ith basis vector is stored in basis(:,i)
    function random_orthonormal_basis(nDims) result(basis)
        !> Dimensionality of the basis
        integer, intent(in) ::  nDims

        ! Set of vectors, the ith vector is in basis(:,i)
        real(dp), dimension(nDims,nDims) :: basis

        ! Iterators
        integer :: i,j

        do i=1,nDims
            ! Generate a randomly directed vector 
            basis(:,i) = random_direction(nDims)
            ! Othogonalise it with respect to the other vectors using Gram
            ! Schmidt orthogonalisation
            do j= 1,i-1
                basis(:,i) = basis(:,i)- dot_product(basis(:,i),basis(:,j)) * basis(:,j)
            end do
            ! normalise the vector
            basis(:,i) = basis(:,i)/sqrt(dot_product(basis(:,i),basis(:,i)))
        end do

    end function random_orthonormal_basis


    !> Construct a sequence of nhats composed of several random orthonormal bases
    !!
    !! Outputs a matrix where the ith basis vector is stored in basis(:,i)
    function random_orthonormal_bases(nDims,num_nhats) result(nhats)
        !> Dimensionality of the basis
        integer, intent(in) ::  nDims
        integer, intent(in) ::  num_nhats

        ! Set of vectors, the ith vector is in basis(:,i)
        real(dp), dimension(nDims,num_nhats) :: nhats

        real(dp), dimension(nDims,nDims) :: basis

        integer :: lower_index,upper_index

        ! Fill up the first whole sections with nDims
        lower_index = 1
        upper_index = nDims
        do while(upper_index<num_nhats)
            nhats(:,lower_index:upper_index) = random_orthonormal_basis(nDims)
            lower_index = lower_index+nDims
            upper_index = upper_index+nDims
        end do

        basis = random_orthonormal_basis(nDims)

        nhats(:,lower_index:num_nhats) = basis(:,1:1+num_nhats-lower_index)
        



    end function random_orthonormal_bases

    ! ===========================================================================================
    !> Generate a set of k distinct random integers between [1,m]
    !! There are two ways of doing this:
    !! # Generate successive random numbers, rejecting any which have already
    !!   been found
    !! # Generate a shuffled deck of random numbers, and pick the first k of
    !!   them
    !!
    !! Which of these is the more efficient depends on the size difference of
    !! k and m. In general, the first method will require one to draw an
    !! expected number of random numbers evaluating to:
    !! \f[ m\sum\limits_{i=1}^k \frac{1}{m-(i-1)} \approx m \log\left(\frac{m}{m-k}\right) \f]
    !! whereas the second requires m random numbers to be drawn. The cutoff
    !! moment is therefore when
    !! \f[ k \sim \frac{e-1}{e} n \sim 0.63 n \f]
    !!
    !! We thus use the first method if k is less than 0.63n
    function random_distinct_integers(m,k) result(integers)
        implicit none
        real(dp), parameter :: cutoff=0.6321205588285576784d0

        !> The upper bound of integers to be generated
        integer, intent(in) :: m

        !> The number of distinct integers to be generated
        !! If k is not present, then we generate a shuffled deck of integers
        integer,intent(in) :: k

        ! The returning array
        integer, dimension(k) :: integers

        integer :: i
        integer, dimension(m) :: deck 

        if(k<cutoff*m) then
            ! Case 1, generate by rejection

            i=1
            do while (i<=k)
                ! Draw a random integer
                integers(i) = random_integer(m) 

                ! Move to the next index if it's unique
                if(all(integers(i)/=integers(:i-1))) i=i+1
            end do

        else
            ! Case 2, generate by shuffling

            ! Generate a randomly shuffled deck
            deck = [(i,i=1,m)]
            call shuffle_deck(deck)

            ! output the first k of them
            integers = deck

        end if

    end function random_distinct_integers


    !> Shuffle a 'deck' of integers
    !!
    !! This uses a [Fischer-Yates](http://en.wikipedia.org/wiki/Fisher%E2%80%93Yates_shuffle)
    !! shuffle, which is \f$\mathcal{O}(n)\f$

    subroutine shuffle_deck(deck)
        implicit none

        ! The input deck to be shuffled
        integer, intent(inout), dimension(:) :: deck

        ! Temporary variable for swapping
        integer :: temp

        ! Indices
        integer :: i,j

        ! Size of deck
        integer :: n

        n = size(deck)

        do i=n,1,-1
            ! pick a random integer in [1,i]
            j=random_integer(i)

            ! swap elements i and j
            temp    = deck(i) 
            deck(i) = deck(j)
            deck(j) = temp
        end do

    end subroutine shuffle_deck


    !> This function generates a random integer with variable probability
    !!
    !! The probability is defined by the input array, and need not be
    !! normalised.
    !!
    !! E.g: If one reieves an array (/ 50.0, 120.0, 30.0 /), this function will
    !! return:
    !! |---|-----------------|
    !! | 1 | 25% of the time |
    !! | 2 | 60% of the time |
    !! | 3 | 15% of the time |
    !! |---|-----------------|
    !!
    function random_integer_P(probabilities)
        implicit none
        real(dp), dimension(:),intent(in) :: probabilities

        integer :: random_integer_P

        real(dp) :: norm
        real(dp) :: cdf
        real(dp) :: rand


        ! Calculate normalisation constant
        norm = sum(probabilities)

        ! Generate a random real number
        rand = random_real()

        ! Initialise the cumulative probability at 0
        cdf=0d0

        ! iterate through the array, returning when the cdf is bigger than the
        ! random real.
        do random_integer_P=1,size(probabilities)
            cdf = cdf + probabilities(random_integer_P)/norm
            if(rand<cdf) return
        end do


    end function random_integer_P


    !> Generate a random inverse covariance matrix with unit determinant
    !! 
    subroutine random_inverse_covmat(invcovmat,logdetcovmat,sigma,nDims)
        implicit none
        integer,          intent(in)                         :: nDims
        real(dp), intent(out),dimension(nDims,nDims) :: invcovmat
        real(dp), intent(out)                        :: logdetcovmat
        real(dp), intent(in)                         :: sigma

        real(dp), dimension(nDims)       :: eigenvalues
        real(dp), dimension(nDims,nDims) :: eigenvectors
        integer :: j
        real(dp), parameter :: rng=1d-2

        ! Generate a random basis for the eigenvectors
        eigenvectors = random_orthonormal_basis(nDims)
        ! Generate the eigenvalues logarithmically in [rng,1] * sigma
        do j=1,nDims
            eigenvalues(j)  = sigma * rng**((j-1d0)/(nDims-1d0))
        end do
        ! Sort them lowest to highest for consistency
        !call dlasrt('D',nDims,eigenvalues,info)

        ! Create the inverse covariance matrix in the eigenbasis
        invcovmat = 0d0
        do j=1,nDims
            invcovmat(j,j) = 1d0/eigenvalues(j)**2
        end do

        ! Rotate the matrix into the coordinate basis
        invcovmat = matmul(eigenvectors,matmul(invcovmat,transpose(eigenvectors)))

        ! sum up the logs of the eigenvalues to get the log of the determinant
        logdetcovmat = 2 * sum(log(eigenvalues))

    end subroutine random_inverse_covmat

end module random_module

!> This allows for a simple C interface... 


module interfaces_module
    use utils_module, only: dp

    implicit none
    interface run_polychord
        module procedure run_polychord_full, run_polychord_no_prior, run_polychord_no_dumper, run_polychord_no_prior_no_dumper, run_polychord_ini
    end interface run_polychord

contains


    subroutine run_polychord_full(loglikelihood, prior_transform, dumper, settings_in)
        use settings_module,          only: program_settings,initialise_settings
        use random_module,            only: initialise_random
        use nested_sampling_module,   only: NestedSampling
#ifdef MPI
        use mpi_module,               only: initialise_mpi, finalise_mpi
#endif
        implicit none
#ifdef MPI
        include 'mpif.h'
#endif

        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),  dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function loglikelihood
        end interface
        interface
            function prior_transform(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function prior_transform
        end interface
        interface
            subroutine dumper(live, dead, logweights, logZ, logZerr)
                import :: dp
                real(dp), intent(in) :: live(:,:), dead(:,:), logweights(:)
                real(dp), intent(in) :: logZ, logZerr
            end subroutine dumper
        end interface

        type(program_settings),intent(in)    :: settings_in
        type(program_settings)               :: settings 

        real(dp), dimension(4) :: output_info

#ifdef MPI
        call initialise_mpi(settings_in%feedback)
#endif
        if (settings_in%seed >= 0) then
            call initialise_random(settings_in%seed)
        else
            call initialise_random()
        end if
        settings = settings_in
        call initialise_settings(settings)   
#ifdef MPI
        output_info = NestedSampling(loglikelihood,prior_transform,dumper,settings,MPI_COMM_WORLD) 
        call finalise_mpi
#else
        output_info = NestedSampling(loglikelihood,prior_transform,dumper,settings,0) 
#endif

    end subroutine run_polychord_full


    !===================== INTERFACE ===============================================
    subroutine run_polychord_no_prior(loglikelihood,dumper,settings)
        use settings_module,          only: program_settings
        implicit none
        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),  dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function loglikelihood
        end interface
        interface
            subroutine dumper(live, dead, logweights, logZ, logZerr)
                import :: dp
                real(dp), intent(in) :: live(:,:), dead(:,:), logweights(:)
                real(dp), intent(in) :: logZ, logZerr
            end subroutine dumper
        end interface
        type(program_settings),intent(in)    :: settings  ! The program settings 
        call run_polychord(loglikelihood,prior_transform,dumper,settings)
    contains
        function prior_transform(cube) result(theta)
            implicit none
            real(dp), intent(in), dimension(:) :: cube
            real(dp), dimension(size(cube))    :: theta
            theta = cube
        end function prior_transform
    end subroutine run_polychord_no_prior

    subroutine run_polychord_no_dumper(loglikelihood,prior_transform,settings)
        use settings_module,          only: program_settings
        implicit none
        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),  dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function loglikelihood
        end interface
        interface
            function prior_transform(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function prior_transform
        end interface
        type(program_settings),intent(in)    :: settings  ! The program settings 
        call run_polychord(loglikelihood,prior_transform,dumper,settings)
    contains
        subroutine dumper(live, dead, logweights, logZ, logZerr)
            real(dp), intent(in) :: live(:,:), dead(:,:), logweights(:)
            real(dp), intent(in) :: logZ, logZerr
        end subroutine dumper
    end subroutine run_polychord_no_dumper

    subroutine run_polychord_no_prior_no_dumper(loglikelihood, settings)
        use settings_module,          only: program_settings
        implicit none
        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),  dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function loglikelihood
        end interface
        type(program_settings),intent(in)    :: settings  ! The program settings 
        call run_polychord(loglikelihood,prior_transform,settings)
    contains
        function prior_transform(cube) result(theta)
            implicit none
            real(dp), intent(in), dimension(:) :: cube
            real(dp), dimension(size(cube))    :: theta
            theta = cube
        end function prior_transform
        subroutine dumper(live, dead, logweights, logZ, logZerr)
            real(dp), intent(in) :: live(:,:), dead(:,:), logweights(:)
            real(dp), intent(in) :: logZ, logZerr
        end subroutine dumper
    end subroutine run_polychord_no_prior_no_dumper


    subroutine run_polychord_ini(loglikelihood, setup_loglikelihood, input_file)
        use ini_module,               only: read_params
        use params_module,            only: add_parameter,param_type
        use priors_module
        use settings_module,          only: program_settings
        use utils_module,             only: STR_LENGTH
        implicit none
        type(program_settings)                    :: settings  ! The program settings 
        type(prior), dimension(:),allocatable     :: priors    ! The details of the priors

        character(len=STR_LENGTH), intent(in)     :: input_file     ! input file
        type(param_type),dimension(:),allocatable :: params         ! Parameter array
        type(param_type),dimension(:),allocatable :: derived_params ! Derived parameter array
        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),  dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function loglikelihood
        end interface
        interface
            subroutine setup_loglikelihood(settings)
                import :: program_settings
                type(program_settings), intent(in) :: settings
            end subroutine setup_loglikelihood
        end interface

        call read_params(trim(input_file),settings,params,derived_params)
        call create_priors(priors,params,settings)
        call setup_loglikelihood(settings)
        call run_polychord(loglikelihood,prior_wrapper,settings) 

        contains
            function prior_wrapper(cube) result(theta)
                implicit none
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
                theta = hypercube_to_physical(cube,priors)
            end function prior_wrapper
    end subroutine run_polychord_ini


    subroutine polychord_c_interface(&
            c_loglikelihood_ptr,&
            c_prior_ptr,&
            c_dumper_ptr,&
            nlive,&
            num_repeats,&
            nprior,&
            do_clustering,&
            feedback, &
            precision_criterion,&
            logzero,&
            max_ndead,&
            boost_posterior,&
            posteriors,&
            equals,&
            cluster_posteriors,&
            write_resume, &
            write_paramnames,&
            read_resume,&
            write_stats,&
            write_live,&
            write_dead,&
            write_prior,&
            compression_factor,&
            nDims,&
            nDerived, &
            base_dir,&
            file_root,&
            nGrade,&
            grade_frac,&
            grade_dims,&
            n_nlives,&
            loglikes,&
            nlives,&
            seed) &
            bind(c,name='polychord_c_interface')

        use iso_c_binding
        use utils_module,             only: STR_LENGTH, convert_c_string
        use ini_module,               only: default_params
        use params_module,            only: param_type
        use settings_module,          only: program_settings,initialise_settings
        use random_module,            only: initialise_random
        use nested_sampling_module,   only: NestedSampling
        use read_write_module,        only: write_paramnames_file

        ! ~~~~~~~ Local Variable Declaration ~~~~~~~
        implicit none

        interface
            function c_loglikelihood(theta,nDims,phi,nDerived) bind(c)
                use iso_c_binding
                integer(c_int), intent(in), value :: nDims
                integer(c_int), intent(in), value :: nDerived
                real(c_double), intent(in),  dimension(nDims) :: theta
                real(c_double), intent(out),  dimension(nDerived) :: phi
                real(c_double) :: c_loglikelihood
            end function c_loglikelihood
        end interface
        interface
            subroutine c_prior(cube,theta,nDims) bind(c)
                use iso_c_binding
                integer(c_int), intent(in), value :: nDims
                real(c_double), intent(in),  dimension(nDims) :: cube
                real(c_double), intent(out), dimension(nDims) :: theta
            end subroutine c_prior
        end interface
        interface
            subroutine c_dumper(ndead, nlive, npars, live, dead, logweights, logZ, logZerr) bind(c)
                use iso_c_binding
                integer(c_int), intent(in), value :: ndead, nlive, npars
                real(c_double), intent(in), dimension(npars,nlive) :: live, dead(npars,ndead), logweights(ndead)
                real(c_double), intent(in), value :: logZ, logZerr
            end subroutine c_dumper
        end interface

        type(c_funptr), intent(in), value   :: c_loglikelihood_ptr
        type(c_funptr), intent(in), value   :: c_prior_ptr
        type(c_funptr), intent(in), value   :: c_dumper_ptr
        integer(c_int), intent(in), value   :: nlive
        integer(c_int), intent(in), value   :: num_repeats
        integer(c_int), intent(in), value   :: nprior
        logical(c_bool), intent(in), value  :: do_clustering
        integer(c_int), intent(in), value   :: feedback
        real(c_double), intent(in), value   :: precision_criterion
        real(c_double), intent(in), value   :: logzero
        integer(c_int), intent(in), value   :: max_ndead
        real(c_double), intent(in), value   :: boost_posterior
        logical(c_bool), intent(in), value  :: posteriors
        logical(c_bool), intent(in), value  :: equals
        logical(c_bool), intent(in), value  :: cluster_posteriors
        logical(c_bool), intent(in), value  :: write_resume
        logical(c_bool), intent(in), value  :: write_paramnames
        logical(c_bool), intent(in), value  :: read_resume
        logical(c_bool), intent(in), value  :: write_stats
        logical(c_bool), intent(in), value  :: write_live
        logical(c_bool), intent(in), value  :: write_dead
        logical(c_bool), intent(in), value  :: write_prior
        real(c_double),  intent(in), value  :: compression_factor
        integer(c_int), intent(in), value   :: nDims
        integer(c_int), intent(in), value   :: nDerived
        character(len=1,kind=c_char), intent(in), dimension(STR_LENGTH) :: base_dir
        character(len=1,kind=c_char), intent(in), dimension(STR_LENGTH) :: file_root

        integer(c_int), intent(in), value             :: nGrade
        real(c_double), intent(in), dimension(nGrade) :: grade_frac
        integer(c_int), intent(in), dimension(nGrade) :: grade_dims

        integer(c_int), intent(in), value               :: n_nlives
        real(c_double), intent(in), dimension(n_nlives) :: loglikes
        integer(c_int), intent(in), dimension(n_nlives) :: nlives
        integer(c_int), intent(in), value               :: seed

        type(program_settings)    :: settings  ! The program settings 

        type(param_type),dimension(:),allocatable :: params         ! Parameter array
        type(param_type),dimension(:),allocatable :: derived_params ! Derived parameter array

        procedure(c_loglikelihood), pointer :: f_loglikelihood_ptr
        procedure(c_prior), pointer         :: f_prior_ptr
        procedure(c_dumper), pointer         :: f_dumper_ptr

        settings%nlive               = nlive                
        settings%num_repeats         = num_repeats          
        settings%nprior              = nprior
        settings%do_clustering       = do_clustering        
        settings%feedback            = feedback             
        settings%precision_criterion = precision_criterion  
        settings%logzero             = logzero  
        settings%max_ndead           = max_ndead            
        settings%boost_posterior     = boost_posterior      
        settings%posteriors          = posteriors           
        settings%equals              = equals               
        settings%cluster_posteriors  = cluster_posteriors   
        settings%write_resume        = write_resume         
        settings%write_paramnames    = write_paramnames     
        settings%read_resume         = read_resume          
        settings%write_stats         = write_stats          
        settings%write_live          = write_live           
        settings%write_dead          = write_dead           
        settings%write_prior         = write_prior
        settings%compression_factor  = compression_factor         
        settings%nDims               = nDims
        settings%nDerived            = nDerived

        settings%base_dir            = convert_c_string(base_dir)
        settings%file_root           = convert_c_string(file_root) 

        settings%seed                = seed

        allocate(settings%grade_frac(nGrade),settings%grade_dims(nGrade))
        settings%grade_frac = grade_frac
        settings%grade_dims = grade_dims

        allocate(settings%loglikes(n_nlives),settings%nlives(n_nlives))
        settings%loglikes = loglikes
        settings%nlives = nlives

        if(settings%write_paramnames) then
            params = default_params(settings%nDims,'theta','\theta')
            derived_params = default_params(settings%nDerived,'phi','\phi')
            call write_paramnames_file(settings,params,derived_params)
        end if

        call c_f_procpointer(c_loglikelihood_ptr, f_loglikelihood_ptr)
        call c_f_procpointer(c_prior_ptr, f_prior_ptr)
        call c_f_procpointer(c_dumper_ptr, f_dumper_ptr)

        call run_polychord(fort_loglikelihood,prior_transform,fort_dumper,settings) 

    contains
        function fort_loglikelihood(theta,phi)
            implicit none
            real(dp), intent(in),  dimension(:) :: theta
            real(dp), intent(out),  dimension(:) :: phi
            real(dp) :: fort_loglikelihood

            real (c_double),dimension(size(theta)) :: c_theta
            integer (c_int)                        :: c_nDims
            real (c_double),dimension(size(phi))   :: c_phi
            integer (c_int)                        :: c_nDerived
            real (c_double)                        :: c_loglike

            c_nDims = size(theta)
            c_nDerived = size(phi)
            c_theta = theta
            c_loglike = f_loglikelihood_ptr(c_theta,c_nDims,c_phi,c_nDerived)
            phi = c_phi
            fort_loglikelihood = c_loglike

        end function fort_loglikelihood

        function prior_transform(cube) result(theta)
            implicit none
            real(dp), intent(in), dimension(:) :: cube
            real(dp), dimension(size(cube))    :: theta

            integer (c_int)                       :: c_nDims
            real (c_double),dimension(size(cube)) :: c_cube
            real (c_double),dimension(size(cube)) :: c_theta

            c_nDims = size(cube)
            c_cube = cube
            call f_prior_ptr(c_cube,c_theta,c_nDims)
            theta = c_theta

        end function prior_transform

        subroutine fort_dumper(live, dead, logweights, logZ, logZerr)
            implicit none
            real(dp), intent(in) :: live(:,:), dead(:,:), logweights(:)
            real(dp), intent(in) :: logZ, logZerr

            integer(c_int) :: c_ndead, c_nlive, c_npars
            real(c_double) :: c_live(size(live,1),size(live,2)), c_dead(size(dead,1),size(dead,2)), c_logweights(size(logweights))
            real(c_double) :: c_logZ, c_logZerr

            c_npars = size(live,1)
            c_nlive = size(live,2)
            c_ndead = size(dead,2)
            c_live = live
            c_dead = dead
            c_logweights = logweights
            c_logZ = logZ
            c_logZerr = logZerr
            call f_dumper_ptr(c_ndead, c_nlive, c_npars, c_live, c_dead, c_logweights, c_logZ, c_logZerr)
        end subroutine fort_dumper


    end subroutine polychord_c_interface


    subroutine polychord_c_interface_ini(c_loglikelihood_ptr, c_setup_loglikelihood_ptr, input_file_c)&
            bind(c,name='polychord_c_interface_ini')

        use iso_c_binding
        use utils_module,             only: STR_LENGTH, convert_c_string

        ! ~~~~~~~ Local Variable Declaration ~~~~~~~
        implicit none

        interface
            function c_loglikelihood(theta,nDims,phi,nDerived) bind(c)
                use iso_c_binding
                integer(c_int), intent(in), value :: nDims
                integer(c_int), intent(in), value :: nDerived
                real(c_double), intent(in),  dimension(nDims) :: theta
                real(c_double), intent(out),  dimension(nDerived) :: phi
                real(c_double) :: c_loglikelihood
            end function c_loglikelihood
        end interface
        interface
            subroutine c_setup_loglikelihood() bind(c)
            end subroutine c_setup_loglikelihood
        end interface
        character(len=STR_LENGTH)     :: input_file     ! input file

        type(c_funptr), intent(in), value   :: c_loglikelihood_ptr
        type(c_funptr), intent(in), value   :: c_setup_loglikelihood_ptr
        character(len=1,kind=c_char), intent(in), dimension(STR_LENGTH) :: input_file_c

        procedure(c_loglikelihood), pointer :: f_loglikelihood_ptr
        procedure(c_setup_loglikelihood), pointer :: f_setup_loglikelihood_ptr

        input_file = convert_c_string(input_file_c)

        call c_f_procpointer(c_loglikelihood_ptr, f_loglikelihood_ptr)
        call c_f_procpointer(c_setup_loglikelihood_ptr, f_setup_loglikelihood_ptr)

        call run_polychord(fort_loglikelihood, setup_loglikelihood, input_file) 

    contains
        function fort_loglikelihood(theta,phi)
            implicit none
            real(dp), intent(in),  dimension(:) :: theta
            real(dp), intent(out),  dimension(:) :: phi
            real(dp) :: fort_loglikelihood

            real (c_double),dimension(size(theta)) :: c_theta
            integer (c_int)                        :: c_nDims
            real (c_double),dimension(size(phi))   :: c_phi
            integer (c_int)                        :: c_nDerived
            real (c_double)                        :: c_loglike

            c_nDims = size(theta)
            c_nDerived = size(phi)
            c_theta = theta
            c_loglike = f_loglikelihood_ptr(c_theta,c_nDims,c_phi,c_nDerived)
            phi = c_phi
            fort_loglikelihood = c_loglike

        end function fort_loglikelihood

        subroutine setup_loglikelihood(settings)
            use settings_module,          only: program_settings
            implicit none
            type(program_settings), intent(in)    :: settings
            call f_setup_loglikelihood_ptr()
        end subroutine setup_loglikelihood

    end subroutine polychord_c_interface_ini


end module interfaces_module

!This is just a scratch space for testing
!not a proper test suite
program test_cosmosis
    use cosmosis_modules
    implicit none


    call test_scalar()
    call test_defaults()
    call test_array()
    call test_double_array()
    call test_2d()


    contains 

    subroutine cosmosis_assert(predicate, message)
        logical :: predicate
        character(*) :: message

        if (.not. predicate) then
            write(*,*) "Test Failure: ", trim(message) 
            stop 1
        endif
    end subroutine



    subroutine test_template()
        integer(cosmosis_block) :: block
        integer(cosmosis_status) :: status
        ! ...
        block = make_datablock()

        !.. tests here

        status = destroy_c_datablock(block)
        call cosmosis_assert(status==0, "Destroy failed")
    end subroutine test_template




    subroutine test_defaults()
        integer(cosmosis_block) :: block
        integer(cosmosis_status) :: status
        integer n
        real(8) :: x
        complex(c_double_complex) :: z
        block = make_datablock()

        status = datablock_get_int_default(block, "fish", "n", 14, n)
        status = status + datablock_get_double_default(block, "fish", "x", 7.5_8, x)
        status = status + datablock_get_complex_default(block, "fish", "z", dcmplx(0,-2), z)
        call cosmosis_assert(status==0, "Default get failed")
        call cosmosis_assert(n==14, "Default get int wrong answer")
        call cosmosis_assert(x==7.5, "Default get double wrong answer")
        call cosmosis_assert(z==dcmplx(0,-2), "Default get complex wrong answer")

        !These tests now lead to failure since get with default leads to
        !implicit put
        !status = datablock_put_int(block, "fish", "n", 3)
        !status = status + datablock_put_double(block, "fish", "x", 4.0_8)
        !status = status + datablock_put_complex(block, "fish", "z", dcmplx(1,-6))
        !call cosmosis_assert(status==0, "Default puts failed")
        
        !status = datablock_get_int_default(block, "fish", "n", 14, n)
        !status = status + datablock_get_double_default(block, "fish", "x", 7.5_8, x)
        !status = status + datablock_get_complex_default(block, "fish", "z", dcmplx(0,-2), z)
        !call cosmosis_assert(status==0, "Default get 2 failed")
        !call cosmosis_assert(n==3, "Default get int 2 wrong answer")
        !call cosmosis_assert(x==4.0, "Default get double 2 wrong answer")
        !call cosmosis_assert(z==dcmplx(1,-6), "Default get complex 2 wrong answer")

        status = destroy_c_datablock(block)
        call cosmosis_assert(status==0, "Destroy failed")
    end subroutine test_defaults


    subroutine test_scalar()
        integer(cosmosis_block) :: block
        integer(cosmosis_status) :: status
        integer n
        real(8) :: x
        complex(c_double_complex) :: z
        character(len=20) :: s
        logical :: b

        block = make_datablock()


        n=15
        x=14.8
        z=dcmplx(1.4,-1.2)
        b = .true.
        status = 0
        status = datablock_put_int(block, "MAGIC", "NUMBER", n)
        status = status + datablock_put_double(block, "MAGIC", "WEIGHT", x)
        status = status + datablock_put_complex(block, "MAGIC", "FOURIER", z)
        status = status + datablock_put_logical(block, "MAGIC", "LOGIC", b)
        call cosmosis_assert(status==0, "Put scalar failed")

        n=666
        x=666.
        z=dcmplx(666.,666.)
        b = .false.
        status = datablock_get_int(block, "MAGIC", "NUMBER", n)
        status = status + datablock_get_double(block, "MAGIC", "WEIGHT", x)
        status = status + datablock_get_complex(block, "MAGIC", "FOURIER", z)
        status = status + datablock_get_logical(block, "MAGIC", "LOGIC", b)

        call cosmosis_assert(status==0, "Get scalar failed")
        call cosmosis_assert(n==15, "Get int wrong answer")
        call cosmosis_assert(x==14.8, "Get float wrong answer")
        call cosmosis_assert(z==dcmplx(1.4,-1.2), "Get complex wrong answer")
        call cosmosis_assert(b, "Get bool wrong answer")

        s = "cat"
        status = datablock_put_string(block, "STRINGS", "ANIMALS", s)
        s = ""
        call cosmosis_assert(status==0, "Put string failed")
        status = datablock_get_string(block, "STRINGS", "ANIMALS", s)
        call cosmosis_assert(s=="cat", "Put string failed")


        status = destroy_c_datablock(block)
        call cosmosis_assert(status==0, "Destroy failed")

    end subroutine test_scalar



    subroutine test_array()
        integer(cosmosis_block) :: block
        integer(cosmosis_status) :: status
        integer size_recovered, i, j
        integer(c_int), dimension(10) :: int_arr, slice
        integer, dimension(:), allocatable :: int_arr_recovered
        integer, dimension(10,10) :: int_arr_2d


        block = make_datablock()

        do i=1,10
            int_arr(i) = i*i
        enddo


        status = datablock_put_int_array_1d(block, "MAGIC", "FIELD", int_arr)
        call cosmosis_assert(status==0, "Put int array failed")

        call cosmosis_assert(.not. allocated(int_arr_recovered), "Put int array did not allocate")
        status = datablock_get_int_array_1d(block, "MAGIC", "FIELD", int_arr_recovered, size_recovered)
        call cosmosis_assert(status==0, "Put int array did not work")
        call cosmosis_assert(allocated(int_arr_recovered), "Put int array did not allocate")
        call cosmosis_assert(size(int_arr_recovered)==10, "Wrong size array back")
        call cosmosis_assert(size_recovered==10, "Wrong size array back")
        do i=1,10
            call cosmosis_assert(int_arr_recovered(i)==i*i, "get int array wrong answer")
        enddo

        call cosmosis_assert(datablock_num_sections(block)==1, "wrong section count")
        deallocate(int_arr_recovered)

        call cosmosis_assert(trim(datablock_get_section_name(block,0))=="magic", "Wrong section name")

        do i=1,10
            do j=1,10
                int_arr_2d(i,j) = i+10*j
            enddo
        enddo

        slice = int_arr_2d(1,:)
        status = datablock_put_int_array_1d(block, "MAGIC", "SLICE", int_arr_2d(1,:))
        call cosmosis_assert(status==0, "Put int slice did not work")
        status = datablock_get_int_array_1d(block, "MAGIC", "SLICE", int_arr_recovered, size_recovered)
        call cosmosis_assert(status==0, "Get int slice did not work")
        call cosmosis_assert(all(slice==int_arr_recovered), "Slice dim 1 fail")
        deallocate(int_arr_recovered)


        slice = int_arr_2d(:,1)
        status = datablock_replace_int_array_1d(block, "MAGIC", "SLICE", int_arr_2d(:,1))
        call cosmosis_assert(status==0, "Replace int slice 2 did not work")
        status = datablock_get_int_array_1d(block, "MAGIC", "SLICE", int_arr_recovered, size_recovered)
        call cosmosis_assert(status==0, "Get int slice 2 did not work")
        call cosmosis_assert(all(slice==int_arr_recovered), "Slice dim 2 fail")
        deallocate(int_arr_recovered)


        status = destroy_c_datablock(block)
        call cosmosis_assert(status==0, "Destroy failed")
    end subroutine test_array


    subroutine test_2d()
        integer(cosmosis_block) :: block
        integer(cosmosis_status) :: status, status2
        real(8), dimension(10, 10) :: arr
        real(8), dimension(:,:), allocatable :: recovered

        integer, dimension(10, 10) :: iarr
        integer, dimension(:,:), allocatable :: irecovered
        integer i, j

        do i=1,10
            do j=1,10
                arr(i,j) = i+10*j
                iarr(i,j) = j+10*i + 3
            enddo
        enddo

        block = make_datablock()

        status = datablock_put_double_array_2d(block, "xxx", "yyy", arr)
        call cosmosis_assert(status==0, "put double 2d failed")

        status = datablock_get_double_array_2d(block, "xxx", "yyy", recovered)
        call cosmosis_assert(status==0, "get double 2d failed")
        call cosmosis_assert(all(arr==recovered), "2d double compare failed")

        status = datablock_put_int_array_2d(block, "xxx", "iyyy", iarr)
        call cosmosis_assert(status==0, "put double 2d failed")

        status = datablock_get_int_array_2d(block, "xxx", "iyyy", irecovered)
        call cosmosis_assert(status==0, "get int 2d failed")
        call cosmosis_assert(all(iarr==irecovered), "2d int compare failed")


    end subroutine test_2d

    subroutine test_double_array()
        integer(cosmosis_block) :: block
        integer(cosmosis_status) :: status
        integer size_recovered, i, j
        real(8), dimension(10) :: arr, slice
        real(8), dimension(:), allocatable :: arr_recovered
        real(8), dimension(10,10) :: arr_2d


        block = make_datablock()

        do i=1,10
            arr(i) = i*i*2.0
        enddo


        status = datablock_put_double_array_1d(block, "MAGIC", "FIELD", arr)
        call cosmosis_assert(status==0, "Put double array failed")

        call cosmosis_assert(.not. allocated(arr_recovered), "Put double array did not allocate")
        status = datablock_get_double_array_1d(block, "MAGIC", "FIELD", arr_recovered, size_recovered)
        call cosmosis_assert(status==0, "Put double array did not work")
        call cosmosis_assert(allocated(arr_recovered), "Put double array did not allocate")
        call cosmosis_assert(size(arr_recovered)==10, "Wrong size array back")
        call cosmosis_assert(size_recovered==10, "Wrong size array back")
        do i=1,10
            call cosmosis_assert(arr_recovered(i)==i*i*2.0, "get double array wrong answer")
        enddo

        call cosmosis_assert(datablock_num_sections(block)==1, "wrong section count")
        deallocate(arr_recovered)

        call cosmosis_assert(trim(datablock_get_section_name(block,0))=="magic", "Wrong section name")

        do i=1,10
            do j=1,10
                arr_2d(i,j) = i+0.1*j
            enddo
        enddo

        slice = arr_2d(1,:)
        status = datablock_put_double_array_1d(block, "MAGIC", "SLICE", arr_2d(1,:))
        call cosmosis_assert(status==0, "Put double slice did not work")
        status = datablock_get_double_array_1d(block, "MAGIC", "SLICE", arr_recovered, size_recovered)
        call cosmosis_assert(status==0, "Get double slice did not work")
        call cosmosis_assert(all(slice==arr_recovered), "Slice dim 1 fail")
        deallocate(arr_recovered)


        slice = arr_2d(:,1)
        status = datablock_replace_double_array_1d(block, "MAGIC", "SLICE", arr_2d(:,1))
        call cosmosis_assert(status==0, "Replace double slice 2 did not work")
        status = datablock_get_double_array_1d(block, "MAGIC", "SLICE", arr_recovered, size_recovered)
        call cosmosis_assert(status==0, "Get double slice 2 did not work")
        call cosmosis_assert(all(slice==arr_recovered), "Slice dim 2 fail")
        deallocate(arr_recovered)


        status = destroy_c_datablock(block)
        call cosmosis_assert(status==0, "Destroy failed")
    end subroutine test_double_array


end program test_cosmosis

module priors_module
    use utils_module, only: dp
    implicit none

    integer, parameter :: unknown_type        = 0
    integer, parameter :: uniform_type        = 1
    integer, parameter :: gaussian_type       = 2
    integer, parameter :: log_uniform_type    = 3
    integer, parameter :: sorted_uniform_type = 4

    type prior
        integer :: npars = 0
        integer :: prior_type = unknown_type
        integer, dimension(:), allocatable :: hypercube_indices
        integer, dimension(:), allocatable :: physical_indices

        real(dp), dimension(:), allocatable :: parameters

    end type prior



    contains


    !============= Uniform (Separable) ================================================

    function uniform_htp(hypercube_coords,parameters) result(physical_coords)
        implicit none
        !> The hypercube coordinates to be transformed
        real(dp), intent(in), dimension(:) :: hypercube_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(hypercube_coords)) :: physical_coords

        ! This is a fairly simple transformation, each parameter is transformed as
        ! hypercube_coord -> min + hypercube_coord * (max-min)
        ! odd indices of the parameters array are the minimums
        ! even indices of the parameters array are the maximums

        physical_coords = parameters(1::2) + (parameters(2::2) - parameters(1::2) ) * hypercube_coords

    end function uniform_htp

    function uniform_pth(physical_coords,parameters) result(hypercube_coords)
        implicit none
        !> The physical coordinates to be transformed
        real(dp), intent(in), dimension(:) :: physical_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(physical_coords)) :: hypercube_coords

        hypercube_coords = (physical_coords - parameters(1::2)) / (parameters(2::2) - parameters(1::2) )

    end function uniform_pth


    !============= Gaussian (Separable) ===============================================

    function gaussian_htp(hypercube_coords,parameters) result(physical_coords)
        use utils_module, only: inv_normal_cdf
        implicit none
        !> The hypercube coordinates to be transformed
        real(dp), intent(in), dimension(:) :: hypercube_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(hypercube_coords)) :: physical_coords

        ! Transform via the inverse normal cumulative distribution function
        physical_coords = inv_normal_cdf(hypercube_coords)

        ! Scale by the standard deviation and shift by the mean
        physical_coords = parameters(1::2) + parameters(2::2) * physical_coords

    end function gaussian_htp

    function gaussian_pth(physical_coords,parameters) result(hypercube_coords)
        use utils_module, only: normal_cdf
        implicit none
        !> The physical coordinates to be transformed
        real(dp), intent(in), dimension(:) :: physical_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(physical_coords)) :: hypercube_coords

        integer :: npars 

        npars=size(physical_coords)

        ! Scale by the standard deviation and shift by the mean
        ! odd indices of the parameters array are the means
        ! even indices of the parameters array are the stdevs

        hypercube_coords = ( physical_coords - parameters(1::2) )/parameters(2::2)

        ! Transform via the normal cumulative distribution function
        hypercube_coords = normal_cdf(hypercube_coords)

    end function gaussian_pth





    !============= Log-Uniform (Separable) ============================================
    function log_uniform_htp(hypercube_coords,parameters) result(physical_coords)
        implicit none
        !> The hypercube coordinates to be transformed
        real(dp), intent(in), dimension(:) :: hypercube_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(hypercube_coords)) :: physical_coords

        ! hypercube_coord -> min * (max/min)**hypercube_coord
        ! Lower half of the parameters array are the minimums
        ! Upper half of the parameters array are the maximums
        physical_coords = parameters(1::2) * (parameters(2::2)/parameters(1::2)) ** hypercube_coords

    end function log_uniform_htp

    function log_uniform_pth(physical_coords,parameters) result(hypercube_coords)
        implicit none
        !> The physical coordinates to be transformed
        real(dp), intent(in), dimension(:) :: physical_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(physical_coords)) :: hypercube_coords

        ! hypercube_coord -> min * (max/min)**hypercube_coord
        ! Lower half of the parameters array are the minimums
        ! Upper half of the parameters array are the maximums
        hypercube_coords = log(physical_coords/parameters(1::2)) / log(parameters(2::2)/parameters(1::2))

    end function log_uniform_pth



    !============= Sorted Uniform =====================================================

    !> This transforms the unit hypercube to a "forced identifiablity" prior.
    !! This means that the \f$(\theta_1,\theta_2,\ldots,\theta_n)\f$ variables are uniformly distributed in the
    !! physical prior space between \f$\theta_\mathrm{min}\f$ and \f$\theta_\mathrm{max}\f$, but have been sorted so
    !! that \f$(\theta_1<\theta_2<\ldots<\theta_n)\f$. This amounts to choosing a non-separable prior such that:
    !!
    !! \f[ \pi_n(\theta_n)            
    !!     =  n  \frac{(\theta_n-\theta_\mathrm{min})^{n-1}}{(\theta_\mathrm{max}-\theta_\mathrm{min})^n}
    !!     \qquad  \theta_\mathrm{min}<\theta_n<\theta_\mathrm{max} \f]
    !! \f[ \pi_{n-1}(\theta_{n-1}|\theta_n)            
    !!     =(n-1)\frac{(\theta_{n-1}-\theta_\mathrm{min})^{n-2}}{(\theta_\mathrm{max}-\theta_\mathrm{min})^{n-1}}
    !!     \qquad  \theta_\mathrm{min}<\theta_{n-1}<\theta_n \f]
    !! \f[ \pi_{n-2}(\theta_{n-2}|\theta_n,\theta{n-1})            
    !!     =(n-2)\frac{(\theta_{n-2}-\theta_\mathrm{min})^{n-3}}{(\theta_\mathrm{max}-\theta_\mathrm{min})^{n-2}}
    !!     \qquad  \theta_\mathrm{min}<\theta_{n-2}<\theta_{n-1} \f]
    !! \f[...\f]
    !! \f[ \pi_1(\theta_1|\theta_n,\ldots,\theta_2)            
    !!     =\frac{1}{(\theta_\mathrm{max}-\theta_\mathrm{min})}
    !!     \qquad  \theta_\mathrm{min}<\theta_1<\theta_2 \f]
    !!
    !! The first of these is the probability density for the largest of n points
    !! in \f$[\theta_\mathrm{min},\theta_\mathrm{max}]\f$.
    !!
    !! For the next highest point it is the smallest of \f$n-1\f$ points in the
    !! range \f$[\theta_\mathrm{min},\theta_n]\f$. 
    !!
    !! To perform this transformation, it is cleanest to do this in two
    !! steps. First perform the above transformations using the inverse of the cumulative
    !! distribution function:
    !! \f[ CDF^{-1}(x) = x^{1/n} \f]
    !!
    !! Then transform the unit hypercube into the physical space with a linear
    !! rescaling

    function sorted_uniform_htp(hypercube_coords,parameters) result(physical_coords)
        implicit none

        !> The hypercube coordinates to be transformed
        real(dp), intent(in), dimension(:) :: hypercube_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(hypercube_coords)) :: physical_coords

        integer n_prior ! the dimension

        ! Get the size of the array
        n_prior = size(hypercube_coords)

        ! Transform the largest index to the largest of n_prior variables in [0,1]
        physical_coords(n_prior) = hypercube_coords(n_prior)**(1d0/n_prior)

        ! Then for the remaining variables, transform them to the largest of the
        ! remaining variables, and rescale so that the variable one larger is
        ! the maximum
        do n_prior=n_prior-1,1,-1
            physical_coords(n_prior) = hypercube_coords(n_prior)**(1d0/n_prior)*physical_coords(n_prior+1)
        end do

        ! Rescale using the parameters
        physical_coords = parameters(1) + physical_coords*(parameters(2)-parameters(1))

    end function sorted_uniform_htp


    function sorted_uniform_pth(physical_coords,parameters) result(hypercube_coords)
        implicit none

        !> The physical coordinates to be transformed
        real(dp), intent(in), dimension(:) :: physical_coords

        !> The parameters of the transformation
        real(dp), intent(in), dimension(:) :: parameters

        !> The transformed coordinates
        real(dp), dimension(size(physical_coords)) :: hypercube_coords

        integer n_prior ! the dimension
        integer i_prior ! the dimension

        ! Get the size of the array
        n_prior = size(physical_coords)


        ! Rescale back to [0,1]
        hypercube_coords =  (physical_coords - parameters(1)) / (parameters(2)-parameters(1))  

        ! Undo the trasformation piece by piece
        do i_prior = 1,n_prior-1
            hypercube_coords(i_prior) = ( hypercube_coords(i_prior)/hypercube_coords(i_prior+1) )**i_prior
        end do
        hypercube_coords(n_prior) = hypercube_coords(n_prior)**n_prior


    end function sorted_uniform_pth




    ! =============================== Wrapper functions =====================================

    ! prior transformations
    function hypercube_to_physical(hypercube_coords,priors) result(physical_coords)
        implicit none
        type(prior), dimension(:), intent(in) :: priors
        real(dp), intent(in), dimension(:) :: hypercube_coords

        real(dp), dimension(size(hypercube_coords)) :: physical_coords

        integer :: i

        physical_coords=0d0

        do i=1,size(priors)
            select case(priors(i)%prior_type)
            case(uniform_type)
                physical_coords(priors(i)%physical_indices)= uniform_htp&
                    (hypercube_coords(priors(i)%hypercube_indices),priors(i)%parameters)
            case(gaussian_type)
                physical_coords(priors(i)%physical_indices)= gaussian_htp&
                    (hypercube_coords(priors(i)%hypercube_indices),priors(i)%parameters)
            case(log_uniform_type)
                physical_coords(priors(i)%physical_indices)= log_uniform_htp&
                    (hypercube_coords(priors(i)%hypercube_indices),priors(i)%parameters)
            case(sorted_uniform_type)
                physical_coords(priors(i)%physical_indices)= sorted_uniform_htp&
                    (hypercube_coords(priors(i)%hypercube_indices),priors(i)%parameters)
            end select
        end do

    end function hypercube_to_physical

    function physical_to_hypercube(physical_coords,priors) result(hypercube_coords)
        implicit none
        type(prior), dimension(:), intent(in) :: priors
        real(dp), intent(in), dimension(:) :: physical_coords

        real(dp), dimension(size(physical_coords)) :: hypercube_coords

        integer :: i

        hypercube_coords=0d0

        do i=1,size(priors)
            select case(priors(i)%prior_type)
            case(uniform_type)
                hypercube_coords(priors(i)%hypercube_indices)= uniform_pth&
                    (physical_coords(priors(i)%physical_indices),priors(i)%parameters)
            case(gaussian_type)
                hypercube_coords(priors(i)%hypercube_indices)= gaussian_pth&
                    (physical_coords(priors(i)%physical_indices),priors(i)%parameters)
            case(log_uniform_type)
                hypercube_coords(priors(i)%hypercube_indices)= log_uniform_pth&
                    (physical_coords(priors(i)%physical_indices),priors(i)%parameters)
            case(sorted_uniform_type)
                hypercube_coords(priors(i)%hypercube_indices)= sorted_uniform_pth&
                    (physical_coords(priors(i)%physical_indices),priors(i)%parameters)
            end select
        end do

    end function physical_to_hypercube



    function prior_log_volume(priors) result(log_volume)
        use utils_module, only: logTwoPi
        implicit none
        type(prior), dimension(:), intent(in) :: priors

        real(dp) :: log_volume
        integer :: i

        log_volume = 0

        do i=1,size(priors)
            select case(priors(i)%prior_type)
            case(uniform_type)
                log_volume = log_volume + sum( log(priors(i)%parameters(2::2)- priors(i)%parameters(1::2) )) 
            case(gaussian_type)
                log_volume = log_volume + sum( 0.5d0*logTwoPi + log(priors(i)%parameters(2::2)) )
            case(log_uniform_type)
                log_volume = log_volume + sum( log(log( priors(i)%parameters(2::2)/priors(i)%parameters(1::2) )) ) 
            case(sorted_uniform_type)
                log_volume = log_volume + log(priors(i)%parameters(2)- priors(i)%parameters(1) ) - log(gamma(1d0+priors(i)%npars)) 
            end select
        end do

    end function prior_log_volume




    !> This function converts from strings to integer prior types
    function prior_type_from_string(string) result(prior_type)
        use utils_module, only: STR_LENGTH
        implicit none
        character(len=*),intent(in) :: string
        integer :: prior_type

        character(len=STR_LENGTH) :: string_buf

        write(string_buf,'(A)') string

        select case(trim(string_buf))

        case('uniform')
            prior_type=uniform_type
        case('gaussian')
            prior_type=gaussian_type
        case('log_uniform')
            prior_type=log_uniform_type
        case('sorted_uniform')
            prior_type=sorted_uniform_type
        case default
            prior_type=unknown_type
        end select

    end function prior_type_from_string



    !> This function converts an array of parameters into a set of prior blocks
    subroutine create_priors(priors,params,settings)
        use settings_module,   only: program_settings
        use params_module, only: param_type
        use utils_module,  only: relabel
        implicit none 
        type(prior), dimension(:), allocatable,intent(out)   :: priors  !> The array of priors to be returned
        type(param_type),dimension(:),allocatable,intent(in) :: params  !> Parameter array
        type(program_settings), intent(inout) :: settings !> Program settings

        integer, dimension(size(params)) :: prior_blocks
        integer :: num_blocks

        integer :: num_params
        integer :: i_params

        integer, dimension(size(params)) :: speeds_old
        integer, dimension(size(params)) :: speeds
        integer :: i_speed
        integer, parameter :: max_speed = huge(1)

        integer, dimension(size(params)) :: hypercube_indices
        integer :: i_hypercube

        num_params = size(params) 

        ! First determine how many prior blocks there are
        do i_params=1,num_params
            prior_blocks(i_params) = params(i_params)%prior_block
        end do
        ! re-organise these labels
        prior_blocks = relabel(prior_blocks,num_blocks)

        ! Allocate the priors array
        if(allocated(priors)) deallocate(priors)
        allocate(priors(num_blocks))


        ! Next determine the hypercube indices via the grades

        ! Find the various speeds:
        do i_params=1,num_params
            speeds_old(i_params) = params(i_params)%speed
        end do

        ! Relabel them with the numbers 1,2,3...
        i_speed = 0
        do while(any(speeds_old/=max_speed))
            i_speed=i_speed+1
            where(speeds_old==minval(speeds_old))
                speeds=i_speed
                speeds_old=max_speed
            end where
        end do

        if(allocated(settings%grade_dims)) deallocate(settings%grade_dims)
        allocate(settings%grade_dims(maxval(speeds)))

        ! Now assign hypercube indices
        i_hypercube = 0
        do i_speed=1,maxval(speeds)
            do i_params=1,num_params
                if(speeds(i_params)==i_speed) then
                    i_hypercube=i_hypercube+1
                    hypercube_indices(i_params) = i_hypercube
                end if
            end do
            settings%grade_dims(i_speed) = count(speeds==i_speed)
        end do

        allocate(settings%sub_clustering_dimensions(count([ (params(i_params)%sub_cluster, i_params=1,num_params) ])))
        settings%sub_clustering_dimensions = pack(hypercube_indices, [ (params(i_params)%sub_cluster, i_params=1,num_params) ] ) 


        ! Finally, add each of the parameters to the prior blocks, coupled with the hypercube information
        do i_params=1,num_params
            call add_param_to_prior(priors(prior_blocks(i_params)),params(i_params),i_params,hypercube_indices(i_params))
        end do

    end subroutine create_priors

    subroutine add_param_to_prior(priori,param,physical_index,hypercube_index)
        use params_module, only: param_type
        use array_module,  only: reallocate
        use abort_module,  only: halt_program
        implicit none
        type(prior), intent(inout)   :: priori          !> The prior to be added to
        type(param_type),intent(in)  :: param           !> The params to add
        integer, intent(in)          :: physical_index  !> The position in the likelihood call
        integer, intent(in)          :: hypercube_index !> The position in the unit hypercube

        ! Allocate physical indices if it is unallocated
        if(.not.allocated(priori%physical_indices))  allocate(priori%physical_indices(0))
        if(.not.allocated(priori%hypercube_indices)) allocate(priori%hypercube_indices(0))

        priori%npars=priori%npars+1                               ! Increment the number of parameters

        call reallocate(priori%physical_indices,priori%npars) ! reallocate the physical index array
        priori%physical_indices(priori%npars) = physical_index    ! give it the physical index of this point

        call reallocate(priori%hypercube_indices,priori%npars) ! reallocate the physical index array
        priori%hypercube_indices(priori%npars) = hypercube_index   ! give it the physical index of this point

        if(priori%prior_type==unknown_type) then
            priori%prior_type = param%prior_type
        else if(priori%prior_type/= param%prior_type) then
            call halt_program('create_priors error: parameter '//trim(param%paramname)// ' must have the same prior type as others within its block')
        end if

        ! Allocate the prior parameters if its unallocated
        if (.not. allocated(priori%parameters) ) allocate(priori%parameters(0))
        ! expand the parameters array by size prior_params
        call reallocate(priori%parameters,size(priori%parameters)+size(param%prior_params))
        ! add these to the end
        priori%parameters(size(priori%parameters)-size(param%prior_params)+1:size(priori%parameters)) =param%prior_params


    end subroutine add_param_to_prior






end module priors_module

!> This module contains 'generating tools', namely:
!!
!! * GenerateSeed
!! * GenerateLivePoints
module generate_module
    use utils_module, only: dp


    implicit none

    contains


    !> This function generates a seed point for slice sampling.
    !!
    !! It uses the existing set of live points and the details of the clustering
    !! in order to select a seed point to generate from in proportion to the
    !! estimates of the prior volume of each cluster.
    function GenerateSeed(settings,RTI,seed_cluster) result(seed_point)
        use settings_module,   only: program_settings
        use run_time_module,   only: run_time_info
        use random_module,     only: random_integer,random_integer_P,bernoulli_trial
        use utils_module,      only: logsumexp
        implicit none

        !> Program settings
        type(program_settings), intent(in) :: settings
        !> The evidence storage
        type(run_time_info), intent(in) :: RTI
        !> The cluster number chosen
        integer,intent(out) :: seed_cluster


        ! The seed point to be produced
        real(dp), dimension(settings%nTotal) :: seed_point

        integer :: seed_choice

        real(dp), dimension(RTI%ncluster) :: probs

        ! 0) Calculate an array proportional to the volumes
        probs = RTI%logXp                 ! prob_p = log( X_p )
        probs = probs - logsumexp(probs)  ! prob_p = log( X_p/(sum_q X_q) )
        probs = exp(probs)                ! prob_p = X_p/(sum_q X_q)

        ! 1) Pick cluster in proportion to the set of volume estimates of the active clusters
        seed_cluster = random_integer_P(probs)

        ! 3) Pick a random integer in between 1 and the number of live points in the cluster 'p'
        seed_choice = random_integer(RTI%nlive(seed_cluster))

        ! 4) Select the live point at index 'seed_choice' in cluster 'p' for the seed point
        seed_point = RTI%live(:,seed_choice,seed_cluster)

    end function GenerateSeed




    !> Generate an initial set of live points distributed uniformly in the unit hypercube in parallel
    subroutine GenerateLivePoints(loglikelihood,prior,settings,RTI,mpi_information)
        use settings_module,  only: program_settings
        use random_module,   only: random_reals
        use utils_module,    only: write_phys_unit,DB_FMT,fmt_len,minpos,time
        use calculate_module, only: calculate_point
        use read_write_module, only: phys_live_file
        use feedback_module,  only: write_started_generating,write_finished_generating,write_generating_live_points
        use run_time_module,   only: run_time_info,initialise_run_time_info
        use array_module,     only: add_point
        use abort_module
#ifdef MPI
        use mpi_module, only: mpi_bundle,is_root,linear_mode,throw_point,catch_point,more_points_needed,sum_integers,sum_doubles,request_point,no_more_points
#else
        use mpi_module, only: mpi_bundle,is_root,linear_mode
#endif

        implicit none

        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in), dimension(:)  :: theta
                real(dp), intent(out), dimension(:) :: phi
                real(dp) :: loglikelihood
            end function
        end interface
        interface
            function prior(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function
        end interface


        !> Program settings
        type(program_settings), intent(in) :: settings

        ! The run time info (very important, see src/run_time_info.f90)
        type(run_time_info) :: RTI

        type(mpi_bundle),intent(in) :: mpi_information
#ifdef MPI
        integer             :: active_slaves    !  Number of currently working slaves
        integer             :: slave_id         !  Slave identifier to signal who to throw back to
#endif

        real(dp), dimension(settings%nTotal) :: live_point ! Temporary live point array


        character(len=fmt_len) :: fmt_dbl ! writing format variable

        integer :: nlike ! number of likelihood calls
        integer :: nprior

        real(dp) :: time0,time1,total_time
        real(dp),dimension(size(settings%grade_dims)) :: speed


        ! Initialise number of likelihood calls to zero here
        nlike = 0


        if(is_root(mpi_information)) then
            ! ---------------------------------------------- !
            call write_started_generating(settings%feedback)
            ! ---------------------------------------------- !

            ! Initialise the format
            write(fmt_dbl,'("(",I0,A,")")') settings%nDims+settings%nDerived+1, DB_FMT

            ! Open the live points file to sequentially add live points
            if(settings%write_live) open(write_phys_unit,file=trim(phys_live_file(settings)), action='write')

            ! Allocate the run time arrays, and set the default values for the variables
            call initialise_run_time_info(settings,RTI)

        end if

        if (settings%nprior <= 0) then
            nprior = settings%nlive
        else
            nprior = settings%nprior
        end if

        total_time=0
        if(linear_mode(mpi_information)) then
            !===================== LINEAR MODE =========================

            do while(RTI%nlive(1)<nprior)

                ! Generate a random coordinate
                live_point(settings%h0:settings%h1) = random_reals(settings%nDims)

                ! Compute physical coordinates, likelihoods and derived parameters
                time0 = time()
                call calculate_point( loglikelihood, prior, live_point, settings, nlike)
                time1 = time()
                live_point(settings%b0) = settings%logzero

                ! If its valid, and we need more points, add it to the array
                if(live_point(settings%l0)>settings%logzero) then
                    total_time =total_time+ time1-time0

                    call add_point(live_point,RTI%live,RTI%nlive,1) ! Add this point to the array

                    !-------------------------------------------------------------------------------!
                    call write_generating_live_points(settings%feedback,RTI%nlive(1),nprior)
                    !-------------------------------------------------------------------------------!

                    if(settings%write_live) then
                        ! Write the live points to the live_points file
                        write(write_phys_unit,fmt_dbl) live_point(settings%p0:settings%d1), live_point(settings%l0)
                        flush(write_phys_unit) ! flush the unit to force write
                    end if

                end if

            end do


#ifdef MPI
        else 
            !===================== PARALLEL MODE =======================

            if(is_root(mpi_information)) then
                ! The root node just recieves data from all other processors


                active_slaves=mpi_information%nprocs-1 ! Set the number of active processors to the number of slaves

                do while(active_slaves>0) 

                    ! Recieve a point from any slave
                    slave_id = catch_point(live_point,mpi_information)

                    ! If its valid, and we need more points, add it to the array
                    if(live_point(settings%l0)>settings%logzero .and. RTI%nlive(1)<nprior) then

                        call add_point(live_point,RTI%live,RTI%nlive,1) ! Add this point to the array

                        !-------------------------------------------------------------------------------!
                        call write_generating_live_points(settings%feedback,RTI%nlive(1),nprior)
                        !-------------------------------------------------------------------------------!

                        if(settings%write_live) then
                            ! Write the live points to the live_points file
                            write(write_phys_unit,fmt_dbl) live_point(settings%p0:settings%d1), live_point(settings%l0)
                            flush(write_phys_unit) ! flush the unit to force write
                        end if

                    end if


                    if(RTI%nlive(1)<nprior) then
                        call request_point(mpi_information,slave_id)  ! If we still need more points, send a signal to have another go
                    else
                        call no_more_points(mpi_information,slave_id) ! Otherwise, send a signal to stop
                        active_slaves=active_slaves-1                  ! decrease the active slave counter
                    end if

                end do




            else

                ! The slaves simply generate and send points until they're told to stop by the master
                do while(.true.)
        
                    live_point(settings%h0:settings%h1) = random_reals(settings%nDims)       ! Generate a random hypercube coordinate
                    time0 = time()
                    call calculate_point( loglikelihood, prior, live_point, settings,nlike) ! Compute physical coordinates, likelihoods and derived parameters
                    time1 = time()
                    live_point(settings%b0) = settings%logzero
                    if(live_point(settings%l0)>settings%logzero) total_time = total_time + time1-time0
                    call throw_point(live_point,mpi_information)                                    ! Send it to the root node
                    if(.not. more_points_needed(mpi_information)) exit                              ! If we've recieved a kill signal, then exit this loop

                end do
            end if
#endif
        end if !(nprocs case)

#ifdef MPI
        nlike = sum_integers(nlike,mpi_information) ! Gather the likelihood calls onto one node
        total_time = sum_doubles(total_time,mpi_information) ! Sum up the total time taken
#endif


        ! ----------------------------------------------- !
        if(is_root(mpi_information)) call write_finished_generating(settings%feedback)  
        ! ----------------------------------------------- !
        ! Find the average time taken
        speed(1) = total_time/nprior
        call time_speeds(loglikelihood,prior,settings,RTI,speed,mpi_information) 



        if(is_root(mpi_information)) then

            ! Pass over the number of likelihood calls
            RTI%nlike(1) = nlike

            ! Set the local and global loglikelihood bounds
            RTI%i(1)  = minpos(RTI%live(settings%l0,:,1)) ! Find the position of the minimum loglikelihood
            RTI%logLp = RTI%live(settings%l0,RTI%i(1),1)  ! Store the value of the minimum loglikelihood 

            ! Close the file
            if(settings%write_live) close(write_phys_unit)

            if(.not. allocated(RTI%num_repeats) ) allocate(RTI%num_repeats(size(settings%grade_dims)))
            RTI%num_repeats(1) = settings%num_repeats
            RTI%num_repeats(2:) = nint(settings%grade_frac(2:)/(settings%grade_frac(1)+0d0)*RTI%num_repeats(1)*speed(1)/speed(2:))

            ! Set the posterior thinning factor
            if(settings%boost_posterior<0d0) then
                RTI%thin_posterior = 1d0
            else
                RTI%thin_posterior = (settings%boost_posterior+0d0)/(sum(RTI%num_repeats)+0d0)
            end if

        end if





    end subroutine GenerateLivePoints



    subroutine time_speeds(loglikelihood,prior,settings,RTI,speed,mpi_information)
        use settings_module,  only: program_settings
        use run_time_module,   only: run_time_info
        use random_module,   only: random_reals
        use utils_module,    only: normal_fb,stdout_unit,fancy_fb,time
        use calculate_module, only: calculate_point
        use abort_module
#ifdef MPI
        use mpi_module, only: mpi_bundle,is_root,sum_doubles,sum_integers
#else
        use mpi_module, only: mpi_bundle,is_root
#endif

        implicit none

        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),  dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function
        end interface
        interface
            function prior(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function
        end interface


        !> Program settings
        type(program_settings), intent(in) :: settings
       
        ! The run time info (very important, see src/run_time_info.f90)
        type(run_time_info) :: RTI

        real(dp),dimension(size(settings%grade_dims)) :: speed

        type(mpi_bundle), intent(in) :: mpi_information

        integer :: i_speed
        integer :: i_live
        integer :: nlike
        integer :: h0,h1
        integer :: failed

        real(dp) :: time0,time1,total_time

        real(dp), dimension(settings%nTotal) :: live_point ! Temporary live point array

        nlike=0

        ! Calculate a slow likelihood
        do 
            live_point(settings%h0:settings%h1) = random_reals(settings%nDims)
            call calculate_point( loglikelihood, prior, live_point, settings, nlike)
            live_point(settings%b0) = settings%logzero
            if (live_point(settings%l0)> settings%logzero) exit
        end do

        if (is_root(mpi_information)) then
            if(settings%feedback>=normal_fb) write(stdout_unit,'(A1,"Speed ",I2," = ",E10.3, " seconds")') char(13), 1, speed(1)
        end if
        do i_speed=2,size(speed)

            h0 = settings%h0+sum(settings%grade_dims(:i_speed-1))
            h1 = settings%h1

            i_live=0
            total_time=0
            
            if (is_root(mpi_information)) then
                if(settings%feedback>=fancy_fb) then
                    write(stdout_unit,'(A1,"Speed ",I2, " = ? (calculating)")',advance='no') char(13), i_speed
                    flush(stdout_unit)
                end if
            end if

            failed = 0
            do while( total_time/settings%grade_frac(i_speed)< speed(1)/settings%grade_frac(1) *settings%nlive / dble(mpi_information%nprocs ))
                live_point(h0:h1) = random_reals(h1-h0+1)

                time0 = time()
                call calculate_point( loglikelihood, prior, live_point, settings, nlike)
                time1 = time()
                live_point(settings%b0) = settings%logzero

                if(live_point(settings%l0)>settings%logzero) then
                    total_time=total_time+time1-time0
                    i_live=i_live+1
                else
                    failed = failed + 1
                    if (failed > 10*(i_live+1)) then
                        ! Do another slow likelihood calculation
                        do 
                            live_point(settings%h0:settings%h1) = random_reals(settings%nDims)
                            call calculate_point( loglikelihood, prior, live_point, settings, nlike)
                            live_point(settings%b0) = settings%logzero
                            if (live_point(settings%l0)> settings%logzero) exit
                        end do
                        failed = 0
                    end if
                end if

            end do
#ifdef MPI
            total_time=sum_doubles(total_time,mpi_information)
            i_live = sum_integers(i_live,mpi_information)
            nlike = sum_integers(nlike,mpi_information)
#endif
            speed(i_speed) = total_time/i_live
            if (is_root(mpi_information)) then
                RTI%nlike(i_speed) =  RTI%nlike(i_speed) + nlike 
                if(settings%feedback>=fancy_fb) then
                    write(stdout_unit,'(A1,"Speed ",I2," = ",E10.3, " seconds     ")') char(13), i_speed, speed(i_speed)
                else if(settings%feedback>=normal_fb) then
                    write(stdout_unit,'("Speed ",I2," = ",E10.3, " seconds     ")') i_speed, speed(i_speed)
                end if
            end if


        end do

    end subroutine time_speeds


    subroutine GenerateLivePointsFromSeed(loglikelihood,prior,settings,RTI,mpi_information)
        use settings_module,  only: program_settings
        use utils_module,    only: write_phys_unit,DB_FMT,fmt_len,minpos,time,stdout_unit
        use calculate_module, only: calculate_point
        use read_write_module, only: phys_live_file
        use feedback_module,  only: write_started_generating,write_finished_generating,write_generating_live_points
        use run_time_module,   only: run_time_info,initialise_run_time_info
        use array_module,     only: add_point
        use abort_module
        use chordal_module, only: slice_sample
#ifdef MPI
        use mpi_module, only: mpi_bundle,is_root,linear_mode,throw_point,catch_point,more_points_needed,sum_integers,sum_doubles,request_point,no_more_points
#else
        use mpi_module, only: mpi_bundle,is_root,linear_mode
#endif

        implicit none

        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in), dimension(:)  :: theta
                real(dp), intent(out), dimension(:) :: phi
                real(dp) :: loglikelihood
            end function
        end interface
        interface
            function prior(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function
        end interface


        !> Program settings
        type(program_settings), intent(in) :: settings

        ! The run time info (very important, see src/run_time_info.f90)
        type(run_time_info) :: RTI

        type(mpi_bundle),intent(in) :: mpi_information
#ifdef MPI
        integer             :: active_slaves    !  Number of currently working slaves
        integer             :: slave_id         !  Slave identifier to signal who to throw back to
#endif

        real(dp), dimension(settings%nTotal) :: live_point ! Temporary live point array


        character(len=fmt_len) :: fmt_dbl ! writing format variable

        integer :: nprior

        real(dp) :: time0,time1
        real(dp),dimension(size(settings%grade_dims)) :: speed
        real(dp),dimension(size(settings%grade_dims)) :: times
        integer, dimension(size(settings%grade_dims)) :: nlikes

        integer :: i_dim,i_repeat,i_grade
        integer, dimension(settings%nDims) :: grade
        real(dp), dimension(settings%nDims) :: nhat

        do i_grade = size(settings%grade_dims),1,-1
            grade(:sum(settings%grade_dims(:i_grade))) = i_grade
        end do
        nlikes = 0
        times = 0d0

        if(is_root(mpi_information)) then
            ! ---------------------------------------------- !
            call write_started_generating(settings%feedback)
            ! ---------------------------------------------- !

            ! Initialise the format
            write(fmt_dbl,'("(",I0,A,")")') settings%nDims+settings%nDerived+1, DB_FMT

            ! Open the live points file to sequentially add live points
            if(settings%write_live) open(write_phys_unit,file=trim(phys_live_file(settings)), action='write')

            ! Allocate the run time arrays, and set the default values for the variables
            call initialise_run_time_info(settings,RTI)

        end if

        if (settings%nprior <= 0) then
            nprior = settings%nlive
        else
            nprior = settings%nprior
        end if

        if(linear_mode(mpi_information)) then
            !===================== LINEAR MODE =========================

            do while(RTI%nlive(1)<nprior)
                live_point = settings%seed_point
                do i_repeat = 1,settings%nprior_repeat
                    i_dim = 1+mod(i_repeat,settings%nDims)
                    i_grade = grade(i_dim)
                    nhat = 0d0
                    nhat(i_dim) = 1d0

                    time0 = time()
                    live_point = slice_sample(loglikelihood,prior,settings%logzero,nhat,live_point,1d0,settings,nlikes(i_grade))
                    time1 = time()
                    times(i_grade) = times(i_grade) + time1 - time0
                end do

                call add_point(live_point,RTI%live,RTI%nlive,1) ! Add this point to the array
                call write_generating_live_points(settings%feedback,RTI%nlive(1),nprior)
                if(settings%write_live) then
                    ! Write the live points to the live_points file
                    write(write_phys_unit,fmt_dbl) live_point(settings%p0:settings%d1), live_point(settings%l0)
                    flush(write_phys_unit) ! flush the unit to force write
                end if

            end do

#ifdef MPI
        else 
            !===================== PARALLEL MODE =======================

            if(is_root(mpi_information)) then
                ! The root node just recieves data from all other processors

                active_slaves=mpi_information%nprocs-1 ! Set the number of active processors to the number of slaves

                do while(active_slaves>0) 

                    ! Recieve a point from any slave
                    slave_id = catch_point(live_point,mpi_information)

                    ! If its valid, and we need more points, add it to the array
                    if(RTI%nlive(1)<nprior) then

                        call add_point(live_point,RTI%live,RTI%nlive,1) ! Add this point to the array

                        !-------------------------------------------------------------------------------!
                        call write_generating_live_points(settings%feedback,RTI%nlive(1),nprior)
                        !-------------------------------------------------------------------------------!

                        if(settings%write_live) then
                            ! Write the live points to the live_points file
                            write(write_phys_unit,fmt_dbl) live_point(settings%p0:settings%d1), live_point(settings%l0)
                            flush(write_phys_unit) ! flush the unit to force write
                        end if

                    end if


                    if(RTI%nlive(1)<nprior) then
                        call request_point(mpi_information,slave_id)  ! If we still need more points, send a signal to have another go
                    else
                        call no_more_points(mpi_information,slave_id) ! Otherwise, send a signal to stop
                        active_slaves=active_slaves-1                  ! decrease the active slave counter
                    end if

                end do




            else

                ! The slaves simply generate and send points until they're told to stop by the master
                live_point = settings%seed_point
                do while(.true.)
                    do i_repeat = 1,5
                        do i_dim=1,settings%nDims
                            i_grade = grade(i_dim)
                            nhat = 0d0
                            nhat(i_dim) = 1d0

                            time0 = time()
                            live_point = slice_sample(loglikelihood,prior,settings%logzero,nhat,live_point,1d0,settings,nlikes(i_grade))
                            time1 = time()
                            times(i_grade) = times(i_grade) + time1 - time0
                        end do
                    end do
        
                    call throw_point(live_point,mpi_information)                                    ! Send it to the root node
                    if(.not. more_points_needed(mpi_information)) exit                              ! If we've recieved a kill signal, then exit this loop

                end do
            end if
#endif
        end if !(nprocs case)

#ifdef MPI
        do i_grade=1,size(settings%grade_dims)
            nlikes(i_grade) = sum_integers(nlikes(i_grade),mpi_information) ! Gather the likelihood calls onto one node
            times(i_grade) = sum_doubles(times(i_grade),mpi_information) ! Sum up the total time taken
        end do
#endif


        ! ----------------------------------------------- !
        if(is_root(mpi_information)) call write_finished_generating(settings%feedback)  
        ! ----------------------------------------------- !

        if(is_root(mpi_information)) then
            ! Find the average time taken
            speed = times/nlikes

            do i_grade = 1,size(settings%grade_dims)
                write(stdout_unit,'("Speed ",I2," = ",E10.3, " seconds     ")') i_grade, speed(i_grade)
            end do


            ! Pass over the number of likelihood calls
            RTI%nlike = nlikes

            ! Set the local and global loglikelihood bounds
            RTI%i(1)  = minpos(RTI%live(settings%l0,:,1)) ! Find the position of the minimum loglikelihood
            RTI%logLp = RTI%live(settings%l0,RTI%i(1),1)  ! Store the value of the minimum loglikelihood 

            ! Close the file
            if(settings%write_live) close(write_phys_unit)

            if(.not. allocated(RTI%num_repeats) ) allocate(RTI%num_repeats(size(settings%grade_dims)))
            RTI%num_repeats(1) = settings%num_repeats
            RTI%num_repeats(2:) = nint(settings%grade_frac(2:)/(settings%grade_frac(1)+0d0)*RTI%num_repeats(1)*speed(1)/speed(2:))

            ! Set the posterior thinning factor
            if(settings%boost_posterior<0d0) then
                RTI%thin_posterior = 1d0
            else
                RTI%thin_posterior = (settings%boost_posterior+0d0)/(sum(RTI%num_repeats)+0d0)
            end if

        end if





    end subroutine GenerateLivePointsFromSeed







end module generate_module

module like
	
use params
use utils1
implicit none
      
contains
      
      
!=======================================================================

subroutine slikelihood(Cube,slhood)
         
	implicit none
      
	double precision Cube(nest_nPar),slhood
	integer i,j
	
	slhood = 0d0
	
	do i = 1, sdim
		Cube(i) = spriorran(i, 1) + ( spriorran(i, 2) - spriorran(i, 1) ) * Cube(i)
	enddo
	
	do i = 1, sdim - 1
		slhood = slhood - ( ( ( 1d0 - Cube(i) ) ** 2 ) + 100d0 * ( ( Cube(i+1) - ( Cube(i) ** 2 ) ) ** 2 ) )
	enddo

end subroutine slikelihood
      
!=======================================================================

end module like

module params_module
    use utils_module, only: dp
    use utils_module, only: STR_LENGTH
    implicit none

    type param_type
        character(len=STR_LENGTH) :: paramname   ! Name of parameter
        character(len=STR_LENGTH) :: latex       ! LaTeX name
        integer                   :: speed       ! grade of parameter
        integer                   :: prior_type  ! type of prior
        integer                   :: prior_block ! prior block
        logical                   :: sub_cluster ! sub_clustering?

        ! Parameters in the prior
        real(dp), dimension(:), allocatable :: prior_params
    end type param_type

    contains

    subroutine assign_parameter(param,paramname,latex,speed,prior_type,prior_block,prior_params,sub_cluster)
        implicit none
        type(param_type),intent(out):: param       ! Parameter to be returned
        character(len=*),intent(in) :: paramname   ! Name of parameter
        character(len=*),intent(in) :: latex       ! LaTeX name
        integer         ,intent(in) :: speed       ! grade of parameter
        integer         ,intent(in) :: prior_type  ! type of prior
        integer         ,intent(in) :: prior_block ! prior block
        logical,optional,intent(in) :: sub_cluster ! sub clustering?

        ! Parameters in the prior
        real(dp), dimension(:),intent(in) :: prior_params


        write(param%paramname,'(A)') paramname
        write(param%latex,'(A)') latex
        param%speed = speed
        param%prior_type = prior_type
        param%prior_block = prior_block
        allocate( param%prior_params(size(prior_params)) )
        param%prior_params = prior_params
        if(present(sub_cluster)) then
            param%sub_cluster = sub_cluster
        else 
            param%sub_cluster = .false.
        end if

    end subroutine assign_parameter

    subroutine add_parameter(params,paramname,latex,speed,prior_type,prior_block,prior_params,sub_cluster)
        implicit none
        ! Parameter array
        type(param_type),dimension(:),allocatable,intent(inout) :: params

        character(len=*),intent(in) :: paramname   ! Name of parameter
        character(len=*),intent(in) :: latex       ! LaTeX name
        integer         ,intent(in),optional :: speed       ! grade of parameter
        integer         ,intent(in),optional :: prior_type  ! type of prior
        integer         ,intent(in),optional :: prior_block ! prior block
        logical         ,intent(in),optional :: sub_cluster ! sub cluster on this?

        ! Parameters in the prior
        real(dp), dimension(:),intent(in),optional :: prior_params 
        real(dp), dimension(0) :: blank_params 

        ! expand parameter array
        type(param_type), dimension(:),allocatable :: temp_params

        integer :: num_params 


        num_params = size(params)

        allocate(temp_params(num_params))
        temp_params = params

        deallocate(params)
        allocate(params(num_params+1))

        params(1:num_params) = temp_params


        if(present(speed) .and. present(prior_type) .and. present(prior_block) .and. present(prior_params) ) then
            if(present(sub_cluster)) then
                call assign_parameter(params(num_params+1),paramname,latex,speed,prior_type,prior_block,prior_params,.true.) 
            else
                call assign_parameter(params(num_params+1),paramname,latex,speed,prior_type,prior_block,prior_params) 
            end if
        else
            call assign_parameter(params(num_params+1),paramname,latex,1,0,0,blank_params) 
        end if

    end subroutine add_parameter


end module params_module

! This module is auto-generated from the file cosmosis/datablock/section_names.txt.
! Edit that and then re-make to add your own pre-defined section names.

module cosmosis_section_names


    implicit none
    character(*), parameter :: likelihoods_section = "likelihoods"
    character(*), parameter :: data_vector_section = "data_vector"
    character(*), parameter :: cosmological_parameters_section = "cosmological_parameters"
    character(*), parameter :: halo_model_parameters_section = "halo_model_parameters"
    character(*), parameter :: baryon_parameters_section = "baryon_parameters"
    character(*), parameter :: shear_calibration_parameters_section = "shear_calibration_parameters"
    character(*), parameter :: number_density_params_section = "number_density_params"
    character(*), parameter :: post_friedmann_parameters_section = "post_friedmann_parameters"
    character(*), parameter :: intrinsic_alignment_parameters_section = "intrinsic_alignment_parameters"
    character(*), parameter :: intrinsic_power_section = "intrinsic_power"
    character(*), parameter :: galaxy_intrinsic_power_section = "galaxy_intrinsic_power"
    character(*), parameter :: matter_intrinsic_power_section = "matter_intrinsic_power"
    character(*), parameter :: wl_number_density_section = "wl_number_density"
    character(*), parameter :: matter_power_nl_section = "matter_power_nl"
    character(*), parameter :: matter_power_lin_section = "matter_power_lin"
    character(*), parameter :: matter_power_lin_cdm_baryon_section = "matter_power_lin_cdm_baryon"
    character(*), parameter :: matter_galaxy_power_section = "matter_galaxy_power"
    character(*), parameter :: galaxy_power_section = "galaxy_power"
    character(*), parameter :: shear_xi_section = "shear_xi"
    character(*), parameter :: shear_cl_section = "shear_cl"
    character(*), parameter :: shear_cl_gg_section = "shear_cl_gg"
    character(*), parameter :: shear_cl_gi_section = "shear_cl_gi"
    character(*), parameter :: shear_cl_ii_section = "shear_cl_ii"
    character(*), parameter :: galaxy_cl_section = "galaxy_cl"
    character(*), parameter :: cmb_cl_section = "cmb_cl"
    character(*), parameter :: lss_autocorrelation_section = "lss_autocorrelation"
    character(*), parameter :: gal_matter_power_lin_section = "gal_matter_power_lin"
    character(*), parameter :: linear_cdm_transfer_section = "linear_cdm_transfer"
    character(*), parameter :: sigma_r_lin_section = "sigma_r_lin"
    character(*), parameter :: sigma_r_nl_section = "sigma_r_nl"
    character(*), parameter :: galaxy_xi_section = "galaxy_xi"
    character(*), parameter :: galaxy_shear_xi_section = "galaxy_shear_xi"
    character(*), parameter :: galaxy_intrinsic_xi_section = "galaxy_intrinsic_xi"
    character(*), parameter :: planck_section = "planck"
    character(*), parameter :: intrinsic_alignment_field_section = "intrinsic_alignment_field"
    character(*), parameter :: fgas_parameters_section = "fgas_parameters"
    character(*), parameter :: shear_calibration_section = "shear_calibration"
    character(*), parameter :: supernova_params_section = "supernova_params"
    character(*), parameter :: bias_field_section = "bias_field"
    character(*), parameter :: galaxy_luminosity_function_section = "galaxy_luminosity_function"
    character(*), parameter :: distances_section = "distances"
    character(*), parameter :: de_equation_of_state_section = "de_equation_of_state"
    character(*), parameter :: growth_parameters_section = "growth_parameters"
    character(*), parameter :: test_parameters_section = "test_parameters"
    character(*), parameter :: mass_function_section = "mass_function"
    character(*), parameter :: evs_section = "evs"
    character(*), parameter :: clusters_section = "clusters"

end module

module calculate_module
    use utils_module, only: dp
    implicit none
    contains

    subroutine calculate_point(loglikelihood,prior,point,settings,nlike)
        use settings_module, only: program_settings
        implicit none
        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),   dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function
        end interface
        interface
            function prior(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function
        end interface

        type(program_settings), intent(in) :: settings
        real(dp), intent(inout) , dimension(:) :: point
        integer, intent(inout) :: nlike

        real(dp),dimension(settings%nDims)    :: cube   ! Hypercube coordinate
        real(dp),dimension(settings%nDims)    :: theta  ! Physical parameters
        real(dp),dimension(settings%nDerived) :: phi    ! derived parameters
        real(dp)                              :: logL

        cube = point(settings%h0:settings%h1)

        if ( any(cube<0) .or. any(cube>1) )  then
            theta = 0
            logL  = settings%logzero
        else
            theta = prior(cube)
            logL  = loglikelihood(theta,phi)
        end if

        if(logL>settings%logzero) nlike = nlike+1

        point(settings%p0:settings%p1) = theta
        point(settings%d0:settings%d1) = phi
        point(settings%l0) = logL

    end subroutine calculate_point

    !> Calculate a posterior point from a live/phantom point
    function calculate_posterior_point(settings,point,logweight,evidence,volume) result(posterior_point)
        use settings_module,   only: program_settings
        use utils_module,      only: logincexp
        implicit none

        type(program_settings), intent(in) :: settings
        real(dp), dimension(settings%nTotal),intent(in) :: point
        real(dp),intent(in) :: logweight
        real(dp),intent(in) :: evidence
        real(dp),intent(in) :: volume
        real(dp), dimension(settings%nposterior) :: posterior_point


        ! Volume
        posterior_point(settings%pos_X)  = volume
        ! Likelihood
        posterior_point(settings%pos_l)  = point(settings%l0)
        ! Un-normalised weighting 
        posterior_point(settings%pos_w)  = logweight
        ! un-normalise cumulative weighting
        posterior_point(settings%pos_Z)  = evidence
        ! Physical parameters
        posterior_point(settings%pos_p0:settings%pos_p1) = point(settings%p0:settings%p1)
        ! Derived parameters
        posterior_point(settings%pos_d0:settings%pos_d1) = point(settings%d0:settings%d1)

    end function calculate_posterior_point


    !> This function computes the similarity matrix of an array of data.
    !!
    !! Assume that the data_array can be considered an indexed array of vectors
    !! V = ( v_i : i=1,n )
    !!
    !! The similarity matrix can be expressed very neatly as
    !! d_ij = (v_i-v_j) . (v_i-v_j)
    !!      = v_i.v_i + v_j.v_j - 2 v_i.v_j
    !!
    !! The final term can be written as a data_array^T data_array, and the first
    !! two are easy to write. We can therefore calculate this in two lines with
    !! instrisic functions
    function calculate_similarity_matrix(data_array) result(similarity_matrix)

        real(dp), intent(in), dimension(:,:) :: data_array

        real(dp), dimension(size(data_array,2),size(data_array,2)) :: similarity_matrix

        integer :: i


        similarity_matrix = spread( &
            [ ( dot_product(data_array(:,i),data_array(:,i)), i=1,size(data_array,2) ) ], &
            dim=2,ncopies=size(data_array,2) )

        similarity_matrix = similarity_matrix + transpose(similarity_matrix) - 2d0 * matmul( transpose(data_array),data_array )

    end function calculate_similarity_matrix








end module calculate_module

! Covariance matrix, diagonalization

module utils1
  !$ use omp_lib
  use RandomNS
  implicit none
  
  	integer lwork,liwork
  	data lwork,liwork /1,1/
      logical setBlk
      data setBlk /.false./

    integer, parameter :: root_max_len = 512

contains

!---------------------------------------------------------------------- 
  
 subroutine Diagonalize(a,diag,n,switch)
	!Does m = U diag U^T, returning U in m
	integer n,id
	double precision a(n,n),diag(n)
	logical switch
	integer i,j,ierr,il,iu,m,isuppz(2*n)
	double precision vl,vu,abstol,z(n,n)
	double precision, dimension(:), allocatable :: work
	integer, dimension(:), allocatable :: iwork

	diag=0.
      abstol=0.
      
      id=0
      !$ id=omp_get_thread_num()
      
      if(.not.setBlk .or. switch) then
      	if(id==0) then
      		!find optimal block sizes
      		allocate(work(1))
            	allocate(iwork(1))
            	lwork=-1
            	liwork=-1
		
            	call DSYEVR( 'V', 'A', 'U', n, a, n, vl, vu, il, iu, &
      		abstol, m, diag, Z, n, isuppz, work, lwork, iwork, liwork, ierr )

            	lwork=int(work(1))
            	liwork=iwork(1)
            	deallocate(work,iwork)
            	setBlk=.true.
	else
            	do
                  	!$OMP FLUSH(setBlk)
                  	if(setBlk) exit
		enddo
	end if
      endif 
      	
      allocate(work(lwork),iwork(liwork))
      call DSYEVR( 'V', 'A', 'U', n, a, n, vl, vu, il, iu, &
      abstol, m, diag, Z, n, isuppz, work, lwork, iwork, liwork, ierr )
      a=z
      deallocate(work,iwork)
    
      !check for inf & nan
      do i=1,n
    	if(diag(i)/=diag(i) .or. diag(i)>huge(1d0)) then
		diag=1d0
		a=0d0
		do j=1,n
			a(j,j)=1d0
		enddo
		exit
	endif
      enddo
	  
 end subroutine Diagonalize

!---------------------------------------------------------------------- 

! LogSumExp(x,y)=log(exp(x)+exp(y))
  double precision function LogSumExp(x,y)
    double precision x,y

    if (x.gt.y) then
       LogSumExp=x+log(1+exp(y-x))
    else
       LogSumExp=y+log(1+exp(x-y))
    end if
    return

  end function LogSumExp
  
!----------------------------------------------------------------------

  subroutine calc_covmat(npt,np,p,mean,covmat)
    implicit none
    integer np,npt
    double precision p(:,:)
    double precision covmat(:,:)
    double precision mean(:)
    integer i,j,ip

    covmat=0.
    do i=1,np
       do j=i,np
          do ip=1,npt
             covmat(i,j)=covmat(i,j)+((p(i,ip)-mean(i))*(p(j,ip)-mean(j)))
          end do
          if(j/=i) covmat(j,i)=covmat(i,j)
       end do
       covmat(i,1:np)=covmat(i,1:np)/dble(npt-1)
    end do
   
    return
    
  end subroutine calc_covmat

!----------------------------------------------------------------------

  subroutine calc_covmat_wt(npt,np,p,wt,mean,covmat)
    implicit none
    integer np,npt
    double precision p(:,:),wt(:)
    double precision covmat(:,:)
    double precision mean(:)
    integer i,j,ip

    covmat=0.
    do i=1,np
       do j=i,np
          do ip=1,npt
             covmat(i,j)=covmat(i,j)+((p(i,ip)-mean(i))*(p(j,ip)-mean(j)))*wt(ip)
          end do
          if(j/=i) covmat(j,i)=covmat(i,j)
       end do
    end do
   
    return
    
  end subroutine calc_covmat_wt

!----------------------------------------------------------------------

  !inv_cov=(evec).(inv_eval).Transpose(evec)
  subroutine calc_invcovmat(numdim,evec,eval,invcov)
    implicit none
    integer numdim !num of dimensions & points
    double precision evec(:,:),eval(:) !eigenvectors & eigenvalues
    double precision invcov(:,:)
    integer i,j,k

    invcov=0d0
    do i=1,numdim
       do j=i,numdim
          do k=1,numdim
             invcov(i,j)=invcov(i,j)+(evec(i,k)*evec(j,k)/eval(k))
          end do
          if(i/=j) invcov(j,i)=invcov(i,j)
       end do
    end do
    
    return
    
  end subroutine calc_invcovmat

!----------------------------------------------------------------------

  subroutine ScaleFactor(npt,ndim,pt,mean,inv_cov,kmax)
    implicit none
 
    double precision kmax
    integer npt,ndim
    double precision pt(ndim,npt),ptM(1,ndim),sf(1,1)
    integer i,k
    double precision inv_cov(ndim,ndim)
    double precision mean(ndim)
    double precision temp_p(ndim,npt)
    
    do i=1,ndim
	temp_p(i,1:npt)=pt(i,1:npt)-mean(i)
    enddo
    
    kmax=0d0
    do k=1,npt
    	ptM(1,:)=temp_p(:,k)
    	sf=MatMul(MatMul(ptM,inv_cov),Transpose(ptM))
        if(sf(1,1)>kmax) kmax=sf(1,1)
    enddo
    
    !kmax=sqrt(kmax)
    
  end subroutine ScaleFactor
   
!----------------------------------------------------------------------	
 
 double precision function ptScaleFac(ndim,pt,meanx,invcovx)
 	
	implicit none
      
	integer ndim!dimensionality
      	double precision pt(ndim),point(1,ndim)!point to be checked
      	double precision meanx(ndim),invcovx(ndim,ndim)!cluster attributes
      	double precision kfac(1,1)!k factor of present point
      
      	point(1,:)=pt(:)-meanx(:)
	kfac=MATMUL(MATMUL(point,invcovx),Transpose(point))
	ptScaleFac=kfac(1,1)
      
 end function ptScaleFac
  
!----------------------------------------------------------------------
   
   subroutine getTMatrix(ndim,evec,eval,TMatrix)
    
    implicit none
 
    double precision TMatrix(ndim,ndim),evec(ndim,ndim),eval(ndim)
    integer ndim,np,i,j
    double precision TMat(ndim,ndim)
    
    np=ndim
    TMatrix=evec
    
    do i=1,np
       do j=1,np
          TMatrix(i,j) = evec(i,j) * sqrt(eval(j))
       enddo
    enddo
    TMat=Transpose(TMatrix)
    TMatrix=TMat
    
  end subroutine getTMatrix
  
!----------------------------------------------------------------------

  !return the Mahalanobis distance of a point from the given ellipsoid
  double precision function MahaDis(ndim,pt,mean,inv_cov,kfac)
    implicit none
    
    !input varaibles
    integer ndim !dimensionality
    double precision pt(ndim) !point
    double precision mean(ndim) !centroid of the ellipsoid
    double precision inv_cov(ndim,ndim) !inv covariance matrix of the ellipsoid
    double precision kfac !enlargement factor
    
    MahaDis=ptScaleFac(ndim,pt,mean,inv_cov)/kfac
    
  end function MahaDis
   
!----------------------------------------------------------------------	
  
  double precision function ellVol(ndim,eval,k_fac)
    
    implicit none
    
    integer ndim
    double precision eval(ndim),k_fac,pi
    integer i
    
    pi=4.d0*atan(1.d0)
    
    ellVol=sqrt(product(eval)*(k_fac**dble(ndim)))
    
    if(mod(ndim,2)==0) then
    	do i=2,ndim,2
		ellVol=ellVol*2.d0*pi/dble(i)
	enddo
    else
    	ellVol=ellVol*2.
    	do i=3,ndim,2
		ellVol=ellVol*2.d0*pi/dble(i)
	enddo
    endif
  end function ellVol

!---------------------------------------------------------------------- 
  
  subroutine genPtInSpheroid(np,u,id)
   
    implicit none
    
    integer np,i,id
    double precision u(:), mod, urv
  
    mod=0d0
    do i=1,np
       u(i)=gaussian1NS(id)
       mod=mod+u(i)**2.
    enddo
    urv=ranmarNS(id)
    mod=(urv**dble(1./np))/sqrt(mod)
    u(:)=mod*u(:)
    
  end subroutine genPtInSpheroid

!----------------------------------------------------------------------   
  
  subroutine genPtOnSpheroid(np,u,id)
   
    implicit none
    
    integer np,i,id
    double precision u(:), mod
  
    mod=0.d0
    do i=1,np
       u(i)=gaussian1NS(id)
       mod=mod+u(i)**2.
    enddo
    mod=1.d0/sqrt(mod)
    u(:)=mod*u(:)
    
  end subroutine genPtOnSpheroid

!----------------------------------------------------------------------  

  !calculate the mean, covariance matrix, inv covariance matrix, evalues,
  !evects, det(cov) & enlargement of a given point set
  subroutine CalcEllProp(npt,ndim,pt,mean,covmat,invcov,tMat,evec,eval,detcov, &
  	kfac,eff,vol,pVol,switch)
    implicit none
    !input variables
    integer npt !no. of points
    integer ndim !dimensionality
    double precision pt(ndim,npt) !points
    double precision pVol !min vol this ellipsoid should occupy
    logical switch !initialize the LAPACK eigen analysis routines?
    !output variables
    double precision mean(ndim) !mean
    double precision covmat(ndim,ndim) !covariance matrix
    double precision invcov(ndim,ndim) !inverse covariance matrix
    double precision tMat(ndim,ndim) !transformation matrix
    double precision evec(ndim,ndim) !eigenvectors
    double precision eval(ndim)
    double precision detcov !determinant of the covariance matrix
    double precision kfac !enlargement point factor
    double precision eff !enlargement volume factor
    double precision vol !ellipsoid volume
    !work variables
    integer i,j
    
    !calculate the mean
    do i=1,ndim
    	mean(i)=sum(pt(i,1:npt))/npt
    enddo
    
    if(npt<=1) then
    	kfac=0.d0
	vol=0.d0
	eval=0.d0
	eff=1.d0
	return
    endif
    
    !calculate the covariance matrix
    call calc_covmat(npt,ndim,pt,mean,covmat)
    
    !eigen analysis
    evec=covmat
    call Diagonalize(evec,eval,ndim,switch)
    
    !eigenvalues of covariance matrix can't be zero
    do i=1,ndim-1
	if(eval(i)<=0.d0) eval(1:i)=eval(i+1)/2.
    enddo
	
    !if the no. of points is less than ndim+1 then set the eigenvalues of unconstrained 
    !dimensions equal to the min constrained eigenvalue
    if(npt<ndim+1) then
	eval(1:ndim+1-npt)=eval(ndim+2-npt)
    endif
    
    !calculate the determinant of covariance matrix
    detcov=product(eval)
    
    !calculate the inverse of covariance matrix
    call calc_invcovmat(ndim,evec,eval,invcov)
    
    !calculate the enlargement factor
    call ScaleFactor(npt,ndim,pt,mean,invcov,kfac)
    
    !calculate the ellipsoid volume
    vol=ellVol(ndim,eval,kfac)
    
    !scale the enlargement factor if vol<pVol
    if(pVol>0d0 .and. vol<pVol) then
    	eff=(pVol/vol)**(2.d0/ndim)
	vol=pVol
    else
    	eff=1.d0
    endif
        
    !calculate the transformation matrix
    call getTMatrix(ndim,evec,eval,tMat)
    
  end subroutine CalcEllProp

!---------------------------------------------------------------------- 

  !calculate the inv covariance matrix, evalues & evects of a given point set
  subroutine CalcBEllInfo(npt,ndim,pt,mean,eval,evec,invcov,tMat,kfac,minPt)
    implicit none
    !input variables
    integer npt !no. of points
    integer ndim !dimensionality
    double precision pt(ndim,npt) !points
    integer minPt
    !output variables
    double precision mean(ndim) !centroid
    double precision invcov(ndim,ndim) !inverse covariance matrix
    double precision tMat(ndim,ndim) !transformation matrix
    double precision evec(ndim,ndim) !eigenvectors
    double precision eval(ndim) !eigenvalues
    double precision kfac !multiplicative factor for covmat for bounding ell
    !work variables
    double precision sigma(ndim)
    integer i,j,k,n
    parameter(n=0)
    double precision covmat(ndim,ndim),ptk(ndim,npt),dist(npt)
    double precision maxIndx(n,2)
    integer nOut,ptOut(n),nptk
    logical flag
    
    
    !calculate the mean
    do i=1,ndim
    	mean(i)=sum(pt(i,1:npt))/npt
    	sigma(i)=sum(pt(i,1:npt)**2)/npt
    enddo
    sigma(1:ndim)=sqrt(sigma(1:ndim)-mean(1:ndim)**2)
    
    if(npt==1) then
	eval=0.d0
	kfac=0.d0
	return
    endif
    
    !remove outliers
    if(npt>minPt) then
	k=min(n,npt-minPt)
	if(k>0) then
		maxIndx(:,2)=0d0
    		do i=1,npt
			dist(i)=0d0
			do j=1,ndim
				dist(i)=dist(i)+abs((pt(j,i)-mean(j)))/sigma(j)
			enddo
		
			do j=1,k+1
				if(j==k+1) exit
				if(dist(i)<maxIndx(j,2)) exit
			enddo
			j=j-1
			if(j>0) then
				maxIndx(1:j-1,:) = maxIndx(2:j,:)
				maxIndx(j,1) = dble(i)
				maxIndx(j,2) = dist(i)
			endif
    		enddo
	
		nOut=0
		do i=1,k
			if(maxIndx(i,2)>3d0) then
				nOut=nOut+1
				ptOut(nOut)=int(maxIndx(i,1))
			endif
		enddo
	else
		nOut=0
	endif
	
	if(nOut>0) then
		j=0
		do i=1,npt
			flag=.false.
			do k=1,nOut
				if(i == ptOut(k)) then
					flag=.true.
					exit
				endif
			enddo
			
			if(flag) cycle
			
			ptk(:,j+1)=pt(:,i)
			j=j+1
		enddo
		nptk=npt-nOut
	else
		ptk=pt
		nptk=npt
	endif
    else
	ptk=pt
	nptk=npt
    endif
    
    
    !calculate the covariance matrix
    call calc_covmat(nptk,ndim,ptk,mean,covmat)
    
    !eigen analysis
    evec=covmat
    call Diagonalize(evec,eval,ndim,.false.)
    !eigenvalues of covariance matrix can't be zero
    do i=1,ndim-1
	if(eval(i)<=0.d0) eval(1:i)=eval(i+1)/2.
    enddo
	
    !if the no. of points is less than ndim+1 then set the eigenvalues of unconstrained 
    !dimensions equal to the min constrained eigenvalue
    if(nptk<ndim+1) then
	eval(1:ndim+1-nptk)=eval(ndim+2-nptk)
    endif
    
    !calculate the inverse of covariance matrix
    call calc_invcovmat(ndim,evec,eval,invcov)
    
    !now scale the eigenvalues so that its a bounding ellipsoid with k = kfac
    call ScaleFactor(nptk,ndim,ptk,mean,invcov,kfac)
        
    !calculate the transformation matrix
    call getTMatrix(ndim,evec,eval,tMat)
    
  end subroutine CalcBEllInfo

!----------------------------------------------------------------------

  !generate a point uniformly inside the given ellipsoid
  subroutine genPtInEll(ndim,mean,efac,TMat,id,pt)
  	implicit none
	
	!input variables
	integer ndim !dimensionality
	double precision mean(ndim) !centroid of the given ellipsoid
	double precision efac !enlargement factor of the given ellipsoid
	double precision TMat(ndim,ndim) !transformation matrix of the given ellipsoid
	integer id !processor id (for OpenMP)
	!output variable
	double precision pt(ndim)
	!work variables
	double precision u(1,ndim),pnewM(1,ndim)
	
	call genPtInSpheroid(ndim,u(1,:),id)
	pnewM=MatMul(u,TMat)
	pt(:)=sqrt(efac)*pnewM(1,:)+mean(:)
	
  end subroutine genPtInEll

!----------------------------------------------------------------------

  !generate a point uniformly on the surface of the given ellipsoid
  subroutine genPtOnEll(ndim,mean,efac,TMat,id,pt)
  	implicit none
	
	!input variables
	integer ndim !dimensionality
	double precision mean(ndim) !centroid of the given ellipsoid
	double precision efac !enlargement factor of the given ellipsoid
	double precision TMat(ndim,ndim) !transformation matrix of the given ellipsoid
	integer id !processor id (for OpenMP)
	!output variable
	double precision pt(ndim)
	!work variables
	double precision u(1,ndim),pnewM(1,ndim)
	
	call genPtOnSpheroid(ndim,u(1,:),id)
	pnewM=MatMul(u,TMat)
	pt(:)=sqrt(efac)*pnewM(1,:)+mean(:)
	
  end subroutine genPtOnEll

!----------------------------------------------------------------------
   
   !evolve an ellipsoid from which a point has either been rejected or a point
   !has been inserted
  subroutine evolveEll(a_r,npt,ndim,newpt,pts,mean,eval,invcov,kfac,eff,vol,pVol)
    
	implicit none
    	!input variables
	integer a_r !if 0 then point rejected, 1 then point inserted
	integer npt !no. of points after rejection or before insertion
	integer ndim !dimensionality
	double precision newpt(ndim) !point to be rejected/inserted
	double precision pts(ndim,npt) !point set after rejection or before insertion
	double precision mean(ndim) !centroid of the ellipsoid
	double precision eval(ndim) !eigenvalues of the ellipsoid
	double precision invcov(ndim,ndim) !inverse covariance matrix of the ellipsoid
	double precision pVol !target volume
	
	!input/output variables
	double precision kfac !input (output): point enlargement before (after) rejection/insertion
	double precision eff !input (output): volume enlargement before (after) rejection/insertion
	double precision vol !input (output): volume before (after) rejection/insertion
	
	!work variables
	double precision new_pt(ndim,1),new_kfac
	
	
	!sanity check
	if(a_r < 0 .or. a_r > 1) then
		write(*,*)"a_r in evolveEll cannot be", a_r
		stop
	endif
	
	if(pVol==0.d0 .or. eval(ndim)==0.d0) then
		kfac=0.d0
		eff=1.d0
		vol=0.d0
		return
	endif
	
	
	!point inserted
	if(a_r==1) then
		if(npt==0) then
			write(*,*)"can not insert point in an ellipsoid with no points"
			stop
		else
			!calculate the scale factor
			new_pt(:,1)=newpt(:)
			call ScaleFactor(1,ndim,new_pt,mean,invcov,new_kfac)
			if(new_kfac>kfac) then
				eff=eff*kfac/new_kfac
				kfac=new_kfac
				if(eff<1d0) then
					eff=1d0
					vol=ellVol(ndim,eval,kfac)
				endif
			endif
			
			!if the point has been inserted to a cluster with npt > 0 then kfac remains the same
			!scale eff if target vol is bigger
			if(pVol>vol) then
    				eff=eff*(pVol/(vol))**(2.d0/dble(ndim))
				vol=pVol
			else
				!if target vol is smaller then calculate the point volume & 
				!scale eff if required
				vol=ellVol(ndim,eval,kfac)
			
				!scale the enlargement factor if vol<pVol
    				if(vol<pVol) then
    					eff=max(1d0,(pVol/(vol))**(2.d0/dble(ndim)))
					vol=pVol
    				else
    					eff=1.d0
    				endif
			endif
		endif
	else
		if(npt==0) then
			vol=0.d0
			kfac=0.d0
			eff=1.d0
			return
		endif
		
		!if the point has been rejected then figure out if its a boundary point
		new_pt(:,1)=newpt(:)
		call ScaleFactor(1,ndim,new_pt,mean,invcov,new_kfac)
		
		!if it's a boundary point then find new kfac
		if(new_kfac==kfac) then
			call ScaleFactor(npt,ndim,pts,mean,invcov,kfac)
			if(kfac>new_kfac*eff .and. npt>1) then
				write(*,*)"Problem in evoleell"
				write(*,*)kfac,new_kfac,eff,npt
				stop
			endif
			eff=1d0
			vol=ellVol(ndim,eval,kfac)
		endif
		
		!scale the enlargement factor if vol<pVol
    		if(vol<pVol) then
    			eff=(pVol/(vol))**(2.d0/dble(ndim))
			vol=pVol
    		endif
	endif
    
  end subroutine evolveEll
  
!----------------------------------------------------------------------
   
   !enlarge an ellipsoid because of an additional point being inserted in it
  subroutine enlargeEll(ndim,newpt,mean,eval,invcov,kfac,eff,vol,pVol)
    
	implicit none
    	!input variables
	integer ndim !dimensionality
	double precision newpt(ndim) !point to be inserted
	double precision mean(ndim) !centroid of the ellipsoid
	double precision eval(ndim) !eigenvalues of the ellipsoid
	double precision invcov(ndim,ndim) !inverse covariance matrix of the ellipsoid
	double precision pVol !target volume
	
	!input/output variables
	double precision kfac !input (output): point enlargement before (after) insertion
	double precision eff !input (output): volume enlargement before (after) insertion
	double precision vol !input (output): volume before (after) insertion
	
	!work variables
	double precision new_pt(ndim,1),d1
	
	
	!find new kfac
	new_pt(:,1)=newpt(:)
	call ScaleFactor(1,ndim,new_pt,mean,invcov,d1)
	if(d1>kfac) then
		kfac=d1
		eff=1.d0
		vol=ellVol(ndim,eval,kfac)
	endif
		
	if(pVol>vol) then
    		eff=eff*(pVol/(vol))**(2.d0/dble(ndim))
		vol=pVol
	endif
    
  end subroutine enlargeEll
  
!----------------------------------------------------------------------


  function inprior(np,p)
    
    implicit none
    
    logical inprior
    integer np, i
    double precision p(np)
    
    inprior = .true.
    
    do i=1,np
	if(p(i)<0d0 .or. p(i)>1d0) then
          	inprior = .false.
            	return
	endif
    enddo
  
  end function inprior

!----------------------------------------------------------------------
  
  !Returns the value gamma(ln[(xx)]) for xx > 0.
  FUNCTION gammln(xx) 
  	REAL gammln,xx  
      INTEGER j 
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6) 
      !Internal arithmetic will be done in double precision, 
      !a nicety that you can omit if  ve- gure accuracy is good enough. 
      SAVE cof,stp 
      
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,24.01409824083091d0, &
      -1.231739572450155d0,.1208650973866179d-2,-.5395239384953d-5,2.5066282746310005d0/ 
      
      x=xx 
      y=x 
      tmp=x+5.5d0 
      tmp=(x+0.5d0)*log(tmp)-tmp 
      ser=1.000000000190015d0 
      do j=1,6 
      	y=y+1.d0 
            ser=ser+cof(j)/y 
      enddo
      gammln=tmp+log(stp*ser/x) 
      return 
  END FUNCTION gammln
  
  
  
  
  !USES gcf,gser Returns the incomplete gamma function P(a, x). 
  FUNCTION gammp(a,x) 
  	REAL a,gammp,x 
  	REAL gammcf,gamser,gln 
  
  	if(x.lt.0..or.a.le.0.) then
		write(*,*)  'bad arguments in gammp'
		stop
	endif
  	if(x.lt.a+1.)then 
  		!Use the series representation. 
  		call gser(gamser,a,x,gln) 
      	gammp=gamser
  	else 
  		!Use the continued fraction representation 
      	call gcf(gammcf,a,x,gln) 
      	gammp=1.-gammcf !and take its complement. 
  	endif 
  	return 
  END FUNCTION gammp
  
  
  !USES gcf,gser Returns the incomplete gamma function Q(a,x)=1-P(a,x). 
  FUNCTION gammq(a,x) 
  	REAL a,gammq,x 
      REAL gammcf,gamser,gln 
      
      if(x.lt.0..or.a.le.0.) then
      	write(*,*) 'bad arguments in gammq'
	stop
      endif
      if(x.lt.a+1.)then 
      	!Use the series representation 
      	call gser(gamser,a,x,gln) 
            gammq=1.-gamser !and take its complement. 
      else 
      	!Use the continued fraction representation. 
            call gcf(gammcf,a,x,gln) 
            gammq=gammcf 
	endif 
      return 
  END FUNCTION gammq
  
  
  !USES gammln Returns the incomplete gamma function P(a,x) evaluated by its series 
  !representation as gamser. 
  !Also returns ln (a) as gln. 
  SUBROUTINE gser(gamser,a,x,gln) 
  	INTEGER ITMAX 
      REAL a,gamser,gln,x,EPS 
      PARAMETER (ITMAX=100,EPS=3.e-7) 
      INTEGER n 
      REAL ap,del,sum 
      
      gln=gammln(a) 
      if(x.le.0.)then 
      	if(x.lt.0.) write(*,*)  'x < 0 in gser'  
            gamser=0. 
            return 
      endif 
      ap=a 
      sum=1./a 
      del=sum 
      do n=1,ITMAX 
      	ap=ap+1. 
            del=del*x/ap 
            sum=sum+del 
            if(abs(del).lt.abs(sum)*EPS)goto 91 
      enddo
      write(*,*)  'a too large, ITMAX too small in gser'  
    91 gamser=sum*exp(-x+a*log(x)-gln) 
    	return 
  END SUBROUTINE gser
   
   
  !USES gammln Returns the incomplete gamma function Q(a, x) evaluated by its continued 
  !fraction representation as gammcf. Also returns ln  (a) as gln. 
  !Parameters: ITMAX is the maximum allowed number of iterations; 
  !EPS is the relative accuracy; FPMIN is a number near the smallest representable 
  !floating-point number.  
  SUBROUTINE gcf(gammcf,a,x,gln) 
  	INTEGER ITMAX 
  	REAL a,gammcf,gln,x,EPS,FPMIN 
      PARAMETER (ITMAX=100,EPS=3.e-7,FPMIN=1.e-30) 
      INTEGER i 
      REAL an,b,c,d,del,h 
      
      gln=gammln(a) 
      b=x+1.-a 
      c=1./FPMIN 
      d=1./b 
      h=d 
      do i=1,ITMAX !Iterate to convergence. 
      	an=-i*(i-a) 
            b=b+2. 
            d=an*d+b 
            if(abs(d).lt.FPMIN)d=FPMIN 
            c=b+an/c 
            if(abs(c).lt.FPMIN)c=FPMIN 
            d=1./d 
            del=d*c
            h=h*del 
            if(abs(del-1.).lt.EPS)goto 91 
	enddo
      write(*,*)  'a too large, ITMAX too small in gcf'  
   91 gammcf=exp(-x+a*log(x)-gln)*h !Put factors in front. 
   	return
  END SUBROUTINE gcf
  
  
  !USES gammp Returns the error function erf(x). 
  FUNCTION erf(x) 
  	REAL erf,x
      
      if(x.lt.0.)then 
      	erf=-gammp(.5,x**2) 
      else 
      	erf=gammp(.5,x**2) 
      endif 
      return 
  END FUNCTION erf
  
  
  double precision function stNormalCDF(x)
  	double precision x
     
     	if(x>6.) then
      	stNormalCDF=1.
      else if(x<-6.) then
      	stNormalCDF=0.
	else
      	stNormalCDF=0.5*(1.+erf(real(x)/1.41421356))
      end if
      
  end function stNormalCDF
  
!----------------------------------------------------------------------

  integer function binSearch(array,npt,x)
    implicit none
    integer npt,array(npt) !total no. of points in the array & the array
    integer x !no. whose position has to be found
    integer sp,ep !starting, end & insertion points

    binSearch = 1
    if(npt==0) then
      	return
    elseif(x>=array(1)) then
      	return
    end if
    if(x<=array(npt)) then
    	binSearch=npt+1
      return
    end if
    sp=1
    ep=npt
    do
    	if(sp==ep) return
	if(x>array((ep+sp)/2)) then
		ep=(ep+sp)/2
		binSearch=ep
	elseif(x<array((ep+sp)/2)) then
		sp=(ep+sp)/2+1
		binSearch=sp
	else
		ep=(ep+sp)/2
		binSearch=ep+1
            return
	end if
    end do
    
  end function binSearch

!----------------------------------------------------------------------

  subroutine piksrt(n,n1,arr,arr1)
  	integer n,n1
  	double precision arr(n)
  	double precision arr1(n1,n)
  	integer i,j
  	double precision a
  	double precision a1(n1)
  	do j=2,n
     		a=arr(j)
     		a1(1:n1)=arr1(1:n1,j)
     		do i=j-1,1,-1
        		if(arr(i).le.a) goto 10
        			arr(i+1)=arr(i)
				arr1(1:n1,i+1)=arr1(1:n1,i)
     		end do
     		i=0
10     	arr(i+1)=a
      	arr1(1:n1,i+1)=a1(1:n1)
  	end do
  	return
  end subroutine piksrt

!----------------------------------------------------------------------
  !calculation the multivariate normal function
  double precision function mNormalF(d,x,mu,C)
  	integer d !dimension
      double precision x(d) !data vector
      double precision mu(d) !mean
      double precision C(d,d) !covariance matrix
      double precision a(d) !residual vector (x-mu)
      integer i
      double precision Chisq,sqrD
      double precision TwoPi
      Parameter(TwoPi=6.283185307)
      double precision b(d)
      
      !DCHDC routine variables
      integer INFO
      double precision L(d,d) !cholesky decomposition matrix
      
      !compute the Cholesky decomposition of the covariance matrix 'C'
      !C = L^T.L
      !uses the LAPACK routine DPOTRF
      L=C
      call DPOTRF('L',d,L,d,INFO)
      
	!Compute chi-squared as the dot product b^T b, where
	!Lb=a and a is the vector of residuals
      !(x-mu)^T.C^-1.(x-mu)=b^T.b
      !where L.b=(x-mu) & C=L^T.L
	a(1:d)=x(1:d)-mu(1:d)
	do i=1,d
      	b(i)=(a(i)-sum(L(i,1:i-1)*b(1:i-1)))/L(i,i)
	end do
      Chisq=sum(b(1:d)**2.)
      
      !square root of det(C)
      sqrD=1.
      do i=1,d
      	sqrD=sqrD*L(i,i)
	end do
      
      !calculate the multivariate normal function
      mNormalF=exp(-Chisq/2.)/(sqrD*(TwoPi**(d/2.)))
      
  end function mNormalF

!----------------------------------------------------------------------
  !calculation the cumulative Gaussian mixture probability in 1-D
  double precision function cGaussMix(nClstr,pPt,pMean,pCov,wt)
  	integer nClstr !no. of cluster
      double precision pPt !point
      double precision pMean(nClstr),pCov(nClstr) !projected mean & variance of clusters
      double precision wt(nClstr)
      integer i
      double precision z
      
      cGaussMix=0.
      do i=1,nClstr
      	z=(pPt-pMean(i))/sqrt(pCov(i))
            cGaussMix=cGaussMix+wt(i)*stNormalCDF(z)
	end do
      
  end function cGaussMix

!---------------------------------------------------------------------- 
 
 logical function ptIn1Ell(ndim,pt,meanx,invcovx,kfacx)
 	
      implicit none
      
      integer ndim
      double precision pt(:),point(1,ndim)!point to be checked
      double precision meanx(:),invcovx(:,:),kfacx!cluster attributes
      double precision kfac!k factor of present point
      
      ptIn1Ell=.false.
        
      !if the cluster has vol=0 (i.e. kfacx=0) then point isn't in this cluster
      if(kfacx==0.d0) return
      
      point(1,:)=pt(:)
      call ScaleFactor(1,ndim,point,meanx,invcovx,kfac)
      if(kfac<kfacx .or. abs(kfac-kfacx)<0.0001) then
	ptIn1Ell=.true.
      endif
      
 end function ptIn1Ell
  
!----------------------------------------------------------------------
 
 subroutine ceffEvolve(ndim,vol,eff,npt)
 	
      implicit none
      
      !input variables
      integer ndim
      integer npt !no. of points in the mode
      
      !input/output variables
      double precision vol !ellipsoid volume
      double precision eff !enlargement
      
      !work variables
      double precision d1
      
      if(eff>1d0) then
      	d1=eff
      	eff=max(1d0,eff*exp(-2d0/dble(npt*ndim)))
      	vol=vol*((eff/d1)**(dble(ndim)/2d0))
      endif
      
      
 end subroutine ceffEvolve
  
!----------------------------------------------------------------------

end module utils1

module KNN_clustering
    use utils_module, only: dp

    implicit none
    contains

    !> This function returns a clustering from a similarity matrix based on
    !! 'nearest neighbor' clustering.
    !!
    !! Points belong to the same cluster if they are in either of each others k
    !! nearest neighbor sets. 
    !!
    !! The algorithm computes the k nearest neihbor sets from the similarity
    !! matrix, and then tests
    recursive function NN_clustering(similarity_matrix,num_clusters) result(cluster_list)
        use utils_module, only: relabel
        use abort_module, only: halt_program
        implicit none

        real(dp), intent(in), dimension(:,:) :: similarity_matrix

        integer, dimension(size(similarity_matrix,1)) :: cluster_list
        integer, intent(out):: num_clusters

        integer :: num_clusters_new

        integer, dimension(size(similarity_matrix,1)) :: cluster_list_old
        integer :: num_clusters_old

        integer, dimension(size(similarity_matrix,1),size(similarity_matrix,1)) :: knn

        integer :: k
        integer :: nlive
        integer :: n
        integer :: i_cluster
        integer :: i_point

        integer, allocatable, dimension(:) :: points

        ! Get the number of points to be clustered
        nlive=size(similarity_matrix,1)

        ! 10 degrees of separation are usually fine, we'll expand this if necessary
        k = min(nlive,10)

        ! compute the k nearest neighbors for each point
        knn(:k,:) = compute_knn(similarity_matrix,k)

        ! Set up the cluster list
        cluster_list_old = [( i_point,i_point=1,nlive )]
        num_clusters_old = nlive

        do n=2,k

            cluster_list = do_clustering_k( knn(:n,:) )     ! Get a raw clustering 

            ! Re-label the cluster list using integers 1,2,3,....
            cluster_list = relabel(cluster_list,num_clusters)

            if(num_clusters<=0) then
                call halt_program("Cluster error: cannot have fewer than 1 clusters")
            else if( num_clusters == 1 ) then
                return  ! If we're down to a single cluster, then just return
            else if( all( cluster_list == cluster_list_old ) ) then
                exit ! check that the clustering hasn't changed since the last pass
            else if(n==k) then
                ! If we need to cluster further, then expand the knn list
                k=min(k*2,nlive)
                knn(:k,:) = compute_knn(similarity_matrix,k)
            end if

            ! Save the old cluster list for later.
            cluster_list_old = cluster_list
            num_clusters_old = num_clusters

        end do


        ! If we've found clusters, then search within these clusters
        if(num_clusters>1) then
            i_cluster=1
            do while(i_cluster<=num_clusters)
                ! Get the indices of cluster i_cluster
                call get_indices_of_cluster(cluster_list,points,i_cluster)

                ! Call this function again on the similarity sub matrix, adding an offset
                cluster_list(points) = num_clusters + NN_clustering(similarity_matrix(points,points),num_clusters_new)

                ! If we didn't find any new clusters, then move on to the next one
                if(num_clusters_new==1) i_cluster=i_cluster+1

                ! re-label the clusters
                cluster_list = relabel(cluster_list,num_clusters)
            end do
        end if

    end function NN_clustering


    function do_clustering_k(knn) result(c)
        implicit none

        integer, dimension(:,:) :: knn
        integer, dimension(size(knn,2)) :: c

        integer :: i,j

        ! Set up the cluster list
        c = [( i,i=1,size(knn,2)  )]

        do i=1,size(knn,2)
            do j=i+1,size(knn,2)

                ! If they're not in the same cluster already...
                if(c(i)/=c(j)) then
                    ! ... check to see if they are within each others k nearest neihbors...
                    if( neighbors( knn(:,i),knn(:,j) ) ) then

                        ! If they are then relabel cluster_i and cluster_j to the smaller of the two
                        where(c==c(i).or.c==c(j)) 
                            c=min(c(i),c(j))
                        end where

                    end if
                end if

            end do
        end do

    end function do_clustering_k



    function compute_knn(similarity_matrix,k) result(knn)
        implicit none

        !> The data to compute on
        real(dp), intent(in),dimension(:,:) :: similarity_matrix

        !> The number of nearest neighbors to compute
        integer, intent(in) :: k

        ! The indices of the k nearest neighbors to output
        integer, dimension(k,size(similarity_matrix,1)) :: knn

        integer :: nPoints,i,j

        integer :: insert_index(1)

        real(dp), dimension(k) :: distance2s

        nPoints = size(similarity_matrix,1)

        knn=0

        do i=1,nPoints
            ! Find the k nearest neighbors for each point
            distance2s = huge(1d0)
            do j=1,nPoints
                ! If the distance between i and j is too large to be considered,
                ! this returns 0
                ! otherwise this returns the position to insert
                insert_index = minloc(distance2s, mask=distance2s>similarity_matrix(i,j))
                ! If it needs to be inserted, insert into both the integer
                ! array, and the local distance2s array
                if(insert_index(1)/=0) then
                    distance2s(insert_index(1):) =  eoshift( distance2s(insert_index(1):), -1,dim=1,boundary=similarity_matrix(i,j))
                    knn(insert_index(1):,i) =  eoshift( knn(insert_index(1):,i) ,-1 ,dim=1, boundary=j)
                end if
            end do

        end do

    end function compute_knn


    ! Return whether they're each others n nearest neighbor list
    function neighbors(knn1,knn2) result(same_list)
        implicit none
        integer,intent(in), dimension(:) :: knn1
        integer,intent(in), dimension(:) :: knn2 

        logical :: same_list

        ! Check to see if they're in each others neighbors lists
        same_list= any(knn1==knn2(1)) .or. any(knn2==knn1(1))

    end function neighbors



    ! Return the number of matches in the n nearest neighbor list
    function matches(knn1,knn2)
        implicit none
        integer,intent(in), dimension(:) :: knn1
        integer,intent(in), dimension(:) :: knn2 

        integer :: matches

        integer i,j

        matches = count( [( [( knn1(i)==knn2(j), i=1,size(knn1) )], j=1,size(knn2) )] )

    end function matches


    !> This subroutine returns points: an allocated array of indices of the points in cluster_list
    !! which belong to i_cluster
    subroutine get_indices_of_cluster(cluster_list,points,i_cluster)
        implicit none
        integer, dimension(:), intent(in)                 :: cluster_list
        integer, intent(out), allocatable, dimension(:)   :: points
        integer, intent(in)                               :: i_cluster

        integer :: nlive,npoints,j

        nlive = count(cluster_list==i_cluster)

        if(allocated(points)) deallocate(points)

        allocate( points(nlive) )

        npoints=0
        do j=1,size(cluster_list)
            if(cluster_list(j)==i_cluster) then
                npoints = npoints+1
                points(npoints) = j
            end if
        end do


    end subroutine get_indices_of_cluster



end module KNN_clustering











module cluster_module
    use utils_module, only: dp
    implicit none
    contains

    function do_clustering(settings,RTI,sub_dimensions)
        use settings_module,   only: program_settings
        use run_time_module,   only: run_time_info,add_cluster
        use calculate_module,  only: calculate_similarity_matrix
        use KNN_clustering,    only: NN_clustering
        implicit none

        !> Program settings
        type(program_settings), intent(in) :: settings
        !> The evidence storage
        type(run_time_info), intent(inout) :: RTI
        !> Dimensions to cluster on
        integer,dimension(:),optional,intent(in) :: sub_dimensions
        !> Whether or not a cluster has been found
        logical :: do_clustering


        ! Similarity matrix
        real(dp),dimension(sum(RTI%nlive),sum(RTI%nlive)) :: similarity_matrix
        integer,dimension(sum(RTI%nlive)) :: clusters

        integer :: num_clusters
        integer :: num_old_clusters

        ! number of live points
        integer :: nlive

        integer :: i_cluster

        ! Initially no clusters found
        do_clustering=.false.

        ! Get the number of old clusters
        num_old_clusters=RTI%ncluster

        i_cluster = 1
        do while(i_cluster<=num_old_clusters)

            nlive = RTI%nlive(i_cluster) ! Get the number of live points in a temp variable

            if(nlive>2) then 
                ! Calculate the similarity matrix for this cluster
                if(present(sub_dimensions)) then
                    similarity_matrix(:nlive,:nlive) =&
                        calculate_similarity_matrix(RTI%live(sub_dimensions,:nlive,i_cluster))
                else 
                    similarity_matrix(:nlive,:nlive) =&
                        calculate_similarity_matrix(RTI%live(settings%h0:settings%h1,:nlive,i_cluster))
                end if

                clusters(:nlive) = NN_clustering(similarity_matrix(:nlive,:nlive),num_clusters)

                ! Do clustering on this 
                if ( num_clusters>1 ) then
                    ! If we find a cluster
                    do_clustering=.true.

                    ! we split this cluster into n, and put the others at the end
                    call add_cluster(settings,RTI,i_cluster,clusters(:nlive),num_clusters)

                else
                    i_cluster=i_cluster+1
                end if
            else
                i_cluster=i_cluster+1
            end if


            
        end do

    end function do_clustering



end module cluster_module

module like
	
use params
use utils1
implicit none
      
contains
      
      
!=======================================================================

subroutine slikelihood(Cube,slhood)
         
	implicit none
      
	double precision Cube(nest_nPar),slhood
	integer i,j
	
	slhood = 0d0
	
	do i = 1, sdim
		Cube(i) = spriorran(i, 1) + ( spriorran(i, 2) - spriorran(i, 1) ) * Cube(i)
	enddo
	
	slhood = -( Cube(1)**2 + Cube(2) - 11 )**2 - ( Cube(1) + Cube(2)**2 - 7 )**2

end subroutine slikelihood
      
!=======================================================================

end module like

module chordal_module
    use utils_module, only: dp
    implicit none

    contains

    function SliceSampling(loglikelihood,prior,settings,logL,seed_point,cholesky,nlike,num_repeats)  result(baby_points)
        use settings_module, only: program_settings
        use random_module, only: random_orthonormal_basis,random_real

        implicit none
        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in), dimension(:)  :: theta
                real(dp), intent(out), dimension(:) :: phi
                real(dp) :: loglikelihood
            end function
        end interface
        interface
            function prior(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function
        end interface

        !> program settings (mostly useful to pass on the number of live points)
        type(program_settings), intent(in) :: settings

        !> The seed point
        real(dp), intent(in), dimension(settings%nTotal)   :: seed_point

        !> The loglikelihood contour to sample on
        real(dp), intent(in)   :: logL

        !> The directions of the chords
        real(dp), intent(in), dimension(settings%nDims,settings%nDims) :: cholesky

        !> The number of babies within each grade to produce
        integer, dimension(:), intent(in) :: num_repeats

        ! ------- Outputs -------
        !> The number of likelihood evaluations
        integer, dimension(:), intent(out) :: nlike

        !> The newly generated point, plus the loglikelihood bound that
        !! generated it
        real(dp),    dimension(settings%nTotal,sum(num_repeats))   :: baby_points


        ! ------- Local Variables -------
        real(dp),    dimension(settings%nDims)   :: nhat
        real(dp),    dimension(settings%nDims,sum(num_repeats))   :: nhats
        integer,   dimension(sum(num_repeats))   :: speeds ! The speed of each nhat

        real(dp), dimension(settings%nTotal)   :: previous_point

        integer :: i_babies

        real(dp) :: w

        ! Start the baby point at the seed point
        previous_point = seed_point

        ! Initialise the likelihood counter at 0
        nlike = 0

        ! Generate a choice of nhats in the orthogonalised space
        nhats = generate_nhats(settings,num_repeats,speeds)

        ! Transform to the unit hypercube
        nhats = matmul(cholesky,nhats)

        do i_babies=1,size(nhats,2)
            ! Get a new random direction
            nhat = nhats(:,i_babies)

            ! Normalise it
            w = sqrt(dot_product(nhat,nhat))
            nhat = nhat/w
            w = w * 3d0 !* exp( lgamma(0.5d0 * settings%nDims) - lgamma(1.5d0 + 0.5d0 * settings%nDims) ) * settings%nDims

            ! Generate a new random point along the chord defined by the previous point and nhat
            baby_points(:,i_babies) = slice_sample(loglikelihood,prior,logL, nhat, previous_point, w, settings,nlike(speeds(i_babies)))

            ! Save this for the next loop
            previous_point = baby_points(:,i_babies)

        end do

    end function SliceSampling

    function generate_nhats(settings,num_repeats,speeds) result(nhats)
        use settings_module, only: program_settings
        use random_module, only: random_orthonormal_bases,shuffle_deck
        implicit none
        type(program_settings), intent(in) :: settings

        integer, dimension(:), intent(in) :: num_repeats !> The number of babies within each grade to produce
        integer,  intent(out), dimension(sum(num_repeats))   :: speeds !> The speed of each nhat
        real(dp),    dimension(settings%nDims,sum(num_repeats))   :: nhats


        integer :: i_grade
        integer :: grade_nDims
        integer :: grade_index

        integer :: i_babies

        integer, dimension(size(nhats,2)) :: deck

        ! Initialise at 0
        nhats=0d0

        i_babies=1

        ! Generate a sequence of random bases
        do i_grade=1,size(num_repeats)

            grade_nDims   = sum(settings%grade_dims(i_grade:))
            grade_index   = sum(settings%grade_dims(:i_grade-1))+1

            nhats(grade_index:,i_babies:i_babies+num_repeats(i_grade)-1) = random_orthonormal_bases(grade_nDims,num_repeats(i_grade))

            speeds(i_babies:i_babies+num_repeats(i_grade)-1) = i_grade

            i_babies = i_babies + num_repeats(i_grade)

        end do

        ! Create a shuffled deck
        ! N.B. we want the first one to be a slow likelihood evaluation, as this
        ! will be the first one we're doing this run
        deck = [ (i_babies,i_babies=1,size(nhats,2)) ]
        call shuffle_deck(deck(2:))

        ! Shuffle the nhats
        nhats = nhats(:,deck)

        ! Shuffle the speeds
        speeds = speeds(deck)


    end function generate_nhats






    !> Slice sample at slice logL, along the direction defined by nhat, starting at x0.
    !!
    !! We loosely follow the notation found in Neal's landmark paper:
    !! [Neal 2003](http://projecteuclid.org/download/pdf_1/euclid.aos/1056562461).
    !!
    !! We use the 'stepping out proceedure' to expand the bounds R and L until
    !! they lie outside the iso-likelihood contour, and then contract inwards
    !! using the  'shrinkage' procedure
    !!
    !! Each seed point x0 contains an initial estimate of the width w.
    !!
    function slice_sample(loglikelihood,prior,logL,nhat,x0,w,S,n) result(baby_point)
        use settings_module, only: program_settings
        use utils_module,  only: distance
        use random_module, only: random_real
        use calculate_module, only: calculate_point
        implicit none
        interface
            function loglikelihood(theta,phi)
                import :: dp
                real(dp), intent(in),  dimension(:) :: theta
                real(dp), intent(out),  dimension(:) :: phi
                real(dp) :: loglikelihood
            end function
        end interface
        interface
            function prior(cube) result(theta)
                import :: dp
                real(dp), intent(in), dimension(:) :: cube
                real(dp), dimension(size(cube))    :: theta
            end function
        end interface

        !> program settings
        type(program_settings), intent(in) :: S
        !> The Loglikelihood bound
        real(dp), intent(in)                           :: logL
        !> The direction to search for the root in
        real(dp), intent(in),    dimension(S%nDims)   :: nhat
        !> The start point
        real(dp), intent(in),    dimension(S%nTotal)   :: x0
        !> The initial width
        real(dp), intent(in) :: w
        !> The number of likelihood calls
        integer, intent(inout) :: n

        ! The output finish point
        real(dp),    dimension(S%nTotal)   :: baby_point

        ! The upper bound
        real(dp),    dimension(S%nTotal)   :: R
        ! The lower bound
        real(dp),    dimension(S%nTotal)   :: L


        real(dp) :: temp_random

        integer :: i_step
        real(dp) :: x0Rd, x0Ld

        ! Select initial start and end points
        temp_random = random_real()
        L(S%h0:S%h1) = x0(S%h0:S%h1) -   temp_random   * w * nhat 
        R(S%h0:S%h1) = x0(S%h0:S%h1) + (1-temp_random) * w * nhat 

        ! Calculate initial likelihoods
        call calculate_point(loglikelihood,prior,R,S,n)
        call calculate_point(loglikelihood,prior,L,S,n)

        ! expand R until it's outside the likelihood region
        i_step=0
        do while( R(S%l0) >= logL .and. R(S%l0) > S%logzero )
            i_step=i_step+1
            R(S%h0:S%h1) = x0(S%h0:S%h1) + nhat * w * i_step
            call calculate_point(loglikelihood,prior,R,S,n)
        end do
        if(i_step>100) write(*,'(" too many R steps (",I10,")")') i_step

        ! expand L until it's outside the likelihood region
        i_step=0
        do while(L(S%l0) >= logL      .and. L(S%l0) > S%logzero )
            i_step=i_step+1
            L(S%h0:S%h1) = x0(S%h0:S%h1) - nhat * w * i_step
            call calculate_point(loglikelihood,prior,L,S,n)
        end do
        if(i_step>100) write(*,'(" too many L steps (",I10,")")') i_step

        ! Sample within this bound
        do i_step=0,100
            ! Find the distance between x0 and L 
            x0Ld= distance(x0(S%h0:S%h1),L(S%h0:S%h1))
            ! Find the distance between x0 and R 
            x0Rd= distance(x0(S%h0:S%h1),R(S%h0:S%h1))

            ! Draw a random point within L and R
            baby_point(S%h0:S%h1) = x0(S%h0:S%h1)+ (random_real() * (x0Rd+x0Ld) - x0Ld) * nhat 

            ! calculate the likelihood 
            call calculate_point(loglikelihood,prior,baby_point,S,n)

            ! If we're not within the likelihood bound then we need to sample further
            if( baby_point(S%l0) < logL .or. baby_point(S%l0) <= S%logzero ) then
                if ( dot_product(baby_point(S%h0:S%h1)-x0(S%h0:S%h1),nhat) > 0d0 ) then
                    ! If baby_point is on the R side of x0, then
                    ! contract R
                    R = baby_point
                else
                    ! If baby_point is on the L side of x0, then
                    ! contract L
                    L = baby_point
                end if
            else
                return
            end if
        end do

        if (i_step>100) then
            write(*,'("Polychord Warning: Non deterministic loglikelihood")')
            baby_point(S%l0) = S%logzero
        end if

    end function slice_sample


end module chordal_module

!> Module containing all of the statements written to the command line during
!! compilation
!! 
!! There are several levels of feedback, indicated by a variable stored in
!! settings%feedback  :
!!
!! | integer  | Feedback level  
!! |----------|--------------------
!! |    0     | Only output the final evidence and error
!! |    1     | Indicate when entering various major sections of the program

module feedback_module
    use utils_module, only: dp
    implicit none

    contains

    !> Called before running the program
    subroutine write_opening_statement(settings)
        use utils_module,    only: stdout_unit,title_fb,normal_fb
        use read_write_module, only: resume_file
        use settings_module, only: program_settings
        implicit none
        type(program_settings), intent(in) :: settings  ! The program settings 


        if(settings%feedback >=title_fb) then
            write(stdout_unit,'("")')
            write(stdout_unit,'("PolyChord: Next Generation Nested Sampling")')
            write(stdout_unit,'("copyright: Will Handley, Mike Hobson & Anthony Lasenby")')
            write(stdout_unit,'("  version: 1.14")')
            write(stdout_unit,'("  release: 1st May 2018")')
            write(stdout_unit,'("    email: wh260@mrao.cam.ac.uk")')
            write(stdout_unit,'("")')
        end if

        if(settings%feedback >=normal_fb) then
            write(stdout_unit,'("Run Settings"   )')
            write(stdout_unit,'("nlive    :",I8)')   settings%nlive
            write(stdout_unit,'("nDims    :",I8)')   settings%nDims
            write(stdout_unit,'("nDerived :",I8)')   settings%nDerived
            if(settings%do_clustering) write(stdout_unit,'("Doing Clustering")')
            if(settings%equals) write(stdout_unit,'("Generating equally weighted posteriors")')
            if(settings%posteriors) write(stdout_unit,'("Generating weighted posteriors")')
            if((settings%equals.or.settings%posteriors).and.settings%cluster_posteriors.and.settings%do_clustering) write(stdout_unit,'("Clustering on posteriors")')
            if(settings%write_resume) write(stdout_unit,'("Writing a resume file to",A)') trim(resume_file(settings,.false.))
            if(allocated(settings%sub_clustering_dimensions)) then
                if(size(settings%sub_clustering_dimensions)==1) then
                    write(stdout_unit,'("Sub clustering on ",I4," dimension")') size(settings%sub_clustering_dimensions)
                else 
                    write(stdout_unit,'("Sub clustering on ",I4," dimensions")') size(settings%sub_clustering_dimensions)
                end if
                write(*,*) settings%sub_clustering_dimensions
            end if

            write(stdout_unit,'("")')
        end if




    end subroutine write_opening_statement


    subroutine write_resuming(feedback)
        use utils_module,    only: stdout_unit,normal_fb
        implicit none
        integer, intent(in) :: feedback

        if(feedback>=normal_fb) then
            write(stdout_unit,'("Resuming from previous run")')
        end if

    end subroutine write_resuming


    !> Called before generating the live points
    subroutine write_started_generating(feedback)
        use utils_module,    only: stdout_unit,normal_fb
        implicit none
        !> The degree of feedback required
        integer, intent(in) :: feedback 


        if (feedback>=normal_fb) then
            write(stdout_unit,'("generating live points")')
            write(stdout_unit,'("")')
        end if

    end subroutine write_started_generating

    !> Called during generation of the live points
    !!
    !! Prints a neat progress bar to show you how far its got
    subroutine write_generating_live_points(feedback,i_live,nlive)
        use utils_module,    only: fancy_fb
        implicit none
        !> The degree of feedback required
        integer, intent(in) :: feedback 

        !> The current number of live points generate
        integer, intent(in) :: i_live
        !> The number of live points to be generated
        integer, intent(in) :: nlive

        if (feedback>=fancy_fb) then
            call progress(dble(i_live)/dble(nlive),100)
        end if

    end subroutine write_generating_live_points

    !> Called at the end of generating the live points
    subroutine write_finished_generating(feedback)
        use utils_module,    only: stdout_unit,normal_fb
        implicit none
        !> The degree of feedback required
        integer, intent(in) :: feedback 


        if (feedback>=normal_fb) then
            write(stdout_unit,'("")')
            write(stdout_unit,'("all live points generated")')
            write(stdout_unit,'("")')
        end if

    end subroutine write_finished_generating


    !> Subroutine to produce a progress bar of (optional) length brz, with frac
    !! filled
    !!
    !! Note that you shouldn't put any write statements in between using this
    !! subroutine.
    subroutine progress(frac,bar_size)
        use utils_module,    only: stdout_unit
        implicit none

        !> fraction completed
        real(dp),intent(in) :: frac
        !> The size of the progress bar
        integer,intent(in) :: bar_size


        integer :: percent                    ! the percentage completed
        character(bar_size+7) :: bar          ! the bounds on the progress bar
        integer :: i                          ! loop variable

        character(len=40) :: bar_fmt  ! format string for outputting


        write(bar_fmt,'("(a1,a",i0,")")') bar_size+7

        ! Convert the fraction to an integer percentage
        percent = nint(100 * frac)

        ! Create the progress bar structure:
        ! e.g.  bar = "???% |                     |"
        ! The question marks indicate where the percentage completed will be
        ! written to.
        !
        ! Start:
        bar="???% |"
        do i= 1, bar_size-1
            ! Put in bar_size number of spaces
            bar(6+i:6+i) = ' '
        end do
        ! Finish
        bar(bar_size+7:bar_size+7) = '|'

        ! Write the percentage to the bar variable, so it now reads
        ! e.g.  bar = " 70% |                     |"
        write(unit=bar(1:3),fmt="(i3)") percent

        ! Produce a number of *'s to indicade the progress, so it now reads
        ! e.g.  bar = " 70% |***************      |"
        do i=1, int(frac*bar_size)
            bar(6+i:6+i)="*"
        enddo

        ! print the progress bar to stdout (unit 6)
        write(stdout_unit,fmt=bar_fmt,advance="no") char(13), bar
        flush(stdout_unit)

        return
    end subroutine progress


    subroutine write_num_repeats(num_repeats,feedback)
        use utils_module,    only: stdout_unit,fmt_len,INT_FMT,normal_fb
        implicit none
        integer, dimension(:) :: num_repeats
        integer, intent(in) :: feedback 

        character(len=fmt_len) fmt_int

        if(feedback>=normal_fb) then
            write(fmt_int,'("( ""number of repeats: "",",I0,A,")")') size(num_repeats),INT_FMT
            write(stdout_unit,fmt_int) num_repeats
        end if

    end subroutine write_num_repeats


    !> Called before starting sampling
    subroutine write_started_sampling(feedback)
        use utils_module,    only: stdout_unit,normal_fb
        implicit none
        !> The degree of feedback required
        integer, intent(in) :: feedback 


        if (feedback>=normal_fb) then
            write(stdout_unit,'("started sampling")')
            write(stdout_unit,'("")')
        end if

    end subroutine write_started_sampling

    !> Intermediate results
    subroutine write_intermediate_results(settings,RTI,nlikesum)
        use run_time_module, only: run_time_info,calculate_logZ_estimate
        use settings_module, only: program_settings
        use utils_module,    only: stdout_unit,fmt_len,normal_fb,sort_doubles
        implicit none
        type(program_settings), intent(in)    :: settings    !> program settings
        type(run_time_info),    intent(in)    :: RTI         !> run time info
        integer,dimension(:),   intent(in)    :: nlikesum    !> number of likelihood calls since last call

        integer :: p

        real(dp)                          :: logZ       
        real(dp)                          :: varlogZ  
        real(dp), dimension(RTI%ncluster) :: logZp      
        real(dp), dimension(RTI%ncluster) :: varlogZp 
        real(dp), dimension(RTI%ncluster_dead) :: logZp_dead      
        real(dp), dimension(RTI%ncluster_dead) :: varlogZp_dead 

        integer, dimension(RTI%ncluster+RTI%ncluster_dead) :: ordering

        character(len=fmt_len) fmt_head,fmt_live,fmt_phantom,fmt_posterior,fmt_equals,fmt_tail,fmt_nlike

        integer :: int_width

        int_width = ceiling(log10(dble(maxval([RTI%nlive(:RTI%ncluster),RTI%nphantom(:RTI%ncluster),RTI%nposterior(:RTI%ncluster),RTI%nequals(:RTI%ncluster)]))))

        ! Get the number of active clusters
        write(fmt_head,'("(",I0,"(""_""))")') (int_width+2)*RTI%ncluster + 11
        write(fmt_live,'("(""lives      |"",",I0,"(I",I0,","" |""))")') RTI%ncluster,int_width
        write(fmt_phantom,'("(""phantoms   |"",",I0,"(I",I0,","" |""))")') RTI%ncluster,int_width
        write(fmt_posterior,'("(""posteriors |"",",I0,"(I",I0,","" |""))")') RTI%ncluster,int_width
        write(fmt_equals,'("(""equals     |"",",I0,"(I",I0,","" |""))")') RTI%ncluster,int_width
        write(fmt_tail,'("(",I0,"(""‾""))")') (int_width+2)*RTI%ncluster + 11


        if (settings%feedback>=normal_fb) then
            write(stdout_unit,fmt_head)
            write(stdout_unit,fmt_live)  RTI%nlive
            write(stdout_unit,fmt_phantom)  RTI%nphantom
            write(stdout_unit,fmt_posterior)  RTI%nposterior
            write(stdout_unit,fmt_equals)  RTI%nequals
            write(stdout_unit,fmt_tail)
            write(stdout_unit,'("ncluster   =",  I8," /",I8            )') RTI%ncluster, RTI%ncluster+RTI%ncluster_dead
            write(stdout_unit,'("ndead      =",  I20                   )') RTI%ndead
            write(stdout_unit,'("nposterior =",  I20                   )') RTI%nposterior_global
            write(stdout_unit,'("nequals    =",  I20                   )') RTI%nequals_global

            write(fmt_nlike,'("(""nlike      ="",",I0,"I20)")') size(nlikesum)
            write(stdout_unit,fmt_nlike) RTI%nlike

            write(fmt_nlike,'(  "(""<nlike>    ="","  ,I0,   "F15.2,""   ("",",I0,"F15.2, "" per slice )"")")') size(nlikesum), size(nlikesum)
            write(stdout_unit,fmt_nlike) dble(nlikesum)/dble(settings%nlive),dble(nlikesum)/dble(RTI%num_repeats*settings%nlive)


            call calculate_logZ_estimate(RTI,logZ,varlogZ,logZp,varlogZp,logZp_dead,varlogZp_dead)            

            if(abs(logZ) < 1e9) then
                write(stdout_unit,'("log(Z)     = ", F15.2, " +/- ", F5.2)') logZ,sqrt(abs(varlogZ))
            else
                write(stdout_unit,'("log(Z_)    = ?")')
            end if

            ordering = sort_doubles([-RTI%logZp,-RTI%logZp_dead])

            do p=1,RTI%ncluster+RTI%ncluster_dead

                if(ordering(p)<=RTI%ncluster) then

                    if(abs(logZp(ordering(p)))<1e9) then
                        write(stdout_unit,'("log(Z_",I2,")  = ", F15.2, " +/- ", F5.2, " (still evaluating)")') p, logZp(ordering(p)),sqrt(abs(varlogZp(ordering(p))))
                    else
                        write(stdout_unit,'("log(Z_",I2,")  = ? (still evaluating)")') p
                    end if

                else
                    if(abs(logZp_dead(ordering(p)-RTI%ncluster))<1e9) then
                        write(stdout_unit,'("log(Z_",I2,")  = ", F15.2, " +/- ", F5.2)') p, logZp_dead(ordering(p)-RTI%ncluster),sqrt(abs(varlogZp_dead(ordering(p)-RTI%ncluster)))
                    else
                        write(stdout_unit,'("log(Z_",I2,")  = ?")') p
                    end if
                end if

            end do

            write(stdout_unit,'("")')
            write(stdout_unit,'("")')
            write(stdout_unit,'("")')
        end if

    end subroutine write_intermediate_results



    !> Nicely formatted final output statement
    subroutine write_final_results(output_info,feedback)
        use utils_module,    only: stdout_unit,title_fb
        implicit none
        !> Output of the program.
        !! # log(evidence)
        !! # error(log(evidence))
        !! # ndead
        !! # number of likelihood calls
        real(dp), dimension(4) :: output_info
        !> The degree of feedback required
        integer, intent(in) :: feedback 

        if (feedback>=title_fb) then
            write(stdout_unit,'(A54)')                                        ' ____________________________________________________ '
            write(stdout_unit,'(A54)')                                        '|                                                    |'
            write(stdout_unit,'("| ndead  = ", I12, "                              |"  )') nint(output_info(3))
            write(stdout_unit,'("| log(Z) = ", F18.5, " +/- ", F18.5,  " |")') output_info(1),sqrt(abs(output_info(2)))
            write(stdout_unit,'(A54)')                                        '|____________________________________________________|'
        endif
    end subroutine write_final_results

end module feedback_module

! posterior samples code

module posterior
  use utils1
  use xmeans_clstr
  
  implicit none
      
  double precision, dimension(:,:,:), allocatable :: evdatp
  integer, dimension(:), allocatable :: nbranchp,nPtPerNode,ncon,nSamp,clstrdNode
  double precision, dimension(:,:), allocatable :: branchp
  double precision, dimension(:,:), allocatable :: pts,pts2,consP,unconsP,pwt,pNwt
  logical, dimension(:), allocatable :: check
  integer nClst,nUncon
  double precision, dimension(:,:), allocatable :: stMu,stSigma

contains 
  
!------------------------------------------------------------------------
      
 subroutine pos_samp(Ztol,nIter,root,nLpt,ndim,nCdim,nPar,multimodal,outfile,globZ,globinfo,ic_n,ic_Z,ic_info,ic_reme, &
 ic_vnow,ic_npt,ic_nBrnch,ic_brnch,phyP,l,evDataAll,IS,IS_Z,dumper,context)
 !subroutine pos_samp
  	implicit none
  	
	double precision Ztol !null evidence
	integer nIter !globff (total no. replacements)
	character(len=root_max_len)root !base root
	integer nLpt !no. of live points
	integer ndim !dimensionality
	integer nCdim !no. of parameters to cluster on
	integer nPar !total no. of parameters to save
	logical multimodal
	logical outfile !write output files?
	integer i,j,k,i1,ios,ic_n,m,indx
	integer ic_npt(ic_n),ic_nptloc(ic_n),ic_nBrnch(ic_n)
	double precision ic_Z(ic_n),ic_info(ic_n),ic_vnow(ic_n),ic_brnch(ic_n,ic_n),phyP(nPar,nLpt),l(nLpt),evDataAll(:)
	logical IS !importance sampling?
	double precision IS_Z(2) !importance sampling log(Z) estimate & its standard deviation
	logical ic_reme(ic_n)
  	character(len=root_max_len) evfile,livefile,postfile,resumefile
      	character(len=root_max_len) sepFile,statsFile,postfile4,strictSepFile,summaryFile
  	character(len=32) fmt,fmt2
      	logical l1
      	double precision d1,d2,urv
      	double precision ltmp(nPar+2),ic_zloc(ic_n),ic_infoloc(ic_n),gzloc,ginfoloc
	integer phyID(nLpt)
	integer context
      
      	!posterior info
      	double precision lognpost,globZ,globInfo,gZold,maxWt
      	integer npost !no. of equally weighted posterior samples
      	double precision, dimension(:,:), allocatable :: wt,temp !probability weight of each posterior sample
      	double precision, dimension(:), allocatable :: ic_zold,llike !local evidence
	
	! parameters for dumper
	double precision, pointer :: physLive(:,:), posterior(:,:), paramConstr(:)
	double precision maxLogLike, logZ, INSlogZ, logZerr
	integer nSamples
	
	INTERFACE
		!the user dumper function
    		subroutine dumper(nSamples, nlive, nPar, physLive, posterior, paramConstr, maxLogLike, logZ, INSlogZ, logZerr, context_pass)
			integer nSamples, nlive, nPar, context_pass
			double precision, pointer :: physLive(:,:), posterior(:,:), paramConstr(:)
			double precision maxLogLike, logZ, INSlogZ, logZerr
		end subroutine dumper
	end INTERFACE
	
	
	ic_zloc=ic_z
	ic_infoloc=ic_info
	gzloc=globz
	ginfoloc=globinfo
	ic_nptloc=ic_npt
	
	
	!Ztol=-1.d99
      	!file names
      	postfile=TRIM(root)//'.txt'
      	statsFile=TRIM(root)//'stats.dat'
      	postfile4=TRIM(root)//'post_equal_weights.dat'
      	strictSepFile=TRIM(root)//'post_separate_strict.dat'
      	sepFile=TRIM(root)//'post_separate.dat'
      	evfile=TRIM(root)//'ev.dat'
      	livefile = TRIM(root)//'phys_live.points'
      	resumefile = TRIM(root)//'resume.dat'
      	summaryFile = TRIM(root)//'summary.txt'
	
      	allocate(branchp(0:ic_n,ic_n),evdatp(ic_n,nIter,nPar+2),wt(ic_n,nIter))
      	allocate(nbranchp(0:ic_n),nPtPerNode(ic_n))
      	allocate(pts2(ndim+1,nIter),pts(nPar+2,nIter),consP(nIter,nPar+2),unconsP(nIter,nPar+2),pwt(nIter,ic_n), &
	pNwt(nIter,ic_n))
      	allocate(ncon(ic_n),nSamp(ic_n),clstrdNode(ic_n))
	allocate(check(ic_n),ic_zold(ic_n),temp(ic_n,3))
	allocate(stMu(ic_n,nPar),stSigma(ic_n,nPar),llike(ic_n))
	
	nPtPerNode=0
	clstrdNode=0
      	nbranchp=0
	check=.false.
	nSamp=0
	
	nbranchp(1:ic_n)=ic_nbrnch(1:ic_n)
	branchp(1:ic_n,:)=ic_brnch(1:ic_n,:)
	
	
	!set the membership of live points to their coresponding nodes
	k=0
	do i=1,ic_n
		if(ic_nptloc(i)==0) cycle
		phyID(k+1:k+ic_nptloc(i))=i
		k=k+ic_nptloc(i)
	enddo
	
	
	!add in the contribution of the remaining live points to the evidence 
	i1=1
	do i=1,nLpt
		ltmp(1:nPar)=phyP(1:nPar,i)
		ltmp(nPar+1)=l(i)
		i1=phyID(i)
	
		d1=ltmp(nPar+1)+log(ic_vnow(i1)/dble(ic_nptloc(i1)))
		
		!global evidence & info
		gZold=gzloc
		gzloc=LogSumExp(gzloc,d1)
!		ginfoloc=exp(d1-gzloc)*ltmp(nPar+1)+exp(gZold-gzloc)*(ginfoloc+gZold)-gzloc
		ginfoloc=ginfoloc*exp(gzold-gzloc)+exp(d1-gzloc)*ltmp(nPar+1)
		
		!local evidence & info
!		gZold=ic_Z(i1)
		ic_zold(i1)=ic_zloc(i1)
		ic_zloc(i1)=LogSumExp(ic_zloc(i1),d1)
!		ic_infoloc(i1)=exp(d1-ic_zloc(i1))*ltmp(nPar+1)+exp(gZold-ic_zloc(i1))*(ic_infoloc(i1)+gZold)-ic_zloc(i1)
		ic_infoloc(i1)=ic_infoloc(i1)*exp(ic_zold(i1)-ic_zloc(i1))+exp(d1-ic_zloc(i1))*ltmp(nPar+1)
	enddo
	
	ginfoloc=ginfoloc-gzloc
	ic_infoloc(1:ic_n)=ic_infoloc(1:ic_n)-ic_zloc(1:ic_n)

      	!make the top level branch
      	nbranchp(0)=1
      	branchp(0,1)=1.d0
        
      	lognpost=0.d0
	if(outfile) then
      		!read the ev.dat file & calculate the probability weights
      		open(unit=55,file=evfile,status='old')
	endif
	i=0
    	do
		if(outfile) then
    			read(55,*,IOSTAT=ios) ltmp(1:nPar+2),i1
		
			!end of file?
        		if(ios<0) then
				close(55)
				exit
			endif
		else
			i=i+1
			if(i*(nPar+3)>size(evDataAll)) exit
			ltmp(1:nPar+2)=evDataAll((i-1)*(nPar+3)+1:i*(nPar+3)-1)
			i1=int(evDataAll(i*(nPar+3)))
		endif
		
		nPtPerNode(i1)=nPtPerNode(i1)+1
		evdatp(i1,nPtPerNode(i1),1:nPar+2)=ltmp(1:nPar+2)
		
		!probability weight  	
		wt(i1,nPtPerNode(i1))=exp(evdatp(i1,nPtPerNode(i1),nPar+1)+evdatp(i1,nPtPerNode(i1),nPar+2)-gzloc)
		if(wt(i1,nPtPerNode(i1))>0.d0) lognpost=lognpost-wt(i1,nPtPerNode(i1))*log(wt(i1,nPtPerNode(i1)))
    	enddo
	
	allocate(posterior(nIter, nPar+2), physLive(nLpt, nPar+1), paramConstr(4*nPar))
	paramConstr(1:2*nPar) = 0d0
	maxLogLike = -huge(1d0)
	logZ = gzloc
	nSamples = nIter
	maxWt = 0d0
	m = 0
      	
 	!read in final remaining points & calculate their probability weights
     	do i=1,nLpt
		ltmp(1:nPar)=phyP(1:nPar,i)
		ltmp(nPar+1)=l(i)
		i1=phyID(i)
		
		physLive(i,1:nPar+1) = ltmp(1:nPar+1)
		if( ltmp(nPar+1) > maxLogLike ) then
			maxLogLike = ltmp(nPar+1)
			indx = i
		endif
		nPtPerNode(i1)=nPtPerNode(i1)+1
            	evdatp(i1,nPtPerNode(i1),1:nPar+1)=ltmp(1:nPar+1)
            	evdatp(i1,nPtPerNode(i1),nPar+2)=log(ic_vnow(i1)/dble(ic_nptloc(i1)))
		wt(i1,nPtPerNode(i1))=exp(evdatp(i1,nPtPerNode(i1),nPar+1)+evdatp(i1,nPtPerNode(i1),nPar+2)-gzloc)
		if(wt(i1,nPtPerNode(i1))>0.d0) lognpost=lognpost-wt(i1,nPtPerNode(i1))*log(wt(i1,nPtPerNode(i1)))
	enddo
	! global maxlike parameters
	paramConstr(nPar*2+1:nPar*3) = physLive(indx,1:nPar)
      	
      	!no. of equally weighted posterior samples
      	npost=nint(exp(lognpost))
	
      	!write the global posterior files
	if(outfile) then
      		open(55,file=postfile,form='formatted',status='replace')
      		open(56,file=postfile4,form='formatted',status='replace')
      		write(fmt,'(a,i4,a)')  '(',nPar+2,'E28.18)'
      		write(fmt2,'(a,i4,a)')  '(',nPar+1,'E28.18)'
	endif
      	do i=1,ic_n
      		do j=1,nPtPerNode(i)
			m = m + 1
			posterior(m, 1:nPar+1) = evdatp(i, j, 1:nPar+1)
			posterior(m, nPar+2) = wt(i,j)
			if( wt(i,j) > maxWt ) then
				indx = m
				maxWt = wt(i,j)
			endif
			! global paramater means
			paramConstr(1:nPar) = paramConstr(1:nPar) + evdatp(i, j, 1:nPar) * wt(i,j)
			! global paramater standard deviations
			paramConstr(nPar+1:2*nPar) = paramConstr(nPar+1:2*nPar) + (evdatp(i, j, 1:nPar)**2.0) * wt(i,j)
			
            		if(wt(i,j)>1.d-99) then
            			if(outfile) write(55,fmt) wt(i,j),-2.d0*evdatp(i,j,nPar+1),evdatp(i,j,1:nPar)
                  	
      				!find the multiplicity
      				d1=wt(i,j)*npost
            			!calculate the integer part of multiplicity
        	    		k=int(d1)
            			!calculate the remaining part of multiplicity
            			d2=d1-dble(k)
            			!increase the multiplicity by one with probability d2
				urv=ranmarns(0)
        	    		if(urv<=d2) k=k+1
				if(outfile) then
      					do i1=1,k
            					write(56,fmt) evdatp(i,j,1:nPar+1)
            				enddo
				endif
			endif
		enddo
	enddo
	
	! global paramater standard deviations
	paramConstr(nPar+1:2*nPar) = sqrt( paramConstr(nPar+1:2*nPar) - paramConstr(1:nPar)**2.0 )
	! global MAP parameters
	paramConstr(nPar*3+1:nPar*4) = posterior(indx,1:nPar)
	
	if(outfile) then
      		close(55)
      		close(56)
      			
		open(unit=57,file=statsFile,form='formatted',status='replace')
      		!stats file
		write(57,'(a,E28.18,a,E28.18)')		"Nested Sampling Global Log-Evidence           :",gzloc,"  +/-",sqrt(ginfoloc/dble(nLpt))
		if( IS ) write(57,'(a,E28.18,a,E28.18)')"Nested Importance Sampling Global Log-Evidence:",IS_Z(1),"  +/-",IS_Z(2)
	      		
		!now the separated posterior samples
	      
	      	!generate the point set to be used by the constrained clustering algorithm
	      	nUncon=0
	      	nClst=0
		i=0
		j=1
	      	call genPoints(i,j,nPar,ic_reme)
		
		do i=1,nClst
			temp(i,1)=ic_zloc(clstrdNode(i))
			temp(i,2)=ic_infoloc(clstrdNode(i))
			temp(i,3)=ic_nptloc(clstrdNode(i))
		enddo
		ic_zloc(1:nClst)=temp(1:nClst,1)
		ic_infoloc(1:nClst)=temp(1:nClst,2)
		ic_nptloc(1:nClst)=temp(1:nClst,3)
	      			
		!now arrange the point set, constrained points first, unconstrained later
		pNwt=0.d0
		pwt=0.d0
	      	k=0
	      	do i=1,nClst
			llike(i)=minval(consP(k+1:k+nCon(i),nPar+1))
	      		do j=1,nCon(i)
	      			k=k+1
	          		pts(1:nPar+2,k)=consP(k,1:nPar+2)
				pwt(k,i)=1.d0
			enddo
		enddo
	      	do i=1,nUncon
	      		k=k+1
	      		pts(1:nPar+2,k)=unconsP(i,1:nPar+2)
		enddo
		
		i1=0
	      	do
			if(.false.) then
				i1=i1+1
	      		
				do i=1,k
					pts2(1:ndim,i)=pts(1:ndim,i)
					pts2(ndim+1,i)=pts(nPar+1,i)
				enddo
			
	      			!perform constrained clustering
				i=nCdim
				l1=.true.
	
	      			call GaussMixExpMaxLike(i,nClst,k,nCon(1:nClst),.true.,pts2(1:i,1:k), &
	      			pts(nPar+1:nPar+2,1:k),pwt(1:k,1:nClst),pNwt(1:k,1:nClst),ic_zloc(1:nClst), &
				llike(1:nClst),l1)
			endif
			
			!calculate cluster properties
			do i=1,nClst
				call rGaussProp(k,nCdim,pts(1:nCdim,1:k),pts(nPar+1:nPar+2,1:k), &
				pwt(1:k,i),pNwt(1:k,i),stMu(i,1:nCdim),stSigma(i,1:nCdim),ic_zloc(i))
			enddo
			
			i=sum(nCon(1:nClst))
			j=nCdim
	
			!if(.not.merge(nClst,j,nPar,i,k,nCon(1:nClst),pts(:,1:k),stMu(1:nClst,1:j), &
			!stSigma(1:nClst,1:j),ic_zloc(1:nClst),Ztol,pwt(1:k,1:nClst),pNwt(1:k,1:nClst), &
			!llike(1:nClst))) exit
			exit
		enddo
		
		!open the output file
		if(multimodal .and. outfile) then
			!open(unit=56,file=strictSepFile,form='formatted',status='replace')
	      		open(unit=55,file=sepFile,form='formatted',status='replace')
			write(57,'(a)')
	      		write(57,'(a)')"Local Mode Properties"
	      		write(57,'(a)')"-------------------------------------------"
	      		write(57,'(a)')
			write(57,'(a,i12)')"Total Modes Found:",nClst
		endif
		
		open(unit=58,file=summaryFile,status='unknown')
		if( IS ) then
			write(fmt,'(a,i4,a)')  '(',nPar*4+4,'E28.18)'
			write(58,fmt)paramConstr(1:nPar),paramConstr(nPar+1:2*nPar),paramConstr(nPar*2+1:nPar*3), &
			paramConstr(nPar*3+1:nPar*4),globZ,maxLogLike,IS_Z
		else
			write(fmt,'(a,i4,a)')  '(',nPar*4+2,'E28.18)'
			write(58,fmt)paramConstr(1:nPar),paramConstr(nPar+1:2*nPar),paramConstr(nPar*2+1:nPar*3), &
			paramConstr(nPar*3+1:nPar*4),globZ,maxLogLike
		endif
		call genSepFiles(k,nPar,nClst,Ztol,pts,pNwt(1:k,1:nClst),nCon(1:nClst),ic_zloc(1:nClst), &
		ic_infoloc(1:nClst), ic_nptloc(1:nClst),55,56,57,58,multimodal)
		close(58)
		
	      	if(multimodal) close(55)
	      	close(57)
	endif
	
	!error on global evidence
	logZerr=sqrt(ginfoloc/dble(nLpt))
	
	! call the dumper
	INSlogZ = logZ
	if( IS ) INSlogZ = IS_Z(1)
	call dumper(nSamples, nLpt, nPar, physLive, posterior, paramConstr, maxLogLike, logZ, INSlogZ, logZerr, context)

      	deallocate(branchp,evdatp,wt)
      	deallocate(nbranchp,nPtPerNode)
      	deallocate(pts2,pts,consP,unconsP,pwt,pNwt)
      	deallocate(ncon,nSamp,clstrdNode)
	deallocate(check,ic_zold,temp)
	deallocate(stMu,stSigma,llike)
	deallocate(posterior, physLive, paramConstr)

  end subroutine pos_samp
  
!------------------------------------------------------------------------
      
  recursive subroutine genPoints(br,brNum,nPar,ic_reme)
  
  	implicit none
      
      	integer br !branch to be analyzed
      	integer brNum !branching no. of the branch to be analyzed
	integer nPar !dimensionality
	logical ic_reme(:)
      	!work variables
      	integer i,j,k,i1,i2,node

      	node=int(branchp(br,brNum))
	
      	!find starting node
      	i1=1
      
      	!find out the ending position
      	i2=nPtPerNode(node)
	
      	if(nbranchp(node)==0 .and. .not.ic_reme(node) .and. nPtPerNode(node)>0) then
      		!add the points to the constrained point set if encountered the leaf
		!& calculate the means & sigmas
           	nClst=nClst+1
           	nCon(nClst)=i2-i1+1
            	j=sum(nCon(1:nClst-1))
		stMu(nClst,:)=0.d0
		stSigma(nClst,:)=0.d0
		ClstrdNode(nClst)=node
            	do i=i1,i2
            		j=j+1
            		consP(j,1:nPar+2)=evdatp(node,i,1:nPar+2)
			stMu(nClst,1:nPar)=stMu(nClst,1:nPar)+evdatp(node,i,1:nPar)
			stSigma(nClst,1:nPar)=stSigma(nClst,1:nPar)+evdatp(node,i,1:nPar)**2
            	enddo
		stMu(nClst,1:nPar)=stMu(nClst,1:nPar)/dble(nCon(nClst))
		stSigma(nClst,1:nPar)=stSigma(nClst,1:nPar)/dble(nCon(nClst))
		stSigma(nClst,1:nPar)=sqrt(stSigma(nClst,1:nPar)-stMu(nClst,1:nPar)**2)
	elseif(.not.(nbranchp(node)==0)) then
		if(.not.check(node)) then
            		!add the points to the un-constrained point set
            		do i=i1,i2
            			nUncon=nUncon+1
            			unconsP(nUncon,1:nPar+2)=evdatp(node,i,1:nPar+2)
            		enddo
			check(node)=.true.
		endif
            	!now parse the daughter branches
      		do i=1,nbranchp(node)
            		k=node
            		i1=i
			call genPoints(k,i1,nPar,ic_reme)
		enddo
	endif
      
  end subroutine genPoints
  
!------------------------------------------------------------------------
      
  subroutine genSepFiles(npt,nPar,nCls,Ztol,pt,pwt,nCon,locZ,locInfo,locNpt,funit1,funit2,funit3,funit4,multimodal)
  
  	implicit none
	
	!input variables
	integer npt !total no. of points
	integer nPar !dimensionality
	integer nCls !no. of modes
	double precision pt(nPar+2,npt) !points
	integer nCon(nCls) !no. of constrained points
	double precision pwt(npt,nCls) !ptrobability weights
	double precision locZ(nCls), locInfo(nCls) !local evidence
	integer locNpt(nCls)
	double precision Ztol
	integer funit1 !file having strictly separated samples
	integer funit2 !file having separated samples
	integer funit3 !stats file
	integer funit4 !summary file
	logical multimodal
	!work variables
	integer i,j,k,indx(1),nliveP
	double precision d1,d2,d3,mean(nCls,nPar),sigma(nCls,nPar),maxLike(nPar),MAP(nPar)
	double precision old_slocZ,sinfo,slocZ
	character*30 fmt,stfmt

	nliveP=sum(locNpt(1:nCls))
	write(stfmt,'(a,i4,a)')  '(',nPar*4+2,'E28.18)'

	!calculate the weights including the posterior component
	do i=1,nCls
		k=sum(nCon(1:i-1))
		!first calculate the evidence & info for points strictly lying the cluster
		slocZ=-huge(1.d0)*epsilon(1.d0) !logZero
		sinfo=0.d0
		do j=k+1,k+nCon(i)
			!local evidence
			old_slocZ=slocZ
			slocZ=logSumExp(slocZ,pt(nPar+1,j)+pt(nPar+2,j))
			!local info
			sinfo=exp(pt(nPar+1,j)+pt(nPar+2,j)-slocZ)*pt(nPar+1,j) &
				+exp(old_slocZ-slocZ)*(sinfo+old_slocZ)-slocZ
		enddo
		
		if(locZ(i)<Ztol) cycle
		
		mean(i,:)=0.d0
		sigma(i,:)=0.d0
		nSamp(i)=0
		
		!normalize
		d1=sum(pwt(1:npt,i))
		pwt(1:npt,i)=pwt(1:npt,i)/d1		
		
		!insert two blank line
!		write(funit2,*)
!            	write(funit2,*)
		if(multimodal) then
			write(funit1,*)
            		write(funit1,*)
		endif
		do j=1,npt
			mean(i,1:nPar)=mean(i,1:nPar)+pt(1:nPar,j)*pwt(j,i)
			sigma(i,1:nPar)=sigma(i,1:nPar)+(pt(1:nPar,j)**2)*pwt(j,i)
			
			if(multimodal) then
				!write the strictly separate file
      				write(fmt,'(a,i4,a)')  '(',nPar+2,'E28.18)'
				!strictly separate points
!				if(j>k .and. j<k+nCon(i)+1) then
!					!probability weight
!					swt=exp(pt(nPar+1,j)+pt(nPar+2,j)-slocZ)
!					if(swt>1.d-99) then
!						write(funit2,fmt)swt,-2.d0*pt(nPar+1,j),pt(1:nPar,j)
!					endif
!				endif
			
				!write the separate file
				if(pwt(j,i)>1.d-99) then
					nSamp(i)=nSamp(i)+1
					write(funit1,fmt)pwt(j,i),-2.d0*pt(nPar+1,j),pt(1:nPar,j)
				endif
			endif
		enddo
		sigma(i,1:nPar)=sqrt(sigma(i,1:nPar)-mean(i,1:nPar)**2.)
		
		!stMu(i,:)=mean(i,:)
		!stSigma(i,:)=sigma(i,:)
		
		!find maxLike parameters
		k=sum(nCon(1:i-1))
		indx=maxloc(pt(nPar+1,k+1:k+nCon(i)))
		maxLike(1:nPar)=pt(1:nPar,indx(1)+k)
		d2=pt(nPar+1,indx(1)+k)
		
		!find MAP parameters
		indx=maxloc(pwt(1:npt,i))
		MAP(1:nPar)=pt(1:nPar,indx(1))
		
		!write the stats file
		if(multimodal) then
			write(funit3,*)
			write(funit3,*)
			write(funit3,'(a,i4)')'Mode',i
			d3=(nliveP-locNpt(i))*sinfo/locInfo(i)+locNpt(i)
			write(funit3,'(a,E28.18,a,E28.18)')"Strictly Local Log-Evidence",slocZ," +/-",sqrt(sinfo/locNpt(i))
			write(funit3,'(a,E28.18,a,E28.18)')"Local Log-Evidence",locZ(i)," +/-",sqrt(locInfo(i)/d3)
     		endif
		write(funit3,'(a)')""
		write(funit3,'(a)')"Dim No.       Mean        Sigma"
           	do j=1,nPar
           		!write(funit3,'(i4,2E28.18)')j,stMu(i,j),stSigma(i,j)
           		write(funit3,'(i4,2E28.18)')j,mean(i,j),sigma(i,j)
           	enddo      		
            	write(funit3,'(a)')""
            	write(funit3,'(a)')"Maximum Likelihood Parameters"
            	write(funit3,'(a)')"Dim No.        Parameter"
            	do j=1,nPar
           		write(funit3,'(i4,1E28.18)')j,maxLike(j)
           	enddo
      		write(funit3,'(a)')""
           	write(funit3,'(a)')"MAP Parameters"
           	write(funit3,'(a)')"Dim No.        Parameter"
           	do j=1,nPar
           		write(funit3,'(i4,1E28.18)')j,MAP(j)
           	enddo
		write(funit4,stfmt)mean(i,1:nPar),sigma(i,1:nPar),maxLike(1:nPar),MAP(1:nPar),locZ(i),d2
	enddo
      
  end subroutine genSepFiles
  
!------------------------------------------------------------------------

 logical function merge(n,nCdim,nPar,npt,gnpt,nptx,pt,mean,sigma,locEv,nullEv,wt,nWt,llike)
 
 	implicit none
	
	!input variables
	integer n !no. of clusters
	integer nCdim,nPar !dimensionality
	integer npt !total no. of constrained points
	integer gnpt !total no. of  points
	integer nptx(n) !no. of points in each cluster
	double precision pt(nPar+2,gnpt) !points
	double precision mean(n,nCdim),sigma(n,nCdim)
	double precision locEv(n) !local evidence
	double precision nullEv !null evidence
	double precision wt(gnpt,n)
	double precision nWt(gnpt,n),llike(n)
	
	!work variables
	integer i,j,k,l,m
	double precision tP(nPar+2,npt),tWt(npt,n)
	logical check(n),flag
 	
	
	flag = .false.
	merge=.false.
	check=.false.
	do i=1,n
		if(nptx(i)==0 .or. locEv(i)<nullEv) cycle
		do
			do j=1,n
				if(i==j .or. nptx(j)==0 .or. locEv(j)<nullEv) cycle
				flag=.false.
					
				!merge required?
				l=0
				do k=1,nCdim
					if(abs(mean(i,k)-mean(j,k))<=1.d0*sigma(i,k)) then
						l=l+1
					else
						exit
					endif
				enddo
					
				!yes, then merge the modes
				if(l==nCdim) then
					flag=.true.
					merge=.true.
					
					!re-arrange the constrained points & weights
					wt(:,i)=wt(:,i)+wt(:,j)
					
					!lowest likelihood
					llike(i)=max(llike(i),llike(j))
					
					l=sum(nptx(1:j-1))
					m=sum(nptx(1:i-1))
					tP(:,1:nptx(j))=pt(:,l+1:l+nptx(j))
					tWt(1:nptx(j),:)=wt(l+1:l+nptx(j),:)
					if(i<j) then
						pt(:,m+nptx(i)+nptx(j)+1:l+nptx(j))=pt(:,m+nptx(i)+1:l)
						pt(:,m+nptx(i)+1:m+nptx(i)+nptx(j))=tP(:,1:nptx(j))
						wt(m+nptx(i)+nptx(j)+1:l+nptx(j),:)=wt(m+nptx(i)+1:l,:)
						wt(m+nptx(i)+1:m+nptx(i)+nptx(j),:)=tWt(1:nptx(j),:)
					else
						pt(:,l+1:m-nptx(j))=pt(:,l+nptx(j)+1:m)
						pt(:,m-nptx(j)+1:m)=tP(:,1:nptx(j))
						wt(l+1:m-nptx(j),:)=wt(l+nptx(j)+1:m,:)
						wt(m-nptx(j)+1:m,:)=tWt(1:nptx(j),:)
					endif
					nptx(i)=nptx(i)+nptx(j)
					nptx(j)=0
					
					!recalculate the means & sigmas
					call rGaussProp(gnpt,nCdim,pt(1:nCdim,:),pt(nPar+1:nPar+2,:),wt(:,i), &
					nWt(:,i),mean(i,:),sigma(i,:),locEv(i))
						
					exit
				endif
			enddo
				
			if(.not.flag) exit
		enddo
	enddo
	j=0
	do i=1,n
		if(nptx(i)>0) then
			j=j+1
			nptx(j)=nptx(i)
			locEv(j)=locEv(i)
			mean(j,:)=mean(i,:)
			sigma(j,:)=sigma(i,:)
			wt(:,j)=wt(:,i)
			nWt(:,j)=nWt(:,i)
			llike(j)=llike(i)
		endif
	enddo
	n=j
 
 end function merge
  
!------------------------------------------------------------------------
  
  subroutine rGaussProp(n,d,p,LX,wt,nWt,mean,sigma,Z)
  
	implicit none
      
      	!input variables
      	integer n !no. of points
	integer d !dimensionality
	double precision p(d,n) !points
	double precision LX(2,n) !log-like & log-dX of points
	double precision wt(n)
	double precision nWt(n)
      
      	!output variables
      	double precision mean(d) !mean
      	double precision sigma(d) !standard deviations
      	double precision Z !local evidence
	
      
      	!work variables
      	integer i
  	
      	
	nWt=wt
	!calculate the evidence
!      	Z=-huge(1.d0)*epsilon(1.d0) !logZero
!	do i=1,n
!		if(nWt(i)>0.d0) Z=logSumExp(Z,LX(1,i)+LX(2,i)+log(nWt(i)))
!	enddo
	
	!now calculate the normalized posterior probabilty weights
	do i=1,n
		if(nWt(i)>0.d0) nWt(i)=nWt(i)*exp(LX(1,i)+LX(2,i)-Z)
	enddo
      	
	!mean & sigma
      	mean=0.d0
	sigma=0.d0
      	do i=1,n
            	mean(1:d)=mean(1:d)+p(1:d,i)*nWt(i)
            	sigma(1:d)=sigma(1:d)+(p(1:d,i)**2)*nWt(i)
	enddo
	sigma(1:d)=sqrt(sigma(1:d)-mean(1:d)**2)
	
  end subroutine rGaussProp
      
!----------------------------------------------------------------------


end module posterior

#!/usr/bin/env Rscript

### Read a CosmoSIS standard output file for a grid sampler, and
### generate a series of 1- and 2-dimensional likelihood density plots.

suppressPackageStartupMessages(library("optparse"))
suppressPackageStartupMessages(library("lattice"))
suppressPackageStartupMessages(library("doBy"))

### Create a dataframe from CosmoSIS grid sampler output. We expect the
### first line of the output to contain the names of the parameters,
### separated by spaces, and with section names separated from parameter
### names by a double-hyphen.

make.data.frame <- function(fname)
{
  d <- read.table(fname)
  first <- readLines(fname, n=1)
  first <- sub("#", "", first)          # Remove comment
  parts <- strsplit(first, "\t")[[1]]   # split on tabs
  cols <- sub("[a-zA-Z_]+--", "", parts) # remove leading section names

  names(d) <- cols
  likes <- exp(d$LIKE)
  norm <- sum(likes)
  d$l <- likes/norm
  return(d)
}

# Make a 1-d posterior density plot for each variable in the dataframe.
# We use bw="nrd", which gives a bandwidth calculation according to:
#    Scott, D. W. (1992) Multivariate Density Estimation: Theory, Practice, and
#    Visualization. Wiley.
make.1d.density.plots <- function(df, prefix, output, device, verbose)
{
  cols <- Filter(function(n) { ! n %in% c("l","LIKE") }, names(dframe))
  for(col in cols)
  {
    if (verbose) cat("Making 1-d density plot for", col, "\n")
    form <- as.formula(paste("l~", col, sep=""))
    df.summary <- summaryBy(form, data = df, FUN=sum)
    names(df.summary)[2] <- "l" # Replace ugly name generated by summaryBy
    dev.fcn <- get(device)
    filename <- file.path(output, paste(prefix, "_", col, ".", device, sep=""))
    p1 <- xyplot( form
                , df.summary
                , type="l"
                , lwd=2
                , ylab = "likelihood"
                , grid = TRUE
                )
    dev.fcn(filename)
    print(p1)
    invisible(dev.off())
  }
}

# Return the likelihood values corresponding to the boundary of the
# regions containing the probability contents 'levels'.
find.contours <- function(df, levels = c(0.68, 0.95))
{
  probs.sorted <- sort(df$l, decreasing=TRUE)
  probs.cs <- cumsum(probs.sorted)
  # Get the indices of the first values greater than the given confidence levels.
  indices <- sapply( levels
                   , function(x) which(probs.cs>x)[1]
                   )
  probs.sorted[indices]
}

## vmat2df will convert the kind of list returned by kde2d (containing two)
## vectors and a matrix, named x, y and z) into a dataframe with columns
## x, y, z.
#vmat2df <- function(u)
#{
#  g = expand.grid(u$x, u$y)
#  data.frame( x = g$Var1, y = g$Var2, z = as.numeric(u$z))
#}

# Make a 2-d density plot of  xcol vs. ycol, using data from df.
make.2d.density.plot <- function( df, xcol, ycol, prefix, output, device
                                , use.color
                                )
{
  form <- as.formula(paste("l~", xcol, "+", ycol, sep=""))
  df.summary <- summaryBy(form, data = df, FUN = sum)
  names(df.summary)[3] <- "l" # replace the ugly name given by summaryBy

  # Find the values of z which correspond to the given confidence levels.
  conf.levels = c(0.68, 0.95)
  zvals = find.contours(df.summary, conf.levels)
  
  dev.fcn <- get(device)
  filename <- file.path( output
                       , paste(prefix, "_", xcol, "_", ycol, ".", device, sep=""))
  levels <- c(0, zvals, 1)
  labels <- as.character(c(0, conf.levels, 1))
  form <- as.formula(paste("l~", xcol, "*", ycol, sep=""))
  p <- contourplot( form, df.summary, at=levels, labels=labels
                  , panel=function(...){panel.grid(-1,-1); panel.contourplot(...)}
                  , xlab = xcol
                  , ylab = ycol
                  , region = use.color
                  , lwd=2
                  , col.regions = function(n,a) rev(terrain.colors(n,a))
                  , colorkey = FALSE
                  )
  dev.fcn(filename)
  print(p)
  invisible(dev.off())
}

# For each pair, generate the kde2d result matrix.
# Determine the values of z at which the 68% and 95% contour lines lie.
# Transform the matrix to a dataframe.
# Make the contour plot.

make.2d.density.plots <- function(df, prefix, output, device, verbose, use.color)
{
  if (verbose) cat("Making 2-d density plots\n")
  # Go through all pairs of interesting variables (all but 'LIKE' and 'l',
  # the last two columns).
  n.interesting <- ncol(df)-2
  cols <- names(df)[1:n.interesting]
  pairs <- combn(cols, 2, simplify=FALSE)
  for(pair in pairs)
  {
    xcol <- pair[[1]]
    ycol <- pair[[2]]
    if (verbose) cat("Making 2-d density plot of", xcol, "vs.", ycol, "\n")
    make.2d.density.plot(df, xcol, ycol, prefix, output, device, use.color)
  }

}

################################################################################
###
### Start of the main program.

option_list <-
  list( make_option( c("-v", "--verbose")
                   , action="store_true"
                   , default = FALSE
                   , help = "Print extra output [%default]"
                   )
      , make_option( c("-p", "--prefix")
                   , default="plot"
                   , type="character"
                   , help="Prefix for all output files"
                   )
      , make_option( c("-o", "--output")
                   , default="."
                   , type="character"
                   , help="Directory for all output files"
                   )
      , make_option( c("-d", "--device")
                   , default="png"
                   , type="character"
                   , help="Graphics device for plots: png or pdf"
                   )
      , make_option( c("-f", "--fill")
                   , action="store_true"
                   , default=FALSE
                   , help="Color regions in 2-d density plots"
                   )
      , make_option( c("-b", "--burn")
                   , default = 0
                   , type="integer"
                   , help="Number of burn-in samples to ignore [%default]"
                   )
      )

parser <- OptionParser(option_list=option_list, usage="%prog [options] infile")
args   <- parse_args(parser, positional_arguments = TRUE)
opt    <- args$options

if (length(args$args) != 1)
{
  cat("Incorrect number of required arguments\n\n")
  print_help(parser)
  stop()    
}

input.file <- as.character(args$args)
if (file.exists(input.file) == FALSE )
{
  cat("Unable to open input file", input.file, "\n")
  stop()
}

if (opt$output != ".")
  if (! file.exists(opt$output))
    dir.create(opt$output, recursive=TRUE)

opt$device <- tolower(opt$device)

if (opt$device %in% c("png", "pdf") == FALSE)
{
  cat("Device", opt$device, "is not supported, using png\n")
  opt$device <- "png"
}

if (opt$verbose) 
   cat("Processing file", input.file, "\n")

dframe = make.data.frame(input.file)
make.1d.density.plots(dframe, opt$prefix, opt$output, opt$device, opt$verbose)
if (length(dframe) > 3)
  make.2d.density.plots(dframe, opt$prefix, opt$output, opt$device, opt$verbose, opt$fill)

module like

use params
use RandomNS
implicit none
      
double precision GLLhood0
      
contains

!----------------------------------------------------------------------
 
subroutine sCreateData(var,sdata,spredict)
         
	implicit none

	double precision var(4),sdata(snpix,snpix),tmp
	logical spredict
	integer i,j,k
	double precision gap!pixel gap in each direction between clusters
	character(len=root_max_len) datafile

	sdata=0.
	   
	!position cluster uniformly if autopos flag is set
	if(.not.spredict) then
		if(autopos) then
			gap=snpix*0.8/(sqrt(1.*snclstr)-1.)
			do i=1,int(sqrt(1.*snclstr))
				do j=1,int(sqrt(1.*snclstr))
					spos(j*2-1+int(sqrt(1.*snclstr))*(i-1)*2)=snpix*0.1+(i-1)*gap
					spos(j*2+int(sqrt(1.*snclstr))*(i-1)*2)=snpix*0.1+(j-1)*gap
				end do
			end do
		end if
	end if
         
         
	do i=1,snpix
		do j=1,snpix
			if(.not.spredict) then
				do k=1,snclstr
					sdata(i,j)=sdata(i,j)+samp(k)*exp(-((i-0.5-spos(k*2-1))**2.+(j-0.5-spos(k*2))**2.)/(2.*(ssig(k)**2.)))
				end do
                  	else
                  		sdata(i,j)=var(3)*exp(-((i-0.5-var(1))**2.+(j-0.5-var(2))**2.)/(2.*(var(4)**2.)))
                  	end if
              	end do	
	end do
         
	if (.not.spredict) then
!		datafile='data.dat'
!            	open(2,file=datafile,form='formatted',status='replace')
            	if(dseed<0) then
        		!take the seed from system clock
        		call InitRandomNS(1)
        	else
        		call InitRandomNS(1,dseed)
	  	end if
            
            	do i=1,snpix
               		do j=1,snpix
               			tmp=Gaussian1NS(0)
                  		sdata(i,j)=sdata(i,j)+tmp*snoise
               		end do
            	end do
            
!            	do j=1,snpix
!               	do i=1,snpix
!               		write(2,*)sdata(i,j)
!               	end do
!               	write(2,*)""
!            	end do
!            
!            	close(2)
		call killRandomNS()
	end if

end subroutine sCreateData
      
!=======================================================================

subroutine sInitialize(snullev)
         
	implicit none
         
	integer i,j
	double precision Chisq
	double precision snullev
	double precision TwoPi
         
	TwoPi=6.2831853
	GLLhood0 = 0.
	GLLhood0=-dble(snpix*snpix)*log(snoise)-dble(snpix*snpix)*log(TwoPi)/2.
         
	Chisq=0.

	do i=1,snpix
		do j=1,snpix
			Chisq=Chisq+(sodata(i,j))*(1./(snoise**2))*(sodata(i,j))
            	end do
	end do

	snullev=GLLhood0-Chisq/2.
	write(*,*)"Null Evidence=",snullev

end subroutine sInitialize
      
!=======================================================================

subroutine slikelihood(Cube,slhood)
         
	implicit none
      
        double precision Cube(sdim),slhood
	double precision spdata(snpix,snpix),Chisq,temp(4)
	integer i,j

	j=0
	do i=1,4
		if(spriorran(i,1)==spriorran(i,2)) then
			temp(i)=spriorran(i,1)
            	else
            		j=j+1
            		temp(i)=(spriorran(i,2)-spriorran(i,1))*Cube(j)+spriorran(i,1)
		end if
	end do
	Cube(1:sdim)=temp(1:sdim)
	 
	call sCreateData(temp,spdata,.true.)
         
	slhood=0.
	Chisq=0.

	do i=1,snpix
		do j=1,snpix
			Chisq=Chisq+((sodata(i,j)-spdata(i,j))/snoise)**2.
            	end do
	end do
	slhood=GLLhood0-Chisq/2.d0

end subroutine slikelihood
      
!=======================================================================

end module like

! X-means, Pelleg, Moore

module xmeans_clstr
  use kmeans_clstr
  use utils1
  implicit none
  
      integer n_dim
      double precision LogTwoPi
      parameter(LogTwoPi=1.83787706641)
      double precision larg
      parameter(larg=huge(1.d0))
      !information about ellipses at each node
      integer numClstr,nCls,ptClstrd,maxClstr !total clusters found yet & total pts in clstrs yet
      double precision, dimension(:,:), allocatable :: p,xclsMean,xclsEval,aux
      double precision, dimension(:), allocatable :: xclsBIC,loglike,xclsVar,xclsVol,xclsKfac,xclsEff,xclsDetcov
      double precision, dimension(:,:,:), allocatable :: xclsInvCov,xclsTMat,xclsCovmat,xclsEvec
      integer, dimension(:), allocatable :: revcPos,xclsPos,ptInClstr
      integer, dimension(:,:), allocatable :: pt_Clstr

 contains
 
  !simple X-means with likelihoods also being rearranged
  subroutine doXmeans(points,npt,np,nClstr,ptClstr,cMean,cCovmat,cInvCov,cEval,cEvec,like,min_pt)
	implicit none
      
      double precision points(:,:),like(:)
      integer npt,np !num of points & dimensionality
      integer nClstr !total clusters found
      integer ptClstr(:),min_pt
      double precision cMean(:,:),cCovmat(:,:,:),cInvCov(:,:,:),cEval(:,:),cEvec(:,:,:)
      integer i,j

	n_dim=np
      maxClstr=npt/min_pt+1
	allocate (p(n_dim,npt),loglike(npt),xclsBIC(maxClstr),revcPos(maxClstr), &
      	xclsPos(maxClstr),ptInClstr(maxClstr))
	allocate (xclsMean(maxClstr,n_dim),xclsCovmat(maxClstr,n_dim,n_dim), &
      	xclsInvCov(maxClstr,n_dim,n_dim),xclsEvec(maxClstr,n_dim,n_dim), &
      	xclsEval(maxClstr,n_dim))
      nCls=1
	numClstr=0
      ptClstrd=0
      ptInClstr=0
      revcPos=0
      
      call xmeans(points,npt,like,min_pt)
      !if(numClstr>1) call postprocess
      j=0
      do i=1,numClstr
      	if(ptInClstr(xclsPos(i))>0) then
            	j=j+1
      		ptClstr(j)=ptInClstr(xclsPos(i))
                  cMean(j,1:n_dim)=xclsMean(i,1:n_dim)
                  cEvec(j,1:n_dim,1:n_dim)=xclsEvec(i,1:n_dim,1:n_dim)
                  cEval(j,1:n_dim)=xclsEval(i,1:n_dim)
                  cCovmat(j,1:n_dim,1:n_dim)=xclsCovmat(i,1:n_dim,1:n_dim)
                  cInvCov(j,1:n_dim,1:n_dim)=xclsInvCov(i,1:n_dim,1:n_dim)
            end if
      end do
      nClstr=j
      points=p
      like=loglike
      deallocate(p,loglike,xclsBIC,revcPos,xclsPos,ptInClstr)
      deallocate(xclsMean,xclsInvCov,xclsCovmat,xclsEvec,xclsEval)
      
  end subroutine doXmeans
  
!----------------------------------------------------------------------
  !sub-clustering X-means with shared points
  !points rearranged with the cluster index of primary points also returned
  subroutine doXmeans5(points,npt,np,nClstr,ptClstr,ad,naux,auxa,min_pt)
      implicit none
      !input/output
      double precision points(:,:) !actual points which are rearranged after clustering
      			 !note: the clusters have shared points too
      double precision auxa(:,:) !auxilliary variables which are rearranged after clustering
      !input
      integer npt,np !num of points & dimensionality
      integer ad !no. of shared points required per cluster
      integer min_pt !min points allowed per cluster
      integer naux !no. of auxilliary variables to be a re-arranged
      !ouput
      integer nClstr !total clusters found
      integer ptClstr(:) !total no. of points in each cluster (including shared points)
      integer cluster(npt) !cluster index of primary points (before re-arrangement)
      
      !work
      integer i,j,maxec,k
      
      if(npt<2*min_pt) then
      	nClstr=1
            ptClstr(1)=npt
            ad=0
            return
	end if

      if(ad<0) ad=0
	n_dim=np
      maxec=npt/min_pt+1
      
	allocate (p(n_dim,npt+maxec*ad),revcPos(maxec),xclsPos(maxec), &
      	ptInClstr(maxec),aux(naux,npt+maxec*ad))
      
      ptInClstr=0
      nCls=1
	numClstr=0
      ptClstrd=0
      revcPos=0
      
      call xmeans5(points(:,1:npt),npt,cluster,ad,naux,auxa,min_pt)
      
      j=0
      k=0
      do i=1,numClstr
      	if(ptInClstr(xclsPos(i))>0) then
            	j=j+1
      		ptClstr(j)=ptInClstr(xclsPos(i))
                  k=k+ptInClstr(xclsPos(i))
            end if
      end do
      
      nClstr=j
      points(1:n_dim,1:k)=p(1:n_dim,1:k)
      auxa(1:naux,1:k)=aux(1:naux,1:k)
      
      deallocate(p,revcPos,xclsPos,ptInClstr,aux)
      
  end subroutine doXmeans5
      
!----------------------------------------------------------------------
  !sub-clustering X-means with 
  !nClstr = no. of clusters found by previous clustering
  !ptClstr(nClstr) = no. of pts in each cluster found by previous clustering
  !nb = every cluster is divided into nb sub-clusters
  !ad = shared pts per sub-cluster
  subroutine doXmeans8(points,like,npt,np,nClstr,ptClstr,ad,min_pt)
	implicit none
      
      double precision points(:,:),like(:)
      integer npt,np !num of points & dimensionality
      integer nClstr !total clusters found
      integer ptClstr(:),min_pt
      integer i,j,maxec,k
      integer ad !no. of shared points per cluster

      if(npt<2*min_pt) then
      	nClstr=1
            ptClstr(1)=npt
            ad=0
            return
	end if
      
      if(ad<0) ad=0

	n_dim=np
      maxec=npt/min_pt+1
      
	allocate (p(n_dim,npt+maxec*ad))
	allocate (loglike(npt+maxec*ad))
	allocate (revcPos(maxec))
	allocate (xclsPos(maxec))
	allocate (ptInClstr(maxec))
      
      ptInClstr=0
      nCls=1
	numClstr=0
      ptClstrd=0
      revcPos=0
      
      call Xmeans8(nClstr,points(:,1:npt),like(1:npt),ptClstr,npt,ad,min_pt)
      
      j=0
      k=0
      do i=1,numClstr
      	if(ptInClstr(xclsPos(i))>0) then
            	j=j+1
      		ptClstr(j)=ptInClstr(xclsPos(i))
                  k=k+ptInClstr(xclsPos(i))
            end if
      end do
      
      nClstr=j
      points(1:n_dim,1:k)=p(1:n_dim,1:k)
      like(1:k)=loglike(1:k)
      
      deallocate(p)
      deallocate(revcPos)
      deallocate(loglike)
      deallocate(xclsPos)
      deallocate(ptInClstr)
      
  end subroutine doXmeans8
      
!----------------------------------------------------------------------
 
  !simple X-means with likelihoods also being rearranged
  subroutine doXmeans6(points,npt,np,nClstr,ptClstr,naux,auxa,min_pt,maxC)
	implicit none
      
      double precision points(:,:),auxa(:,:)
      integer npt,np !num of points & dimensionality
      integer naux !dimension of auxilliary array
      integer nClstr !total clusters found
      integer ptClstr(:),min_pt,maxC
      integer i,j

      if(npt<2*min_pt) then
      	nClstr=1
            ptClstr(1)=npt
            return
	end if

	n_dim=np
      maxClstr=maxC
      allocate (p(n_dim,npt),aux(naux,npt),xclsPos(maxClstr),ptInClstr(maxClstr), &
      	xclsMean(maxClstr,n_dim),xclsVar(maxClstr),xclsBIC(maxClstr),revcPos(maxClstr))
      nCls=1
	numClstr=0
      ptClstrd=0
      ptInClstr=0
      
      call xmeans6(points,npt,naux,auxa,min_pt)
      
      j=0
      do i=1,numClstr
      	if(ptInClstr(xclsPos(i))>0) then
            	j=j+1
      		ptClstr(j)=ptInClstr(xclsPos(i))
            end if
      end do
      
      nClstr=j
      points(1:n_dim,1:npt)=p(1:n_dim,1:npt)
      auxa(1:naux,1:npt)=aux(1:naux,1:npt)
      deallocate(p,aux,xclsPos,ptInClstr,xclsMean,xclsVar,xclsBIC,revcPos)
      
  end subroutine doXmeans6
      
!----------------------------------------------------------------------
 
  !simple X-means
  subroutine doXmeans7(points,npt,np,nClstr,ptClstr,min_pt)
	implicit none
      
      double precision points(:,:)
      integer npt,np !num of points & dimensionality
      integer nClstr !total clusters found
      integer ptClstr(:),min_pt
      integer i,j

      if(npt<2*min_pt) then
      	nClstr=1
            ptClstr(1)=npt
            return
	end if

	n_dim=np
      maxClstr=npt/min_pt+1
      allocate (p(n_dim,npt),xclsPos(maxClstr),ptInClstr(maxClstr), &
      	xclsMean(maxClstr,n_dim),xclsVar(maxClstr),xclsBIC(maxClstr),revcPos(maxClstr))
      nCls=1
	numClstr=0
      ptClstrd=0
      ptInClstr=0
      
      call Xmeans7(points,npt,min_pt)
      
      j=0
      do i=1,numClstr
      	if(ptInClstr(xclsPos(i))>0) then
            	j=j+1
      		ptClstr(j)=ptInClstr(xclsPos(i))
            end if
      end do
      
      nClstr=j
      points(1:n_dim,1:npt)=p(1:n_dim,1:npt)
      deallocate(p,xclsPos,ptInClstr,xclsMean,xclsVar,xclsBIC,revcPos)
      
  end subroutine doXmeans7
      
!----------------------------------------------------------------------
  
  subroutine doGmeans(points,npt,np,nClstr,ptClstr,naux,auxa,min_pt,maxC)
	implicit none
      
      	double precision points(:,:),auxa(:,:)
      	integer npt,naux,np !num of points & dimensionality
      	integer nClstr !total clusters found
      	integer ptClstr(:),min_pt,maxC
      	integer i,j

      	if(npt<2*min_pt) then
      		nClstr=1
            	ptClstr(1)=npt
            	return
	endif

	n_dim=np
      	maxClstr=maxC
	allocate (p(n_dim,npt),aux(naux,npt),xclsPos(maxClstr),ptInClstr(maxClstr))
      	nCls=1
	numClstr=0
      	ptClstrd=0
      	ptInClstr=0
      
      	call Gmeans(points,npt,naux,auxa,min_pt)
      
      	j=0
      	do i=1,numClstr
      		if(ptInClstr(xclsPos(i))>0) then
            		j=j+1
      			ptClstr(j)=ptInClstr(xclsPos(i))
            	endif
      	enddo
      
      	nClstr=j
      	points(1:n_dim,1:npt)=p(1:n_dim,1:npt)
      	auxa(1:naux,1:npt)=aux(1:naux,1:npt)
      
      	deallocate(p,aux,xclsPos,ptInClstr)
      
  end subroutine doGmeans
      
!----------------------------------------------------------------------  
  
  subroutine doGmeans2(points,npt,np,nClstr,ptClstr,min_pt)
	implicit none
      
      double precision points(:,:)
      integer npt,np !num of points & dimensionality
      integer nClstr !total clusters found
      integer ptClstr(:),min_pt
      integer i,j

      if(npt<2*min_pt) then
      	nClstr=1
            ptClstr(1)=npt
            return
	end if

	n_dim=np
      maxClstr=npt/min_pt+1
	allocate (p(n_dim,npt),xclsPos(maxClstr),ptInClstr(maxClstr))
      nCls=1
	numClstr=0
      ptClstrd=0
      ptInClstr=0
      
      call Gmeans2(points,npt,min_pt)

      j=0
      do i=1,numClstr
      	if(ptInClstr(xclsPos(i))>0) then
            	j=j+1
      		ptClstr(j)=ptInClstr(xclsPos(i))
            end if
      end do
      nClstr=j
      points=p
      deallocate(p,xclsPos,ptInClstr)
      
  end subroutine doGmeans2
      
!----------------------------------------------------------------------  

  recursive subroutine Xmeans(pt,npt,like,min_pt)
    	implicit none
 
	integer min_pt,npt !num of points
    	double precision pt(:,:) !points
      double precision like(:) !likelihood values
    	double precision ptk(2,n_dim,npt)!points in clusters
    	double precision likek(2,npt)!loglike, to change order only
      integer nptk(2) !no. of points in the clusters
    	integer cluster(npt) !cluster array having cluster num of each pt
    	integer i,j,ip
      double precision covar(n_dim,n_dim),covark(2,n_dim,n_dim),invcov(n_dim,n_dim),invcovk(2,n_dim,n_dim)
    	double precision evec(n_dim,n_dim),eveck(2,n_dim,n_dim),eval(n_dim),evalk(2,n_dim),detcov,detcovk(2)
      double precision mean(n_dim),meank(2,n_dim)
      double precision BIC1,BIC2 !BIC for 1 & 2 clusters respectively
      integer i1
      logical flag
      
      flag=.false.
      
      do i=1,n_dim
		mean(i)=sum(pt(i,1:npt))/dble(npt)
      enddo
      !calculate cov,inv_cov,evec matrices & eval & det(cov)
      call calc_covmat(npt,n_dim,pt,mean,covar)
      evec=covar
      call diagonalize(evec,eval,n_dim,flag)
      !if any of the eval are 0 or -ve then use the lowest +ve eval
      do j=1,n_dim
		if(eval(j)<=0.) eval(1:j)=eval(j+1)
      enddo
      detcov=product(eval)
      call calc_invcovmat(n_dim,evec,eval,invcov)
      
      !don't cluster 
      !if it produces a cluster with less than 2*(min_pt-1)+1 points
      !since it would cluster into clusters having less than min_pt points
      !or
      !if the number of clusters has reached maxCls
      if(npt<2*min_pt.or.nCls==maxClstr) then
      	BIC2=larg
            BIC1=-larg
            flag=.true.
	end if
      
      if(.not.flag) then
      	!calculate BIC for all the points, no clustering
      	BIC1=calcBIC1(pt,npt,mean,invcov,detcov)
      
      	!breakup the points in 2 clusters
		i1=2
		meank(1,1:n_dim)=mean(1:n_dim)
      	call kmeans3(i1,pt,npt,n_dim,meank(1:i1,1:n_dim),cluster,min_pt)
      	!calculate the no. of points in each cluster & separate them
      	nptk=0
      	ptk=0.
      	do i=1,npt
            	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
            	likek(cluster(i),nptk(cluster(i)))=like(i)
		end do
      
      	!don't cluster if either of the clusters have less than min_pt points
      	!since that might be noise
      	do i=1,2
      		if(nptk(i)<min_pt) then
      			BIC2=larg
                        flag=.true.
                        exit
			end if
		end do
      end if
      
      if(.not.flag) then      
     		!calculate covar,inv_cov,evec matrices & eval & det(cov) for the points in each of the clusters
     		do i=1,2
      		!calculate covariance matrix
      		call calc_covmat(nptk(i),n_dim,ptk(i,:,1:nptk(i)),meank(i,:),covark(i,:,:))
			!diagonalize
            	eveck(i,:,:)=covark(i,:,:)
      		call diagonalize(eveck(i,:,:),evalk(i,:),n_dim,flag)
      
      		!if any of the eval are 0 or -ve then use the lowest +ve eval
     			do j=1,n_dim
				if(evalk(i,j)<=0.) evalk(i,1:j)=evalk(i,j+1)
      		enddo
      
      		detcovk(i)=product(evalk(i,:))
       		call calc_invcovmat(n_dim,eveck(i,:,:),evalk(i,:),invcovk(i,:,:))
      	end do

     		BIC2=calcBIC2(ptk(1:2,:,:),nptk(1:2),meank,invcovk,detcovk)
	end if
      
      if(BIC1>BIC2) then
		nCls=nCls+1
      	call xmeans(ptk(1,:,1:nptk(1)),nptk(1),likek(1,1:nptk(1)),min_pt)
      	call xmeans(ptk(2,:,1:nptk(2)),nptk(2),likek(2,1:nptk(2)),min_pt)
      	return
      else
      	p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
            loglike(ptClstrd+1:ptClstrd+npt)=like(1:npt)
      	ip=binSearch(ptInClstr,numClstr,npt)
            ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            ptInClstr(ip)=npt
            do i=1,numClstr
            	if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            end do
            xclsPos(numClstr+1)=ip
            ptClstrd=ptClstrd+npt
            numClstr=numClstr+1
            !save cluster info
            xclsBIC(numClstr)=BIC1
            xclsMean(numClstr,1:n_dim)=mean(1:n_dim)
            xclsCovmat(numClstr,1:n_dim,1:n_dim)=covar(1:n_dim,1:n_dim)
            xclsInvCov(numClstr,1:n_dim,1:n_dim)=invcov(1:n_dim,1:n_dim)
            xclsEvec(numClstr,1:n_dim,1:n_dim)=evec(1:n_dim,1:n_dim)
            xclsEval(numClstr,1:n_dim)=eval(1:n_dim)
      end if
      
  end subroutine Xmeans 
      
!---------------------------------------------------------------------- 

  recursive subroutine Xmeans4(pt,npt,ad,min_pt)
    	implicit none
 
	integer min_pt,npt !num of points
      integer ad !no. of shared points required, returns the no. of shared points found
    	double precision pt(:,:) !points
    	double precision ptk(npt/(n_dim+1),n_dim,npt+ad)!points in clusters
      integer nptk(npt/(n_dim+1)) !no. of points in the clusters
    	integer cluster(npt) !cluster array having cluster num of each pt
    	integer i,j,ip,q
      double precision covar(n_dim,n_dim),covark(2,n_dim,n_dim),invcov(n_dim,n_dim),invcovk(2,n_dim,n_dim)
    	double precision evec(n_dim,n_dim),eveck(2,n_dim,n_dim),eval(n_dim),evalk(2,n_dim),detcov,detcovk(2)
      double precision mean(n_dim),meank(2,n_dim)
      double precision BIC1,BIC2 !BIC for 1 & 2 clusters respectively
      integer i1
      integer cluster2(npt/(n_dim+1),ad)
      logical flag
      
      flag=.false.
      
      do i=1,n_dim
		mean(i)=sum(pt(i,1:npt))/dble(npt)
      enddo
      
      !don't cluster if it produces a cluster with less than 2*(min_pt-1)+1 points
      !since it would cluster into clusters having less than min_pt points
      !don't cluster if the number of clusters has reached maxCls
      if(npt<2*min_pt .or. nCls==maxClstr) then
      	BIC2=larg
            BIC1=-larg
            flag=.true.
      end if
      
      if(.not.flag) then
      	!calculate cov,inv_cov,evec matrices & eval & det(cov)
      	call calc_covmat(npt,n_dim,pt,mean,covar)
      	evec=covar
      	call diagonalize(evec,eval,n_dim,flag)
      	!if any of the eval are 0 or -ve then use the lowest +ve eval
      	do j=1,n_dim
			if(eval(j)<=0.) eval(1:j)=eval(j+1)
      	enddo
      	detcov=product(eval)
      	call calc_invcovmat(n_dim,evec,eval,invcov)
      
      	!calculate BIC for all the points, no clustering
      	BIC1=calcBIC1(pt,npt,mean,invcov,detcov)

      
      	!breakup the points in 2 clusters
		i1=2
		meank(1,1:n_dim)=mean(1:n_dim)
      	call kmeans3(i1,pt,npt,n_dim,meank(1:i1,1:n_dim),cluster,min_pt)
      	!calculate the no. of points in each cluster & separate them
      	nptk=0
      	ptk=0.
      	do i=1,npt
            	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
		end do
      
      	!don't cluster if either of the clusters have less than min_pt points
      	!since that might be noise
      	do i=1,2
      		if(nptk(i)<min_pt) then
      			BIC2=larg
            		flag=.true.
                        exit
			end if
		end do
      end if
                  
	if(.not.flag) then
     		!calculate covar,inv_cov,evec matrices & eval & det(cov) for the points in each of the clusters
     		do i=1,2
      		!calculate covariance matrix
            	call calc_covmat(nptk(i),n_dim,ptk(i,:,1:nptk(i)),meank(i,:),covark(i,:,:))
			!diagonalize
            	eveck(i,:,:)=covark(i,:,:)
      		call diagonalize(eveck(i,:,:),evalk(i,:),n_dim,flag)
      
      		!if any of the eval are 0 or -ve then use the lowest +ve eval
     			do j=1,n_dim
				if(evalk(i,j)<=0.) evalk(i,1:j)=evalk(i,j+1)
      		enddo
      
      		detcovk(i)=product(evalk(i,:))
       		call calc_invcovmat(n_dim,eveck(i,:,:),evalk(i,:),invcovk(i,:,:))
            
      	end do
     		BIC2=calcBIC2(ptk(1:2,:,:),nptk(1:2),meank,invcovk,detcovk)
	end if
      
      if(BIC1>BIC2) then
		nCls=nCls+1
            call xmeans4(ptk(1,:,1:nptk(1)),nptk(1),ad,min_pt)
		call xmeans4(ptk(2,:,1:nptk(2)),nptk(2),ad,min_pt)
      	return
      else
      	!i1=min(nb,npt/max(min_pt,min(10,2*min_pt)))
            i1=npt/min_pt+1
      	!if(npt>=2*max(min_pt,min(10,2*min_pt)).and.i1>1) then
      	if(npt>=2*min_pt.and.i1>1) then
            	!break up the cluster into nb clusters
                  call kmeans7(i1,pt,npt,n_dim,cluster,ad,cluster2,min_pt)
			!calculate the no. of points in each cluster & separate them
                  
      		nptk=0
      		ptk=0.
      		do i=1,npt
            		nptk(cluster(i))=nptk(cluster(i))+1
            		ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
			end do
                  
                  do i=1,i1
                  	do j=1,ad
                              !if(cluster2(i,j)==0) exit
					nptk(i)=nptk(i)+1
                              ptk(i,:,nptk(i))=pt(:,cluster2(i,j))
				end do
			end do
                  	
                  !arrange the points
                  do i=1,i1
                  	p(:,ptClstrd+1:ptClstrd+nptk(i))=ptk(i,:,1:nptk(i))
      			ip=binSearch(ptInClstr,numClstr,nptk(i))
           	 		ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            		ptInClstr(ip)=nptk(i)
           			do q=1,numClstr
            			if(xclsPos(q)>=ip) xclsPos(q)=xclsPos(q)+1
            		end do
            		xclsPos(numClstr+1)=ip
            		ptClstrd=ptClstrd+nptk(i)
            		numClstr=numClstr+1
            		!save cluster info
                        do q=1,n_dim
            			xclsMean(numClstr,q)=sum(ptk(i,q,1:nptk(i)))/dble(nptk(i))
                        end do
			end do
		else
      		p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
      		ip=binSearch(ptInClstr,numClstr,npt)
            	ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            	ptInClstr(ip)=npt
            	do i=1,numClstr
            		if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            	end do
            	xclsPos(numClstr+1)=ip
            	ptClstrd=ptClstrd+npt
            	numClstr=numClstr+1
            	!save cluster info
            	xclsInvCov(numClstr,1:n_dim,1:n_dim)=invcov(1:n_dim,1:n_dim)
            	xclsBIC(numClstr)=BIC1
            	xclsMean(numClstr,1:n_dim)=mean(1:n_dim)
		end if
      end if
      
  end subroutine xmeans4 
      
!---------------------------------------------------------------------- 

  recursive subroutine Xmeans5(ptf,tnpt,cluster,ad,naux,auxa,min_pt)
    	implicit none
 
	integer min_pt,npt !num of points
      integer ad !no. of shared points required, returns the no. of shared points found
      integer tnpt
    	double precision ptf(:,:),pt(n_dim,tnpt) !points
    	double precision ptk(tnpt/(n_dim+1),n_dim,tnpt+ad)!points in clusters
      integer nptk(tnpt/(n_dim+1)) !no. of points in the clusters
    	integer cluster(tnpt) !cluster array having cluster num of each pt
    	integer i,j,ip
      integer i1
      integer cluster2(tnpt/(n_dim+1),ad)
      integer naux
      double precision auxa(:,:),auxk(tnpt/(n_dim+1),naux,tnpt+ad)
      
      npt=tnpt
      pt(:,1:npt)=ptf(:,1:npt)
            
      i1=npt/min_pt+1
      	
      if(npt>=2*min_pt.and.i1>1) then
            !break up the cluster into nb clusters
		call kmeans7(i1,pt(:,1:npt),npt,n_dim,cluster(1:npt),ad,cluster2,min_pt)
		!calculate the no. of points in each cluster & separate them
		nptk=0
      	do i=1,npt
            	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
            	auxk(cluster(i),:,nptk(cluster(i)))=auxa(:,i)
		end do
                  
		do i=1,i1
			do j=1,ad
				!if(cluster2(i,j)==0) exit
				nptk(i)=nptk(i)+1
				ptk(i,:,nptk(i))=pt(:,cluster2(i,j))
				auxk(i,:,nptk(i))=auxa(:,cluster2(i,j))
			end do
		end do
                  	
		!arrange the points
		do i=1,i1
                  p(:,ptClstrd+1:ptClstrd+nptk(i))=ptk(i,:,1:nptk(i))
                  aux(:,ptClstrd+1:ptClstrd+nptk(i))=auxk(i,:,1:nptk(i))
      		!ip=binSearch(ptInClstr,numClstr,nptk(i))
			ip=numClstr+1
			!ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            	ptInClstr(ip)=nptk(i)
			!do q=1,numClstr
            		!if(xclsPos(q)>=ip) xclsPos(q)=xclsPos(q)+1
            	!end do
            	xclsPos(numClstr+1)=ip
            	ptClstrd=ptClstrd+nptk(i)
            	numClstr=numClstr+1
		end do
	else
      	p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
      	aux(:,ptClstrd+1:ptClstrd+npt)=auxa(:,1:npt)
      	!ip=binSearch(ptInClstr,numClstr,npt)
		ip=numClstr+1
		!ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            ptInClstr(ip)=npt
            !do i=1,numClstr
			!if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            !end do
            xclsPos(numClstr+1)=ip
            ptClstrd=ptClstrd+npt
            numClstr=numClstr+1
	end if
      
  end subroutine xmeans5 
      
!----------------------------------------------------------------------   

  recursive subroutine Xmeans8(nClsf,ptf,lkf,ptInClsf,tnpt,ad,min_pt)
    	implicit none
 
	integer min_pt,npt !num of points
      integer ad  !no. of shared points required, returns the no. of shared points found
      integer tnpt,nClsf,ptInClsf(:)
    	double precision ptf(:,:),pt(n_dim,tnpt),lkf(:),lk(tnpt) !points & log-like
    	double precision ptk(tnpt/(n_dim+1),n_dim,tnpt+ad)!points in clusters
    	double precision likek(tnpt/(n_dim+1),tnpt+ad)!log-like of points in clusters
      integer nptk(tnpt/(n_dim+1)) !no. of points in the clusters
    	integer cluster(tnpt) !cluster array having cluster num of each pt
    	integer i,j,ip,q,l,m
      integer i1
      integer cluster2(tnpt/(n_dim+1),ad)
      
      m=1
	do l=1,nClsf
      	npt=ptInClsf(l)
            pt(:,1:npt)=ptf(:,m:m+ptInClsf(l))
            lk(1:npt)=lkf(m:m+ptInClsf(l))
            m=m+ptInClsf(l)
            
      	i1=npt/min_pt+1
      	
            if(npt>=2*min_pt.and.i1>1) then
            	!break up the cluster into nb clusters
                  call kmeans7(i1,pt(:,1:npt),npt,n_dim,cluster(1:npt),ad,cluster2,min_pt)
			!calculate the no. of points in each cluster & separate them
                  
      		nptk=0
      		ptk=0.
      		do i=1,npt
            		nptk(cluster(i))=nptk(cluster(i))+1
            		ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
            		likek(cluster(i),nptk(cluster(i)))=lk(i)
			end do
                  
                  if(ad>0) then
                  	do i=1,i1
                  		do j=1,ad
                              	!if(cluster2(i,j)==0) exit
                                    nptk(i)=nptk(i)+1
                              	ptk(i,:,nptk(i))=pt(:,cluster2(i,j))
                              	likek(i,nptk(i))=lk(cluster2(i,j))
                              end do
				end do
                  end if
                  	
                  !arrange the points
                  do i=1,i1
                  	p(:,ptClstrd+1:ptClstrd+nptk(i))=ptk(i,:,1:nptk(i))
                  	loglike(ptClstrd+1:ptClstrd+nptk(i))=likek(i,1:nptk(i))
      			ip=binSearch(ptInClstr,numClstr,nptk(i))
           	 		ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            		ptInClstr(ip)=nptk(i)
           			do q=1,numClstr
            			if(xclsPos(q)>=ip) xclsPos(q)=xclsPos(q)+1
            		end do
            		xclsPos(numClstr+1)=ip
            		ptClstrd=ptClstrd+nptk(i)
            		numClstr=numClstr+1
			end do
		else
      		p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
      		loglike(ptClstrd+1:ptClstrd+npt)=lk(1:npt)
      		ip=binSearch(ptInClstr,numClstr,npt)
            	ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            	ptInClstr(ip)=npt
            	do i=1,numClstr
            		if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            	end do
            	xclsPos(numClstr+1)=ip
            	ptClstrd=ptClstrd+npt
            	numClstr=numClstr+1
		end if
      end do
      
  end subroutine Xmeans8 
      
!----------------------------------------------------------------------   

  recursive subroutine Xmeans6(pt,npt,naux,auxa,min_pt)
    	implicit none
 
	integer min_pt,npt,naux !num of points
    	double precision pt(:,:) !points
      double precision auxa(:,:) !auxilliary array
    	double precision ptk(2,n_dim,npt)!points in clusters
    	double precision auxk(2,naux,npt)!aux, to change order only
      integer nptk(2) !no. of points in the clusters
    	integer cluster(npt) !cluster array having cluster num of each pt
      double precision mean(3,n_dim),var(3)
    	integer i,j,ip
      double precision BIC1,BIC2 !BIC for 1 & 2 clusters respectively
      integer i1
      logical flag
      
      flag=.false.
      
      !don't cluster 
      !if it produces a cluster with less than 2*(min_pt-1)+1 points
      !since it would cluster into clusters having less than min_pt points
      !or
      !if the number of clusters has reached maxCls
      if(npt<2*min_pt.or.nCls==maxClstr) then
      	BIC2=larg
            BIC1=-larg
            flag=.true.
	end if
      
      if(.not.flag) then
      	var=0.
      	!calculate mean & variance
      	do i=1,n_dim
      		mean(3,i)=sum(pt(i,1:npt))/npt
            	var(3)=var(3)+sum(pt(i,1:npt)**2.)/npt-mean(3,i)**2.
     	 	end do
      
      	!calculate BIC for all the points, no clustering
      	BIC1=calcBIC1_iso(npt,var(3))
      
      	!breakup the points in 2 clusters
		i1=2
		mean(1,:)=mean(3,:)
      	call kmeans3(i1,pt(1:n_dim,1:npt),npt,n_dim,mean(1:i1,1:n_dim),cluster,min_pt)
      	!calculate the no. of points in each cluster & separate them
      	nptk=0
      	ptk=0.
      	do i=1,npt
            	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
            	auxk(cluster(i),:,nptk(cluster(i)))=auxa(:,i)
		end do
      
      	!don't cluster if either of the clusters have less than min_pt points
      	!since that might be noise
      	do i=1,2
      		if(nptk(i)<min_pt) then
      			BIC2=larg
                        flag=.true.
                        exit
			end if
		end do
	end if
      
      if(.not.flag) then
      	!calculate mean & variance
		var(1:2)=0.
      	do i=1,2
      		do j=1,n_dim
            		var(i)=var(i)+sum(ptk(i,j,1:nptk(i))**2.)/nptk(i)-mean(i,j)**2.
			end do
      	end do
      
      	BIC2=calcBIC2_iso(nptk(1:2),var(1:2))
	end if
      
      if(BIC1>BIC2) then
		nCls=nCls+1
      	call Xmeans6(ptk(1,:,1:nptk(1)),nptk(1),naux,auxk(1,:,1:nptk(1)),min_pt)
      	call Xmeans6(ptk(2,:,1:nptk(2)),nptk(2),naux,auxk(2,:,1:nptk(2)),min_pt)
      	return
      else
      	p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
            aux(:,ptClstrd+1:ptClstrd+npt)=auxa(:,1:npt)
      	ip=binSearch(ptInClstr,numClstr,npt)
            ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            ptInClstr(ip)=npt
            do i=1,numClstr
            	if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            end do
            xclsPos(numClstr+1)=ip
            xclsMean(numClstr+1,1:n_dim)=mean(3,1:n_dim)
            xclsVar(numClstr+1)=var(3)
            xclsBIC(numClstr+1)=BIC1
            ptClstrd=ptClstrd+npt
            numClstr=numClstr+1
      end if
      
  end subroutine Xmeans6
      
!----------------------------------------------------------------------  

  recursive subroutine Xmeans7(pt,npt,min_pt)
    	implicit none
 
	integer min_pt,npt !num of points
    	double precision pt(:,:) !points
    	double precision ptk(2,n_dim,npt)!points in clusters
      integer nptk(2) !no. of points in the clusters
    	integer cluster(npt) !cluster array having cluster num of each pt
      double precision mean(3,n_dim),var(3)
    	integer i,j,ip
      double precision BIC1,BIC2 !BIC for 1 & 2 clusters respectively
      integer i1
      logical flag
      
      flag=.false.
      
      !don't cluster 
      !if it produces a cluster with less than 2*(min_pt-1)+1 points
      !since it would cluster into clusters having less than min_pt points
      !or
      !if the number of clusters has reached maxCls
      if(npt<2*min_pt.or.nCls==maxClstr) then
      	BIC2=larg
            BIC1=-larg
            flag=.true.
	end if
      
      if(.not.flag) then
      	var=0.
      	!calculate mean & variance
      	do i=1,n_dim
      		mean(3,i)=sum(pt(i,1:npt))/npt
            	var(3)=var(3)+sum(pt(i,1:npt)**2.)/npt-mean(3,i)**2.
     	 	end do
      
      	!calculate BIC for all the points, no clustering
      	BIC1=calcBIC1_iso(npt,var(3))
      
      	!breakup the points in 2 clusters
		i1=2
		mean(1,:)=mean(3,:)
      	call kmeans3(i1,pt(1:n_dim,1:npt),npt,n_dim,mean(1:i1,1:n_dim),cluster,min_pt)
      	!calculate the no. of points in each cluster & separate them
      	nptk=0
      	ptk=0.
      	do i=1,npt
            	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
		end do
      
      	!don't cluster if either of the clusters have less than min_pt points
      	!since that might be noise
      	do i=1,2
      		if(nptk(i)<min_pt) then
      			BIC2=larg
                        flag=.true.
                        exit
			end if
		end do
	end if
      
      if(.not.flag) then
      	!calculate mean & variance
		var(1:2)=0.
      	do i=1,2
      		do j=1,n_dim
            		var(i)=var(i)+sum(ptk(i,j,1:nptk(i))**2.)/nptk(i)-mean(i,j)**2.
			end do
      	end do
      
      	BIC2=calcBIC2_iso(nptk(1:2),var(1:2))
	end if
      
      if(BIC1>BIC2) then
		nCls=nCls+1
      	call Xmeans7(ptk(1,:,1:nptk(1)),nptk(1),min_pt)
      	call Xmeans7(ptk(2,:,1:nptk(2)),nptk(2),min_pt)
      	return
      else
      	p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
      	ip=binSearch(ptInClstr,numClstr,npt)
            ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            ptInClstr(ip)=npt
            do i=1,numClstr
            	if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            end do
            xclsPos(numClstr+1)=ip
            xclsMean(numClstr+1,1:n_dim)=mean(3,1:n_dim)
            xclsVar(numClstr+1)=var(3)
            xclsBIC(numClstr+1)=BIC1
            ptClstrd=ptClstrd+npt
            numClstr=numClstr+1
      end if
      
  end subroutine Xmeans7
      
!---------------------------------------------------------------------- 
  !sub-clustering X-means with shared points
  !points rearranged with the cluster index of primary points also returned
  subroutine doXmeans9(points,npt,np,nClstr,ptClstr,ad,min_pt)
	implicit none
      !input/output
      double precision points(:,:) !actual points which are rearranged after clustering
      			 !note: the clusters have shared points too
      !input
      integer npt,np !num of points & dimensionality
      integer ad !no. of shared points required per cluster
      integer min_pt !min points allowed per cluster
      !ouput
      integer nClstr !total clusters found
      integer ptClstr(:) !total no. of points in each cluster (including shared points)
      integer cluster(npt) !cluster index of primary points (before re-arrangement)
      
      !work
      integer i,j,maxec,k
      
      if(npt<2*min_pt) then
      	nClstr=1
            ptClstr(1)=npt
            ad=0
            return
	end if

      if(ad<0) ad=0
	n_dim=np
      maxec=npt/min_pt+1
      
	allocate (p(n_dim,npt+maxec*ad))
	allocate (revcPos(maxec))
	allocate (xclsPos(maxec))
	allocate (ptInClstr(maxec))
      
      ptInClstr=0
      nCls=1
	numClstr=0
      ptClstrd=0
      revcPos=0
      
      call Xmeans9(points(:,1:npt),npt,cluster,ad,min_pt)
      
      j=0
      k=0
      do i=1,numClstr
      	if(ptInClstr(xclsPos(i))>0) then
            	j=j+1
      		ptClstr(j)=ptInClstr(xclsPos(i))
                  k=k+ptInClstr(xclsPos(i))
            end if
      end do
      
      nClstr=j
      points(1:n_dim,1:k)=p(1:n_dim,1:k)
      
      deallocate(p)
      deallocate(revcPos)
      deallocate(xclsPos)
      deallocate(ptInClstr)
      
  end subroutine doXmeans9
      
!----------------------------------------------------------------------

  recursive subroutine Xmeans9(ptf,tnpt,cluster,ad,min_pt)
    	implicit none
 
	integer min_pt,npt !num of points
      integer ad !no. of shared points required, returns the no. of shared points found
      integer tnpt
    	double precision ptf(:,:),pt(n_dim,tnpt) !points
    	double precision ptk(tnpt/(n_dim+1),n_dim,tnpt+ad)!points in clusters
      integer nptk(tnpt/(n_dim+1)) !no. of points in the clusters
    	integer cluster(tnpt) !cluster array having cluster num of each pt
    	integer i,j,ip
      integer i1
      integer cluster2(tnpt/(n_dim+1),ad)
      
      npt=tnpt
      pt(:,1:npt)=ptf(:,1:npt)
            
      i1=npt/min_pt+1
      	
      if(npt>=2*min_pt.and.i1>1) then
            !break up the cluster into nb clusters
		call kmeans7(i1,pt(:,1:npt),npt,n_dim,cluster(1:npt),ad,cluster2,min_pt)
		!calculate the no. of points in each cluster & separate them
		nptk=0
      	do i=1,npt
            	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
		end do
                  
		do i=1,i1
			do j=1,ad
				!if(cluster2(i,j)==0) exit
				nptk(i)=nptk(i)+1
				ptk(i,:,nptk(i))=pt(:,cluster2(i,j))
			end do
		end do
                  	
		!arrange the points
		do i=1,i1
                  p(:,ptClstrd+1:ptClstrd+nptk(i))=ptk(i,:,1:nptk(i))
      		!ip=binSearch(ptInClstr,numClstr,nptk(i))
			ip=numClstr+1
			!ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            	ptInClstr(ip)=nptk(i)
			!do q=1,numClstr
            		!if(xclsPos(q)>=ip) xclsPos(q)=xclsPos(q)+1
            	!end do
            	xclsPos(numClstr+1)=ip
            	ptClstrd=ptClstrd+nptk(i)
            	numClstr=numClstr+1
		end do
	else
      	p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
      	!ip=binSearch(ptInClstr,numClstr,npt)
		ip=numClstr+1
		!ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            ptInClstr(ip)=npt
            !do i=1,numClstr
			!if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            !end do
            xclsPos(numClstr+1)=ip
            ptClstrd=ptClstrd+npt
            numClstr=numClstr+1
	end if
      
  end subroutine Xmeans9 
      
!----------------------------------------------------------------------   

  recursive subroutine Gmeans(pt,npt,naux,auxa,min_pt)
    	implicit none
 
	integer min_pt,npt,naux !num of points
    	double precision pt(:,:) !points
      double precision auxa(:,:) !auxilliary points
    	double precision ptk(2,n_dim,npt)!points in clusters
    	double precision auxk(2,naux,npt)!loglike, to change order only
      integer nptk(2) !no. of points in the clusters
    	integer cluster(npt) !cluster array having cluster num of each pt
    	integer i,ip
      integer i1
      double precision alpha !confidence level for Anderson-Darlind test
      parameter(alpha=0.0001)
      double precision mean(n_dim),meank(2,n_dim)
      double precision delMean(n_dim) !difference between the means of the two clusters
      logical flag
      
      flag=.false.
      
      !calculate the mean
      do i=1,n_dim
		mean(i)=sum(pt(i,1:npt))/npt
      enddo
      
      !don't cluster if it produces a cluster with less than 2*(min_pt-1)+1 points
      !since it would cluster into clusters having less than min_pt points
      if(npt<2*min_pt.or.nCls==maxClstr) flag=.true.
      
      if(.not.flag) then
      	!breakup the points in 2 clusters
		i1=2
      	meank(1,1:n_dim)=mean(1:n_dim)
      	call kmeans3(i1,pt,npt,n_dim,meank(1:i1,1:n_dim),cluster,min_pt)
      	!calculate the no. of points in each cluster & separate them
      	nptk=0
      	do i=1,npt
           	 	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
            	auxk(cluster(i),:,nptk(cluster(i)))=auxa(:,i)
		end do
      
      	!don't cluster if either of the clusters have less than min_pt points
      	!since that might be noise
      	do i=1,2
      		if(nptk(i)<min_pt) then
                  	flag=.true.
                        exit
			end if
		end do
	end if
      
      if(.not.flag) then
      	!calculate the means of the two clusters & their difference
      	delMean=meank(1,1:n_dim)-meank(2,1:n_dim)
            flag=AndersonDarling(npt,pt,delMean,alpha)
	end if
      
      if(.not.flag) then
		nCls=nCls+1
      	call Gmeans(ptk(1,:,1:nptk(1)),nptk(1),naux,auxk(1,:,1:nptk(1)),min_pt)
      	call Gmeans(ptk(2,:,1:nptk(2)),nptk(2),naux,auxk(2,:,1:nptk(2)),min_pt)
      	return
      else
      	p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
            aux(:,ptClstrd+1:ptClstrd+npt)=auxa(:,1:npt)
      	ip=binSearch(ptInClstr,numClstr,npt)
            ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            ptInClstr(ip)=npt
            do i=1,numClstr
            	if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            end do
            xclsPos(numClstr+1)=ip
            ptClstrd=ptClstrd+npt
            numClstr=numClstr+1
      end if
      
  end subroutine Gmeans 
      
!----------------------------------------------------------------------

  recursive subroutine Gmeans2(pt,npt,min_pt)
    	implicit none
 
	integer min_pt,npt !num of points
    	double precision pt(:,:) !points
    	double precision ptk(2,n_dim,npt)!points in clusters
      integer nptk(2) !no. of points in the clusters
    	integer cluster(npt) !cluster array having cluster num of each pt
    	integer i,ip
      integer i1
      double precision alpha !confidence level for Anderson-Darlind test
      parameter(alpha=0.0001)
      double precision mean(n_dim),meank(2,n_dim)
      double precision delMean(n_dim) !difference between the means of the two clusters
      logical flag
      
      flag=.false.
      
      !calculate the mean
      do i=1,n_dim
		mean(i)=sum(pt(i,1:npt))/npt
      enddo
      
      !don't cluster if it produces a cluster with less than 2*(min_pt-1)+1 points
      !since it would cluster into clusters having less than min_pt points
      if(npt<2*min_pt.or.nCls==maxClstr) flag=.true.
      
      if(.not.flag) then
      	!breakup the points in 2 clusters
		i1=2
      	meank(1,1:n_dim)=mean(1:n_dim)
      	call kmeans3(i1,pt,npt,n_dim,meank(1:i1,1:n_dim),cluster,min_pt)
      	!calculate the no. of points in each cluster & separate them
      	nptk=0
      	do i=1,npt
           	 	nptk(cluster(i))=nptk(cluster(i))+1
            	ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
		end do
      
      	!don't cluster if either of the clusters have less than min_pt points
      	!since that might be noise
      	do i=1,2
      		if(nptk(i)<min_pt) then
                  	flag=.true.
                        exit
			end if
		end do
	end if
      
      if(.not.flag) then
      	!calculate the means of the two clusters & their difference
      	delMean=meank(1,1:n_dim)-meank(2,1:n_dim)
            flag=AndersonDarling(npt,pt,delMean,alpha)
	end if
      
      if(.not.flag) then
		nCls=nCls+1
      	call Gmeans2(ptk(1,:,1:nptk(1)),nptk(1),min_pt)
      	call Gmeans2(ptk(2,:,1:nptk(2)),nptk(2),min_pt)
      	return
      else
      	p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
      	ip=binSearch(ptInClstr,numClstr,npt)
            ptInClstr(ip+1:numClstr+1)=ptInClstr(ip:numClstr)
            ptInClstr(ip)=npt
            do i=1,numClstr
            	if(xclsPos(i)>=ip) xclsPos(i)=xclsPos(i)+1
            end do
            xclsPos(numClstr+1)=ip
            ptClstrd=ptClstrd+npt
            numClstr=numClstr+1
      end if
      
  end subroutine Gmeans2 
      
!----------------------------------------------------------------------

  !calculate BIC for no clustering in the data
  double precision function calcBIC1(pt,npt,mean,invcov,detcov)
	implicit none
      integer npt !num of points
      double precision pt(:,:)
      double precision detcov !determinant of the covariance matrix
      double precision mean(:),invcov(:,:)
      double precision tpt(n_dim,npt),a,nd,nn
	integer i,j,k
      
      nd=n_dim
      nn=npt
      
      !calculate point-mean
      do i=1,npt
      	do j=1,n_dim
            	tpt(j,i)=pt(j,i)-mean(j)
            end do
      end do
            	
      !a=sum(Transpose(pt(i)-mean).invcov.(pt(i)-mean))
      a=0.
      do i=1,npt
      	do j=1,n_dim
            	a=a+tpt(j,i)*tpt(j,i)*invcov(j,j)
            	do k=j+1,n_dim
            		a=a+2.*tpt(j,i)*tpt(k,i)*invcov(j,k)
                  end do
		end do
	end do
	calcBIC1=nn*nd*LogTwoPi+nn*log(detcov)+a+0.5*nd*(nd+3.)*log(nn)
  	
  end function calcBIC1
      
!----------------------------------------------------------------------

  !calculate BIC for no clustering in the data
  double precision function calcBIC1_iso(npt,variance)
	implicit none
      integer npt !num of points
      double precision variance,var
      double precision nd,nn
      
      nd=n_dim
      nn=npt
      var=variance
      
      !convert into unbiased variance
      var=var*nn/(nn-1.)
      
      calcBIC1_iso=nn*LogTwoPi+nn*nd*log(var)+nn-1.+(nd+1.)*log(nn)
  	
  end function calcBIC1_iso
      
!----------------------------------------------------------------------

  !calculate BIC for clustering in the data
  double precision function calcBIC2(ptk,nptk,meank,invcovk,detcovk)
	implicit none
      integer nptk(2) !num of points
      double precision ptk(2,n_dim,nptk(1)+nptk(2))
      double precision detcovk(2) !determinant of the covariance matrix
      double precision meank(2,n_dim),invcovk(2,n_dim,n_dim)
      double precision tptk(2,n_dim,nptk(1)+nptk(2)),ak(2)
	integer i,j,k,l
      double precision nd,np1,np2,npt
      
      np1=nptk(1)
      np2=nptk(2)
      npt=np1+np2
      nd=n_dim
      
      !calculate point-mean
	do l=1,2
      	do i=1,nptk(l)
      		do j=1,n_dim
            		tptk(l,j,i)=ptk(l,j,i)-meank(l,j)
            	end do
      	end do
      end do
      
      !a=sum(Transpose(pt(i)-mean).invcov.(pt(i)-mean))
      ak=0.
      do l=1,2
      	do i=1,nptk(l)
      		do j=1,n_dim
            		ak(l)=ak(l)+tptk(l,j,i)*tptk(l,j,i)*invcovk(l,j,j)
                        do k=j+1,n_dim
            			ak(l)=ak(l)+2.*tptk(l,j,i)*tptk(l,k,i)*invcovk(l,j,k)
                  	end do
			end do
		end do
	end do
      
	calcBIC2=npt*nd*LogTwoPi+np1*log(detcovk(1))+np2*log(detcovk(2))+ak(1)+ak(2) &
      -2.*(np1*log(np1)+np2*log(np2))+2.*npt*log(npt)+(nd**2.+3.*nd+1.)*log(npt)
  end function calcBIC2
      
!----------------------------------------------------------------------

  !calculate BIC for clustering in the data
  double precision function calcBIC2_iso(nptk,var)
	implicit none
      integer nptk(2) !num of points
      double precision var(2)
      double precision variance
	integer i
      double precision nd,np1,np2,npt
      
      np1=nptk(1)
      np2=nptk(2)
      npt=np1+np2
      nd=n_dim
      
      variance=0.
      do i=1,2
      	variance=variance+var(i)*nptk(i)
	end do
      variance=variance/(npt-2.)
      
      calcBIC2_iso=npt*LogTwoPi+npt*nd*log(variance)+(npt-2.)-2.*np1*log(np1)- &
      2.*np2*log(np2)+(2.+2.*nd+2.*npt)*log(npt)
  end function calcBIC2_iso
      
!----------------------------------------------------------------------

  !calculate BIC for no clustering of the points constituting the given clusters
  double precision function caltBIC(cls1,cls2)
	implicit none
      integer cls1,cls2
      integer n1,n2,n !total num of points
      double precision mean(n_dim),covar(n_dim,n_dim),invcov(n_dim,n_dim),evec(n_dim,n_dim),eval(n_dim),detcov
      integer i,j
      integer ind1,ind2!indices of starting points of the 2 clusters
      double precision, dimension(:,:), allocatable :: ptt
      logical flag
      
      !find total number of points
      n1=ptInClstr(xclsPos(cls1))
      n2=ptInClstr(xclsPos(cls2))
      n=n1+n2
      
      !find the starting indices of points in both the clusters
      ind1=0
      ind2=0
      do i=1,cls1-1
      	ind1=ind1+ptInClstr(xclsPos(i))
	end do
      do i=1,cls2-1
      	ind2=ind2+ptInClstr(xclsPos(i))
	end do
      
      !combine points from both the clusters
      allocate(ptt(n_dim,n))
      ptt(:,1:n1)=p(:,ind1+1:ind1+n1)
      ptt(:,n1+1:n)=p(:,ind2+1:ind2+n2)
      
      !find mean of the merged cluster
      mean(1:n_dim)=(n1*xclsMean(cls1,1:n_dim)+n2*xclsMean(cls2,1:n_dim))/n
      !calculate invcov & det(cov) of the merged cluster
      call calc_covmat(n,n_dim,ptt,mean,covar)
      evec=covar
      flag=.false.
      call diagonalize(evec,eval,n_dim,flag)
      
	!if any of the eval are 0 or -ve then use the lowest +ve eval
	do j=1,n_dim
		if(eval(j)<=0.) eval(1:j)=eval(j+1)
	enddo
            
      detcov=product(eval)
      call calc_invcovmat(n_dim,evec,eval,invcov)
      
      caltBIC=calcBIC1(ptt,n,mean,invcov,detcov)
      
      deallocate(ptt)
      
  end function caltBIC
      
!----------------------------------------------------------------------

  !Anderson Darling test for normal distribution
  logical function AndersonDarling(npt,pt,delMean,alpha)
	implicit none
      integer npt !no. of points
      double precision pt(n_dim,npt) !points
      double precision alpha !significance level
      double precision delMean(n_dim) !difference between the two cluster means
      double precision ppt(npt) !projected & normalized points
      double precision mean,sigma !mean & st.dev. of the projected & normalized points
      double precision A !Anderson Darling statistic
      double precision stn1,stn2
      integer i
      double precision mode
      integer*8 nn,info
      
      mean=0.
      sigma=0.
      !project the points onto delMean & calculate the mean & sigma of the
      !projected points
      mode=sqrt(sum((delMean(1:n_dim)**2)))
      do i=1,npt
      	ppt(i)=sum(pt(1:n_dim,i)*delMean(1:n_dim))/mode
            mean=mean+ppt(i)
            sigma=sigma+ppt(i)**2
      end do
      mean=mean/npt
      sigma=sqrt(sigma/npt-mean**2)*npt/(npt-1.)
      
      !transform the projected points into ones with mean=0 & sigma=1
      ppt(1:npt)=(ppt(1:npt)-mean)/sigma
      
      !sort ppt in ascending order
      !CALL QSORT(ppt,npt,8,COMPARE)
      nn=npt
      call DLASRT('I',nn,ppt,info)
      
      !calculate Anderson Darling statistic
      A=0.
      do i=1,npt
		if(ppt(i)>5.) then
            	stn1=1.
            else if(ppt(i)<-5.) then
            	stn1=0.
		else
            	stn1=stNormalCDF(ppt(i))
		end if
            
		if(ppt(npt+1-i)>5.) then
            	stn2=1.
            else if(ppt(npt+1-i)<-5.) then
            	stn2=0.
		else
            	stn2=stNormalCDF(ppt(npt+1-i))
		end if
            
      	A=A+(2.*i-1.)*(log(stn1)+log(1.-stn2))
      end do
      A=A/(-1.*npt)-npt
      A=A*(1.+4./npt-25./(npt**2))
      
      !inference at alpha=0.0001 
      if(A>1.8692) then
      	AndersonDarling=.false.
      else
      	AndersonDarling=.true.
      end if
      
  end function AndersonDarling
      
!----------------------------------------------------------------------

  INTEGER*2 FUNCTION COMPARE(N1, N2)
	double precision N1
	double precision N2

	IF (N1 .LT. N2) THEN
		COMPARE = -1
	ELSE IF (N1 .EQ. N2) THEN
		COMPARE = 0
	ELSE
		COMPARE = 1
	END IF
      
	RETURN
      
  END FUNCTION COMPARE
      
!----------------------------------------------------------------------

  !learn the Gaussian mixture by expectation maximization
  !some points are constrained to be in specific clusters
  !likelihood constraint
  subroutine GaussMixExpMaxLike(ndim,nCls,npt,ncon,norm,pt,like,wt,wtNorm,locZ,lowlike,switch)
	implicit none
      
      	!input variables
      	integer ndim !dimensionality
      	integer nCls !no. of clusters
      	integer npt !total no. of points
      	integer ncon(nCls) !no. constrained points in each cluster
      	double precision pt(ndim,npt) !points
      	double precision like(2,npt) !log-like & log of the dx
      	logical norm !rescale the points so that all have the same range?
	double precision lowlike(nCls)
      	logical switch !initialize the LAPACK eigenanalysis routines?
      
      	!output variables
      	double precision wt(npt,nCls) !probability weights of points for each cluster
      	double precision wtNorm(npt,nCls) !normalized probability weights of points for each cluster
	double precision locZ(nCls) !local evidence
      
      	!work variables
	integer i,k,count
      	double precision d1
	double precision pts(ndim,npt)
      	double precision mean(nCls,ndim),eval(nCls,ndim),evec(nCls,ndim,ndim),cwt(nCls)
      	double precision old_locZ(nCls),covmat(nCls,ndim,ndim),invcov(nCls,ndim,ndim),detcov(nCls)
      
      	n_dim=ndim
	count=0
      	!rescaling
      	pts=pt
      	if(norm) call rescale(ndim,npt,pts)
      
      	wt=0.d0
      	!set the initial probability weights
      	k=0
      	do i=1,nCls
		wt(k+1:k+ncon(i),i)=1.d0
            
		k=k+ncon(i)
	enddo
      
      	!calculate the initial Gaussian mixture model
	wtNorm=wt
	do i=1,nCls
		!calculate the evidence & normalized weights
	    	call setWt(npt,like,wtNorm(:,i),locZ(i),.true.)
		!now the Gaussian with normalized weights
            	call GaussProp(npt,ndim,pts,wt(:,i),wtNorm(:,i),cwt(i),mean(i,:),covmat(i,:,:), &
			invcov(i,:,:),eval(i,:),evec(i,:,:),detcov(i),switch,.true.)
	enddo
	!normalize cluster prior probabilities
	d1=sum(cwt(1:nCls))
	cwt(1:nCls)=cwt(1:nCls)/d1
      
	k=sum(ncon(1:nCls))
      	!expectation-maximization
      	do
		count=count+1
      		old_locZ=locZ
		!check all the points now
		do i=k+1,npt
            		!calculate the probability of points lying in each cluster
			call normalProbClsGivPt(nCls,ndim,pts(:,i),like(1,i), &
				lowlike(1:nCls),mean(1:nCls,:),invcov(1:nCls,:,:), &
				detcov(1:nCls),cwt(1:nCls),wt(i,1:nCls))
		enddo
            
      		!re-calculate the Gaussian mixture model
		wtNorm=wt
            	do i=1,nCls
			!calculate the evidence & normalized weights
	    		call setWt(npt,like,wtNorm(:,i),locZ(i),.true.)
			!now the Gaussian with normalized weights
            		call GaussProp(npt,ndim,pts,wt(:,i),wtNorm(:,i),cwt(i),mean(i,:),covmat(i,:,:), &
                  	invcov(i,:,:),eval(i,:),evec(i,:,:),detcov(i),.false.,.true.)
		enddo
            	!normalize cluster prior probabilities
            	d1=sum(cwt(1:nCls))
            	cwt(1:nCls)=cwt(1:nCls)/d1
            
            	!check for convergence
            	d1=sqrt(sum((old_locZ(1:nCls)-locZ(1:nCls))**2.))
            	if(d1<0.0001 .or. count==100) then
			!wt=wtNorm
			exit
		endif
	enddo
            	
  end subroutine GaussMixExpMaxLike
      
!----------------------------------------------------------------------
  
  !returns the normalized normal probability for the given point
  double precision function normalProb(d,p,mean,invcov,detcov)
  
  	implicit none
      
      !input variables
      integer d !dimensionality
      double precision p(d) !point
      double precision mean(d) !mean
      double precision invcov(d,d) !inverse covariance matrix
      double precision detcov !determinant of the covariance matrix
      
      !work variables
      integer j,k
      double precision a,tpt(d),pi
      
      pi=4.*atan(1.d0)
      
      !calculate point-mean
      tpt(1:d)=p(1:d)-mean(1:d)
            	
      !a=sum(Transpose(pt-mean).invcov.(pt-mean))
      a=0.
      do j=1,n_dim
            a=a+tpt(j)*tpt(j)*invcov(j,j)
            do k=j+1,n_dim
            	a=a+2.*tpt(j)*tpt(k)*invcov(j,k)
		end do
	end do
	normalProb=exp(-a/2.)/((detcov**0.5)*((2.*pi)**(d/2.)))
  
  end function normalProb
      
!----------------------------------------------------------------------
  
  !returns the normalized normal probability for the points given a cluster
  subroutine setWt(npt,like,wt,locZ,flag)
  
  	implicit none
	
	!input variables
	integer npt !no. of points
	double precision like(2,npt) !log-like & log of dX of points
	logical flag !set the weights
	!input/output variables
	double precision wt(npt) !weights
	double precision locZ !local evidence
	!work variables
	integer j
	
	
	locZ=-huge(1.d0)*epsilon(1.d0) !logZero
	do j=1,npt
		if(wt(j)>0.d0) locZ=logSumExp(locZ,like(1,j)+like(2,j)+log(wt(j)))
	enddo
	
	if(flag) then
		!now calculate the posterior probabilty weights
		do j=1,npt
			if(wt(j)>0.d0) wt(j)=wt(j)*exp(like(1,j)+like(2,j)-locZ)
		enddo
	endif
  
  end subroutine setWt
      
!----------------------------------------------------------------------
  
  !assuming the model is Gaussian Mixuture, return the probability of each cluster given a particular point
  subroutine normalProbClsGivPt(nCls,d,p,like,lowlike,mean,invcov,detcov,cwt,prob)
  
  	implicit none
      
      !input variables
      integer nCls !no. of clusters
      integer d !dimensionality
      double precision p(d) !point
      double precision like !log-like of the point
      double precision lowlike(nCls) !lowest log-like of each cluster
      double precision mean(nCls,d) !mean
      double precision invcov(nCls,d,d) !inverse covariance matrix
      double precision detcov(nCls) !determinant of the covariance matrix
      double precision cwt(nCls) !cluster prior probabilities
      
      !output variables
      double precision prob(nCls)
      
      !work variables
      integer i,j,k
      double precision a(nCls),tpt(nCls,d),pi,d2
      logical flag
      
      pi=4.d0*atan(1.d0)
      
      do i=1,nCls
      	!calculate point-mean
      	tpt(i,1:d)=p(1:d)-mean(i,1:d)
      enddo
            	
      !a=sum(Transpose(pt-mean).invcov.(pt-mean))
      flag=.false.
      a=0.d0
      do i=1,nCls
      	if(lowlike(i)>=like) then
		do j=1,d
			a(i)=a(i)+tpt(i,j)*tpt(i,j)*invcov(i,j,j)
            		do k=j+1,d
            			a(i)=a(i)+2.d0*tpt(i,j)*tpt(i,k)*invcov(i,j,k)
			enddo
		enddo
		prob(i)=log(cwt(i))-log(detcov(i))/2.d0-a(i)/2.d0
		flag=.true.
	else
		prob(i)=-huge(1.d0)*epsilon(1.d0) !logZero
	endif
      enddo
      
      if(.not.flag) then
      	prob(1:nCls)=0.d0
	return
      endif
      
      d2=prob(1)
      do i=2,nCls
      	d2=logSumExp(d2,prob(i))
      enddo
      
      if(prob(i)==-huge(1.d0)*epsilon(1.d0)) then
      	prob(i)=0.d0
      else
      	prob(1:nCls)=exp(prob(1:nCls)-d2)
      endif
  
  end subroutine normalProbClsGivPt
      
!----------------------------------------------------------------------
  
  subroutine GaussProp(n,d,p,wt,wtNorm,cwt,mean,covmat,invcov,eval,evec,detcov,switch,calcMu)
  
	implicit none
      
      	!input variables
      	integer n !no. of points
	integer d !dimensionality
	double precision p(d,n) !points
	double precision wt(n) !probability weights of each point
	double precision wtNorm(n) !normalized (with the evidence) probability weights of each point
	logical switch !initialize the LAPACK eigenanalysis routine?
	logical calcMu !calculate the mean?
      
      	!output variables
      	double precision mean(d) !mean
      	double precision covmat(d,d) !covariance matrix
      	double precision invcov(d,d) !inverse covariance matrix
      	double precision eval(d) !eigen values
      	double precision evec(d,d) !eigen vectors
      	double precision detcov !determinant of the covariance matrix
      	double precision cwt !no. of points in the cluster
      
      	!work variables
      	integer i
  	
      
      	!total no. of points in the cluster
      	cwt=sum(wt(1:n))
      
      	if(calcMu) then
      		mean=0.d0
      		do i=1,n
            		mean(1:d)=mean(1:d)+p(1:d,i)*wtNorm(i)
		enddo
      	endif
      
      	!covariance matrix
	call calc_covmat_wt(n,d,p,wtNorm,mean,covmat)
      	!eigen analysis
      	evec=covmat
      	call diagonalize(evec,eval,d,switch)
    	!eigenvalues of covariance matrix can't be zero
    	do i=1,d
		if(eval(i)<=0.d0) eval(1:i)=eval(i+1)/100.
	enddo
      	
	!determinant of the covariance matrix
	detcov=product(eval)
      
      	!inverse of covariance matrix
      	call calc_invcovmat(d,evec,eval,invcov)
	
  end subroutine GaussProp
      
!----------------------------------------------------------------------
      
  !rescale the points so that all have the same range
  subroutine  rescale(ndim,npt,pt)
	implicit none
      
      !input variables
      integer ndim !dimensionality
      integer npt !total no. of points
      
      !input/output varialbe
      double precision pt(ndim,npt) !points
      
      !work variables
      integer i
      double precision d1,d2
      
      
      do i=1,ndim
      	d2=maxval(pt(i,1:npt))
      	d1=minval(pt(i,1:npt))
	pt(i,1:npt)=(pt(i,1:npt)-d1)/(d2-d1)
      enddo
      
  end subroutine rescale 
   
!----------------------------------------------------------------------
  
  function Dinosaur(points,npt,ndim,nClstr,ptClstr,naux,auxa,min_pt,maxC, &
  	meanx,invcovx,tmatx,evalx,evecx,kfacx,effx,volx,pVol,cVol,neVol,eVolFrac, &
	nIter,dTol,switch,rFlag,cSwitch,nCdim)
	implicit none
      	
	!input variables
	integer npt !total no. of points
	integer ndim !dimensionality
      	double precision points(ndim,npt) !points
	integer naux !dimensionality of auxiliary points
	double precision auxa(naux,npt) !auxiliary points
	integer min_pt !min no. of points per cluster
	integer maxC !max no. of clusters
	double precision pVol !prior volume
	double precision cVol !current vol
	integer neVol
	double precision eVolFrac(2*neVol,2)
	integer nIter
	double precision dTol !volume tolerance
    	logical switch !initialize the LAPACK eigen analysis routines?
	logical cSwitch
	integer nCdim
	logical rFlag !desperate acceptance
	
	!output variables
	integer nClstr !total no. clusters found
	integer ptClstr(maxC) !points in each cluster
	double precision meanx(maxC,ndim) !cluster means
	double precision invcovx(maxC,ndim,ndim) !cluster inv covarianc matrices
	double precision tmatx(maxC,ndim,ndim) !cluster transformation matrices
	double precision evalx(maxC,ndim) !cluster eigenvalues
	double precision evecx(maxC,ndim,ndim) !cluster eigenvectors
	double precision kfacx(maxC) !cluster point enlargement factors
	double precision effx(maxC) !cluster volume enlargement factors
	double precision volx(maxC) !cluster volumes
	logical Dinosaur !successful?
	
	!work variables
	integer i,i2,j,k,n1,n2,n3,j1,k1,m,l,logLloc(1)
	integer, allocatable :: nptx(:)
	logical flag
	double precision, allocatable :: mean(:), covmat(:,:), invcov(:,:), tmat(:,:), evec(:,:), eval(:), p2(:,:), aux2(:,:)
	double precision kfac,eff,detcov,vol
	double precision d1,d2
	logical, allocatable :: updEll(:)
	integer, allocatable :: updPt(:), cluster(:)
	integer nClstrk !total no. clusters found
	integer, allocatable :: ptClstrk(:) !points in each cluster
	double precision, allocatable :: meank(:,:) !cluster means
	double precision, allocatable :: covmatk(:,:,:) !cluster covarianc matrices
	double precision, allocatable :: invcovk(:,:,:) !cluster inv covarianc matrices
	double precision, allocatable :: tmatk(:,:,:) !cluster transformation matrices
	double precision, allocatable :: evalk(:,:) !cluster eigenvalues
	double precision, allocatable :: eveck(:,:,:) !cluster eigenvectors
	double precision, allocatable :: kfack(:) !cluster point enlargement factors
	double precision, allocatable :: effk(:) !cluster volume enlargement factors
	double precision, allocatable :: detcovk(:) !cluster covariance matrix determinants
	double precision, allocatable :: volk(:) !cluster volumes
	double precision, allocatable :: pointsk(:,:), auxk(:,:)
	!merge operation variables
	integer mChk
	double precision, allocatable :: dis(:,:)
	logical, allocatable :: check(:,:)
	logical gflag
	
	
	n_dim=ndim
		
	!sanity checks
	if(min_pt<2) min_pt=2
	if(npt<min_pt) then
		nClstr=1
		ptClstr(1)=npt
		volx(1)=0.d0
		kfacx(1)=0.d0
		effx(1)=1.d0
      		Dinosaur=.true.
            	return
	endif
	
	maxClstr=min(maxC,ceiling(dble(npt)/dble(min_pt)))
	!maxClstr=npt
      	nCls=1
	numClstr=0
      	ptClstrd=0
	
	
	allocate( updEll(maxC), check(maxC,maxC) )
	allocate( mean(ndim), covmat(ndim,ndim), invcov(ndim,ndim), tmat(ndim,ndim), evec(ndim,ndim),eval(ndim), &
	p2(ndim,npt), aux2(naux,npt) )
	allocate( nptx(npt), updPt(maxC), cluster(npt), ptClstrk(maxC) )
	allocate( meank(maxC,ndim), covmatk(maxC,ndim,ndim), invcovk(maxC,ndim,ndim), tmatk(maxC,ndim,ndim), &
	evalk(maxC,ndim), eveck(maxC,ndim,ndim), kfack(maxC), effk(maxC), detcovk(maxC), volk(maxC), pointsk(ndim,npt), &
	auxk(naux,npt), dis(10,2) )
	
	allocate(xclsMean(maxClstr,ndim),xclsInvcov(maxClstr,ndim,ndim),xclsCovmat(maxClstr,ndim,ndim), &
	xclsTMat(maxClstr,ndim,ndim),xclsEval(maxClstr,ndim),xclsEvec(maxClstr,ndim,ndim),xclsKfac(maxClstr), &
	xclsEff(maxClstr),xclsVol(maxClstr),p(ndim,npt),xclsDetcov(maxClstr), &
	aux(naux,npt),ptInClstr(maxClstr))
      	
	check = .false.
	ptInClstr=0
	
	!first calculate the model with 1 cluster
	call CalcEllProp(npt,ndim,points,mean,covmat,invcov,tmat,evec,eval,detcov,kfac,eff,vol,pVol, &
	switch)
	
		
	!now do the clustering
      	call makeDino(points,npt,ndim,naux,auxa,min_pt,mean,covmat,invcov,tmat,evec,eval,detcov,kfac,eff,vol, &
	pVol,cSwitch,nCdim)

	j=0
	do i=1,numClstr
		if(ptInClstr(i)==0) cycle
		cluster(j+1:j+ptInClstr(i))=i
		j=j+ptInClstr(i)
	enddo
	
	flag=.false.
	
	d1=sum(xclsVol(1:numClstr))

	if(postDino(numClstr,p,npt,aux,naux,ndim,cluster,min_pt,ptInClstr(1:numClstr),xclsMean(1:numClstr,:), &
	xclsCovmat(1:numClstr,:,:),xclsInvcov(1:numClstr,:,:),xclsTmat(1:numClstr,:,:),xclsEval(1:numClstr,:), &
	xclsEvec(1:numClstr,:,:),xclsKfac(1:numClstr),xclsEff(1:numClstr),xclsDetcov(1:numClstr), &
	xclsVol(1:numClstr),cVol)) then
		nClstrk=numClstr
		pointsk=p
		auxk=aux
		ptClstrk(1:nClstrk)=ptInClstr(1:nClstrk)
		meank(1:nClstrk,:)=xclsMean(1:nClstrk,:)
		covmatk(1:nClstrk,:,:)=xclsCovmat(1:nClstrk,:,:)
		invcovk(1:nClstrk,:,:)=xclsInvcov(1:nClstrk,:,:)
		tmatk(1:nClstrk,:,:)=xclsTmat(1:nClstrk,:,:)
		evalk(1:nClstrk,:)=xclsEval(1:nClstrk,:)
		eveck(1:nClstrk,:,:)=xclsEvec(1:nClstrk,:,:)
		kfack(1:nClstrk)=xclsKfac(1:nClstrk)
		effk(1:nClstrk)=xclsEff(1:nClstrk)
		detcovk(1:nClstrk)=xclsDetcov(1:nClstrk)
		volk(1:nClstrk)=xclsVol(1:nClstrk)
	
		j=sum(ptClstrk(1:nClstrk-1))
		d1=pVol*ptClstrk(nClstrk)/npt
	
      		nCls=1
		numClstr=0
      		ptClstrd=0
		ptInClstr=0
		
		call makeDino(pointsk(:,j+1:npt),ptClstrk(nClstrk),ndim,naux,auxk(:,j+1:npt),min_pt, &
		meank(nClstrk,:),covmatk(nClstrk,:,:),invcovk(nClstrk,:,:),tmatk(nClstrk,:,:), &
		eveck(nClstrk,:,:),evalk(nClstrk,:),detcovk(nClstrk),kfack(nClstrk),effk(nClstrk), &
		volk(nClstrk),d1,cSwitch,nCdim)
			
		if(numClstr > 1) then
			j=0
			do i=1,numClstr
				cluster(j+1:j+ptInClstr(i))=i
				j=j+ptInClstr(i)
			enddo
			
			d1=pVol*ptClstrk(nClstrk)/npt
		
			flag=postDino(numClstr,p(:,1:ptClstrk(nClstrk)),ptClstrk(nClstrk), &
			aux(:,1:ptClstrk(nClstrk)),naux,ndim,cluster,min_pt,ptInClstr(1:numClstr), &
			xclsMean(1:numClstr,:),xclsCovmat(1:numClstr,:,:),xclsInvcov(1:numClstr,:,:), &
			xclsTmat(1:numClstr,:,:),xclsEval(1:numClstr,:),xclsEvec(1:numClstr,:,:), &
			xclsKfac(1:numClstr),xclsEff(1:numClstr),xclsDetcov(1:numClstr),xclsVol(1:numClstr), &
			d1)
			
			j=sum(ptClstrk(1:nClstrk-1))
			
			pointsk(:,j+1:npt)=p(:,1:ptClstrk(nClstrk))
			auxk(:,j+1:npt)=aux(:,1:ptClstrk(nClstrk))
			ptClstrk(nClstrk:nClstrk+numClstr-1)=ptInClstr(1:numClstr)
			meank(nClstrk:nClstrk+numClstr-1,:)=xclsMean(1:numClstr,:)
			covmatk(nClstrk:nClstrk+numClstr-1,:,:)=xclsCovmat(1:numClstr,:,:)
			invcovk(nClstrk:nClstrk+numClstr-1,:,:)=xclsInvcov(1:numClstr,:,:)
			tmatk(nClstrk:nClstrk+numClstr-1,:,:)=xclsTmat(1:numClstr,:,:)
			evalk(nClstrk:nClstrk+numClstr-1,:)=xclsEval(1:numClstr,:)
			eveck(nClstrk:nClstrk+numClstr-1,:,:)=xclsEvec(1:numClstr,:,:)
			kfack(nClstrk:nClstrk+numClstr-1)=xclsKfac(1:numClstr)
			effk(nClstrk:nClstrk+numClstr-1)=xclsEff(1:numClstr)
			detcovk(nClstrk:nClstrk+numClstr-1)=xclsDetcov(1:numClstr)
			volk(nClstrk:nClstrk+numClstr-1)=xclsVol(1:numClstr)
		else
			flag=.true.
		endif
		
		numClstr=nClstrk+numClstr-1
		p=pointsk
		aux=auxk
		ptInClstr(1:numClstr)=ptClstrk(1:numClstr)
		xclsMean(1:numClstr,:)=meank(1:numClstr,:)
		xclsCovmat(1:numClstr,:,:)=covmatk(1:numClstr,:,:)
		xclsInvcov(1:numClstr,:,:)=invcovk(1:numClstr,:,:)
		xclsTmat(1:numClstr,:,:)=tmatk(1:numClstr,:,:)
		xclsEval(1:numClstr,:)=evalk(1:numClstr,:)
		xclsEvec(1:numClstr,:,:)=eveck(1:numClstr,:,:)
		xclsKfac(1:numClstr)=kfack(1:numClstr)
		xclsEff(1:numClstr)=effk(1:numClstr)
		xclsDetcov(1:numClstr)=detcovk(1:numClstr)
		xclsVol(1:numClstr)=volk(1:numClstr)
		
		logLloc=maxloc(aux(1,1:npt))
		if(logLloc(1)>npt-ptInClstr(numClstr)) then
			d2=0d0
		else
			d2=0.001d0
		endif
		
		if(flag) then
			xclsVol(numClstr)=0.d0
			if(dble(ptInClstr(numClstr))/dble(npt)<d2) flag=.false.
		endif
	endif
	
	if(flag) then
		Dinosaur=.false.
		
		deallocate( updEll, check )
		deallocate( mean, covmat, invcov, tmat, evec, eval, p2, aux2 )
		deallocate( nptx, updPt, cluster, ptClstrk )
		deallocate( meank, covmatk, invcovk, tmatk, evalk, eveck, kfack, effk, detcovk, volk, pointsk, auxk, dis )
		
		deallocate(xclsMean,xclsInvcov,xclsTMat,xclsEval,xclsEvec,xclsKfac,xclsEff,xclsVol,xclsCovmat,xclsDetcov,p,aux,ptInClstr)
		
		!update the vol fractions of the past iterations
		eVolFrac(2:2*neVol,:)=eVolFrac(1:2*neVol-1,:)
		eVolFrac(1,1)=cVol/pVol
		eVolFrac(1,2)=nIter
		
		return
	endif
	
	!sort out the clusters with less than min_pt points
	if(numClstr>1) then
		updPt=0
		updEll=.false.
		nptx(1:numClstr)=ptInClstr(1:numClstr)
		gflag=.false.
		k=0
		do i=1,numClstr
			if(ptInClstr(i)<min_pt .and. xclsVol(i)>0.d0) then
				do j=1,ptInClstr(i)
					d1=1.d99
					do l=1,numClstr
						if(l==i .or. ptInClstr(l)<min_pt .or. xclsVol(i)==0.d0) cycle
						d2=MahaDis(ndim,p(:,k+j),xclsMean(l,:),xclsInvcov(l,:,:),xclsKfac(l)*xclsEff(l))
						d2=d2*xclsVol(l)
						if(d2<d1) then
							d1=d2
							m=l
						endif
					enddo
					!enlarge the ellipsoid
					nptx(m)=nptx(m)+1
					l=sum(ptInClstr(1:m-1))
					d2=pVol*dble(nptx(m))/dble(npt)
					call enlargeEll(ndim,p(:,k+j),xclsMean(m,:),xclsEval(m,:),xclsInvcov(m,:,:),xclsKfac(m),xclsEff(m), &
					xclsVol(m),d2)
					
					updPt(k+j)=m
					updEll(m)=.true.
					gflag=.true.
				enddo
			endif	
			k=k+ptInClstr(i)
		enddo
		
		if(gflag) then
			j=0
			k=0
			n1=0
			do i=1,numClstr
				if(ptInClstr(i)>=min_pt .or. xclsVol(i)==0.d0) then
					n1=n1+1
					p2(:,j+1:j+ptInClstr(i))=p(:,k+1:k+ptInClstr(i))
					aux2(:,j+1:j+ptInClstr(i))=aux(:,k+1:k+ptInClstr(i))
					j=j+ptInClstr(i)
					k=k+ptInClstr(i)
				
					if(updEll(i)) then
						do m=1,npt
							if(updPt(m)==i) then
								p2(:,j+1)=p(:,m)
								aux2(:,j+1)=aux(:,m)
								j=j+1
								ptInClstr(i)=ptInClstr(i)+1
							endif
						enddo
					endif
				else
					k=k+ptInClstr(i)
					ptInClstr(i)=0
					xclsVol(i)=0.d0
				endif
			enddo
			p=p2
			aux=aux2
		else
			n1=numClstr
		endif
		
		if(xclsVol(numClstr)==0.d0) then
			i2=numClstr-1
		else
			i2=numClstr
		endif
		
		n1=0
		do i=1,i2
			if(ptInClstr(i)>0) n1=n1+1
		enddo
		
		j1=0
		n3=0
		do i=1,i2
			if(ptInClstr(i)==0) cycle
			n3=n3+1
				
			do
				mChk=min(10,n1-1)
				dis=huge(1.d0)
				do j=1,i2
					if(ptInClstr(j)==0 .or. j==i) cycle
					
					d1=sum((xclsMean(i,:)-xclsMean(j,:))**2)
					
					k1=0
					do k=mChk,1,-1
						if(d1>dis(k,1)) then
							exit
						else
							k1=k
						endif
					enddo
					if(k1/=0) then
						dis(k1+1:mChk,:)=dis(k1:mChk-1,:)
						dis(k1,1)=d1
						dis(k1,2)=dble(j)
					endif
				enddo
					
				!now do the merge check
				flag=.false.
				p2(:,1:ptInClstr(i))=p(:,j1+1:j1+ptInClstr(i))
				aux2(:,1:ptInClstr(i))=aux(:,j1+1:j1+ptInClstr(i))
				do j=1,mChk
					k=int(dis(j,2)) !ellipsoid to check
						
					!already checked
					if(check(i,k)) cycle
					
					check(i,k)=.true.
					check(k,i)=.true.
					
					k1=sum(ptInClstr(1:k-1))
					n2=ptInClstr(i)+ptInClstr(k)
					p2(:,ptInClstr(i)+1:n2)=p(:,k1+1:k1+ptInClstr(k))
					aux2(:,ptInClstr(i)+1:n2)=aux(:,k1+1:k1+ptInClstr(k))
					d1=pVol*dble(n2)/dble(npt)
						
					call CalcEllProp(n2,ndim,p2(:,1:n2),mean,covmat,invcov,tmat,evec,eval,detcov,kfac,eff,vol, &
					d1,switch)
					
					!success?
					if(vol/1.1<xclsVol(i)+xclsVol(k)) then
						xclsMean(i,:)=mean(:)
						xclsInvCov(i,:,:)=invcov(:,:)
						xclsCovmat(i,:,:)=covmat(:,:)
						xclsTMat(i,:,:)=tMat(:,:)
						xclsEval(i,:)=eval(:)
						xclsEvec(i,:,:)=evec(:,:)
						xclsKfac(i)=kfac
						xclsEff(i)=eff
						xclsVol(i)=vol
						xclsVol(k)=0.d0
						xclsDetcov(i)=detcov
						
						!re-arrangement
						if(k<i) then
							p(:,k1+1:j1-ptInClstr(k))=p(:,k1+ptInClstr(k)+1:j1)
							aux(:,k1+1:j1-ptInClstr(k))=aux(:,k1+ptInClstr(k)+1:j1)
							j1=j1-ptInClstr(k)
						else
							p(:,j1+n2+1:k1+ptInClstr(k))=p(:,j1+ptInClstr(i)+1:k1)
							aux(:,j1+n2+1:k1+ptInClstr(k))=aux(:,j1+ptInClstr(i)+1:k1)
						endif
						p(:,j1+1:j1+n2)=p2(:,1:n2)
						aux(:,j1+1:j1+n2)=aux2(:,1:n2)
							
						ptInClstr(i)=n2
						ptInClstr(k)=0
						n1=n1-1
						check(i,:)=.false.
						check(:,i)=.false.
							
						flag=.true.
					endif

					if(flag) exit
				enddo
					
				if(.not.flag) exit
			enddo
			j1=j1+ptInClstr(i)
		enddo
	endif
		
	!check if this was a successful partition
	flag=.false.
	!if the actual vol is an improvement then success
	if(.not.flag) then
		if(rFlag .and. maxClstr==numClstr) then
			flag=.true.
		else
			!if(sum(xclsVol(1:numClstr))<100.d0 .and. &
			!sum(xclsVol(1:numClstr))/cVol-1d0<dTol) flag=.true.
			if(sum(xclsVol(1:numClstr))/cVol-1d0<dTol) flag=.true.
		endif
	endif
	
	!update the vol fractions of the past iterations
	eVolFrac(2:2*neVol,:)=eVolFrac(1:2*neVol-1,:)
	eVolFrac(1,1)=sum(xclsVol(1:numClstr))/pVol
	eVolFrac(1,2)=nIter
	
	if(.not.flag) then
		Dinosaur=.false.
	else
		Dinosaur=.true.
      
      		j=0
      		do i=1,numClstr
      			if(ptInClstr(i)>0) then
            			j=j+1
      				ptClstr(j)=ptInClstr(i)
				meanx(j,:)=xclsMean(i,:)
				invcovx(j,:,:)=xclsInvcov(i,:,:)
				tmatx(j,:,:)=xclsTMat(i,:,:)
				evalx(j,:)=xclsEval(i,:)
				evecx(j,:,:)=xclsEvec(i,:,:)
				kfacx(j)=xclsKfac(i)
				effx(j)=xclsEff(i)
				volx(j)=xclsVol(i)
            		endif
      		enddo
		
		nClstr=j
      		points(1:ndim,1:npt)=p(1:ndim,1:npt)
	      	auxa(1:naux,1:npt)=aux(1:naux,1:npt)
	endif
      	
	
	deallocate( updEll, check )
	deallocate( mean, covmat, invcov, tmat, evec, eval, p2, aux2 )
	deallocate( nptx, updPt, cluster, ptClstrk )
	deallocate( meank, covmatk, invcovk, tmatk, evalk, eveck, kfack, effk, detcovk, volk, pointsk, auxk, dis )
	
      	deallocate(xclsMean,xclsInvcov,xclsTMat,xclsEval,xclsEvec,xclsKfac,xclsEff, &
	xclsVol,xclsCovmat,xclsDetcov,p,aux,ptInClstr)
      
  end function Dinosaur
      
!---------------------------------------------------------------------- 

  recursive subroutine makeDino(pt,npt,ndim,naux,auxa,min_pt,mean,covmat,invcov, &
  	tmat,evec,eval,detcov,kfac,eff,vol,pVol,cSwitch,nCdim)
    	implicit none
	
	!input variables
	integer npt !no. of points to analyze
	double precision pVol !total prior volume
	integer ndim !dimensionality
      	double precision pt(ndim,npt) !points
	integer naux !dimensionality of auxiliary points
	double precision auxa(naux,npt) !auxiliary points
	integer min_pt !min no. of points per cluster
	double precision mean(ndim) !overall mean
	double precision covmat(ndim,ndim) !overall covariance matrix
	double precision invcov(ndim,ndim) !overall inv covariance matrix
	double precision tmat(ndim,ndim) !overall transformation matrix
	double precision evec(ndim,ndim) !overall eigenvector
	double precision eval(ndim) !overall eigenvalues
	double precision detcov !overall covariance matrix determinant
	double precision kfac !overall cluster point enlargement factor
	double precision eff !overall cluster volume enlargement factor
	double precision vol !overall volume
	logical cSwitch
	integer nCdim
	
	!work variables
	integer nk
	parameter(nk=2)
	integer i,k,d,ip
	integer, allocatable :: cluster(:), nptk(:)
	logical flag
	double precision, allocatable :: meank(:,:), covmatk(:,:,:), invcovk(:,:,:), tmatk(:,:,:)
	double precision, allocatable :: eveck(:,:,:), evalk(:,:), detcovk(:),kfack(:), effk(:),volk(:)
	double precision, allocatable :: ptk(:,:,:), auxk(:,:,:)
	double precision d1
	
	if(npt==0) return
	
	allocate( cluster(npt), nptk(nk) )
	allocate( meank(nk,ndim), covmatk(nk,ndim,ndim), invcovk(nk,ndim,ndim), tmatk(nk,ndim,ndim), eveck(nk,ndim,ndim), &
	evalk(nk,ndim), detcovk(nk), kfack(nk), effk(nk), volk(nk), ptk(nk,ndim,npt), auxk(nk,naux,npt) )
		
	if(abs((vol-pVol)/pVol)<0.01 .or. npt<2*min_pt .or. nCls>=maxClstr) then
		if(abs((vol-pVol)/pVol)<0.01) d=0
		flag=.true.
	else
		flag=.false.
	endif
      
      	if(.not.flag) then
		!assign all points to the same cluster & calculate its properties
		cluster=1
		meank(1,:)=mean(:)
		covmatk(1,:,:)=covmat(:,:)
		invcovk(1,:,:)=invcov(:,:)
		tmatk(1,:,:)=tmat(:,:)
		evalk(1,:)=eval(:)
		eveck(1,:,:)=evec(:,:)
		kfack(1)=kfac
		effk(1)=eff
		detcovk(1)=detcov
		volk(1)=vol
		nptk(1)=npt
		nptk(2:nk)=0
		volk(2:nk)=0.d0
		
      		!breakup the points in 2 or 3 clusters
		k=2
		do
			if(k>nk) then
				flag=.true.
				exit
			endif
			
			nptk(k)=0
			
      			d=Dmeans(k,pt,npt,auxa(naux,:),ndim,cluster,min_pt,nptk(1:k),meank(1:k,:),covmatk(1:k,:,:), &
			invcovk(1:k,:,:),tmatk(1:k,:,:),evalk(1:k,:),eveck(1:k,:,:),kfack(1:k),effk(1:k), &
			detcovk(1:k),volk(1:k),pVol,vol,cSwitch,nCdim)
			
			if(d==2) then
				!couldn't partition at all, exit the loop
				flag=.true.
				exit
			else
				!found a partition
      				!calculate the no. of points in each partition & separate them
      				nptk=0
      				do i=1,npt
           	 			nptk(cluster(i))=nptk(cluster(i))+1
            				ptk(cluster(i),:,nptk(cluster(i)))=pt(:,i)
            				auxk(cluster(i),:,nptk(cluster(i)))=auxa(:,i)
				enddo
				
				!was it a better partition?
				if(d==0 .or. vol>2.*pVol) then
					!yes, then exit
					flag=.false.
					exit
				else
					!no, then partition further
					k=k+1
				endif
			endif
		enddo
	endif
      
      	if(.not.flag) then
		nCls=nCls+k-1
		do i=1,k
			d1=pVol*dble(nptk(i))/dble(npt)
			call makeDino(ptk(i,:,1:nptk(i)),nptk(i),ndim,naux,auxk(i,:,1:nptk(i)),min_pt, &
			meank(i,:),covmatk(i,:,:),invcovk(i,:,:),tmatk(i,:,:),eveck(i,:,:),evalk(i,:), &
			detcovk(i),kfack(i),effk(i),volk(i),d1,cSwitch,nCdim)
		enddo
      	else
      		p(:,ptClstrd+1:ptClstrd+npt)=pt(:,1:npt)
            	aux(:,ptClstrd+1:ptClstrd+npt)=auxa(:,1:npt)
      		ip=numClstr+1
            	ptInClstr(ip)=npt
		xclsMean(ip,:)=mean(:)
		xclsInvcov(ip,:,:)=invcov(:,:)
		xclsCovmat(ip,:,:)=covmat(:,:)
		xclsTMat(ip,:,:)=tmat(:,:)
		xclsEval(ip,:)=eval(:)
		xclsEvec(ip,:,:)=evec(:,:)
		xclsKfac(ip)=kfac
		xclsEff(ip)=eff
		xclsVol(ip)=vol
		xclsDetcov(ip)=detcov
            	ptClstrd=ptClstrd+npt
            	numClstr=numClstr+1
      	endif
	
	deallocate( cluster, nptk )
	deallocate( meank, covmatk, invcovk, tmatk, eveck, evalk, detcovk, kfack, effk, volk, ptk, auxk )
      
  end subroutine makeDino 
      
!---------------------------------------------------------------------- 
  
  logical function kDinosaur(points,npt,ndim,nClstr,ptClstr,naux,auxa,min_pt,maxC, &
  	meanx,invcovx,tmatx,evalx,evecx,kfacx,effx,volx,pVol,cVol,neVol,eVolFrac, &
	nIter,dTol,switch,rFlag)
	implicit none
      	
	!input variables
	integer npt !total no. of points
	integer ndim !dimensionality
      	double precision points(ndim,npt) !points
	integer naux !dimensionality of auxiliary points
	double precision auxa(naux,npt) !auxiliary points
	integer min_pt !min no. of points per cluster
	integer maxC !max no. of clusters
	double precision pVol !prior volume
	double precision cVol !current vol
	integer neVol
	double precision eVolFrac(2*neVol,2)
	integer nIter
	double precision dTol !volume tolerance
    	logical switch !initialize the LAPACK eigen analysis routines?
	logical rFlag !desperate acceptance
	!output variables
	integer nClstr !total no. clusters found
	integer ptClstr(maxC) !points in each cluster
	double precision meanx(maxC,ndim) !cluster means
	double precision invcovx(maxC,ndim,ndim) !cluster inv covarianc matrices
	double precision tmatx(maxC,ndim,ndim) !cluster tranformation matrices
	double precision evalx(maxC,ndim) !cluster eigenvalues
	double precision evecx(maxC,ndim,ndim) !cluster eigenvectors
	double precision kfacx(maxC) !cluster point enlargement factors
	double precision effx(maxC) !cluster volume enlargement factors
	double precision volx(maxC) !cluster volumes
	!work variables
	integer i,j,k,nChkd
	logical flag
	integer cluster(npt),nptk(maxC)
	double precision meank(maxC,ndim),covmatk(maxC,ndim,ndim),invcovk(maxC,ndim,ndim),tmatk(maxC,ndim,ndim)
	double precision evalk(maxC,ndim),eveck(maxC,ndim,ndim),kfack(maxC),effk(maxC),detcovk(maxC),volk(maxC)
	double precision pts(ndim,npt),auxk(naux,npt)
	
	kDinosaur = .false.
	n_dim=ndim
	
	!sanity checks
	if(min_pt<ndim+1) min_pt=ndim+1
	if(npt<2*min_pt .or. maxC==1) then
      		nClstr=1
		ptClstr(1)=npt
		
		call CalcEllProp(npt,ndim,points,meanx(1,:),covmatk(1,:,:),invcovx(1,:,:),tmatx(1,:,:), &
		evecx(1,:,:),evalx(1,:),detcovk(1),kfacx(1),effx(1),volx(1),0d0,switch)
		return
	endif
	
	maxClstr=min(maxC,npt/min_pt+1)
	k=maxClstr
	
	call sKmeans(k,points,npt,ndim,cluster,min_pt)
	
	nChkd=0
	nptk=0
	do i=1,k
		do j=1,npt
			if(cluster(j)==i) then
				nptk(i)=nptk(i)+1
				pts(:,nChkd+nptk(i))=points(:,j)
				auxk(:,nChkd+nptk(i))=auxa(:,j)
			endif
		enddo
		
		call CalcEllProp(nptk(i),ndim,pts(:,nChkd+1:nChkd+nptk(i)),meank(i,:),covmatk(i,:,:), &
		invcovk(i,:,:),tmatk(i,:,:),eveck(i,:,:),evalk(i,:),detcovk(i),kfack(i),effk(i),volk(i), &
		0d0,switch)
		
		nChkd=nChkd+nptk(i)
	enddo
	
	!check if this was a successful partition
	flag=.false.
	!if the actual vol is an improvement then success
	if(.not.flag) then
		if(rFlag .and. maxClstr==k) then
			flag=.true.
		else
			if(sum(volk(1:k))<100.d0 .and. sum(volk(1:k))/cVol-1d0<dTol) flag=.true.
		endif
		!write(*,*)"xxx",sum(volk(1:k)),sum(volk(1:k)),cVol,dTol,flag
	endif
	
	!update the vol fractions of the past iterations
	eVolFrac(2:2*neVol,:)=eVolFrac(1:2*neVol-1,:)
	eVolFrac(1,1)=sum(volk(1:k))/pVol
	eVolFrac(1,2)=nIter
	
	if(.not.flag) then
		kDinosaur=.false.
	else
		kDinosaur=.true.
	
		ptClstr=nptk
		nClstr=k
      		points(1:ndim,1:npt)=pts(1:ndim,1:npt)
		auxa(1:naux,1:npt)=auxk(1:naux,1:npt)
		meanx(1:nClstr,:)=meank(1:nClstr,:)
		invcovx(1:nClstr,:,:)=invcovk(1:nClstr,:,:)
		tmatx(1:nClstr,:,:)=tmatk(1:nClstr,:,:)
		evalx(1:nClstr,:)=evalk(1:nClstr,:)
		evecx(1:nClstr,:,:)=eveck(1:nClstr,:,:)
		kfacx(1:nClstr)=kfack(1:nClstr)
		effx(1:nClstr)=effk(1:nClstr)
		volx(1:nClstr)=volk(1:nClstr)
	endif
      
  end function kDinosaur
  
!  ---------------------------------------------------------------------------------

  !Dinosaur clustering
  function postDino(k,pt,npt,auxa,naux,ndim,cluster,min_pt,nptk,meank,covmatk,invcovk, &
  tmatk,evalk,eveck,kfack,effk,detcovk,volk,cVol)
	implicit none
    
    	!input variables
    	integer k !no. of clusters required
    	integer npt !no. of points
    	integer ndim !dimensionality
    	double precision pt(ndim,npt) !points
	integer naux !no. of aux parameters
	double precision auxa(naux,npt)
    	integer min_pt !min no. of points allowed in a cluster
    	double precision cVol !prior volume
    
    	!input/output variables
    	integer nptk(k) !no. of points in each of k clusters
    	integer cluster(npt) !cluster membership of each point for k clusters
    	double precision meank(k,ndim) !input: means of k clusters
    	double precision covmatk(k,ndim,ndim)
    	double precision invcovk(k,ndim,ndim)
    	double precision tmatk(k,ndim,ndim)
    	double precision evalk(k,ndim)
    	double precision eveck(k,ndim,ndim)
    	double precision kfack(k)
    	double precision effk(k)
    	double precision detcovk(k)
    	double precision volk(k)
    	
    	!output variables
    	logical postDino !F if everything OK, T if something more needs to be done
    
    	!work variables
    	integer i,j,i1,i2,indx(1),count
    	double precision d1
    	double precision, allocatable :: h(:,:), mdis(:,:), ptk(:,:), auxk(:,:)
    	logical doCal(k),flag
    	!ellipsoid properties
    	integer, allocatable :: nptx(:), clusterx(:)
    	double precision, allocatable :: meanx(:,:), covmatx(:,:,:), invcovx(:,:,:), tmatx(:,:,:), evalx(:,:)
    	double precision, allocatable :: evecx(:,:,:), kfacx(:), effx(:), detcovx(:), volx(:), fVal(:)
    	double precision fTol
	
	if(k==1) then
		postDino=.false.
		return
	endif
	
	allocate( fVal(k) )
	
	fTol=20.d0
	
	fVal(1:k)=volk(1:k)/(cVol*nptk(1:k)/npt)

	!calculate the distance measure
	postDino=.false.
    	do i=1,k
		if(fVal(i)>fTol) then
			postDino=.true.
			exit
		endif
	enddo
	
	if(.not.postDino) then
		deallocate(fVal)
		return
	else
		allocate( h(k,npt), mdis(k,npt), ptk(ndim,npt), auxk(naux,npt) )
		allocate( nptx(k), clusterx(npt) )
		allocate( meanx(k,ndim), covmatx(k,ndim,ndim), invcovx(k,ndim,ndim), tmatx(k,ndim,ndim), evalx(k,ndim), &
		evecx(k,ndim,ndim), kfacx(k), effx(k), detcovx(k), volx(k) )
	endif
	
	!initialization
	nptx=nptk
	clusterx=cluster
	meanx=meank
	covmatx=covmatk
	invcovx=invcovk
	tmatx=tmatk
	evalx=evalk
	evecx=eveck
	kfacx=kfack
	effx=effk
	detcovx=detcovk
	volx=volk
	count=0
	doCal=.false.
	
    	do i=1,k	
		if(fVal(i)>fTol) then
			h(i,:)=1.d99
		else
			do j=1,npt
				if(fVal(clusterx(j))<=fTol) cycle
				mdis(i,j)=MahaDis(ndim,pt(:,j),meanx(i,:),invcovx(i,:,:),kfacx(i)*effx(i))
				if(mdis(i,j)>1.d0) then
					h(i,j)=1.d99
				else
					h(i,j)=volx(i)*mdis(i,j)/nptx(i)
					h(i,j)=mdis(i,j)
				endif
			enddo
		endif
    	enddo
    
    	!now assign point j to the ellipsoid i such that h(i,j) is min
    	flag=.false.
    	do j=1,npt
		if(fVal(clusterx(j))<=fTol) cycle
		
		indx=minloc(h(1:k,j))
		if(h(indx(1),j)/=1.d99) then
			doCal(indx(1))=.true.
			flag=.true.
			nptx(clusterx(j))=nptx(clusterx(j))-1
			if(nptx(clusterx(j))==0) then
				doCal(clusterx(j))=.false.
				fVal(clusterx(j))=0.d0
			else
				doCal(clusterx(j))=.true.
			endif
			nptx(indx(1))=nptx(indx(1))+1
			clusterx(j)=indx(1)
		endif
    	enddo
		
	if(flag) then
		!point reassigned, recalculate the ellipsoid properties
		do i=1,k
			if(.not.doCal(i)) cycle
			i1=0
			do j=1,npt
				if(clusterx(j)==i) then
					i1=i1+1
					ptk(:,i1)=pt(:,j)
					auxk(:,i1)=auxa(:,j)
				endif
			enddo
			
			d1=cVol*dble(i1)/dble(npt)
			call CalcEllProp(i1,ndim,ptk(:,1:i1),meanx(i,:),covmatx(i,:,:), &
				invcovx(i,:,:),tmatx(i,:,:),evecx(i,:,:),evalx(i,:),detcovx(i),kfacx(i), &
				effx(i),volx(i),d1,.false.)
					
			fVal(i)=volx(i)/(cVol*nptx(i)/npt)
		enddo
		
		nptk=nptx
    		cluster=clusterx
    		meank=meanx
    		covmatk=covmatx
	    	invcovk=invcovx
    		tmatk=tmatx
    		evalk=evalx
    		eveck=evecx
    		kfack=kfacx
	    	effk=effx
    		detcovk=detcovx
    		volk=volx
	endif
	
	!rearrange
	i1=0
	i2=0
	
	postDino=.false.
	do i=1,k
		if(fVal(i)<=fTol .and. nptk(i)>=min_pt) then
			i2=i2+1
			nptx(i2)=nptk(i)
    			meanx(i2,:)=meank(i,:)
    			covmatx(i2,:,:)=covmatk(i,:,:)
	   		invcovx(i2,:,:)=invcovk(i,:,:)
    			tmatx(i2,:,:)=tmatk(i,:,:)
    			evalx(i2,:)=evalk(i,:)
    			evecx(i2,:,:)=eveck(i,:,:)
    			kfacx(i2)=kfack(i)
	    		effx(i2)=effk(i)
    			detcovx(i2)=detcovk(i)
    			volx(i2)=volk(i)
		else
			postDino=.true.
			cycle
		endif		
			
		do j=1,npt
			if(cluster(j)==i) then
				i1=i1+1
				clusterx(i1)=i
				ptk(:,i1)=pt(:,j)
				auxk(:,i1)=auxa(:,j)
			endif
    		enddo
	enddo
		
	if(postDino) then
		nptx(i2+1)=0
		do i=1,k
			if(fVal(i)>fTol .or. nptk(i)<min_pt) then
				nptx(i2+1)=nptx(i2+1)+nptk(i)
				
				do j=1,npt
					if(cluster(j)==i) then
						i1=i1+1
						clusterx(i1)=i
						ptk(:,i1)=pt(:,j)
						auxk(:,i1)=auxa(:,j)
					endif
				enddo
			endif
		enddo
		k=i2+1
		
		d1=cVol*dble(nptx(k))/dble(npt)
		call CalcEllProp(nptx(k),ndim,ptk(:,npt-nptx(k)+1:npt),meanx(k,:),covmatx(k,:,:), &
			invcovx(k,:,:),tmatx(k,:,:),evecx(k,:,:),evalx(k,:),detcovx(k),kfacx(k), &
			effx(k),volx(k),d1,.false.)
	endif
	
	nptk=nptx
    	cluster=clusterx
    	meank=meanx
    	covmatk=covmatx
	invcovk=invcovx
    	tmatk=tmatx
    	evalk=evalx
    	eveck=evecx
    	kfack=kfacx
	effk=effx
    	detcovk=detcovx
    	volk=volx
	pt=ptk
	auxa=auxk
	
	deallocate( h, mdis, ptk, auxk )
	deallocate( nptx, clusterx )
	deallocate( meanx, covmatx, invcovx, tmatx, evalx, evecx, kfacx, effx, detcovx, volx, fVal )
	
	
  end function postDino  
 
      
!---------------------------------------------------------------------- 

end module xmeans_clstr

!Main module for module writers to actually use.
!Could just rename this cosmosis.F90 and the module cosmosis?
!That might be easiest for users
module cosmosis_modules
    use cosmosis_types
    use cosmosis_wrappers
    use cosmosis_section_names
    implicit none

    integer, parameter :: DATABLOCK_MAX_STRING_LENGTH=256
    character(*), parameter :: option_section = "module_options"

    interface datablock_put
        module procedure datablock_put_int, datablock_put_double, &
            datablock_put_logical, datablock_put_complex, datablock_put_double_array_1d, &
            datablock_put_int_array_1d, datablock_put_string
    end interface

    interface datablock_get
        module procedure datablock_get_int, datablock_get_double, &
            datablock_get_logical, datablock_get_complex, datablock_get_double_array_1d, &
            datablock_get_int_array_1d, datablock_get_string
    end interface

    interface datablock_replace
        module procedure datablock_replace_int, datablock_replace_double, &
            datablock_replace_logical, datablock_replace_complex, datablock_replace_double_array_1d, &
            datablock_replace_int_array_1d, datablock_replace_string
    end interface

    contains


    !Check whether the block contains a given section
    function datablock_has_section(block, section) result(found)
        logical(c_bool) :: found
        integer(cosmosis_block) :: block
        character(*) :: section

        found = c_datablock_has_section_wrapper(block, trim(section)//C_NULL_CHAR)
    end function datablock_has_section

    !Check whether the block contains a given value
    function datablock_has_value(block, section, name) result(found)
        logical(c_bool) :: found
        integer(cosmosis_block) :: block
        character(*) :: section, name

        found = c_datablock_has_value_wrapper(block, trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR)
    end function datablock_has_value



    function datablock_num_sections(block) result(n)
        integer(cosmosis_block) :: block
        integer :: n

        n = c_datablock_num_sections_wrapper(block)
    end function datablock_num_sections


    function datablock_get_array_length(block, section, name) result(n)
        integer(c_int) :: n
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name

        n = c_datablock_get_array_length_wrapper(block, trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR)
    end function datablock_get_array_length     


    function datablock_get_section_name(block, i) result(name)
        character(DATABLOCK_MAX_STRING_LENGTH) :: name
        integer(cosmosis_block) :: block
        integer :: i

        type(c_ptr) :: c_name
        c_name = c_datablock_get_section_name_wrapper(block, i)
        name = c_string_to_fortran(c_name, DATABLOCK_MAX_STRING_LENGTH)
        !No free here because we do not get
        !a newly allocated copy
    end function datablock_get_section_name

    !Save an integer with the given name to the given section
    function datablock_put_int(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        integer(c_int) :: value

        status = c_datablock_put_int_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_put_int


    !Replace the named integer in the given section with the new value
    function datablock_replace_int(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        integer(c_int) :: value

        status = c_datablock_replace_int_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_replace_int



    !Load the named integer from the given section
    function datablock_get_int(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        integer :: value

        status = c_datablock_get_int_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_get_int

    !Load the named integer from the given section
    function datablock_get_int_default(block, section, name, default, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        integer :: default, value

        status = c_datablock_get_int_default_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, default, value)

    end function datablock_get_int_default


    function datablock_put_logical(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        logical :: value
        logical(c_bool) c_value

        c_value = value
        status = c_datablock_put_bool_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, c_value)

    end function datablock_put_logical

    function datablock_replace_logical(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        logical :: value
        logical(c_bool) c_value

        c_value = value
        status = c_datablock_replace_bool_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, c_value)

    end function datablock_replace_logical

    !Load the named integer from the given section
    function datablock_get_logical(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        logical :: value
        logical(c_bool) :: c_value

        status = c_datablock_get_bool_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, c_value)
        value = c_value

    end function datablock_get_logical

    !Load the named integer from the given section
    function datablock_get_logical_default(block, section, name, default, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        logical :: default, value
        logical(c_bool) :: c_default, c_value

        c_default = default
        status = c_datablock_get_bool_default_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, c_default, c_value)
        value = c_value
    end function datablock_get_logical_default


    !Save a double with the given name to the given section
    function datablock_put_double(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        real(c_double) :: value

        status = c_datablock_put_double_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_put_double


    !Replace the named double in the given section with the new value
    function datablock_replace_double(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        real(c_double) :: value

        status = c_datablock_replace_double_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_replace_double


    !Load the named double from the given section
    function datablock_get_double(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        real(c_double) :: value

        status = c_datablock_get_double_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_get_double


    function datablock_get_double_default(block, section, name, default, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        real(c_double) :: value, default

        status = c_datablock_get_double_default_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, default, value)

    end function datablock_get_double_default


    !Save a complex double with the given name to the given section
    function datablock_put_complex(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        complex(c_double_complex) :: value

        status = c_datablock_put_complex_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_put_complex

    !Replace the named double complex in the given section with the new value
    function datablock_replace_complex(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        complex(c_double_complex) :: value

        status = c_datablock_replace_complex_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_replace_complex

    !Load the named complex double from the given section
    function datablock_get_complex(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        complex(c_double_complex) :: value

        status = c_datablock_get_complex_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value)

    end function datablock_get_complex


    function datablock_get_complex_default(block, section, name, default, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(*) :: section
        character(*) :: name
        complex(c_double_complex) :: default, value

        status = c_datablock_get_complex_default_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, default, value)

    end function datablock_get_complex_default


    function datablock_put_string(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        character(len=*) :: value

        status = c_datablock_put_string_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, trim(value)//C_NULL_CHAR)

    end function datablock_put_string

    function datablock_replace_string(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        character(len=*) :: value

        status = c_datablock_replace_string_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, trim(value)//C_NULL_CHAR)

    end function datablock_replace_string

    function datablock_get_string(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        character(len=*) :: value
        type(c_ptr) :: c_string  !This is actually a pointer-to-a-pointer, I think.

        !Call the C function, which returns a c_ptr.
        status = c_datablock_get_string_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, c_string)

        ! Convert the c_ptr into a fortran string.
        ! This will (silently) truncate the string if
        ! the value put in is not long enough,
        ! but this is apparently standard in Fortran.
        if (status==0) then
            value = c_string_to_fortran(c_string, len(value))
            !Need to free the C string!  Becuase it was allocated with strdup
            call wrap_free(c_string)
        else 
            value=""
        endif

    end function datablock_get_string


    function datablock_get_string_default(block, section, name, default, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        character(len=*) :: default, value
        type(c_ptr) :: c_string  !This is actually a pointer-to-a-pointer, I think.

        !Call the C function, which returns a c_ptr.
        status = c_datablock_get_string_default_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, trim(default)//C_NULL_CHAR, c_string)

        ! Convert the c_ptr into a fortran string.
        ! This will (silently) truncate the string if
        ! the value put in is not long enough,
        ! but this is apparently standard in Fortran.
        value = c_string_to_fortran(c_string, len(value))
        !Need to free the C string!  Becuase it was allocated with strdup
        call wrap_free(c_string)

    end function datablock_get_string_default


!       function c_datablock_put_int_array_1d_wrapper(s, section, name, value, size)

    !Save an integer array with the given name to the given section
    function datablock_put_int_array_1d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        integer(c_int), dimension(:) :: value
        integer(c_int) :: sz

        sz=size(value)

        status = c_datablock_put_int_array_1d_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, sz)

    end function datablock_put_int_array_1d



    function datablock_replace_int_array_1d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        integer(c_int), dimension(:) :: value
        integer(c_int) :: sz

        sz=size(value)

        status = c_datablock_replace_int_array_1d_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, sz)

    end function datablock_replace_int_array_1d


    function datablock_get_int_array_1d(block, section, name, value, size) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        integer(c_int), dimension(:), allocatable :: value
        integer(c_int) :: size
        integer(c_int) :: maxsize

        maxsize = datablock_get_array_length(block, section, name)
        ! We don't actually know which failure we have here
        ! So we just return 1
        if (maxsize<0) then
            status = 1
        else
            allocate(value(maxsize))
            status = c_datablock_get_int_array_1d_preallocated_wrapper(block, &
                trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, size, maxsize)
        endif

    end function datablock_get_int_array_1d

    function datablock_put_int_array_2d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        integer(c_int), dimension(:, :) :: value
        integer(c_int) :: extents(2)

        !Opposite ordering in fortran vs C
        extents(2)=size(value, 1)
        extents(1)=size(value, 2)
 
        status = c_datablock_put_int_array_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, 2, extents)
 
    end function datablock_put_int_array_2d

    function datablock_get_double_array_2d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        real(c_double), allocatable, dimension(:, :) :: value
        integer(c_int) :: extents(2)
        integer(c_int) ndims

        ndims = 2
        status = c_datablock_get_double_array_shape(block, trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, ndims, extents)
        if (status .ne. 0) return
        
        !Order reversed versus fortran
        allocate(value(extents(2), extents(1)))

        status = c_datablock_get_double_array_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, 2, extents)

         if (status .ne. 0) deallocate(value)

    end function datablock_get_double_array_2d

    function datablock_get_int_array_2d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        integer(c_int), allocatable, dimension(:, :) :: value
        integer(c_int) :: extents(2)
        integer(c_int) ndims

        ndims = 2
        status = c_datablock_get_int_array_shape(block, trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, ndims, extents)
        if (status .ne. 0) return
        
        !Order reversed versus fortran
        allocate(value(extents(2), extents(1)))

        status = c_datablock_get_int_array_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, 2, extents)

         if (status .ne. 0) deallocate(value)

    end function datablock_get_int_array_2d


    function datablock_put_double_array_2d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        real(c_double), dimension(:, :) :: value
        integer(c_int) :: extents(2)

        !Opposite ordering in fortran vs C
        extents(2)=size(value, 1)
        extents(1)=size(value, 2)
 
        status = c_datablock_put_double_array_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, 2, extents)
 
    end function datablock_put_double_array_2d



     function datablock_put_double_array_1d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        real(c_double), dimension(:) :: value
        integer(c_int) :: sz
 
        sz=size(value)
 
        status = c_datablock_put_double_array_1d_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, sz)
 
    end function datablock_put_double_array_1d
 



    function datablock_replace_double_array_1d(block, section, name, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        real(c_double), dimension(:) :: value
        integer(c_int) :: sz
 
        sz=size(value)
 
        status = c_datablock_replace_double_array_1d_wrapper(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, sz)

    end function datablock_replace_double_array_1d

    function datablock_get_double_array_1d(block, section, name, value, size) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        real(c_double), dimension(:), allocatable :: value
        integer(c_int) :: size
        integer(c_int) :: maxsize
 
        maxsize = datablock_get_array_length(block, section, name)
        ! We don't actually know which failure we have here
        ! So we just return 1
        if (maxsize<0) then
            status = 1
        else
            allocate(value(maxsize))
            status = c_datablock_get_double_array_1d_preallocated_wrapper(block, &
                trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, size, maxsize)
        endif
 
    end function datablock_get_double_array_1d


!    function datablock_get_complex_array_1d(block, section, name, value, size) result(status)
!        integer(cosmosis_status) :: status
!        integer(cosmosis_block) :: block
!        character(len=*) :: section
!        character(len=*) :: name
!        complex(c_double_complex), dimension(:), allocatable :: value
!        integer(c_int) :: size
!        integer(c_int) :: maxsize
! 
!        maxsize = datablock_get_array_length(block, section, name)
!        ! We don't actually know which failure we have here
!        ! So we just return 1
!        if (maxsize<0) then
!            status = 1
!        else
!            allocate(value(maxsize))
!            status = c_datablock_get_complex_array_1d_preallocated_wrapper(block, &
!                trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, size, maxsize)
!        endif
! 
!    end function datablock_get_complex_array_1d


!    function datablock_put_complex_array_1d(block, section, name, value) result(status)
!        integer(cosmosis_status) :: status
!        integer(cosmosis_block) :: block
!        character(len=*) :: section
!        character(len=*) :: name
!        complex(c_double_complex), dimension(:) :: value
!        integer(c_int) :: sz
! 
!        sz=size(value)
! 
!        status = c_datablock_put_complex_array_1d_wrapper(block, &
!            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, sz)
! 
!    end function datablock_put_complex_array_1d
! 

 !   function datablock_replace_complex_array_1d(block, section, name, value) result(status)
 !       integer(cosmosis_status) :: status
 !       integer(cosmosis_block) :: block
 !       character(len=*) :: section
 !       character(len=*) :: name
 !       complex(c_double_complex), dimension(:) :: value
 !       integer(c_int) :: sz
 !
 !       sz=size(value)
 !
 !       status = c_datablock_replace_complex_array_1d_wrapper(block, &
 !           trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, value, sz)
 !
 !   end function datablock_replace_complex_array_1d
    
    function datablock_put_grid_sentinel(s, section, name_x, name_y, name_z) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: s
        character(*) :: section, name_x, name_y, name_z
        character(512) :: sentinel_key, sentinel_value
        write(sentinel_key, '("_cosmosis_order_", A)') trim(name_z)
        write(sentinel_value, '(A,"_cosmosis_order_", A)') trim(name_y), trim(name_x)

        status = datablock_put_string(s, trim(section), trim(sentinel_key), trim(sentinel_value))
    end function 



    function datablock_put_double_grids(s, section, &
            x_name, x, y_name, y, &
            z1_name, z1, z2_name, z2, z3_name, z3, z4_name, z4, z5_name, z5, &
            z6_name, z6, z7_name, z7, z8_name, z8, z9_name, z9, z10_name, z10) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: s
        character(*) :: section, x_name, y_name, z1_name
        character(256) :: name_x, name_y, name_z
        real(8) :: x(:), y(:),  z1(:,:)
        character(512) :: sentinel_key, sentinel_value
        character(*), optional :: z2_name, z3_name, z4_name, z5_name
        character(*), optional :: z6_name, z7_name, z8_name, z9_name, z10_name
        real(8), optional :: z2(:,:), z3(:,:),  z4(:,:),  z5(:,:)
        real(8), optional :: z6(:,:), z7(:,:),  z8(:,:),  z9(:,:),  z10(:,:)

        status = datablock_put_double_grid(s, section, x_name, x, y_name, y, z1_name, z1)
        if (status .ne. 0) return

        name_x = x_name
        name_y = y_name
        call lowercase_ascii(name_x)
        call lowercase_ascii(name_y)


        if (present(z2) .and. present(z2_name)) then
            name_z = z2_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z2)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z3) .and. present(z3_name)) then
            name_z = z3_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z3)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z4) .and. present(z4_name)) then
            name_z = z4_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z4)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z5) .and. present(z5_name)) then
            name_z = z5_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z5)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z6) .and. present(z6_name)) then
            name_z = z6_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z6)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z7) .and. present(z7_name)) then
            name_z = z7_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z7)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z8) .and. present(z8_name)) then
            name_z = z8_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z8)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z9) .and. present(z9_name)) then
            name_z = z9_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z9)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif

        if (present(z10) .and. present(z10_name)) then
            name_z = z10_name
            call lowercase_ascii(name_z)
            status = status + datablock_put_double_array_2d(s, section, name_z, z10)
            status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
        endif


    end function datablock_put_double_grids


    function datablock_put_double_grid(s, section, &
        x_name, x, y_name, y, z_name, z) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: s
        character(*) :: section, x_name, y_name, z_name
        character(256) :: name_x, name_y, name_z
        integer :: nz
        real(8) :: x(:), y(:), z(:,:)
        character(512) :: sentinel_key, sentinel_value

        status = 0
        name_x = x_name
        name_y = y_name
        name_z = z_name
        call lowercase_ascii(name_x)
        call lowercase_ascii(name_y)
        call lowercase_ascii(name_z)

        status = status + datablock_put_double_array_1d(s, section, name_x, x)
        status = status + datablock_put_double_array_1d(s, section, name_y, y)
        status = status + datablock_put_double_array_2d(s, section, name_z, z)

        status = status + datablock_put_grid_sentinel(s, section, name_x, name_y, name_z)
    end function datablock_put_double_grid

    !There appears to be no intrinsic to do this!
    !This does mean our code will not work for non-ascii characters
    !When this becomes an issue because Mandarin becomes the international
    !Lingua Franca then we should probably switch to wrapping
    !something from libc.
    subroutine lowercase_ascii(s)
        character(*) :: s
        integer i,n, ic
        character(26), parameter :: lower = "abcdefghijklmnopqrstuvwxyz"
        character(26), parameter :: upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

        n=len(trim(s))
        do i=1,n
            ic = index(upper, s(i:i))
            if (ic>0) s(i:i) = lower(ic:ic)
        enddo
    end subroutine lowercase_ascii

    function datablock_get_double_grid(s, section, &
        x_name, x, y_name, y, z_name, z) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: s
        character(*) :: section, x_name, y_name, z_name
        character(256) :: name_x, name_y, name_z
        integer :: nx, ny, nz
        real(8), allocatable :: x(:), y(:), z(:,:), z_temp(:,:)
        character(512) :: sentinel_key, sentinel_value

        status = 0

        name_x = x_name
        name_y = y_name
        name_z = z_name


        call lowercase_ascii(name_x)
        call lowercase_ascii(name_y)
        call lowercase_ascii(name_z)


        status = status + datablock_get_double_array_1d(s, section, name_x, x, nx)
        status = status + datablock_get_double_array_1d(s, section, name_y, y, ny)
        !Ordering check
        write(sentinel_key, '("_cosmosis_order_", A)') trim(name_z)
        status = status + datablock_get_string(s, section, sentinel_key, sentinel_value)

        if (status .ne. 0) then
            if (allocated(x)) deallocate(x)
            if (allocated(y)) deallocate(y)
            return
        endif

        if (sentinel_value==(trim(name_y) // "_cosmosis_order_" // trim(name_x))) then
            !Simple ordering
            status = status + datablock_get_double_array_2d(s, section, name_z, z)

        elseif (sentinel_value==(trim(name_x) // "_cosmosis_order_" // trim(name_y))) then
            !Need to transpose first
            status = status + datablock_get_double_array_2d(s, section, name_z, z_temp)

            if (status==0) then
                allocate(z(nx,ny))
                z = transpose(z_temp)
                deallocate(z_temp)
            endif
        else
            !Something went wrong
            write(*,*) "Marker error", trim(sentinel_key), "  ",trim(sentinel_value)
            write(*,*) (trim(name_y) // "_cosmosis_order_" // trim(name_x))
            write(*,*) (trim(name_x) // "_cosmosis_order_" // trim(name_y))
            status = 8
        endif
    end function datablock_get_double_grid



    function datablock_put_metadata(block, section, name, key, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        character(len=*) :: key
        character(len=*) :: value

        status = c_datablock_put_metadata(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, &
            trim(key)//C_NULL_CHAR, trim(value)//C_NULL_CHAR)

    end function datablock_put_metadata

    function datablock_replace_metadata(block, section, name, key, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        character(len=*) :: key
        character(len=*) :: value

        status = c_datablock_replace_metadata(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, &
            trim(key)//C_NULL_CHAR, trim(value)//C_NULL_CHAR)

    end function datablock_replace_metadata


   function datablock_get_metadata(block, section, name, key, value) result(status)
        integer(cosmosis_status) :: status
        integer(cosmosis_block) :: block
        character(len=*) :: section
        character(len=*) :: name
        character(len=*) :: key
        character(len=*) :: value
        type(c_ptr) :: c_string  !This is actually a pointer-to-a-pointer, I think.

        !Call the C function, which returns a c_ptr.
        status = c_datablock_get_metadata(block, &
            trim(section)//C_NULL_CHAR, trim(name)//C_NULL_CHAR, &
            trim(key)//C_NULL_CHAR, c_string)

        ! Convert the c_ptr into a fortran string.
        ! This will (silently) truncate the string if
        ! the value put in is not long enough,
        ! but this is apparently standard in Fortran.
        if (status==0) then
            value = c_string_to_fortran(c_string, len(value))
            !Need to free the C string!  Becuase it was allocated with strdup
            call wrap_free(c_string)
        else 
            value=""
        endif

    end function datablock_get_metadata



    !Create a datablock.
    !Unless you are writing a sampler you should not
    !have to use this function - you will be given the 
    !datablock you need.
    function make_datablock()
        integer(kind=cosmosis_block) :: make_datablock
        make_datablock =  make_c_datablock()
    end function make_datablock

end module cosmosis_modules

program main

	use params
      	use nestwrapper
      
	implicit none
      
      
	integer i
      
	!setting priors
	spriorran(1:sdim,1)=-6.
      	spriorran(1:sdim,2)=6.
      
      	!no parameters to wrap around
      	nest_pWrap=0
      
      	!setting the centers for dimensions other than the first one
      	do i=1,sModes
      		sc(i,2:sdim)=0.
      	end do

      	call nest_Sample
      	stop
end

module utils_module
    implicit none
#ifdef MPI
    include 'mpif.h'
#endif
    integer, parameter :: dp = kind(1.d0)

    !> The maximum character length
    integer, parameter :: STR_LENGTH = 300

    !> \f$ 2\pi \f$ in real(dp)
    real(dp), parameter :: TwoPi = 8d0*atan(1d0)
    !> \f$ \log(2\pi) \f$ in real(dp)
    real(dp), parameter :: logTwoPi = log(8d0*atan(1d0))

    !> The default writing formats
    integer, parameter :: fmt_len = 200
    character(8) :: DB_FMT='E24.15E3'
    character(4) :: FLT_FMT='F8.2'
    character(3) :: INT_FMT='I12'

    !> Feedback levels
    integer, parameter :: title_fb = 0
    integer, parameter :: normal_fb = 1
    integer, parameter :: fancy_fb = 2
    integer, parameter :: verbose_fb = 3

    !> unit for stderr
    integer, parameter :: stderr_unit = 0
    !> unit for stdin
    integer, parameter :: stdin_unit = 5
    !> unit for stdout
    integer, parameter :: stdout_unit = 6
    !> unit for reading from resume file
    integer, parameter :: read_resume_unit = 10
    !> unit for writing to resum file
    integer, parameter :: write_resume_unit = 11
    !> unit for writing to txt file
    integer, parameter :: write_txt_unit = 12
    !> unit for writing dead file
    integer, parameter :: write_dead_unit = 13
    !> unit for reading covariance matrices
    integer, parameter :: read_covmat_unit = 14
    !> unit for writing live points
    integer, parameter :: write_phys_unit = 15
    !> unit for writing clusters of live points
    integer, parameter :: write_phys_cluster_unit = 16
    !> unit for writing evidence distribution
    integer, parameter :: write_ev_unit = 17
    !> unit for writing evidence distribution
    integer, parameter :: write_stats_unit = 18
    !> unit for writing equal weights files
    integer, parameter :: write_equals_unit = 19
    !> unit for writing weights files
    integer, parameter :: write_posterior_unit = 19

    !> unit for deleting generic files
    integer, parameter :: delete_unit = 20


    !> unit for params file
    integer, parameter :: params_unit = 21
    !> unit for paramnames file
    integer, parameter :: paramnames_unit = 22

    !> unit for prior file
    integer, parameter :: write_prior_unit = 23

    !> unit for writing dead birth file
    integer, parameter :: write_dead_birth_unit = 24

    !> unit for writing live birth file
    integer, parameter :: write_live_birth_unit = 25

    ! All series used to approximate F are computed with relative
    ! tolerance:
    real(dp) eps
    parameter( eps = 1d-15 )
    ! which means that we neglect all terms smaller than eps times the
    ! current sum


    integer,parameter :: flag_blank     = -2
    integer,parameter :: flag_gestating = -1
    integer,parameter :: flag_waiting   = 0


    contains
    
    ! Write format for n integers
    function integer_format(n)
        implicit none
        integer, intent(in) :: n
        character(len=fmt_len) :: integer_format

        write(integer_format,'("(",I0,A,")")') n,INT_FMT   ! define the integer format

    end function integer_format

    ! Write format for n doubles
    function double_format(n)
        implicit none
        integer, intent(in) :: n
        character(len=fmt_len) :: double_format

        write(double_format,'("(",I0,A,")")') n,DB_FMT   ! define the integer format

    end function double_format

    !> Swaps two integers via a temporary variable
    subroutine swap_integers(a,b)
        implicit none
        integer,intent(inout) :: a,b
        integer :: temp
        temp=a
        a=b
        b=temp
    end subroutine swap_integers

    !> location of minimum in an array of doubles
    !!
    !! This is just a wrapper around minloc, but gets around the annoying ideosyncracy
    !! of fortran that minloc must return a length 1 array
    function minpos(a)
        implicit none
        real(dp), intent(in), dimension(:) :: a
        integer :: minpos
        integer :: minpos_vec(1)

        minpos_vec = minloc(a)
        minpos = minpos_vec(1)
    end function minpos



    function cyc(iterator,cycle_size)
        implicit none
        integer, intent(in) :: iterator
        integer, intent(in) :: cycle_size
        logical :: cyc

        if(cycle_size<=0) then
            cyc = .false.
        else
            cyc = mod(iterator,cycle_size)==0
        end if

    end function cyc



    !> Euclidean distance of two coordinates
    !!
    !! returns \f$\sqrt{\sum_i (a_i-b_i)^2 } \f$
    function distance(a,b)
        implicit none
        !> First vector
        real(dp), dimension(:) :: a
        !> Second vector
        real(dp), dimension(:) :: b

        real(dp) :: distance

        distance = sqrt(distance2(a,b))

    end function distance

    !> Euclidean distance squared of two coordinates
    !!
    !! returns \f$\sum_i (a_i-b_i)^2 \f$
    function distance2(a,b)
        implicit none
        !> First vector
        real(dp), dimension(:) :: a
        !> Second vector
        real(dp), dimension(:) :: b

        real(dp) :: distance2

        distance2 = dot_product(a-b,a-b) 

    end function distance2

    function loggamma(n)
        use iso_c_binding
        implicit none
        real(dp)            :: loggamma
        real(dp),intent(in) :: n
        real(c_double) :: c_n
        interface 
            function lgamma (y) bind(c)
                use iso_c_binding
                implicit none
                real(c_double)        :: lgamma
                real(c_double), value :: y
            end function
        end interface


        c_n = n

        loggamma = lgamma(c_n)


    end function loggamma


    !> Mutual proximity 
    !!
    function MP(a,b,live_data)
        implicit none
        real(dp), dimension(:)   :: a
        real(dp), dimension(:)   :: b
        real(dp), dimension(:,:) :: live_data

        real(dp) :: MP

        real(dp) :: dab2

        integer i

        MP=0d0

        dab2 = distance2(a,b)

        do i=1,size(live_data,2)
            if(distance2(live_data(:,i),a) > dab2 .and. distance2(live_data(:,i),b) > dab2 ) MP = MP+1d0
        end do

        MP = MP/(size(live_data,2)+0d0)

    end function MP

    function MP2(seed,baby,live_data)
        implicit none
        real(dp), dimension(:)   :: seed
        real(dp), dimension(:)   :: baby
        real(dp), dimension(:,:) :: live_data

        real(dp) :: MP2

        real(dp) :: dab2

        integer i

        MP2=0d0

        dab2 = distance2(seed,baby)

        do i=1,size(live_data,2)
            if(distance2(live_data(:,i),seed) > dab2 ) MP2 = MP2+1d0
        end do

        MP2 = MP2/(size(live_data,2)+0d0)

    end function MP2

    !> Modulus squared of a vector
    !!
    !! returns \f$\sum_i (a_i)^2 \f$
    function mod2(a)
        implicit none
        !> First vector
        real(dp), dimension(:) :: a

        real(dp) :: mod2

        mod2 = dot_product(a,a)

    end function mod2


    !> Double comparison
    function dbleq(a,b)
        implicit none
        real(dp) :: a,b
        logical :: dbleq
        real(dp), parameter :: eps = 1d-7

        dbleq =  abs(a-b) < eps * max(abs(a),abs(b)) 

    end function dbleq



    !> Identity matrix ( nDims x nDims )
    function identity_matrix(nDims)
        implicit none
        !> dimensionality of the identity matrix
        integer,intent(in) :: nDims
        !> The identity matrix to be returned
        real(dp), dimension(nDims,nDims) :: identity_matrix

        integer :: i_dims ! iterator over dimensions

        identity_matrix=0d0
        do i_dims=1,nDims
            identity_matrix(i_dims,i_dims) = 1d0
        end do


    end function identity_matrix

    !> Trace of a matrix
    function trace(a)
        implicit none
        !> The identity matrix to be returned
        real(dp), dimension(:,:),intent(in) :: a

        real(dp) :: trace

        integer :: i ! iterator over dimensions

        trace= sum ( [( a(i,i), i=1,min(size(a,1),size(a,2)) )] ) 

    end function trace


    function delete_file(file_name,feedback) result(deleted)
        implicit none
        character(STR_LENGTH),intent(in) :: file_name
        logical, optional, intent(in) :: feedback

        logical :: deleted ! whether or not there was a file to be deleted

        ! Check that file exists:
        inquire( file=trim(file_name), exist=deleted)

        if(deleted) then
            if(present(feedback)) then
                if(feedback) write(stdout_unit,'("Deleting file: ", A)') trim(file_name)
            end if
            ! open the file
            open(delete_unit,file=trim(file_name)) 
            ! Delete it if it exists
            close(delete_unit,status='delete')
        end if


    end function delete_file






    !> How to actually calculate sums from logs.
    !!
    !! i.e. if one has a set of logarithms \f$\{\log(L_i)\}\f$, how should one
    !! calculate \f$ \log(\sum_i L_i)\f$ without underflow?
    !!
    !! One does it with the 'log-sum-exp' trick, by subtracting off the maximum
    !! value so that at least the maxmimum value doesn't underflow, and then add
    !! it back on at the end:
    function logsumexp(vector)
        implicit none
        !> vector of log(w
        real(dp), dimension(:),intent(in) :: vector

        real(dp) :: logsumexp
        real(dp) :: maximumlog

        maximumlog = maxval(vector)
        logsumexp  =  maximumlog + log(sum(exp(vector - maximumlog)))

    end function logsumexp


    function logaddexp(loga,logb)
        implicit none
        real(dp) :: loga
        real(dp) :: logb
        real(dp) :: logaddexp

        if (loga>logb) then
            logaddexp = loga + log(exp(logb-loga) + 1)
        else
            logaddexp = logb + log(exp(loga-logb) + 1)
        end if

    end function logaddexp

    function logsubexp(loga,logb)
        implicit none
        real(dp) :: loga
        real(dp) :: logb
        real(dp) :: logsubexp

        if(loga>logb) then
            logsubexp = loga + log(1-exp(logb-loga))
        else 
            logsubexp = -huge(1d0)
        end if

    end function logsubexp

    !> This function increases loga by logb (and by log c if present)
    subroutine logincexp(loga,logb,logc)
        implicit none
        real(dp),intent(inout)       :: loga
        real(dp),intent(in)          :: logb
        real(dp),intent(in),optional :: logc

        if (loga>logb) then
            loga = loga + log(exp(logb-loga) + 1)
        else
            loga = logb + log(exp(loga-logb) + 1)
        end if

        if(present(logc)) then
            if (loga>logc) then
                loga = loga + log(exp(logc-loga) + 1)
            else
                loga = logc + log(exp(loga-logc) + 1)
            end if
        end if

    end subroutine logincexp


    !> Return the sorted indices of an array of doubles
    !!
    function sort_doubles(a) result(k)
        implicit none
        real(dp),intent(in), dimension(:) :: a
        real(dp), dimension(size(a)) :: b
        integer, dimension(size(a)) :: i
        integer, dimension(size(a)) :: k

        integer :: j

        b = a
        i = [ (j,j=1,size(a)) ]

        call quicksort(b,i)

        k=i
        !do j=1,size(a)
            !k(i(j)) = j
        !end do

    end function sort_doubles

    recursive subroutine quicksort(A,Ai)
        real(dp), intent(inout), dimension(:) :: A
        integer, intent(inout), dimension(:) :: Ai
        integer :: iq

        if(size(A) > 1) then
            call Partition(A,Ai,iq)
            call quicksort(A(:iq-1),Ai(:iq-1))
            call quicksort(A(iq:),Ai(iq:))
        endif
    end subroutine quicksort

    subroutine Partition(A,Ai,marker)
        real(dp), intent(inout), dimension(:) :: A
        integer, intent(inout), dimension(:) :: Ai
        integer, intent(out) :: marker
        integer :: i, j
        real(dp) :: temp
        integer :: tempi
        real(dp) :: x      ! pivot point
        x = A(1)
        i= 0
        j= size(A) + 1

        do
            j = j-1
            do
                if (A(j) <= x) exit
                j = j-1
            end do
            i = i+1
            do
                if (A(i) >= x) exit
                i = i+1
            end do
            if (i < j) then
                ! exchange A(i) and A(j)
                temp = A(i)
                A(i) = A(j)
                A(j) = temp
                tempi = Ai(i)
                Ai(i) = Ai(j)
                Ai(j) = tempi

            elseif (i == j) then
                marker = i+1
                return
            else
                marker = i
                return
            endif
        end do

    end subroutine Partition





    !> Hypergeometric function 1F1
    !!
    !!
    function Hypergeometric1F1(a,b,z)
        implicit none
        real(dp), intent(in)  :: a,b,z
        real(dp)              :: Hypergeometric1F1
        integer n
        real(dp) change

        ! This computes the hypergeometric 1F1 function using a
        ! truncated power series, stopping when the relative change
        ! due to higher terms is less than epsilon
        !
        ! (note that this is very similar to 2F1, but without the c)

        ! http://en.wikipedia.org/wiki/Hypergeometric_function#The_hypergeometric_series

        Hypergeometric1F1=0d0
        n=0

        do while( abovetol(change,Hypergeometric1F1) )
            change = Pochhammer(a,n) * Pochhammer(b,n) * z**n / gamma(1d0+n)

            Hypergeometric1F1 = Hypergeometric1F1 + change
            n=n+1
        enddo

    end function Hypergeometric1F1




    !> Hypergeometric function 
    function Hypergeometric2F1(a,b,c,z)
        implicit none
        real(dp), intent(in)  :: a,b,c,z
        real(dp)              :: Hypergeometric2F1
        integer n
        real(dp) change

        ! This computes the hypergeometric 2F1 function using a
        ! truncated power series, stopping when the relative change
        ! due to higher terms is less than epsilon

        ! http://en.wikipedia.org/wiki/Hypergeometric_function#The_hypergeometric_series

        Hypergeometric2F1=0d0
        n=0

        do while( abovetol(change,Hypergeometric2F1) )
            change = Pochhammer(a,n) * Pochhammer(b,n) / Pochhammer(c,n) * z**n / gamma(1d0+n)

            Hypergeometric2F1 = Hypergeometric2F1 + change
            n=n+1
        enddo

    end function Hypergeometric2F1




    recursive function Pochhammer (x,n) result (xn)
    ! This function computes the rising factorial x^(n):
    ! for a non-negative integer n and real x
    !
    ! http://en.wikipedia.org/wiki/Pochhammer_symbol

    implicit none
    real(dp), intent(in)  :: x
    integer,          intent(in)  :: n
    real(dp)              :: xn

    if (n<=0) then
        xn = 1
    else
        xn = Pochhammer(x,n-1)*(x+n-1)
    endif

    end function Pochhammer

    function abovetol (change,current_sum)
        ! This function outputs true if change is outside of the
        ! tolerance epsilon from current_sum
        implicit none
        real(dp), intent(in) :: change,current_sum
        logical abovetol

        if (current_sum <= 0d0) then
            ! this check is useful for entering loops
            abovetol = .true.
        else
            abovetol = abs( change/current_sum ) > eps
        endif

    end function abovetol

    function calc_cholesky(a) result(L)
        implicit none
        real(dp), intent(in),dimension(:,:) :: a
        real(dp), dimension(size(a,1),size(a,2)) :: L
        integer :: i,j

        ! Set it all to zero to begin with
        L = 0

        ! Zero out the upper half
        do i=1,size(a,1)

            L(i,i)= a(i,i) - sum(L(i,:i-1)**2) 
            if (L(i,i).le.0d0) then
                ! If the cholesky decomposition does not exist, then set it to
                ! be a re-scaled identity matrix
                L = identity_matrix(size(a,1)) * sqrt(trace(a))
                return
            else
                L(i,i)=sqrt(L(i,i))
            end if

            do j=i+1,size(a,1)
                L(j,i) = (a(i,j) - sum(L(i,:i-1)*L(j,:i-1)))/L(i,i)
            end do

        end do

    end function calc_cholesky

    function calc_covmat(lives,phantoms) result(covmat)
        implicit none
        real(dp), intent(in), dimension(:,:) :: lives
        real(dp), intent(in), dimension(:,:) :: phantoms

        real(dp), dimension(size(lives,1),size(lives,1)) :: covmat

        real(dp), dimension(size(lives,1)) :: mean

        integer :: nDims,nlive,nphantom

        nDims = size(lives,1)
        nlive = size(lives,2)
        nphantom = size(phantoms,2)

        ! Compute the mean 
        mean = ( sum(lives,dim=2) + sum(phantoms,dim=2) ) 
        mean = mean / (nlive + nphantom)

        ! Compute the covariance matrix
        covmat = matmul(lives    - spread(mean,dim=2,ncopies=nlive) ,    transpose(lives    - spread(mean,dim=2,ncopies=nlive)    ) ) &
            +    matmul(phantoms - spread(mean,dim=2,ncopies=nphantom) , transpose(phantoms - spread(mean,dim=2,ncopies=nphantom) ) )   
        covmat = covmat / (nlive + nphantom -1)

    end function calc_covmat

    !> This function computes the similarity matrix of an array of data.
    !!
    !! Assume that the data_array can be considered an indexed array of vectors
    !! V = ( v_i : i=1,n )
    !!
    !! The similarity matrix can be expressed very neatly as
    !! d_ij = (v_i-v_j) . (v_i-v_j)
    !!      = v_i.v_i + v_j.v_j - 2 v_i.v_j
    !!
    !! The final term can be written as a data_array^T data_array, and the first
    !! two are easy to write. We can therefore calculate this in two lines with
    !! instrisic functions
    function calc_similarity_matrix(data_array) result(similarity_matrix)

        real(dp), intent(in), dimension(:,:) :: data_array

        real(dp), dimension(size(data_array,2),size(data_array,2)) :: similarity_matrix

        integer :: i



        similarity_matrix = spread( [( dot_product(data_array(:,i),data_array(:,i)),i=1,size(data_array,2) )], dim=2,ncopies=size(data_array,2) )

        similarity_matrix = similarity_matrix + transpose(similarity_matrix) - 2d0 * matmul( transpose(data_array),data_array )

    end function calc_similarity_matrix




    !> This function relabels an array with more sensible indices
    !!
    !! We do this by constructing a mapping of each original label to a new label
    !!
    !! mapping :  new labels ---> old labels
    function relabel(array,num_labels) result(array_relabel)
        implicit none
        integer,intent(in),dimension(:)  :: array
        integer,intent(out)              :: num_labels

        integer,dimension(size(array)) :: array_relabel

        integer,dimension(size(array)) :: mapping

        integer :: npoints
        integer :: i_point
        integer :: i_label

        ! Find the number of points
        npoints = size(array)

        ! We will re-label the array type in array(1) with the integer 1
        mapping(1) = array(1)
        num_labels = 1

        do i_point=1,npoints
            ! If the array type for i_point is not already included in the
            ! array, then add it
            if( all(array(i_point)/=mapping(1:num_labels)) ) then
                num_labels=num_labels+1
                mapping(num_labels) = array(i_point)
            end if
        end do

        ! mapping now contains the random integers that are found in array

        ! We now relabel according to the inverse mapping
        do i_label=1,num_labels
            where(array==mapping(i_label)) array_relabel=i_label
        end do

    end function



    !> The volume of a unit n-sphere
    function Vn(nDims)
        implicit none
        integer,intent(in) :: nDims
        real(dp) :: Vn
        real(dp), parameter :: sqrtpi = sqrt(4d0*atan(1d0))
        Vn = sqrtpi**nDims /gamma(1d0+nDims/2d0)
    end function Vn






    function normal_cdf(x)
        implicit none
        real(dp), intent(in),dimension(:) :: x
        real(dp),dimension(size(x)) :: normal_cdf
        real(dp), parameter :: sqrt2 = sqrt(2d0)

        normal_cdf = 0.5d0 * ( 1d0 + erf(x/sqrt2))

    end function normal_cdf

    function inv_normal_cdf(x)
        implicit none
        real(dp), intent(in),dimension(:) :: x
        real(dp),dimension(size(x)) :: inv_normal_cdf
        integer :: i

        inv_normal_cdf = [( r8_normal_01_cdf_inverse(x(i)), i=1,size(x) )]

    end function inv_normal_cdf

    function convert_c_string(c_string) result(string)
        use iso_c_binding
        implicit none
        character(len=1,kind=c_char), intent(in), dimension(:) :: c_string
        character(len=size(c_string)) :: string

        integer :: i

        string = ' '
        do i=1,len(string)
            if( c_string(i) == c_null_char ) exit
            string(i:i) = c_string(i)
        end do

    end function convert_c_string

    ! This was downloaded from:
    ! http://people.sc.fsu.edu/~jburkardt/f_src/asa241/asa241.f90

    function r8_normal_01_cdf_inverse ( p )

        !*****************************************************************************80
        !
        !! R8_NORMAL_01_CDF_INVERSE inverts the standard normal CDF.
        !
        !  Discussion:
        !
        !    The result is accurate to about 1 part in 10**16.
        !
        !  Licensing:
        !
        !    This code is distributed under the GNU LGPL license.
        !
        !  Modified:
        !
        !    27 December 2004
        !
        !  Author:
        !
        !    Original FORTRAN77 version by Michael Wichura.
        !    FORTRAN90 version by John Burkardt.
        !
        !  Reference:
        !
        !    Michael Wichura,
        !    The Percentage Points of the Normal Distribution,
        !    Algorithm AS 241,
        !    Applied Statistics,
        !    Volume 37, Number 3, pages 477-484, 1988.
        !
        !  Parameters:
        !
        !    Input, real ( kind = 8 ) P, the value of the cumulative probability 
        !    densitity function.  0 < P < 1.  If P is outside this range,
        !    an "infinite" value will be returned.
        !
        !    Output, real ( kind = 8 ) D_NORMAL_01_CDF_INVERSE, the normal deviate 
        !    value with the property that the probability of a standard normal 
        !    deviate being less than or equal to the value is P.
        !
        implicit none

        real ( kind = 8 ), parameter, dimension ( 8 ) :: a = (/ &
            3.3871328727963666080D+00, &
            1.3314166789178437745D+02, &
            1.9715909503065514427D+03, &
            1.3731693765509461125D+04, &
            4.5921953931549871457D+04, &
            6.7265770927008700853D+04, &
            3.3430575583588128105D+04, &
            2.5090809287301226727D+03 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: b = (/ &
            1.0D+00, &
            4.2313330701600911252D+01, &
            6.8718700749205790830D+02, &
            5.3941960214247511077D+03, &
            2.1213794301586595867D+04, &
            3.9307895800092710610D+04, &
            2.8729085735721942674D+04, &
            5.2264952788528545610D+03 /)
        real   ( kind = 8 ), parameter, dimension ( 8 ) :: c = (/ &
            1.42343711074968357734D+00, &
            4.63033784615654529590D+00, &
            5.76949722146069140550D+00, &
            3.64784832476320460504D+00, &
            1.27045825245236838258D+00, &
            2.41780725177450611770D-01, &
            2.27238449892691845833D-02, &
            7.74545014278341407640D-04 /)
        real ( kind = 8 ), parameter :: const1 = 0.180625D+00
        real ( kind = 8 ), parameter :: const2 = 1.6D+00
        real ( kind = 8 ), parameter, dimension ( 8 ) :: d = (/ &
            1.0D+00, &
            2.05319162663775882187D+00, &
            1.67638483018380384940D+00, &
            6.89767334985100004550D-01, &
            1.48103976427480074590D-01, &
            1.51986665636164571966D-02, &
            5.47593808499534494600D-04, &
            1.05075007164441684324D-09 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: e = (/ &
            6.65790464350110377720D+00, &
            5.46378491116411436990D+00, &
            1.78482653991729133580D+00, &
            2.96560571828504891230D-01, &
            2.65321895265761230930D-02, &
            1.24266094738807843860D-03, &
            2.71155556874348757815D-05, &
            2.01033439929228813265D-07 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: f = (/ &
            1.0D+00, &
            5.99832206555887937690D-01, &
            1.36929880922735805310D-01, &
            1.48753612908506148525D-02, &
            7.86869131145613259100D-04, &
            1.84631831751005468180D-05, &
            1.42151175831644588870D-07, &
            2.04426310338993978564D-15 /)
        real ( kind = 8 ) p
        real ( kind = 8 ) q
        real ( kind = 8 ) r
        real ( kind = 8 ) r8_normal_01_cdf_inverse 
        real ( kind = 8 ), parameter :: split1 = 0.425D+00
        real ( kind = 8 ), parameter :: split2 = 5.0D+00

        if ( p <= 0.0D+00 ) then
            r8_normal_01_cdf_inverse = - huge ( p )
            return
        end if

        if ( 1.0D+00 <= p ) then
            r8_normal_01_cdf_inverse = huge ( p )
            return
        end if

        q = p - 0.5D+00

        if ( abs ( q ) <= split1 ) then

            r = const1 - q * q
            r8_normal_01_cdf_inverse = q * r8poly_value ( 8, a, r ) &
                / r8poly_value ( 8, b, r )

        else

            if ( q < 0.0D+00 ) then
                r = p
            else
                r = 1.0D+00 - p
            end if

            if ( r <= 0.0D+00 ) then
                r8_normal_01_cdf_inverse = - 1.0D+00
                stop
            end if

            r = sqrt ( -log ( r ) )

            if ( r <= split2 ) then

                r = r - const2
                r8_normal_01_cdf_inverse = r8poly_value ( 8, c, r ) &
                    / r8poly_value ( 8, d, r )

            else

                r = r - split2
                r8_normal_01_cdf_inverse = r8poly_value ( 8, e, r ) &
                    / r8poly_value ( 8, f, r )

            end if

            if ( q < 0.0D+00 ) then
                r8_normal_01_cdf_inverse = - r8_normal_01_cdf_inverse
            end if

        end if

        return
    end function r8_normal_01_cdf_inverse


    function r8poly_value ( n, a, x )

        !*****************************************************************************80
        !
        !! R8POLY_VALUE evaluates an R8POLY
        !
        !  Discussion:
        !
        !    For sanity's sake, the value of N indicates the NUMBER of 
        !    coefficients, or more precisely, the ORDER of the polynomial,
        !    rather than the DEGREE of the polynomial.  The two quantities
        !    differ by 1, but cause a great deal of confusion.
        !
        !    Given N and A, the form of the polynomial is:
        !
        !      p(x) = a(1) + a(2) * x + ... + a(n-1) * x^(n-2) + a(n) * x^(n-1)
        !
        !  Licensing:
        !
        !    This code is distributed under the GNU LGPL license.
        !
        !  Modified:
        !
        !    13 August 2004
        !
        !  Author:
        !
        !    John Burkardt
        !
        !  Parameters:
        !
        !    Input, integer ( kind = 4 ) N, the order of the polynomial.
        !
        !    Input, real ( kind = 8 ) A(N), the coefficients of the polynomial.
        !    A(1) is the constant term.
        !
        !    Input, real ( kind = 8 ) X, the point at which the polynomial is 
        !    to be evaluated.
        !
        !    Output, real ( kind = 8 ) R8POLY_VALUE, the value of the polynomial at X.
        !
        implicit none

        integer ( kind = 4 ) n

        real ( kind = 8 ) a(n)
        integer ( kind = 4 ) i
        real ( kind = 8 ) r8poly_value
        real ( kind = 8 ) x

        r8poly_value = 0.0D+00
        do i = n, 1, -1
            r8poly_value = r8poly_value * x + a(i)
        end do

        return
    end function r8poly_value

    !> Compute the loglikelihood of a multivariate gaussian
    function log_gauss(theta,mean,invcovmat,logdetcovmat)
        implicit none
        !> The input vector
        real(dp), intent(in), dimension(:) :: theta
        !> The mean
        real(dp), intent(in), dimension(:) :: mean
        !> The precomputed inverse covariance matrix
        real(dp), intent(in), dimension(:,:) :: invcovmat
        !> The precomputed logarithm of the determinant
        real(dp), intent(in) :: logdetcovmat


        ! The output
        real(dp) :: log_gauss

        ! Gaussian normalisation
        log_gauss = - ( size(theta) * logTwoPi + logdetcovmat )/2d0 

        log_gauss = log_gauss - dot_product(theta-mean,matmul(invcovmat,theta-mean))/2d0

    end function log_gauss

    !> This gets the wallclock timer from the mpi library
    function time() 
        implicit none
#ifdef MPI
        include 'mpif.h'
#endif
        real(dp) :: time

#ifdef MPI
        time = MPI_Wtime()
#else 
        call cpu_time(time)
#endif
      
    end function time


end module utils_module

module cosmosis


# double, array, grid

datablock_status = Int32
datablock = Ptr{Cvoid}

option_section = "module_options"



struct BlockError <: Exception
    code::datablock_status
    msg::String
    
    function BlockError(code::datablock_status)
        new(code, error_names[code])
    end
    function BlockError(code::datablock_status, msg)
        new(code, error_names[code] * ": " * msg)
    end
end
Base.showerror(io::IO, e::BlockError) = print(io, e.msg)

error_names = [
    "CosmoSIS: Success",
    "CosmoSIS: Datablock is Null",
    "CosmoSIS: Section name is null",
    "CosmoSIS: Section not found",
    "CosmoSIS: Name is Null",
    "CosmoSIS: Name not found",
    "CosmoSIS: Name already exists",
    "CosmoSIS: Value is null",
    "CosmoSIS: Wrong value type",
    "CosmoSIS: Memory allocation error",
    "CosmoSIS: Size is null",
    "CosmoSIS: Size not positive",
    "CosmoSIS: Size is insufficient",
    "CosmoSIS: Dimensionality not positive",
    "CosmoSIS: Number of dimensions too large",
    "CosmoSIS: Dimensions do notmarch",
    "CosmoSIS: Extents are null",
    "CosmoSIS: Extents do not match dimension",
    "CosmoSIS: Internal logic error: please open an issue"
]




function make_datablock()
    res = ccall((:make_c_datablock, "libcosmosis.so"), datablock, ())
    res
end


function put_int(block::datablock, section, name, value)
    res = ccall((:c_datablock_put_int, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Int32), 
            block, section, name, value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * "name was " * string(name) * "value was " * string(value)))
    end
    res
end


function get_int(block, section, name)
    value = Ref{Int32}()
    res = ccall((:c_datablock_get_int, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ref{Int32}), 
            block, section, name, value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end
    value[]
end



function put_double(block::datablock, section, name, value)
    res = ccall((:c_datablock_put_double, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Cdouble), 
            block, section, name, value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end
    res
end


function get_double(block, section, name)
    value = Ref{Cdouble}()
    res = ccall((:c_datablock_get_double, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ref{Cdouble}), 
            block, section, name, value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name) * ", value was " * string(value) ))
    end
    value[]
end


function put_bool(block::datablock, section, name, value)
    if ((value!=0) && (value!=1))
        throw(BlockError("Bool values in Julia must be 0 or 1"))
    end
    if (value==0)
        uint_value = UInt8(0)
    elseif (value==1)
        uint_value = UInt8(1)
    else
        throw(ArgumentError("Bool values in Julia must be 0 or 1. You passed: " * string(value)))
    end
    res = ccall((:c_datablock_put_bool, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, UInt8), 
            block, section, name, uint_value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name) * ", value was " * string(value) ))
    end
    res
end


function get_bool(block, section, name)
    value = Ref{UInt8}()
    res = ccall((:c_datablock_get_bool, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ref{UInt8}), 
            block, section, name, value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end
    value[]
end


function get_string(block, section, name)
    value = Ref{Cstring}()
    res = ccall((:c_datablock_get_string, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ref{Cstring}), 
            block, section, name, value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end
    unsafe_string(value[])
end


function put_string(block, section, name, value)
    res = ccall((:c_datablock_put_string, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Cstring), 
            block, section, name, value)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end
    res
end


function put_double_array_nd(block, section, name, value)

    ndim = ndims(value)
    extents = convert(Array{Int32}, collect(size(value)))

    res = ccall((:c_datablock_put_double_array, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ptr{Cdouble}, Int32, Ptr{Int32}), 
            block, section, name, vec(value), ndim, extents)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end
    res
end


function get_double_array_nd(block, section, name)

    ndim_ptr = Ref{Int32}()
    res = ccall((:c_datablock_get_array_ndim, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ref{Int32}),
            block, section, name, ndim_ptr)

    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end

    ndim = ndim_ptr[]    

    extents = Array{Int32}(undef, ndim)

    res = ccall((:c_datablock_get_double_array_shape, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Int32, Ptr{Int32}), 
            block, section, name, ndim, extents)

    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end


    t = tuple(extents...)

    value = Array{Float64}(undef, t)

    res = ccall((:c_datablock_get_double_array, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ptr{Cdouble}, Int32, Ptr{Int32}), 
            block, section, name, value, ndim, extents)


    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end

    value

end



function put_int_array_nd(block, section, name, value)

    ndim = ndims(value)
    extents = convert(Array{Int32}, collect(size(value)))

    res = ccall((:c_datablock_put_int_array, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ptr{Int32}, Int32, Ptr{Int32}), 
            block, section, name, vec(value), ndim, extents)
    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end
    res
end


function get_int_array_nd(block, section, name)

    ndim_ptr = Ref{Int32}()
    res = ccall((:c_datablock_get_array_ndim, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ref{Int32}),
            block, section, name, ndim_ptr)

    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end

    ndim = ndim_ptr[]    

    extents = Array{Int32}(undef, ndim)

    res = ccall((:c_datablock_get_int_array_shape, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Int32, Ptr{Int32}), 
            block, section, name, ndim, extents)

    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end


    t = tuple(extents...)

    value = Array{Int32}(undef, t)

    res = ccall((:c_datablock_get_int_array, "libcosmosis.so"), 
            datablock_status,
            (datablock, Cstring, Cstring, Ptr{Int32}, Int32, Ptr{Int32}), 
            block, section, name, value, ndim, extents)


    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end

    value

end


function put_double_array_1d(block, section, name, value)

    sz = Int32(length(value))

    res = ccall((:c_datablock_put_double_array_1d, "libcosmosis.so"), 
        datablock_status,
        (datablock, Cstring, Cstring, Ptr{Float64}, Int32), 
        block, section, name, value, sz)

    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end


end


function get_double_array_1d(block, section, name)


    sz = ccall((:c_datablock_get_array_length, "libcosmosis.so"), 
        Int32,
        (datablock, Cstring, Cstring), 
        block, section, name)

    println("size = ", sz)
    if (sz<0)
        throw(BlockError(8, "section was " * string(section) * ", name was " * string(name)))
    end

    sz_ptr = Ref{Int32}()
    value = Array{Float64}(undef, sz)

    println("calling")
    res = ccall((:c_datablock_get_double_array_1d_preallocated, "libcosmosis.so"), 
        datablock_status,
        (datablock, Cstring, Cstring, Ptr{Float64}, Ref{Int32}, Int32), 
        block, section, name, value, sz_ptr, sz)
    println("out")

    if (res!=0)
        throw(BlockError(res, "section was " * string(section) * ", name was " * string(name)))
    end

    value
end


end

program main

	use params
	use nestwrapper
      
	implicit none
	
	integer i
      
      	!no parameters to wrap around
      	nest_pWrap = 0
	
	do i = 1, sdim
		sigma(i) = 0.001
	enddo

      	call nest_Sample
end

module like
	
use params
use utils1
implicit none
      
contains
      
      
!=======================================================================

subroutine slikelihood(Cube,slhood)
         
	implicit none
      
	double precision Cube(nest_nPar),slhood
	integer i
	
	slhood = 1d0
	
	do i = 1, sdim
		Cube(i) = spriorran(i, 1) + ( spriorran(i, 2) - spriorran(i, 1) ) * Cube(i)
		slhood = slhood * cos( Cube(i)/2d0 )
	enddo
	
	slhood = (2d0 + slhood)**5d0

end subroutine slikelihood
      
!=======================================================================

end module like

module like
	
use params
use utils1
implicit none
      
contains
      
      
!=======================================================================

subroutine slikelihood(Cube,slhood)
         
	implicit none
      
	double precision Cube(nest_nPar),slhood
	double precision a,b,pi
	integer i,j
	
	pi = 4d0 * atan(1d0)
	
	do i = 1, sdim
		Cube(i) = spriorran(i, 1) + ( spriorran(i, 2) - spriorran(i, 1) ) * Cube(i)
	enddo
	
	a = 0d0
	b = 0d0
	do i = 1, sdim
		a = a + Cube(i)**2
		b = b + cos( 2 * pi * Cube(i) )
	enddo
	a = -0.2 * sqrt( a / sdim )
	b = b / sdim
	
	slhood = 20d0 * exp(a) + exp(b) - 20d0 - exp(1d0)

end subroutine slikelihood
      
!=======================================================================

end module like

! Include file for example MultiNest program 'Gaussian Rings' (see arXiv:0704.3704 & arXiv:0809.3437)

module params
implicit none

! Toy Model Parameters

	!dimensionality
      	integer sdim
      	parameter(sdim=10)
      
      	!priors on the parameters
      	!uniform priors (-5,5) are used for all dimensions & are set in main.f90
      	double precision spriorran(sdim,2)
      


! Parameters for MultiNest
	
      	!whether to do use Nested Importance Sampling
	logical nest_IS
 	parameter(nest_IS=.true.)
	
      	!whether to do multimodal sampling
	logical nest_mmodal 
 	parameter(nest_mmodal=.false.)
	
      	!sample with constant efficiency
	logical nest_ceff
 	parameter(nest_ceff=.false.)
	
      	!max no. of live points
      	integer nest_nlive
	parameter(nest_nlive=1000)
      
      	!tot no. of parameters, should be sdim in most cases but if you need to
      	!store some additional parameters with the actual parameters then
      	!you need to pass them through the likelihood routine
	integer nest_nPar 
	parameter(nest_nPar=sdim)
      
      	!seed for MultiNest, -ve means take it from sys clock
	integer nest_rseed 
	parameter(nest_rseed=-1)
      
      	!evidence tolerance factor
      	double precision nest_tol 
      	parameter(nest_tol=0.1)
      
      	!enlargement factor reduction parameter
      	double precision nest_efr
      	parameter(nest_efr=0.3d0)
      
      	!root for saving posterior files
      	character*512 nest_root
	parameter(nest_root='chains/rosenbrock-')
	
	!after how many iterations feedback is required & the output files should be updated
	!note: posterior files are updated & dumper routine is called after every updInt*10 iterations
	integer nest_updInt
	parameter(nest_updInt=5000)
	
	!null evidence (set it to very high negative no. if null evidence is unknown)
	double precision nest_Ztol
	parameter(nest_Ztol=-1.d90)
      
      	!max modes expected, for memory allocation
      	integer nest_maxModes 
      	parameter(nest_maxModes=10)
      
      	!no. of parameters to cluster (for mode detection)
      	integer nest_nClsPar
      	parameter(nest_nClsPar=2)
      
      	!whether to resume from a previous run
      	logical nest_resume
      	parameter(nest_resume=.false.)
      
      	!whether to write output files
      	logical nest_outfile
      	parameter(nest_outfile=.true.)
      
      	!initialize MPI routines?, relevant only if compiling with MPI
	!set it to F if you want your main program to handle MPI initialization
      	logical nest_initMPI
      	parameter(nest_initMPI=.true.)
      
      	!points with loglike < nest_logZero will be ignored by MultiNest
      	double precision nest_logZero
      	parameter(nest_logZero=-huge(1d0))
      
      	!max no. of iterations, a non-positive value means infinity. MultiNest will terminate if either it 
	!has done max no. of iterations or convergence criterion (defined through nest_tol) has been satisfied
      	integer nest_maxIter
      	parameter(nest_maxIter=0)
	
	!parameters to wrap around (0 is F & non-zero T)
	integer nest_pWrap(sdim)
	
      	!feedback on the sampling progress?
      	logical nest_fb 
      	parameter(nest_fb=.true.)
!=======================================================================


end module params

push!(LOAD_PATH,".")
import cosmosis
block=cosmosis.make_datablock()
cosmosis.put_int(block, "my_section", "my_int", 17)
x = cosmosis.get_int(block, "my_section", "my_int")

cosmosis.put_double(block, "my_section", "my_double", 12.99)
y = cosmosis.get_double(block, "my_section", "my_double")

cosmosis.put_bool(block, "my_section", "my_bool", 1)
z = cosmosis.get_bool(block, "my_section", "my_bool")

cosmosis.put_string(block, "my_section", "my_str", "hat")
w = cosmosis.get_string(block, "my_section", "my_str")


a = fill(19.4, 2, 3)
cosmosis.put_double_array(block, "my_section", "myarr", a)
b= cosmosis.get_double_array(block, "my_section", "myarr")

c = fill(Int32(19), 2, 3)
cosmosis.put_int_array(block, "my_section", "myarr2", c)
d = cosmosis.get_int_array(block, "my_section", "myarr2")

println("x = ", x)
println("y = ", y)
println("z = ", z)
println("w = ", w)
println("b = ", b)
println("d = ", d)

program main

	use params
	use nestwrapper
      
      	implicit none
	integer i
      	double precision temp(4),s_nullev
      
      	sdim=0
	do i=1,4
      		if(spriorran(i,1)/=spriorran(i,2)) sdim=sdim+1
      	end do
      	nest_nPar=sdim
	nest_pWrap=0
      
  	call sCreateData(temp,sodata,.false.) 
      
 	call sInitialize(s_nullev)
      	call nest_Sample 
      
      	write(*,*)"Null Evidence=",s_nullev   
      
      	stop
end

#!/usr/bin/env Rscript

library(lattice)

data <- read.table("demo3_output.txt")
names(data) <- c("r", "loglike")

#convert to like from log-like and normalize
data$like <- exp(data$loglike)
norm <- data$like/max(data$like)
data$like <- data$like/norm

# Make the output directory if needed.
if (! file.exists("plots"))
   dir.create("plots")

#make plot
png("plots/demo3.png")
xyplot(like~r, data, xlab="Tensor ratio r", ylab="Likelihood", grid=TRUE, type="l")
invisible(dev.off())

#!/usr/bin/env bash

if [ -n "$1" ]
then
	start=$1
else
	start=1
fi

echo Starting from demo $start

# This is used in demo 10
export HALOFIT=halofit_takahashi

# Loop through all demos
for (( D=$start ; D<=24 ; D++ ))
do
	# There is no demo 23 yet
	if [[ $D == 23 ]]
	then
		continue
	fi

	# Check main run
	cosmosis demos/demo$D.ini
	if [ $? -ne 0 ]
		then
		echo "Error running Demo $D"
		exit 1
	fi

	# Also check we can postprocess okay
	postprocess demos/demo$D.ini -o output/plots -p demo$D
	if [ $? -ne 0 ]
		then
		echo "Error postprocessing Demo $D"
		exit 1
	fi
done

# Now do some MPI test runs

# Test one python MPI sampler and one fortran
mpirun -n 3 cosmosis --mpi demos/demo5.ini
if [ $? -ne 0 ]
	then
	echo "Error running Demo 3 in MPI mode"
	exit 1
fi

mpirun -n 3 cosmosis --mpi demos/demo9.ini
if [ $? -ne 0 ]
	then
	echo "Error running Demo 3 in MPI mode"
	exit 1
fi


exit 0
